Attribute VB_Name = "modAutorefresh"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oRefreshObject As Object
Private bEnabled As Boolean
Private lInterval As Long
Private lTimerID As Long

Private bInTimerProc As Boolean

'''

Public Property Get RefreshObject() As Object
    Set RefreshObject = oRefreshObject
End Property
Public Property Set RefreshObject(NewVal As Object)
    Set oRefreshObject = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    If NewVal <> bEnabled Then
        If Not oRefreshObject Is Nothing Then
            bEnabled = NewVal
            If bEnabled Then
                StartTimer
            Else
                StopTimer
            End If
        End If
    End If
End Property

Public Property Get Interval() As Long
    Interval = lInterval
End Property
Public Property Let Interval(ByVal NewVal As Long)
    lInterval = NewVal
    If lTimerID <> 0 Then
        ChangeInterval
    End If
End Property
'
' Methods
'
Public Sub Initialize(ByVal o As Object)
    bEnabled = False
    lInterval = 60000
    lTimerID = 0
    Set oRefreshObject = o
End Sub

Public Sub Terminate()
    Enabled = False
    Set oRefreshObject = Nothing
End Sub

'''

Private Sub StartTimer()
    lTimerID = SetTimer(0, 0, lInterval, AddressOf TimerProc)
End Sub

Private Sub StopTimer()
    Dim lResult As Long
    If lTimerID <> 0 Then
        lResult = KillTimer(0, lTimerID)
        lTimerID = 0
    End If
End Sub

Private Sub ChangeInterval()
    Dim lResult As Long
    lResult = SetTimer(0, lTimerID, lInterval, AddressOf TimerProc)
End Sub

Private Sub TimerProc(ByVal lHwnd As Long, _
                      ByVal lMsg As Long, _
                      ByVal lTimerID As Long, _
                      ByVal lTime As Long)
                      
    On Error Resume Next
    
    If bEnabled And (Not bInTimerProc) Then
        bInTimerProc = True
        oRefreshObject.Refresh
        bInTimerProc = False
    End If
End Sub
