Attribute VB_Name = "APIGDI"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Type SIZE
    cx As Long
    cy As Long
End Type

Public Const SRCCOPY = &HCC0020

Public Const TRANSPARENT = 1
Public Const OPAQUE = 2

Declare Function BitBlt Lib "gdi32.dll" ( _
    ByVal hdcDest As Long, _
    ByVal nXDest As Long, _
    ByVal nYDest As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long, _
    ByVal hdcSrc As Long, _
    ByVal nXSrc As Long, _
    ByVal nYSrc As Long, _
    ByVal dwRop As Long) As Long
    
Declare Function CreatePen Lib "gdi32.dll" ( _
    ByVal nPenStyle As Long, _
    ByVal nWidth As Long, _
    ByVal crColor As Long) As Long

Declare Function CreateSolidBrush Lib "gdi32.dll" ( _
    ByVal crColor As Long) As Long

Declare Function DeleteObject Lib "gdi32.dll" ( _
    ByVal hObject As Long) As Integer

Declare Function GetTextColor Lib "gdi32.dll" ( _
    ByVal hDC As Long) As Long
    
Declare Function LineTo Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal x As Long, _
    ByVal y As Long) As Long

Declare Function MoveToEx Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    lpPoint As POINTAPI) As Long

Declare Function SelectObject Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal hObject As Long) As Long

Declare Function SetBkColor Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal crColor As Long) As Long
    
Declare Function SetBkMode Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal nBkMode As Long) As Long

Declare Function SetTextColor Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal crColor As Long) As Long

Declare Function TextOut Lib "gdi32.dll" Alias "TextOutA" ( _
    ByVal hDC As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal lpString As String, _
    ByVal nCount As Long) As Long

Declare Function Rectangle Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal X1 As Long, _
    ByVal Y1 As Long, _
    ByVal X2 As Long, _
    ByVal Y2 As Long) As Long

'''''''''''''''''''

Declare Function GetTextExtentPoint32 Lib "gdi32.dll" Alias "GetTextExtentPoint32A" ( _
    ByVal hDC As Long, _
    ByVal lpsz As String, _
    ByVal cbString As Long, _
    lpSize As SIZE) As Long


'''

Type TEXTMETRIC
    tmHeight As Long
    tmAscent As Long
    tmDescent As Long
    tmInternalLeading As Long
    tmExternalLeading As Long
    tmAveCharWidth As Long
    tmMaxCharWidth As Long
    tmWeight As Long
    tmOverhang As Long
    tmDigitizedAspectX As Long
    tmDigitizedAspectY As Long
    tmFirstChar As Byte
    tmLastChar As Byte
    tmDefaultChar As Byte
    tmBreakChar As Byte
    tmItalic As Byte
    tmUnderlined As Byte
    tmStruckOut As Byte
    tmPitchAndFamily As Byte
    tmCharSet As Byte
End Type

Declare Function GetTextMetrics Lib "gdi32.dll" Alias "GetTextMetricsA" ( _
    ByVal hDC As Long, _
    lpMetrics As TEXTMETRIC) As Long

'''

Declare Function GetTextCharacterExtra Lib "gdi32.dll" ( _
    ByVal hDC As Long) As Long
    
Declare Function SetTextCharacterExtra Lib "gdi32.dll" ( _
    ByVal hDC As Long, ByVal nCharExtra As Long) As Long

'''

Public Const LF_FACESIZE = 32

Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Declare Function CreateFontIndirect Lib "gdi32.dll" Alias "CreateFontIndirectA" ( _
    lpLogFont As LOGFONT) As Long

