Attribute VB_Name = "APIUser"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Type MENUITEMINFO
    cbSize As Long
    fMask As Long
    fType As Long               ' used if MIIM_TYPE
    fState As Long              ' used if MIIM_STATE
    wID As Long                 ' used if MIIM_ID
    hSubMenu As Long            ' used if MIIM_SUBMENU
    hbmpChecked As Long         ' used if MIIM_CHECKMARKS
    hbmpUnchecked As Long       ' used if MIIM_CHECKMARKS
    dwItemData As Long          ' used if MIIM_DATA
    dwTypeData As String        ' used if MIIM_TYPE
    cch As Long                 ' used if MIIM_TYPE
End Type

Public Const MIIM_STATE = &H1
Public Const MIIM_ID = &H2
Public Const MIIM_SUBMENU = &H4
Public Const MIIM_CHECKMARKS = &H8
Public Const MIIM_TYPE = &H10
Public Const MIIM_DATA = &H20

Public Const MFT_STRING = &H0
Public Const MFT_BITMAP = &H4
Public Const MFT_MENUBARBREAK = &H20
Public Const MFT_MENUBREAK = &H40
Public Const MFT_OWNERDRAW = &H100
Public Const MFT_RADIOCHECK = &H200
Public Const MFT_SEPARATOR = &H800
Public Const MFT_RIGHTORDER = &H2000
Public Const MFT_RIGHTJUSTIFY = &H4000

Public Const MFS_GRAYED = &H3
Public Const MFS_DISABLED = MFS_GRAYED
Public Const MFS_CHECKED = &H8
Public Const MFS_HILITE = &H80
Public Const MFS_ENABLED = &H0
Public Const MFS_UNCHECKED = &H0
Public Const MFS_UNHILITE = &H0
Public Const MFS_DEFAULT = &H1000

Type MEASUREITEMSTRUCT
    CtlType As Long
    CtlID As Long
    ItemID As Long
    ItemWidth As Long
    ItemHeight As Long
    ItemData As Long
End Type

Type DRAWITEMSTRUCT
    CtlType As Long
    CtlID As Long
    ItemID As Long
    ItemAction As Long
    ItemState As Long
    hwndItem As Long
    hDC As Long
    rcItem As RECT
    ItemData As Long
End Type

' Owner draw control types
Public Const ODT_MENU = 1
Public Const ODT_LISTBOX = 2
Public Const ODT_COMBOBOX = 3
Public Const ODT_BUTTON = 4
Public Const ODT_STATIC = 5

' Owner draw actions
Public Const ODA_DRAWENTIRE = &H1
Public Const ODA_SELECT = &H2
Public Const ODA_FOCUS = &H4

' Owner draw state
Public Const ODS_CHECKED = &H8
Public Const ODS_COMBOBOXEDIT = &H1000
Public Const ODS_DEFAULT = &H20
Public Const ODS_DISABLED = &H4
Public Const ODS_FOCUS = &H10
Public Const ODS_GRAYED = &H2
Public Const ODS_SELECTED = &H1

Declare Function CreatePopupMenu Lib "user32.dll" () As Long

Declare Function InsertMenuItem Lib "user32.dll" Alias "InsertMenuItemA" ( _
    ByVal hMenu As Long, _
    ByVal un As Long, _
    ByVal bool As Boolean, _
    lpcMenuItemInfo As MENUITEMINFO) As Long

Declare Function TrackPopupMenu Lib "user32.dll" ( _
    ByVal hMenu As Long, _
    ByVal wFlags As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal nReserved As Long, _
    ByVal hWnd As Long, _
    lprc As Any) As Long
    
Public Const TPM_LEFTBUTTON = &H0
Public Const TPM_RIGHTBUTTON = &H2
Public Const TPM_LEFTALIGN = &H0
Public Const TPM_CENTERALIGN = &H4
Public Const TPM_RIGHTALIGN = &H8
Public Const TPM_TOPALIGN = &H0
Public Const TPM_VCENTERALIGN = &H10
Public Const TPM_BOTTOMALIGN = &H20
Public Const TPM_HORIZONTAL = &H0       ' Horz alignment matters more
Public Const TPM_VERTICAL = &H40        ' Vert alignment matters more
Public Const TPM_NONOTIFY = &H80        ' Don't send any notification msgs
Public Const TPM_RETURNCMD = &H100


Public Const WM_PAINT = &HF

Public Const WM_COMMAND = &H111
Public Const WM_CONTEXTMENU = &H7B
Public Const WM_DRAWITEM = &H2B
Public Const WM_ENTERMENULOOP = &H211
Public Const WM_EXITMENULOOP = &H212
Public Const WM_INITMENU = &H116
Public Const WM_INITMENUPOPUP = &H117
Public Const WM_MEASUREITEM = &H2C
Public Const WM_MENUCHAR = &H120
Public Const WM_MENUSELECT = &H11F
Public Const WM_NEXTMENU = &H213
Public Const WM_SYSCOMMAND = &H112
Public Const WM_WININICHANGE = &H1A

'''

Public Const MF_INSERT = &H0
Public Const MF_CHANGE = &H80
Public Const MF_APPEND = &H100
Public Const MF_DELETE = &H200
Public Const MF_REMOVE = &H1000

Public Const MF_BYCOMMAND = &H0
Public Const MF_BYPOSITION = &H400

Public Const MF_SEPARATOR = &H800

Public Const MF_ENABLED = &H0
Public Const MF_GRAYED = &H1
Public Const MF_DISABLED = &H2

Public Const MF_UNCHECKED = &H0
Public Const MF_CHECKED = &H8
Public Const MF_USECHECKBITMAPS = &H200

Public Const MF_STRING = &H0
Public Const MF_BITMAP = &H4
Public Const MF_OWNERDRAW = &H100

Public Const MF_POPUP = &H10
Public Const MF_MENUBARBREAK = &H20
Public Const MF_MENUBREAK = &H40

Public Const MF_UNHILITE = &H0
Public Const MF_HILITE = &H80

Public Const MF_DEFAULT = &H1000
Public Const MF_SYSMENU = &H2000
Public Const MF_HELP = &H4000
Public Const MF_RIGHTJUSTIFY = &H4000

Public Const MF_MOUSESELECT = &H8000

'''

Public Const MNC_IGNORE = 0
Public Const MNC_CLOSE = 1
Public Const MNC_EXECUTE = 2
Public Const MNC_SELECT = 3

'''

Declare Function DestroyMenu Lib "user32.dll" ( _
    ByVal hMenu As Long) As Long

Declare Function InsertMenu Lib "user32.dll" Alias "InsertMenuA" ( _
    ByVal hMenu As Long, _
    ByVal nPosition As Long, _
    ByVal wFlags As Long, _
    ByVal wIDNewItem As Long, _
    ByVal lpNewItem As Any) As Long
    
Declare Function AppendMenu Lib "user32.dll" Alias "AppendMenuA" ( _
    ByVal hMenu As Long, _
    ByVal wFlags As Long, _
    ByVal wIDNewItem As Long, _
    ByVal lpNewItem As Any) As Long
    
Declare Function DeleteMenu Lib "user32.dll" ( _
    ByVal hMenu As Long, _
    ByVal nPosition As Long, _
    ByVal wFlags As Long) As Long
    
Declare Function RemoveMenu Lib "user32.dll" ( _
    ByVal hMenu As Long, _
    ByVal nPosition As Long, _
    ByVal wFlags As Long) As Long

Declare Function CreateMenu Lib "user32.dll" () As Long

Declare Function SetMenu Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal hMenu As Long) As Long

Declare Function DrawMenuBar Lib "user32.dll" ( _
    ByVal hWnd As Long) As Long

Declare Function GetMenu Lib "user32.dll" ( _
    ByVal hWnd As Long) As Long

Declare Function GetSubMenu Lib "user32.dll" ( _
    ByVal hMenu As Long, _
    ByVal nPos As Long) As Long

Declare Function GetMenuItemInfo Lib "user32.dll" Alias "GetMenuItemInfoA" ( _
    ByVal hMenu As Long, _
    ByVal un As Long, _
    ByVal b As Boolean, _
    lpMenuItemInfo As MENUITEMINFO) As Long
    
'''''''''''''

Declare Function GetMenuItemCount Lib "user32.dll" ( _
    ByVal hMenu As Long) As Long

Declare Function GetMenuItemID Lib "user32.dll" ( _
    ByVal hMenu As Long, _
    ByVal nPos As Long) As Long
'''

Declare Function GetSysColor Lib "user32.dll" ( _
    ByVal nIndex As Integer) As Long

Public Const COLOR_ACTIVEBORDER = 10
Public Const COLOR_ACTIVECAPTION = 2
Public Const COLOR_ADJ_MAX = 100
Public Const COLOR_ADJ_MIN = -100 'shorts
Public Const COLOR_APPWORKSPACE = 12
Public Const COLOR_BACKGROUND = 1
Public Const COLOR_BTNFACE = 15
Public Const COLOR_BTNHIGHLIGHT = 20
Public Const COLOR_BTNSHADOW = 16
Public Const COLOR_BTNTEXT = 18
Public Const COLOR_CAPTIONTEXT = 9
Public Const COLOR_GRAYTEXT = 17
Public Const COLOR_HIGHLIGHT = 13
Public Const COLOR_HIGHLIGHTTEXT = 14
Public Const COLOR_INACTIVEBORDER = 11
Public Const COLOR_INACTIVECAPTION = 3
Public Const COLOR_INACTIVECAPTIONTEXT = 19
Public Const COLOR_MENU = 4
Public Const COLOR_MENUTEXT = 7
Public Const COLOR_SCROLLBAR = 0
Public Const COLOR_WINDOW = 5
Public Const COLOR_WINDOWFRAME = 6
Public Const COLOR_WINDOWTEXT = 8
' >= Windows XP
Public Const COLOR_MENUHILIGHT = 29
Public Const COLOR_MENUBAR = 30

'''

Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" ( _
    ByVal hWnd As Long, _
    ByVal nIndex As Long) As Long

Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" ( _
    ByVal hWnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const GWL_HINSTANCE = (-6)
Public Const GWL_HWNDPARENT = (-8)
Public Const GWL_ID = (-12)
Public Const GWL_STYLE = (-16)
Public Const GWL_EXSTYLE = (-20)
Public Const GWL_USERDATA = (-21)

Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" ( _
    ByVal lpPrevWndFunc As Long, _
    ByVal hWnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long
    
'''

Declare Function GetCursorPos Lib "user32.dll" ( _
    lpPoint As POINTAPI) As Long

'''

Declare Function GetMenuItemRect Lib "user32.dll" (ByVal hWnd As Long, ByVal hMenu As Long, ByVal uItem As Long, lprcItem As RECT) As Long
Declare Function GetMenuState Lib "user32.dll" (ByVal hMenu As Long, ByVal wID As Long, ByVal wFlags As Long) As Long
Declare Function GetMenuString Lib "user32.dll" Alias "GetMenuStringA" (ByVal hMenu As Long, ByVal wIDItem As Long, ByVal lpString As String, ByVal nMaxCount As Long, ByVal wFlag As Long) As Long
Declare Function GetMenuDefaultItem Lib "user32.dll" (ByVal hMenu As Long, ByVal fByPos As Long, ByVal gmdiFlags As Long) As Long
Declare Function GetMenuContextHelpId Lib "user32.dll" (ByVal hMenu As Long) As Long
Declare Function GetMenuCheckMarkDimensions Lib "user32.dll" () As Long

'''

Declare Function WindowFromPoint Lib "user32.dll" ( _
    ByVal xPoint As Long, _
    ByVal yPoint As Long) As Long


'''

Declare Function GetWindowRect Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    lpRect As RECT) As Long
    
Declare Function GetWindowDC Lib "user32.dll" ( _
    ByVal hWnd As Long) As Long

'''

Declare Function GetSystemMetrics Lib "user32.dll" ( _
    ByVal nIndex As Long) As Long

Public Const SM_CXSCREEN = 0
Public Const SM_CYSCREEN = 1
Public Const SM_CXVSCROLL = 2
Public Const SM_CYHSCROLL = 3
Public Const SM_CYCAPTION = 4
Public Const SM_CXBORDER = 5
Public Const SM_CYBORDER = 6
Public Const SM_CXDLGFRAME = 7
Public Const SM_CYDLGFRAME = 8
Public Const SM_CYVTHUMB = 9
Public Const SM_CXHTHUMB = 10
Public Const SM_CXICON = 11
Public Const SM_CYICON = 12
Public Const SM_CXCURSOR = 13
Public Const SM_CYCURSOR = 14
Public Const SM_CYMENU = 15
Public Const SM_CXFULLSCREEN = 16
Public Const SM_CYFULLSCREEN = 17
Public Const SM_CYKANJIWINDOW = 18
Public Const SM_MOUSEPRESENT = 19
Public Const SM_CYVSCROLL = 20
Public Const SM_CXHSCROLL = 21
Public Const SM_DEBUG = 22
Public Const SM_SWAPBUTTON = 23
Public Const SM_RESERVED1 = 24
Public Const SM_RESERVED2 = 25
Public Const SM_RESERVED3 = 26
Public Const SM_RESERVED4 = 27
Public Const SM_CXMIN = 28
Public Const SM_CYMIN = 29
Public Const SM_CXSIZE = 30
Public Const SM_CYSIZE = 31
Public Const SM_CXFRAME = 32
Public Const SM_CYFRAME = 33
Public Const SM_CXMINTRACK = 34
Public Const SM_CYMINTRACK = 35
Public Const SM_CXDOUBLECLK = 36
Public Const SM_CYDOUBLECLK = 37
Public Const SM_CXICONSPACING = 38
Public Const SM_CYICONSPACING = 39
Public Const SM_MENUDROPALIGNMENT = 40
Public Const SM_PENWINDOWS = 41
Public Const SM_DBCSENABLED = 42
Public Const SM_CMOUSEBUTTONS = 43

Public Const SM_CXFIXEDFRAME = SM_CXDLGFRAME          '* ;win40 name change */
Public Const SM_CYFIXEDFRAME = SM_CYDLGFRAME          '* ;win40 name change */
Public Const SM_CXSIZEFRAME = SM_CXFRAME              '/* ;win40 name change */
Public Const SM_CYSIZEFRAME = SM_CYFRAME              '/* ;win40 name change */

Public Const SM_SECURE = 44
Public Const SM_CXEDGE = 45
Public Const SM_CYEDGE = 46
Public Const SM_CXMINSPACING = 47
Public Const SM_CYMINSPACING = 48
Public Const SM_CXSMICON = 49
Public Const SM_CYSMICON = 50
Public Const SM_CYSMCAPTION = 51
Public Const SM_CXSMSIZE = 52
Public Const SM_CYSMSIZE = 53
Public Const SM_CXMENUSIZE = 54
Public Const SM_CYMENUSIZE = 55
Public Const SM_ARRANGE = 56
Public Const SM_CXMINIMIZED = 57
Public Const SM_CYMINIMIZED = 58
Public Const SM_CXMAXTRACK = 59
Public Const SM_CYMAXTRACK = 60
Public Const SM_CXMAXIMIZED = 61
Public Const SM_CYMAXIMIZED = 62
Public Const SM_NETWORK = 63
Public Const SM_CLEANBOOT = 67
Public Const SM_CXDRAG = 68
Public Const SM_CYDRAG = 69
Public Const SM_SHOWSOUNDS = 70
Public Const SM_CXMENUCHECK = 71
Public Const SM_CYMENUCHECK = 72
Public Const SM_SLOWMACHINE = 73
Public Const SM_MIDEASTENABLED = 74

'''

Declare Function GrayString Lib "user32.dll" Alias "GrayStringA" ( _
    ByVal hDC As Long, _
    ByVal hBrush As Long, _
    ByVal lpOutputFunc As Long, _
    ByVal lpData As String, _
    ByVal nCount As Long, _
    ByVal x As Long, _
    ByVal y As Long, _
    ByVal nWidth As Long, _
    ByVal nHeight As Long) As Long

'''

Declare Function CheckMenuItem Lib "user32.dll" ( _
    ByVal hMenu As Long, _
    ByVal wIDCheckItem As Long, _
    ByVal wCheck As Long) As Long

'''

Declare Function GetDC Lib "user32.dll" ( _
    ByVal hWnd As Long) As Long

'''

'''

Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" ( _
    ByVal hDC As Long, _
    ByVal lpStr As String, _
    ByVal nCount As Long, _
    lpRect As RECT, _
    ByVal wFormat As Long) As Long

Public Const DT_LEFT = &H0
Public Const DT_TOP = &H0
Public Const DT_CENTER = &H1
Public Const DT_RIGHT = &H2
Public Const DT_VCENTER = &H4
Public Const DT_BOTTOM = &H8
Public Const DT_WORDBREAK = &H10
Public Const DT_SINGLELINE = &H20
Public Const DT_EXPANDTABS = &H40
Public Const DT_TABSTOP = &H80
Public Const DT_NOCLIP = &H100
Public Const DT_EXTERNALLEADING = &H200
Public Const DT_CALCRECT = &H400
Public Const DT_NOPREFIX = &H800
Public Const DT_INTERNAL = &H1000
Public Const DT_EDITCONTROL = &H2000
Public Const DT_PATH_ELLIPSIS = &H4000
Public Const DT_END_ELLIPSIS = &H8000
Public Const DT_MODIFYSTRING = &H10000
Public Const DT_RTLREADING = &H20000
Public Const DT_WORD_ELLIPSIS = &H40000

'''

Declare Function DrawEdge Lib "user32.dll" ( _
    ByVal hDC As Long, _
    lpRect As RECT, _
    ByVal edge As Long, _
    ByVal grfFlags As Long) As Long

Public Const BDR_RAISEDOUTER = &H1
Public Const BDR_SUNKENOUTER = &H2
Public Const BDR_RAISEDINNER = &H4
Public Const BDR_SUNKENINNER = &H8

Public Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)
Public Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER)
Public Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER)
Public Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER)

Public Const BF_LEFT = &H1
Public Const BF_TOP = &H2
Public Const BF_RIGHT = &H4
Public Const BF_BOTTOM = &H8
Public Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)
Public Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)
Public Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)
Public Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)
Public Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)
Public Const BF_DIAGONAL = &H10
Public Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)
Public Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT)
Public Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)
Public Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)
Public Const BF_MIDDLE = &H800    ' Fill in the middle.
Public Const BF_SOFT = &H1000     ' Use for softer Menus.
Public Const BF_ADJUST = &H2000   ' Calculate the space left over.
Public Const BF_FLAT = &H4000     ' For flat rather than 3-D borders.
Public Const BF_MONO = &H8000     ' For monochrome borders.

'''

Type NMLOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE - 4) As Byte
End Type

Type NCMETRICS
    cbSize As Long
    iBorderWidth As Long
    iScrollWidth As Long
    iScrollHeight As Long
    iCaptionWidth As Long
    iCaptionHeight As Long
    lfCaptionFont As NMLOGFONT
    iSMCaptionWidth As Long
    iSMCaptionHeight As Long
    lfSMCaptionFont As NMLOGFONT
    iMenuWidth As Long
    iMenuHeight As Long
    lfMenuFont As NMLOGFONT
    lfStatusFont As NMLOGFONT
    lfMessageFont As NMLOGFONT
End Type

Declare Function SystemParametersInfo Lib "user32.dll" Alias "SystemParametersInfoA" ( _
    ByVal uAction As Long, _
    ByVal uParam As Long, _
    lpvParam As Any, _
    ByVal fuWinIni As Long) As Long
    
Public Const SPI_GETNONCLIENTMETRICS = 41
Public Const SPI_SETNONCLIENTMETRICS = 42

'''

Declare Function ClientToScreen Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    lpPoint As POINTAPI) As Long

'''

Declare Function SetTimer Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal nIDEvent As Long, _
    ByVal uElapse As Long, _
    ByVal lpTimerFunc As Long) As Long
    
Declare Function KillTimer Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal nIDEvent As Long) As Long

