VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CommandItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum CommandItemTypeConstants
    cmdTypeDefault = 0
    cmdTypeCheck
    cmdTypeSeperator
    cmdTypeSubCommand
    cmdTypeGroup
End Enum

Public Enum CommandItemCheckConstants
    cmdItemUnchecked = 0
    cmdItemChecked
End Enum

Public Enum CommandItemValueConstants
    cmdItemUnpressed = 0
    cmdItemPressed
End Enum

Public Enum CommandItemAlignmentConstants
    cmdAlignmentLeft = 0
    cmdAlignmentCenter
    cmdAlignmentRight
End Enum

' Public Properties
Private lAlignment As CommandItemAlignmentConstants

Private sCaption As String
Private sCaptionText As String

Private iMnemonic As Integer

Private vImage As Variant

Private sDescription As String

Private lChecked As CommandItemCheckConstants
Private lValue As CommandItemValueConstants
Private bEnabled As Boolean
Private bVisible As Boolean

Private lItemType As CommandItemTypeConstants

Private lKey As Long

Private iKeyCode As Integer
Private iShift As Integer

Private sKeyString As String

Private vTag As Variant

Private lInstanceType As Long
Private lVersionNumber As Long

' Friend Properties
Private oLinkedItems As New LinkedItems
'
' Public Properties
'
Public Property Get Alignment() As CommandItemAlignmentConstants
    Alignment = lAlignment
End Property
Public Property Let Alignment(ByVal NewVal As CommandItemAlignmentConstants)
    lAlignment = NewVal
End Property

Public Property Get Caption() As String
Attribute Caption.VB_UserMemId = 0
    Caption = sCaption
End Property
Public Property Let Caption(NewVal As String)
    Dim iPos As Integer
    sCaption = NewVal
    
    iPos = InStr(1, sCaption, "&")
    If iPos > 0 Then
        If Mid$(sCaption, iPos + 1, 1) <> "&" Then
            iMnemonic = Asc(UCase$(Mid$(sCaption, iPos + 1, 1)))
            sCaptionText = Left$(sCaption, iPos - 1) + Mid$(sCaption, iPos + 1)
        Else
            sCaptionText = sCaption
        End If
    Else
        sCaptionText = sCaption
    End If
End Property

Public Property Get CaptionText() As String
    CaptionText = sCaptionText
End Property

Public Property Get CaptionKey() As String
    If Len(sKeyString) > 0 Then
        CaptionKey = sCaption + " " + sKeyString
    Else
        CaptionKey = sCaption
    End If
End Property

Public Property Get Mnemonic() As Integer
    Mnemonic = iMnemonic
End Property

Public Property Get Image() As Variant
    Image = vImage
End Property
Public Property Let Image(NewVal As Variant)
    vImage = NewVal
End Property

Public Property Get ItemType() As CommandItemTypeConstants
    ItemType = lItemType
End Property
Public Property Let ItemType(ByVal NewVal As CommandItemTypeConstants)
    lItemType = NewVal
End Property

Public Property Get Description() As String
    Description = sDescription
End Property
Public Property Let Description(NewVal As String)
    sDescription = NewVal
End Property

Public Property Get Checked() As CommandItemCheckConstants
    Checked = lChecked
End Property
Public Property Let Checked(ByVal NewVal As CommandItemCheckConstants)
    lChecked = NewVal
End Property

Public Property Get Value() As CommandItemValueConstants
    Value = lValue
End Property
Public Property Let Value(ByVal NewVal As CommandItemValueConstants)
    If NewVal <> lValue Then
        lValue = NewVal
        LinkedItemsValue
    End If
End Property

Public Property Get Enabled() As Boolean
    Enabled = bEnabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    If NewVal <> bEnabled Then
        bEnabled = NewVal
        LinkedItemsEnabled
    End If
End Property

Public Property Get Visible() As Boolean
    Visible = bVisible
End Property
Public Property Let Visible(ByVal NewVal As Boolean)
    If NewVal <> bVisible Then
        bVisible = NewVal
        LinkedItemsVisible
    End If
End Property

Public Property Get Key() As Long
    Key = lKey
End Property
Friend Property Let Key(ByVal NewVal As Long)
    lKey = NewVal
End Property

Public Property Get KeyCode() As Integer
    KeyCode = iKeyCode
End Property
Public Property Let KeyCode(ByVal NewVal As Integer)
    iKeyCode = NewVal
    MakeKeyString
End Property

Public Property Get Shift() As Integer
    Shift = iShift
End Property
Public Property Let Shift(ByVal NewVal As Integer)
    iShift = NewVal
    MakeKeyString
End Property

Public Property Get KeyString() As String
    KeyString = sKeyString
End Property

Public Property Get ToolTipText() As String
    If Len(sDescription) = 0 Then
        ToolTipText = sCaptionText
    Else
        ToolTipText = sDescription
    End If
End Property

Public Property Get Tag() As Variant
    Tag = vTag
End Property
Public Property Let Tag(NewVal As Variant)
    vTag = NewVal
End Property
Public Property Set Tag(ByVal NewVal As Variant)
    Set vTag = NewVal
End Property

Public Property Get InstanceType() As Long
    InstanceType = lInstanceType
End Property
Public Property Let InstanceType(ByVal NewVal As Long)
    lInstanceType = NewVal
End Property

Public Property Get VersionNumber() As Long
    VersionNumber = lVersionNumber
End Property
Public Property Let VersionNumber(ByVal NewVal As Long)
    lVersionNumber = NewVal
End Property
'
' Friend Properties
'
Friend Property Get LinkedItems() As LinkedItems
    Set LinkedItems = oLinkedItems
End Property
'
' Private Sub/Function
'
Private Sub Class_Initialize()
    lAlignment = cmdAlignmentLeft
    
    sCaption = ""
    sCaptionText = ""
    
    iMnemonic = 0
    
    vImage = Empty
    
    sDescription = ""
    
    lChecked = cmdItemUnchecked
    lValue = cmdItemUnpressed
    bEnabled = True
    bVisible = True
    
    lItemType = cmdTypeDefault
    
    lKey = 0
    
    iKeyCode = 0
    iShift = 0
    
    sKeyString = ""
    
    lInstanceType = 0
    lVersionNumber = 0
End Sub

Private Sub MakeKeyString()
    Dim s As String
    If (Shift And vbShiftMask) = vbShiftMask Then s = s + "Shift+"
    If (Shift And vbAltMask) = vbAltMask Then s = s + "Alt+"
    If (Shift And vbCtrlMask) = vbCtrlMask Then s = s + "Ctrl+"
    
    If (iKeyCode >= 48 And iKeyCode <= 57) Or _
       (iKeyCode >= 65 And iKeyCode <= 90) Then
       
       s = s + Chr$(iKeyCode)
    
    ElseIf iKeyCode >= 112 And iKeyCode <= 127 Then
        s = s + "F" + CStr(iKeyCode - 111)
    Else
        s = s + "[" + CStr(KeyCode) + "]"
    End If
    
    sKeyString = s
End Sub

Private Sub LinkedItemsEnabled()
    Dim oLinkedItem As LinkedItem
    Dim oMenuBarItem As MenuBarItem
    Dim oOutMenuItem As OutMenuItem
    Dim oPopupItem As PopupItem
    Dim oToolbarItem As ToolbarItem
    
    If oLinkedItems.Count = 0 Then Exit Sub
        
    For Each oLinkedItem In oLinkedItems
        Select Case oLinkedItem.ItemClass
            Case cmdItemClassMenuBar:
                Set oMenuBarItem = oLinkedItem.Item
            Case cmdItemClassPopup:
                Set oPopupItem = oLinkedItem.Item
            Case cmdItemClassToolBar:
                Set oToolbarItem = oLinkedItem.Item
                oToolbarItem.Enabled
            Case cmdItemClassOutMenu:
                Set oOutMenuItem = oLinkedItem.Item
                oOutMenuItem.Enabled
        End Select
    Next
End Sub

Private Sub LinkedItemsVisible()
    Dim oLinkedItem As LinkedItem
    Dim oMenuBarItem As MenuBarItem
    Dim oOutMenuItem As OutMenuItem
    Dim oPopupItem As PopupItem
    Dim oToolbarItem As ToolbarItem
    
    If oLinkedItems.Count = 0 Then Exit Sub
        
    For Each oLinkedItem In oLinkedItems
        Select Case oLinkedItem.ItemClass
            Case cmdItemClassMenuBar:
                Set oMenuBarItem = oLinkedItem.Item
                oMenuBarItem.Visible
            Case cmdItemClassPopup:
                Set oPopupItem = oLinkedItem.Item
                oPopupItem.Visible
            Case cmdItemClassToolBar:
                Set oToolbarItem = oLinkedItem.Item
                oToolbarItem.Visible
            Case cmdItemClassOutMenu:
                Set oOutMenuItem = oLinkedItem.Item
                oOutMenuItem.Visible
        End Select
    Next
End Sub

Private Sub LinkedItemsValue()
    Dim oLinkedItem As LinkedItem
    Dim oMenuBarItem As MenuBarItem
    Dim oOutMenuItem As OutMenuItem
    Dim oPopupItem As PopupItem
    Dim oToolbarItem As ToolbarItem
    
    If oLinkedItems.Count = 0 Then Exit Sub
        
    For Each oLinkedItem In oLinkedItems
        Select Case oLinkedItem.ItemClass
            Case cmdItemClassMenuBar:
                Set oMenuBarItem = oLinkedItem.Item
                oMenuBarItem.Visible
            Case cmdItemClassPopup:
                Set oPopupItem = oLinkedItem.Item
                oPopupItem.Visible
            Case cmdItemClassToolBar:
                Set oToolbarItem = oLinkedItem.Item
                oToolbarItem.Visible
            Case cmdItemClassOutMenu:
                Set oOutMenuItem = oLinkedItem.Item
                oOutMenuItem.Visible
        End Select
    Next
End Sub

Public Sub CleanUp()
    oLinkedItems.CleanUp
    Set oLinkedItems = Nothing
End Sub

#If DBG Then

Private Sub T(ByVal sText As String)
    If Not oTrace Is Nothing Then
        oTrace.Text "CommandItem: " + sText
    End If
End Sub

#End If

