VERSION 5.00
Begin VB.UserControl CommandList 
   BorderStyle     =   1  'Fixed Single
   CanGetFocus     =   0   'False
   ClientHeight    =   555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   660
   InvisibleAtRuntime=   -1  'True
   Picture         =   "CommandList.ctx":0000
   ScaleHeight     =   555
   ScaleWidth      =   660
   ToolboxBitmap   =   "CommandList.ctx":0532
End
Attribute VB_Name = "CommandList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum CommandItemClassConstants
    cmdItemClassMenuBar
    cmdItemClassPopup
    cmdItemClassToolBar
    cmdItemClassOutMenu
End Enum

Private oCommandItems As CommandItems
Private oImageList As Object
'
' Public
'
' Events
'
Public Event ItemClick(ByVal Item As CommandItem)
Public Event ItemSelect(ByVal Item As CommandItem)
'
' Properties
'
Public Property Get CommandItems() As CommandItems
    Set CommandItems = oCommandItems
End Property

Public Property Get ImageList() As Object
    Set ImageList = oImageList
End Property
Public Property Set ImageList(ByVal NewVal As Object)
    Set oImageList = NewVal
End Property
'
' Methods
'
Public Function KeyDown(KeyCode As Integer, Shift As Integer) As Boolean
    Dim oItem As CommandItem
    
    KeyDown = False
    
    For Each oItem In oCommandItems
        If oItem.KeyCode = KeyCode And oItem.Shift = Shift Then
            If oItem.Enabled Then
                RaiseEvent ItemClick(oItem)
                KeyDown = True
            End If
            Exit For
        End If
    Next
End Function

Public Sub EventItemSelect(Item As CommandItem)
Attribute EventItemSelect.VB_MemberFlags = "40"
    If Item.Enabled Then RaiseEvent ItemSelect(Item)
End Sub

Public Sub EventItemClick(Item As CommandItem)
Attribute EventItemClick.VB_MemberFlags = "40"
    If Item.Enabled Then RaiseEvent ItemClick(Item)
End Sub

Public Sub CleanUp()
    oCommandItems.CleanUp
    Set oCommandItems = Nothing
    Set oImageList = Nothing
End Sub
'
' Private
'
' Events UserControl
'
Private Sub UserControl_Initialize()
    Set oCommandItems = New CommandItems
    Set oImageList = Nothing
End Sub

Private Sub UserControl_Resize()
    SIZE ScaleX(20, vbPixels, vbTwips), ScaleY(20, vbPixels, vbTwips)
End Sub

#If DBG Then

Public Property Get Trace() As Object
    Set Trace = oTrace
End Property

Public Property Set Trace(NewVal As Object)
    Set oTrace = NewVal
End Property

#End If

