VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MenuBarItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection
Private oMenuBar As MenuBar
'
' Properties
'
Friend Property Set MenuBar(NewVal As Object)
    Set oMenuBar = NewVal
End Property

Public Property Get Count() As Long
    Count = oItems.Count
End Property

Public Property Get Item(Index As Variant) As MenuBarItem
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property
'
' Methods
'
Public Function Add(ByVal CommandKey As Long) As MenuBarItem
    Dim oItem As New MenuBarItem
    
    oMenuBar.Hide
    
    With oItem
        Set .CommandItem = oMenuBar.CommandList.CommandItems.Item(CommandKey)
        Set .MenuBar = oMenuBar
    End With
    
    oItems.Add oItem

    Set Add = oItem
    
    oItem.CommandItem.LinkedItems.Add oItem, cmdItemClassMenuBar

    oMenuBar.Show oMenuBar.MenuHWnd
End Function

Friend Function AddMenuBarItem(MenuBarItem As MenuBarItem, _
                               Optional ByVal After As Integer) As Integer
    Dim iPos As Integer
    
    If After = 0 Then
        oItems.Add MenuBarItem
        iPos = oItems.Count
    Else
        If After < 1 Then After = 1
        If After > oItems.Count Then After = oItems.Count
    
        oItems.Add MenuBarItem, , , After
        iPos = After + 1
    End If
    
    AddMenuBarItem = iPos
End Function

Friend Sub RemoveMenuBarItem(Index As Integer)
    oItems.Remove Index
End Sub

'''

Public Sub CleanUp()
    Dim i As Integer
    Dim iCount As Integer
    
    iCount = oItems.Count
    For i = 1 To iCount
        Item(i).CleanUp
    Next
    
    For i = 1 To iCount
        oItems.Remove 1
    Next
    
    Set oItems = Nothing
    Set oMenuBar = Nothing
End Sub

#If DBG Then

Private Sub T(ByVal sText As String)
    If Not oTrace Is Nothing Then
        oTrace.Text "MenuBarItems: " + sText
    End If
End Sub

#End If
    


