VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NonClientMetrics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private tNCM As NCMETRICS
Private tLF As LOGFONT
Private hMenuFont As Long

Property Get MenuFont() As Long
    MenuFont = hMenuFont
End Property

Property Get CaptionHeight() As Long
    CaptionHeight = tNCM.iCaptionHeight
End Property
Property Get CaptionWidth() As Long
    CaptionWidth = tNCM.iCaptionWidth
End Property
Property Get MenuHeight() As Long
    MenuHeight = tNCM.iMenuHeight
End Property
Property Get MenuWidth() As Long
    MenuWidth = tNCM.iMenuWidth
End Property
Property Get ScrollHeight() As Long
    ScrollHeight = tNCM.iScrollHeight
End Property
Property Get ScrollWidth() As Long
    ScrollWidth = tNCM.iScrollWidth
End Property
Property Get SMCaptionHeight() As Long
    SMCaptionHeight = tNCM.iSMCaptionHeight
End Property
Property Get SMCaptionWIdth() As Long
    SMCaptionWIdth = tNCM.iSMCaptionWidth
End Property
Property Get BorderWidth() As Long
    BorderWidth = tNCM.iBorderWidth
End Property

'''

Public Sub Refresh()
    DeleteMenuFont
    If GetNonClientMetrics() Then
        CreateMenuFont
    End If
End Sub

'''

Private Sub Class_Initialize()
    hMenuFont = 0
    If GetNonClientMetrics() Then
        CreateMenuFont
    End If
End Sub

Private Sub Class_Terminate()
    DeleteMenuFont
End Sub

'''

Private Function GetNonClientMetrics() As Boolean
    Dim lRC As Long
    
    tNCM.cbSize = 340
    
    lRC = SystemParametersInfo(SPI_GETNONCLIENTMETRICS, 0, tNCM, 0)
    
    GetNonClientMetrics = (lRC <> 0)
End Function

Private Function CreateMenuFont() As Boolean
    CopyMem tLF, tNCM.lfMenuFont, LenB(tNCM.lfMenuFont)
    hMenuFont = CreateFontIndirect(tLF)
End Function

Public Function DeleteMenuFont()
    If hMenuFont <> 0 Then
        DeleteObject hMenuFont
        hMenuFont = 0
    End If
End Function


