VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "OutMenuItem"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

' Public Properties
Private oCommandItem As CommandItem
Private oOutMenuItems As OutMenuItems
Private oParent As OutMenuItem
Private lIndex As Long

' Friend Properties
Private lID As Long

Private iLeft As Integer
Private iTop As Integer
Private iWidth As Integer
Private iHeight As Integer

Private bTopItem As Boolean

Private bSelected As Boolean

Private oOutMenu As OutMenu

' Private
Private r As RECT
Private pic As Object
'
' Public Properties
'
Public Property Get CommandItem() As CommandItem
    Set CommandItem = oCommandItem
End Property
Public Property Set CommandItem(NewVal As CommandItem)
    Set oCommandItem = NewVal
End Property

Public Property Get OutMenuItems() As OutMenuItems
    If oOutMenuItems Is Nothing Then
        Set oOutMenuItems = New OutMenuItems
        Set oOutMenuItems.OutMenu = oOutMenu
        Set oOutMenuItems.Parent = Me
        oOutMenuItems.TopItems = False
    End If
    Set OutMenuItems = oOutMenuItems
End Property

Public Property Get Parent() As OutMenuItem
    Set Parent = oParent
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
'
' Friend Properties
'
Friend Property Get ID() As Long
    ID = lID
End Property
Friend Property Let ID(ByVal NewVal As Long)
    lID = NewVal
End Property

Friend Property Get Left() As Integer
    Left = iLeft
End Property
Friend Property Let Left(ByVal NewVal As Integer)
    iLeft = NewVal
End Property

Friend Property Get Top() As Integer
    Top = iTop
End Property
Friend Property Let Top(ByVal NewVal As Integer)
    iTop = NewVal
End Property

Friend Property Get Width() As Integer
    Width = iWidth
End Property
Friend Property Let Width(ByVal NewVal As Integer)
    iWidth = NewVal
End Property

Friend Property Get Height() As Integer
    Height = iHeight
End Property
Friend Property Let Height(ByVal NewVal As Integer)
    iHeight = NewVal
End Property

Friend Property Get Right() As Long
    Right = Left + Width - 1
End Property

Friend Property Get Bottom() As Long
    Bottom = Top + Height - 1
End Property

Friend Property Get Selected() As Boolean
    Selected = bSelected
End Property
Friend Property Let Selected(ByVal NewVal As Boolean)
    bSelected = NewVal
    
    If bSelected = True And Not oCommandItem.Visible Then oCommandItem.Visible = True
End Property

Friend Property Get TopItem() As Boolean
    TopItem = bTopItem
End Property
Friend Property Let TopItem(ByVal NewVal As Boolean)
    bTopItem = NewVal
End Property

Friend Property Get OutMenu() As OutMenu
    Set OutMenu = oOutMenu
End Property
Friend Property Set OutMenu(NewVal As OutMenu)
    Set oOutMenu = NewVal
End Property

Friend Property Set Parent(NewVal As OutMenuItem)
    Set oParent = NewVal
End Property

Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property
'
' Friend Sub/Function
'
Friend Sub DrawButton(ByVal bPressed As Boolean)
    On Error Resume Next

    Set pic = oOutMenu.ButtonsPic
    
    r.Left = Left
    r.Top = Top
    r.Right = Right
    r.Bottom = Bottom
    
    pic.Line (r.Left, r.Top)-(r.Right - 1, r.Bottom - 1), vbButtonFace, BF
    
    If bPressed Then
        DrawEdge pic.hDC, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
    Else
        DrawEdge pic.hDC, r, EDGE_RAISED, BF_RECT + BF_SOFT
    End If
    
    With r
        .Left = .Left + 2
        .Top = .Top + 2
        .Right = .Right - 2
        .Bottom = .Bottom - 2
    End With
    
    If oCommandItem.Enabled Then
        pic.ForeColor = vbMenuText
        DrawText pic.hDC, oCommandItem.CaptionText, Len(oCommandItem.CaptionText), r, DT_CENTER + DT_VCENTER + DT_SINGLELINE + DT_WORD_ELLIPSIS + DT_NOPREFIX
    Else
        r.Left = r.Left + 1
        r.Top = r.Top + 1
        r.Right = r.Right + 1
        r.Bottom = r.Bottom + 1
        pic.ForeColor = vb3DHighlight
        DrawText pic.hDC, oCommandItem.CaptionText, Len(oCommandItem.CaptionText), r, DT_CENTER + DT_VCENTER + DT_SINGLELINE + DT_WORD_ELLIPSIS + DT_NOPREFIX
        r.Left = r.Left - 1
        r.Top = r.Top - 1
        r.Right = r.Right - 1
        r.Bottom = r.Bottom - 1
        pic.ForeColor = vb3DShadow
        DrawText pic.hDC, oCommandItem.CaptionText, Len(oCommandItem.CaptionText), r, DT_CENTER + DT_VCENTER + DT_SINGLELINE + DT_WORD_ELLIPSIS + DT_NOPREFIX
    End If
End Sub

Friend Sub DrawItem(ByVal bSelected As Boolean)
    On Error Resume Next
    
    r.Left = Left
    r.Top = Top
    r.Right = Right
    r.Bottom = Bottom
    
    Select Case oCommandItem.ItemType
        Case cmdTypeDefault, cmdTypeGroup:  DrawItemLabel bSelected
        Case cmdTypeSeperator:              DrawItemSeperator
    End Select
End Sub

Friend Sub Enabled()
    If bTopItem Then
        DrawButton False
    Else
        If Not oOutMenu.ButtonAct Is Nothing Then
            If oParent.Index = oOutMenu.ButtonAct.Index Then
                DrawItem False
            End If
        End If
    End If
End Sub

Friend Sub Visible()
    oOutMenu.Draw
End Sub

'
' Private Sub/Function
'
Private Sub Class_Initialize()
    Set oCommandItem = Nothing
    Set oOutMenuItems = Nothing
    lID = 0
    bTopItem = False
End Sub
'
' Draw
'
Private Sub DrawItemLabel(ByVal bSelected As Boolean)
    Dim iPicWidth As Integer
    Dim iPicHeight As Integer
    Dim iToScale As Integer
    Dim bPicture As Boolean
    Dim x As Long
    Dim y As Long
    Dim iDrawMode As Integer
    
    On Error Resume Next
    
    Set pic = oOutMenu.ItemsPic
    
    iPicWidth = 0
    iPicHeight = 0
    bPicture = False
    
    If Not oOutMenu.CommandList.ImageList Is Nothing Then
        With oOutMenu.CommandList.ImageList
            iPicWidth = .ImageWidth
            iPicHeight = .ImageHeight
            If Not IsMissing(oCommandItem.Image) Then
                iToScale = .Parent.ScaleMode
                bPicture = True
            End If
        End With
    End If
    
    x = r.Left + 2
    y = r.Top + ((r.Bottom - r.Top) - iPicHeight) \ 2
        
    If x < r.Left Then x = r.Left
    If y < r.Top Then y = r.Top
    
    If bPicture Then
        If oCommandItem.Enabled Then
            If oOutMenu.WinXP Then
                If bSelected Then
                    pic.Line (r.Left, r.Top)-(r.Left + iPicWidth + 5, r.Bottom), vbHighlight, BF
                Else
                    pic.Line (r.Left, r.Top)-(r.Left + iPicWidth + 5, r.Bottom), vbMenuBar, BF
                End If
            Else
                pic.Line (r.Left, r.Top)-(r.Left + iPicWidth + 4, r.Bottom), vbMenuBar, BF
                If bSelected Then
                    pic.Line (r.Left, r.Top)-(r.Left + iPicWidth + 4, r.Top), vb3DHighlight
                    pic.Line (r.Left, r.Top)-(r.Left, r.Bottom), vb3DHighlight
                    pic.Line (r.Left, r.Bottom)-(r.Left + iPicWidth + 4, r.Bottom), vb3DShadow
                    pic.Line (r.Left + iPicWidth + 4, r.Top)-(r.Left + iPicWidth + 4, r.Bottom + 1), vb3DShadow
                End If
            End If
        End If
        
        If oCommandItem.Enabled Then
            oOutMenu.CommandList.ImageList.ListImages.Item(oCommandItem.Image).Draw pic.hDC, _
                pic.ScaleX(x, vbPixels, iToScale), _
                pic.ScaleY(y, vbPixels, iToScale), _
                imlTransparent
        Else
            DisableListImage.DisableListImage oOutMenu.CommandList.ImageList, oCommandItem.Image, pic.hDC, x, y
        End If
    End If
    
    If Not oOutMenu.CommandList.ImageList Is Nothing Then r.Left = r.Left + iPicWidth + 6
    
    If oCommandItem.Enabled Then
        If bSelected Then
            pic.ForeColor = vbHighlightText
            pic.Line (r.Left, r.Top)-(r.Right, r.Bottom), vbHighlight, BF
        Else
            pic.ForeColor = vbMenuText
            pic.Line (r.Left, r.Top)-(r.Right, r.Bottom), vbMenuBar, BF
        End If
        r.Left = r.Left + 2
        DrawText pic.hDC, oCommandItem.CaptionText, Len(oCommandItem.CaptionText), r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_WORD_ELLIPSIS + DT_NOPREFIX
    Else
        pic.Line (r.Left, r.Top)-(r.Right, r.Bottom), vbMenuBar, BF
        r.Left = r.Left + 2
        
        r.Left = r.Left + 1
        r.Top = r.Top + 1
        r.Right = r.Right + 1
        r.Bottom = r.Bottom + 1
        pic.ForeColor = vb3DHighlight
        DrawText pic.hDC, oCommandItem.CaptionText, Len(oCommandItem.CaptionText), r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_WORD_ELLIPSIS + DT_NOPREFIX
        r.Left = r.Left - 1
        r.Top = r.Top - 1
        r.Right = r.Right - 1
        r.Bottom = r.Bottom - 1
        pic.ForeColor = vb3DShadow
        DrawText pic.hDC, oCommandItem.CaptionText, Len(oCommandItem.CaptionText), r, DT_LEFT + DT_VCENTER + DT_SINGLELINE + DT_WORD_ELLIPSIS + DT_NOPREFIX
    End If
    
    r.Left = r.Left - 2
End Sub

Private Sub DrawItemSeperator()
    Dim y As Integer
    
    On Error Resume Next
    
    y = r.Top + Height \ 2
    
    With oOutMenu
        .ItemsPic.Line (r.Left, y - 1)-(r.Right, y - 1), vb3DShadow
        .ItemsPic.Line (r.Left, y)-(r.Right, y), vb3DHighlight
    End With
End Sub

'''

Public Sub CleanUp()
    If Not oOutMenuItems Is Nothing Then
        oOutMenuItems.CleanUp
        Set oOutMenuItems = Nothing
    End If
    Set oParent = Nothing
    Set oCommandItem = Nothing
End Sub

