VERSION 5.00
Begin VB.UserControl Popup 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   CanGetFocus     =   0   'False
   ClientHeight    =   420
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   525
   InvisibleAtRuntime=   -1  'True
   Picture         =   "Popup.ctx":0000
   ScaleHeight     =   28
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   35
   ToolboxBitmap   =   "Popup.ctx":0532
End
Attribute VB_Name = "Popup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private bWinXP As Boolean

Private oCommandList As CommandList

Private oImageList As Object

Private vImageChecked As Variant
Private vImageUnChecked As Variant

Private oPopupMenus As PopupMenus
Private oPopupItems As PopupItems
Private oMenuItems As MenuItems

Private hPopup As Long

Private mi As MEASUREITEMSTRUCT
Private di As DRAWITEMSTRUCT
Private mii As MENUITEMINFO

Private wFlags As Integer
Private wID As Integer
Private wUser As Integer
Private hMenu As Long
Private hDC As Long

Private oNCM As New NonClientMetrics
Private hFontOld As Long

Private hBrushHighlight As Long
Private hBrushMenuBar As Long
Private hBrushMenu As Long
Private hPenHighlight As Long
Private hPenMenuBar As Long
Private hPenMenu As Long
Private hPenBtnHighlight As Long
Private hPenBtnShadow As Long
Private hPenBtnFace As Long
Private lColorHighlightText As Long
Private lColorMenuText As Long
Private lColorGrayText As Long

Private hBrushOld As Long
Private hPenOld As Long
Private lTextColorOld As Long

Private oItem As PopupItem

Private lMenuSizeX As Long
Private lMenuSizeY As Long

Private vImage As Variant
Private lImageWidth As Long
Private lImageHeight As Long

Private r As RECT

Private lFormat As Long

Private lPosX As Long
Private lPosY As Long

Private tPoint As POINTAPI

Private bMenuLoop As Boolean

Private i As Integer

Private lRC As Long
'
' Public
'
' Events
'
Public Event ItemClick(ByVal Item As PopupItem)
Public Event ItemSelect(ByVal Item As PopupItem)
'
' Properties
'
Public Property Get CommandList() As CommandList
    Set CommandList = oCommandList
End Property
Public Property Set CommandList(NewVal As CommandList)
    Set oCommandList = NewVal
    Set oImageList = oCommandList.ImageList
End Property

Public Property Get ImageList() As Object
    Set ImageList = oImageList
End Property

Public Property Get ImageChecked() As Variant
    ImageChecked = vImageChecked
End Property
Public Property Let ImageChecked(NewVal As Variant)
    vImageChecked = NewVal
End Property

Public Property Get ImageUnChecked() As Variant
    ImageUnChecked = vImageUnChecked
End Property
Public Property Let ImageUnChecked(NewVal As Variant)
    vImageUnChecked = NewVal
End Property

Public Property Get PopupMenus() As PopupMenus
    Set PopupMenus = oPopupMenus
End Property

Public Property Get MenuItems() As MenuItems
    Set MenuItems = oMenuItems
End Property
'
' Private
'
' Events UserControl
'
Private Sub UserControl_Initialize()
    Dim hDC As Long
    
    bWinXP = IsWinXP()
    
    Set oCommandList = Nothing
    
    vImageChecked = Empty
    vImageUnChecked = Empty
    
    Set oPopupMenus = New PopupMenus
    Set oPopupMenus.Popup = Me
    
    Set oMenuItems = New MenuItems
    
    mii.fMask = MIIM_DATA
    mii.cbSize = Len(mii)
End Sub

Private Sub UserControl_Resize()
    SIZE ScaleX(20, vbPixels, vbTwips), ScaleY(20, vbPixels, vbTwips)
End Sub
'
' Sub/Functions
'
Public Sub Show(Index As Variant)
    Dim p As POINTAPI
    If hPopup = 0 Then
        GetCursorPos p
        ShowAt Index, p.x, p.y
    End If
End Sub

Public Sub ShowAt(Index As Variant, x As Long, y As Long, Optional hWndClient As Long = 0)
    Dim bEvents As Boolean
    Dim p As POINTAPI
    
    If hPopup = 0 Then
        
        oNCM.Refresh
        
        hFontOld = SelectObject(UserControl.hDC, oNCM.MenuFont)
        
        lMenuSizeX = GetSystemMetrics(SM_CXMENUSIZE) + 2
        lMenuSizeY = GetSystemMetrics(SM_CYMENUSIZE)
        
        If bWinXP Then
            hBrushHighlight = CreateSolidBrush(GetSysColor(COLOR_MENUHILIGHT))
            hBrushMenuBar = CreateSolidBrush(GetSysColor(COLOR_MENUBAR))
            hBrushMenu = CreateSolidBrush(GetSysColor(COLOR_MENU))
            hPenHighlight = CreatePen(0, 1, GetSysColor(COLOR_MENUHILIGHT))
            hPenMenuBar = CreatePen(0, 1, GetSysColor(COLOR_MENUBAR))
            hPenMenu = CreatePen(0, 1, GetSysColor(COLOR_MENU))
        Else
            hBrushHighlight = CreateSolidBrush(GetSysColor(COLOR_HIGHLIGHT))
            hBrushMenuBar = CreateSolidBrush(GetSysColor(COLOR_MENU))
            hBrushMenu = CreateSolidBrush(GetSysColor(COLOR_MENU))
            hPenHighlight = CreatePen(0, 1, GetSysColor(COLOR_HIGHLIGHT))
            hPenMenuBar = CreatePen(0, 1, GetSysColor(COLOR_MENU))
            hPenMenu = CreatePen(0, 1, GetSysColor(COLOR_MENU))
        End If
        
        hPenBtnHighlight = CreatePen(0, 1, GetSysColor(COLOR_BTNHIGHLIGHT))
        hPenBtnShadow = CreatePen(0, 1, GetSysColor(COLOR_BTNSHADOW))
        hPenBtnFace = CreatePen(0, 1, GetSysColor(COLOR_BTNFACE))
        
        lColorHighlightText = GetSysColor(COLOR_HIGHLIGHTTEXT)
        lColorMenuText = GetSysColor(COLOR_MENUTEXT)
        lColorGrayText = GetSysColor(COLOR_GRAYTEXT)
        
        Set oPopupItems = oPopupMenus.Item(Index).PopupItems
        
        hPopup = Create()
        
        If hPopup <> 0 Then
    
            bEvents = False
            
            SubClassPopup.Hook Me, UserControl.hWnd
            
            If hWndClient <> 0 Then
                p.x = x
                p.y = y
                ClientToScreen hWndClient, p
            Else
                p.x = x
                p.y = y
            End If
                
            wID = TrackPopupMenu(hPopup, TPM_RETURNCMD, p.x, p.y, 0, UserControl.hWnd, ByVal 0&)
        
            If wID > 0 Then
                Set oItem = oMenuItems.Item(wID)
                If oItem.CommandItem.ItemType = cmdTypeCheck Then
                    If oItem.CommandItem.Checked = cmdItemChecked Then
                        oItem.CommandItem.Checked = cmdItemUnchecked
                    Else
                        oItem.CommandItem.Checked = cmdItemChecked
                    End If
                End If
                bEvents = True
            End If
            
            hPopup = Destroy(hPopup)
        End If
        
        SelectObject UserControl.hDC, hFontOld
    
        DeleteObject hBrushHighlight
        DeleteObject hBrushMenuBar
        DeleteObject hBrushMenu
        DeleteObject hPenHighlight
        DeleteObject hPenMenuBar
        DeleteObject hPenMenu
        DeleteObject hPenBtnHighlight
        DeleteObject hPenBtnShadow
        DeleteObject hPenBtnFace

        If bEvents Then
            RaiseEvent ItemClick(oItem)
            oCommandList.EventItemClick oItem.CommandItem
        End If
    End If
End Sub

Private Function Create() As Long
    #If DBG Then
        T ">>> Create"
    #End If
    
    Dim hMenu As Long
    Dim oItem As PopupItem
    Dim lItem As Long
    
    hMenu = CreatePopupMenu()

    #If DBG Then
        T "hMenu = 0x" + Hex$(hMenu)
    #End If

    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oPopupItems
            With oItem
                .MenuHandle = hMenu
                .Pos = lItem
                Set .MenuItems = oMenuItems
            End With
            
            oMenuItems.AddPopupItem oItem
        
            oItem.Insert hMenu, lItem, True
            lItem = lItem + 1
        Next
    End If
    
    Create = hMenu
    
    #If DBG Then
        T "<<< Create"
    #End If
End Function

Private Function Destroy(ByVal hMenu As Long) As Long
    #If DBG Then
        T ">>> Destroy hMenu = 0x" & Hex(hMenu)
    #End If
    
    Dim oItem As PopupItem
    Dim lItem As Long

    If hMenu <> 0 Then
        lItem = 0
        For Each oItem In oPopupItems
            oItem.Delete hMenu, oItem.ID, False
            lItem = lItem + 1
            
            oMenuItems.RemovePopupItem oItem
            
            With oItem
                .MenuHandle = 0
                .Pos = 0
                .ID = 0
            End With
        Next
        
        DestroyMenu hMenu
        
        hMenu = 0
    End If
    
    Destroy = hMenu
    
    #If DBG Then
        T "<<< Destroy"
    #End If
End Function

Public Sub CleanUp()
    oPopupMenus.CleanUp
    Set oPopupMenus = Nothing
    Set oPopupItems = Nothing
    Set oMenuItems = Nothing
    Set oItem = Nothing
    Set oCommandList = Nothing
    Set oImageList = Nothing
End Sub
'
' SubClass MsgProc
'
Public Sub MsgProc(ByVal hWnd As Long, _
                   ByVal wMsg As Long, _
                   ByVal wParam As Long, _
                   ByVal lParam As Long, _
                   lReturn As Long, _
                   bResult As Boolean)
Attribute MsgProc.VB_MemberFlags = "40"
    
    Select Case wMsg
        Case WM_MEASUREITEM:
            If wParam = 0 Then
                CopyMem mi, ByVal lParam, Len(mi)
                If mi.CtlType = ODT_MENU Then
                    If mi.ItemID > 0 Then
                        Set oItem = oMenuItems.Item(mi.ItemID)
                        
                        hDC = GetDC(hWnd)
                        
                        lImageWidth = 0
                                                    
                        r.Left = 0
                        r.Top = 0
                        
                        DrawText hDC, oItem.CommandItem.CaptionKey, Len(oItem.CommandItem.CaptionKey), r, DT_SINGLELINE + DT_CALCRECT
                        If Not oImageList Is Nothing Then lImageWidth = oImageList.ImageWidth
                        
                        mi.ItemWidth = lImageWidth + r.Right + 12
                        mi.ItemHeight = lMenuSizeY + 2
                        
                        CopyMem ByVal lParam, mi, Len(mi)
                        bResult = False
                    End If
                End If
            End If
            
        Case WM_DRAWITEM:
            If wParam = 0 Then
                CopyMem di, ByVal lParam, LenB(di)
                
                If di.CtlType = ODT_MENU And _
                   di.ItemID > 0 And _
                   di.ItemAction < 8 _
                Then
                    
                    With di
                        Set oItem = oMenuItems.Item(.ItemID)
                        
                        If (.ItemState And ODS_SELECTED) = ODS_SELECTED And oItem.CommandItem.Enabled Then
                            hBrushOld = SelectObject(.hDC, hBrushHighlight)
                            hPenOld = SelectObject(.hDC, hPenHighlight)
                        Else
                            hBrushOld = SelectObject(.hDC, hBrushMenu)
                            hPenOld = SelectObject(.hDC, hPenMenu)
                        End If

                        SetBkMode .hDC, TRANSPARENT
                    
                        r.Left = .rcItem.Left
                        r.Top = .rcItem.Top
                        r.Right = .rcItem.Right
                        r.Bottom = .rcItem.Bottom
                    
                        If Not oImageList Is Nothing Then
                            If bWinXP Then
                                lRC = Rectangle(.hDC, r.Left, r.Top, r.Right, r.Bottom)
                            End If
                            
                            If oImageList.ListImages.Count > 0 Then
                                r.Right = .rcItem.Left + lMenuSizeX + 1
    
                                vImage = Empty
    
                                If oItem.CommandItem.ItemType = cmdTypeCheck Then
                                    If oItem.CommandItem.Checked = cmdItemChecked Then
                                        vImage = vImageChecked
                                    Else
                                        vImage = vImageUnChecked
                                    End If
                                Else
                                    vImage = oItem.CommandItem.Image
                                End If
                                If Not IsMissing(vImage) Then
                                    lPosY = (lMenuSizeY - oImageList.ImageHeight) \ 2 + 1
                                    If lPosY < 0 Then lPosY = 0
                                    lPosX = lPosY + 1
                                    lPosY = .rcItem.Top + lPosY
                                    lPosX = .rcItem.Left + lPosX
    
                                    If oItem.CommandItem.Enabled Then
'                                        ImageList_Draw oImageList.hImageList, _
'                                            oImageList.ListImages(vImage).Index - 1, _
'                                            .hDC, lPosX, lPosY, ILD_TRANSPARENT
                                        oImageList.ListImages.Item(vImage).Draw .hDC, _
                                            lPosX, _
                                            lPosY, _
                                            imlTransparent
                                    Else
                                        DisableListImage.DisableListImage oImageList, vImage, .hDC, lPosX, lPosY
                                    End If
                                    
                                    If Not bWinXP Then
                                        If oItem.CommandItem.ItemType <> cmdTypeCheck Then
                                            If (.ItemState And ODS_SELECTED) = ODS_SELECTED And oItem.CommandItem.Enabled Then
                                                ThreedBox .hDC, .rcItem.Left, .rcItem.Top, .rcItem.Left + lMenuSizeX, .rcItem.Bottom - 1
                                            Else
                                                Rec .hDC, .rcItem.Left, .rcItem.Top, .rcItem.Left + lMenuSizeX, .rcItem.Bottom - 1
                                            End If
                                        End If
                                    End If
                                End If
                                
                                r.Left = r.Right + 1
                                r.Right = .rcItem.Right
                            
                            End If
                            
                            If Not bWinXP Then
                                lRC = Rectangle(.hDC, r.Left, r.Top, r.Right, r.Bottom)
                            End If
                            
                            r.Right = r.Right - 5
                            
                            If oItem.CommandItem.Enabled Then
                                If (.ItemState And ODS_SELECTED) = ODS_SELECTED Then
                                    lTextColorOld = SetTextColor(.hDC, lColorHighlightText)
                                Else
                                    lTextColorOld = SetTextColor(.hDC, lColorMenuText)
                                End If
        
                                r.Left = r.Left + 3
                                r.Top = r.Top + 3
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_LEFT)
                                lRC = DrawText(.hDC, oItem.CommandItem.KeyString, Len(oItem.CommandItem.KeyString), r, DT_RIGHT)
                                SetTextColor .hDC, lTextColorOld
                            Else
                                lTextColorOld = SetTextColor(.hDC, lColorHighlightText)
                                r.Left = r.Left + 3
                                r.Top = r.Top + 3
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_LEFT)
                                lRC = DrawText(.hDC, oItem.CommandItem.KeyString, Len(oItem.CommandItem.KeyString), r, DT_RIGHT)
                                SetTextColor .hDC, lColorGrayText
                                r.Left = r.Left - 1
                                r.Top = r.Top - 1
                                lRC = DrawText(.hDC, oItem.CommandItem.Caption, Len(oItem.CommandItem.Caption), r, DT_LEFT)
                                lRC = DrawText(.hDC, oItem.CommandItem.KeyString, Len(oItem.CommandItem.KeyString), r, DT_RIGHT)
                                SetTextColor .hDC, lTextColorOld
                            End If
                        End If
                        
                        SelectObject .hDC, hBrushOld
                        SelectObject .hDC, hPenOld
                    End With
                    bResult = False
                End If
            End If
            
        Case WM_MENUSELECT:
            BitWise.HILO wParam, wFlags, wID
            hMenu = lParam
            
            If (wFlags = &HFFFF) And (hMenu = 0) Then
                SubClassPopup.Unhook
            Else
                If (wFlags And MF_POPUP) = MF_POPUP Then
                Else
                    If wID > 0 Then
                        Set oItem = oMenuItems.Item(wID)
                        If oItem.CommandItem.ItemType <> cmdTypeSeperator Then
                            RaiseEvent ItemSelect(oItem)
                            oCommandList.EventItemSelect oItem.CommandItem
                        End If
                    End If
                End If
            End If
            
            bResult = False
            
        Case WM_ENTERMENULOOP:
            bMenuLoop = True
            
        Case WM_EXITMENULOOP:
            bMenuLoop = False

        Case WM_MENUCHAR:
            BitWise.HILO wParam, wFlags, wUser
            hMenu = lParam
            
            For i = 0 To GetMenuItemCount(hMenu) - 1
                wID = GetMenuItemID(hMenu, i)
                If wID = &HFFFFFFFF Then
                    mii.fMask = MIIM_ID
                    If GetMenuItemInfo(hMenu, i, True, mii) <> 0 Then
                        wID = mii.wID
                    Else
                        wID = 0
                    End If
                End If
                Set oItem = oMenuItems.Item(wID)
                If Asc(UCase$(Chr$(wUser))) = oItem.CommandItem.Mnemonic Then
                    lReturn = HL2L(MNC_EXECUTE, i)
                    bResult = False
                    Exit For
                End If
            Next
            
    End Select
End Sub

Private Sub ThreedBox(ByVal hDC As Long, _
                      ByVal X1 As Long, _
                      ByVal Y1 As Long, _
                      ByVal X2 As Long, _
                      ByVal Y2 As Long)
                      
    If hDC = 0 Then Exit Sub
    
    hPenOld = SelectObject(hDC, hPenBtnHighlight)
    
    'FirstLightLine
    MoveToEx hDC, X1, Y2, tPoint
    LineTo hDC, X1, Y1
    'SecondLightLine
    LineTo hDC, X2, Y1
    
    SelectObject hDC, hPenBtnShadow
    
    'FirstDarkLine
    MoveToEx hDC, X1, Y2, tPoint
    LineTo hDC, X2, Y2
    'SecondDarkLine
    LineTo hDC, X2, Y1
    
    SelectObject hDC, hPenOld
End Sub

Private Sub Rec(ByVal hDC As Long, _
                ByVal X1 As Long, _
                ByVal Y1 As Long, _
                ByVal X2 As Long, _
                ByVal Y2 As Long)
                      
    If hDC = 0 Then Exit Sub
    
    hPenOld = SelectObject(hDC, hPenBtnFace)
    
    MoveToEx hDC, X1, Y2, tPoint
    LineTo hDC, X1, Y1
    LineTo hDC, X2, Y1
    LineTo hDC, X2, Y2
    LineTo hDC, X1, Y2
    SelectObject hDC, hPenOld
End Sub

' Trace

#If DBG Then

Public Property Get Trace() As Object
    Set Trace = oTrace
End Property

Public Property Set Trace(NewVal As Object)
    Set oTrace = NewVal
End Property

Private Sub T(ByVal sText As String)
    If Not oTrace Is Nothing Then
        oTrace.Text "Popup: " + sText
    End If
End Sub

#End If


