Attribute VB_Name = "SubClassMenuBar"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oMenuBar As MenuBar

Private lPrevHWND As Long
Private lPrevWndFunc As Long

Private lReturn As Long
Private bResult As Boolean

Private bInWindowProc As Boolean
'
' Methodes
'
Public Sub Hook(o As MenuBar, ByVal hWnd As Long)
    #If DBG Then
        T "Hook: hWnd = 0x" + Hex$(hWnd)
    #End If
    
    bInWindowProc = False

    Set oMenuBar = o
    lPrevHWND = hWnd
    lPrevWndFunc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WindowProc)
End Sub

Public Sub Unhook()
    #If DBG Then
        T "Unhook: hWnd = 0x" + Hex$(lPrevHWND)
    #End If
    
    If lPrevHWND Then
        SetWindowLong lPrevHWND, GWL_WNDPROC, lPrevWndFunc
        lPrevHWND = 0
        lPrevWndFunc = 0
    End If
    Set oMenuBar = Nothing
End Sub

Public Function WindowProc(ByVal hWnd As Long, _
                           ByVal wMsg As Long, _
                           ByVal wParam As Long, _
                           ByVal lParam As Long) As Long
                         
    On Error Resume Next
       

    lReturn = 1
    bResult = True
    
    If Not bInWindowProc Then
        bInWindowProc = True
        oMenuBar.MsgProc hWnd, wMsg, wParam, lParam, lReturn, bResult
        bInWindowProc = False
    End If
    
    If bResult = True Then
        #If DBG Then
            T "-WindowProc: " + _
              "hWnd = 0x" + Hex$(hWnd) + " " + _
              "wMsg = 0x" + Hex$(wMsg) + " " + _
              "wParam = 0x" + Hex$(wParam) + " " + _
              "lParam = 0x" + Hex$(lParam)
        #End If
        WindowProc = CallWindowProc(lPrevWndFunc, hWnd, wMsg, wParam, lParam)
    Else
        #If DBG Then
            T "+WindowProc: " + _
              "hWnd = 0x" + Hex$(hWnd) + " " + _
              "wMsg = 0x" + Hex$(wMsg) + " " + _
              "wParam = 0x" + Hex$(wParam) + " " + _
              "lParam = 0x" + Hex$(lParam)
        #End If
        WindowProc = lReturn
    End If
End Function

#If DBG Then

Private Sub T(ByVal sText As String)
    If Not oTrace Is Nothing Then
        oTrace.Text "SubClassMenuBar: " + sText
    End If
End Sub

#End If



