VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ToolbarItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection
Private oToolBar As ToolBar
'
' Public Properties
'
Public Property Get Count() As Long
    Count = oItems.Count
End Property

Public Property Get Item(Index As Variant) As ToolbarItem
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property
'
' Public Methods
'
Public Function Add(CommandKey As Variant) As ToolbarItem
    Dim oCommandItem As CommandItem
    Dim oButton As MSComCtlLib.Button
    Dim oItem As New ToolbarItem
    Dim lStyle As MSComCtlLib.ButtonStyleConstants
    Dim sCaption As String
    
    Set oCommandItem = oToolBar.CommandList.CommandItems(CommandKey)
    
    If oToolBar.ShowCaptions Then
        sCaption = oCommandItem.Caption
    Else
        sCaption = ""
    End If
    
    With oToolBar.ToolbarCtrl.Buttons
        
        Select Case oCommandItem.ItemType
            Case cmdTypeCheck:      lStyle = tbrCheck
            Case cmdTypeDefault:    lStyle = tbrDefault
            Case cmdTypeGroup:      lStyle = tbrButtonGroup
            Case cmdTypeSeperator:  lStyle = tbrSeparator
            Case cmdTypeSubCommand: lStyle = tbrDefault
        End Select
            
        Set oButton = .Add(, , sCaption, lStyle)
    End With
    
    With oButton
        If Not IsMissing(oCommandItem.Image) Then
            .Image = oCommandItem.Image
        End If
        .ToolTipText = oCommandItem.ToolTipText
        .Description = oCommandItem.Description
        .Enabled = oCommandItem.Enabled
        .Visible = oCommandItem.Visible
        .Tag = CommandKey
        
        Select Case oCommandItem.Checked
            Case cmdItemChecked:    .Value = tbrPressed
            Case cmdItemUnchecked:  .Value = tbrUnpressed
        End Select
        
        Select Case oCommandItem.Value
            Case cmdItemPressed:    .Value = tbrPressed
            Case cmdItemUnpressed:  .Value = tbrUnpressed
        End Select
    End With
    
    With oItem
        Set .ToolBar = oToolBar
        Set .CommandItem = oCommandItem
        Set .Button = oButton
    End With
    
    oItems.Add oItem

    Set Add = oItem
    
    oItem.CommandItem.LinkedItems.Add oItem, cmdItemClassToolBar
    
    Set oItem = Nothing
End Function

Public Sub Remove(Index As Variant)
    oItems.Remove Index
End Sub
'
' Hidden Properties
'
Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

'''

Friend Property Get ToolBar() As ToolBar
Attribute ToolBar.VB_MemberFlags = "40"
    Set ToolBar = oToolBar
End Property
Friend Property Set ToolBar(NewVal As ToolBar)
    Set oToolBar = NewVal
End Property

Public Sub CleanUp()
    Dim i As Integer
    Dim iCount As Integer
    
    iCount = oItems.Count
    For i = 1 To iCount
        Item(i).CleanUp
    Next
    
    For i = 1 To iCount
        oItems.Remove 1
    Next
    
    Set oItems = Nothing
    Set oToolBar = Nothing
End Sub
