Attribute VB_Name = "RES"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum StringResourceIDs
    IDS_G_INFO = 101
    IDS_G_BACKUP
    IDS_G_RECOVERY
    IDS_G_TUNING
    IDS_G_CHECK
    IDS_G_CONFIG
    
    IDS_G1_History
    IDS_G1_CACHES
    IDS_G1_DATA
    IDS_G1_IO
    IDS_G1_LOG
    IDS_G1_LOCKS
    IDS_G1_SESSIONS
    IDS_G1_VERSIONS
    
    IDS_G2_DATABASE
    IDS_G2_COMPLETE
    IDS_G2_INCREMENTEL
    IDS_G2_LOG
    IDS_G2_AUTOLOG
    
    IDS_G3_DATABASE
    IDS_G3_INDEXES
    IDS_G3_DEVSPACES
    IDS_G3_DATADEVSPACE
    IDS_G3_LOGDEVSPACE
    
    IDS_G4_OPTSTAT
    IDS_G4_INDEXES
    IDS_G4_INDEXUSE
    IDS_G4_INDEXWIZARD
    
    IDS_G5_DATABASE
    IDS_G5_TABLE
    IDS_G5_INDEX
    IDS_G5_EVENTS
    IDS_G5_SERVER
    IDS_G5_FILES
    IDS_G5_FILE
    IDS_G5_KERNELTRACE
    
    IDS_G6_Media
    IDS_G6_Medium
    IDS_G6_PARAMETERS
    IDS_G6_DEVSPACES
    IDS_G6_DEVSPACE
    IDS_G6_DATADEVSPACES
    IDS_G6_LOGDEVSPACES
    IDS_G6_USERS
    IDS_G6_USER
    IDS_G6_MAPCHARSETS
    IDS_G6_MAPCHARSET
    IDS_G6_TERMCHARSETS
    IDS_G6_TERMCHARSET
    IDS_G6_SYSTEMTABLES
    IDS_G6_EVENTS
    
    IDS_GG_DATABASE
    IDS_GG_COMMANDLINE
    
    IDS_CHECKSERVER
    IDS_CHECKFILE

    IDS_G5_MEDIUM
    IDS_G6_LOGMODE
    IDS_GG_RESTARTUNTIL
    IDS_GG_SESSIONS
    
    IDS_G1_OMSCACHES
    IDS_G1_OMSMONITOR
    IDS_G1_OMSCLASSCONTAINERS
End Enum

Public Function RS(ByVal ID As StringResourceIDs) As String
    RS = LoadResString(ID)
End Function

Public Function RS1(ByVal ID As StringResourceIDs, _
                    Optional ByVal Parameter1 As String) As String
    Dim s As String
    
    s = LoadResString(ID)
    If Len(Parameter1) > 0 Then
        s = InsertParameter(s, Parameter1)
    End If
    RS1 = s
End Function

Public Function RS2(ByVal ID As StringResourceIDs, _
                    Optional ByVal Parameter1, _
                    Optional ByVal Parameter2 As String) As String
    Dim s As String
    
    s = LoadResString(ID)
    If Len(Parameter1) > 0 Then
        s = InsertParameter(s, Parameter1)
        If Len(Parameter2) > 0 Then
            s = InsertParameter(s, Parameter2)
        End If
    End If
    RS2 = s
End Function

Public Function RI(ByVal ID As Integer) As Object
    Set RI = LoadResPicture(ID, vbResIcon)
End Function

'''

Private Function InsertParameter(ByVal s As String, _
                                 ByVal sParameter As String)
    Dim iPos As Integer
    
    iPos = InStr(1, s, "[%]")
    If iPos > 0 Then
        InsertParameter = Left(s, iPos - 1) & sParameter & Mid(s, iPos + 3)
    Else
        InsertParameter = s
    End If
End Function


