VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MsFlxGrd.ocx"
Begin VB.UserControl ctlTermChar 
   ClientHeight    =   3375
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2835
   ScaleHeight     =   3375
   ScaleWidth      =   2835
   ToolboxBitmap   =   "TermChar.ctx":0000
   Begin VB.TextBox edtCell 
      Appearance      =   0  'Flat
      Height          =   288
      Left            =   360
      TabIndex        =   1
      Top             =   1080
      Visible         =   0   'False
      Width           =   1452
   End
   Begin MSFlexGridLib.MSFlexGrid grdTermchars 
      Height          =   3132
      Left            =   0
      TabIndex        =   0
      Top             =   240
      Width           =   2772
      _ExtentX        =   4895
      _ExtentY        =   5530
      _Version        =   393216
      Cols            =   3
      FixedCols       =   0
      BackColorSel    =   -2147483643
      HighLight       =   0
      ScrollBars      =   2
   End
End
Attribute VB_Name = "ctlTermChar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function GetSystemMetrics Lib "User32.dll" ( _
    ByVal nIndex As Long) As Long
    
Const SM_CXVSCROLL = 2
Const SM_CYEDGE = 46

'''

Public Event Change()

Private nEdtRow As Long
Private nEdtCol As Long

Private nVisibleRows As Long
Private bEnterCell_SelfInvoked As Boolean
Private bScroll_SelfInvoked As Boolean

Private Const Caption_ROW = 0
Private Const FIRST_ROW = 1
Private Const INTERN_COL = 0
Private Const EXTERN_COL = 1
Private Const COMMENT_COL = 2
Private Const FIRST_COL = INTERN_COL
Private Const LAST_COL = COMMENT_COL

Private Const INTERN_SIZE = 2
Private Const EXTERN_SIZE = 2
Private Const COMMENT_SIZE = 8

Private Const INTERN_HEAD = "Intern"
Private Const EXTERN_HEAD = "Extern"
Private Const COMMENT_HEAD = "Comment"

Private Const COL_RESWIDTH As Long = 150

Private nHeightDiff As Long
'
' End General Declarations
' *******************************************************************************

' *******************************************************************************
' Properties
'

' *******************************************************************************
' Public Property Let Enabled
'
Public Property Let Enabled(bValue As Boolean)
  edtCell.Enabled = bValue
  grdTermchars.Enabled = bValue
End Property ' Let Enabled

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    UserControl.BackColor = NewVal
    PropertyChanged "BackColor"
End Property

' *******************************************************************************
' Public Subs/Functions
'

' *******************************************************************************
' Public Sub Grid_Clear
'
Public Sub Grid_Clear()
  grdTermchars.AddItem ("")
  grdTermchars.RowHeight(grdTermchars.Rows - 1) = edtCell.Height + Screen.TwipsPerPixelX
  grdTermchars.TextMatrix(grdTermchars.Rows - 1, EXTERN_COL) = ""
  grdTermchars.TextMatrix(grdTermchars.Rows - 1, COMMENT_COL) = ""
  
  ' remove all non fixed rows execept one
  While grdTermchars.Rows > 2
    grdTermchars.RemoveItem (1)
  Wend
  
  ' grid layout
  Call CalcLayout
End Sub ' Grid_Clear

' *******************************************************************************
' Public Sub Grid_Setup
'
Public Sub Grid_Setup(oTermcharSet As DBMLib.TermcharSet)
  Dim nIndex As Long
  Dim sIntern As String
  Dim sExtern As String
  Dim sComment As String
    
  ' remove all non fixed rows execept one
  While grdTermchars.Rows > 2
    grdTermchars.RemoveItem (1)
  Wend
  
  ' setup table head
  grdTermchars.TextMatrix(Caption_ROW, INTERN_COL) = INTERN_HEAD
  grdTermchars.ColAlignment(INTERN_COL) = flexAlignRightCenter
  grdTermchars.TextMatrix(Caption_ROW, EXTERN_COL) = EXTERN_HEAD
  grdTermchars.ColAlignment(EXTERN_COL) = flexAlignRightCenter
  grdTermchars.TextMatrix(Caption_ROW, COMMENT_COL) = COMMENT_HEAD
  grdTermchars.ColAlignment(COMMENT_COL) = flexAlignLeftCenter
  grdTermchars.RowHeight(Caption_ROW) = edtCell.Height
    
  ' add rows
  For nIndex = 1 To oTermcharSet.MaxCode
    
    Call oTermcharSet.GetCode(nIndex, sComment, sExtern, sIntern)
   
    grdTermchars.AddItem (sIntern)
    grdTermchars.RowHeight(grdTermchars.Rows - 1) = edtCell.Height + Screen.TwipsPerPixelX
    grdTermchars.TextMatrix(grdTermchars.Rows - 1, EXTERN_COL) = sExtern
    grdTermchars.TextMatrix(grdTermchars.Rows - 1, COMMENT_COL) = sComment
    
  Next
   
  ' remove last initial empty  row
  If (grdTermchars.Rows > 2) Then
    grdTermchars.RemoveItem (1)
  End If
  
  ' grid layout
  Call CalcLayout
  
  ' set active row
  grdTermchars.Row = FIRST_ROW
  grdTermchars.Col = FIRST_COL
  Call Grid_EnterEdit
End Sub ' Grid_Setup

' *******************************************************************************
' Public Sub Grid_PutTermchars
'
Public Sub Grid_PutTermchars(oTermcharSet As DBMLib.TermcharSet)
  Dim nCurRow As Long
  
  ' get current cell form edit control
    If (edtCell.Visible) Then
      grdTermchars.TextMatrix(nEdtRow, nEdtCol) = edtCell.Text
    End If
  
  ' Clear Codes
  Call oTermcharSet.Clear
  
  ' get values in loop
  For nCurRow = FIRST_ROW To grdTermchars.Rows - 1
  
    Call oTermcharSet.SetCode(nCurRow, _
                              grdTermchars.TextMatrix(nCurRow, COMMENT_COL), _
                              grdTermchars.TextMatrix(nCurRow, EXTERN_COL), _
                              grdTermchars.TextMatrix(nCurRow, INTERN_COL))
  Next
End Sub ' Grid_PutTermchars

' *******************************************************************************
' Private/Friend Subs/Functions
'

' *******************************************************************************
' Private Sub edtCell_Change
'
' description: Eventhandling
'
Private Sub edtCell_Change()
  If (edtCell.Text <> grdTermchars.TextMatrix(nEdtRow, nEdtCol)) Then
    RaiseEvent Change
  End If
End Sub ' edtCell_Change

' *******************************************************************************
' Private Sub edtCell_KeyDown
'
' description: Eventhandling
'
Private Sub edtCell_KeyDown(KeyCode As Integer, Shift As Integer)
  Dim sKeys As String
  
  If ((KeyCode = vbKeyUp) And (Shift = 0)) Then
    sKeys = "{UP}"
  ElseIf ((KeyCode = vbKeyDown) And (Shift = 0)) Then
    sKeys = "{DOWN}"
  ElseIf ((KeyCode = vbKeyPageUp) And (Shift = 0)) Then
    sKeys = "{PGUP}"
  ElseIf ((KeyCode = vbKeyPageDown) And (Shift = 0)) Then
    sKeys = "{PGDN}"
  ElseIf ((KeyCode = vbKeyHome) And (Shift = vbCtrlMask)) Then
    sKeys = "^{HOME}"
  ElseIf ((KeyCode = vbKeyEnd) And (Shift = vbCtrlMask)) Then
    sKeys = "^{END}"
  ElseIf ((KeyCode = vbKeyLeft) And _
          (Shift = 0) And _
          (edtCell.Visible And edtCell.SelLength = 0 And edtCell.SelStart = 0)) Then
    sKeys = "{LEFT}"
  ElseIf ((KeyCode = vbKeyRight) And _
          (Shift = 0) And _
          (edtCell.Visible And edtCell.SelLength = 0 And edtCell.SelStart = Len(edtCell.Text))) Then
    sKeys = "{RIGHT}"
  Else
    sKeys = ""
  End If

  If (Len(sKeys) > 0) Then
    KeyCode = 0
    Grid_LeaveEdit
    SendKeys sKeys
    DoEvents
    If (Not edtCell.Visible) Then
      Call Grid_EnterEdit
    End If
  End If
End Sub ' edtCell_KeyDown

' *******************************************************************************
' Private Sub grdTermchars_EnterCell
'
' description: Eventhandling
'
Private Sub grdTermchars_EnterCell()
  If (Not bEnterCell_SelfInvoked) Then
    If (grdTermchars.Row < grdTermchars.TopRow) Then
       bScroll_SelfInvoked = True
       grdTermchars.TopRow = grdTermchars.Row
       bScroll_SelfInvoked = False
    End If
    
    If (edtCell.Visible) Then
      Call Grid_LeaveEdit
    End If
    Call Grid_EnterEdit
  End If
End Sub ' grdTermchars_EnterCell

' *******************************************************************************
' Private Sub grdTermchars_Scroll
'
' description: Eventhandling
'
Private Sub grdTermchars_Scroll()
  Dim newEditRow As Long
  
  If (Not bScroll_SelfInvoked) Then
    
    newEditRow = nEdtRow
  
    If (nEdtRow < grdTermchars.TopRow) Then
      newEditRow = grdTermchars.TopRow
    ElseIf (nEdtRow >= (grdTermchars.TopRow + nVisibleRows)) Then
      newEditRow = grdTermchars.TopRow + nVisibleRows - 1
    End If
    
    If (newEditRow <> nEdtRow) Then
      
      grdTermchars.Row = newEditRow
   
    Else
      
      If (edtCell.Visible) Then
        Call edtCell.Move(grdTermchars.CellLeft + grdTermchars.Left, _
                          grdTermchars.CellTop + grdTermchars.Top, _
                          grdTermchars.CellWidth)
      End If
    
    End If
  
  End If
End Sub ' grdTermchars_Scroll

' *******************************************************************************
' Private Sub UserControl_EnterFocus
'
' description: Eventhandling
'
Private Sub UserControl_EnterFocus()
  edtCell.Visible = False
  
  If (grdTermchars.Enabled) Then
    Call Grid_EnterEdit
  End If
End Sub ' UserControl_EnterFocus

' *******************************************************************************
' Private Sub UserControl_ExitFocus
'
' description: Eventhandling
'
Private Sub UserControl_ExitFocus()
  Call Grid_LeaveEdit
End Sub ' UserControl_ExitFocus

' *******************************************************************************
' Private Sub UserControl_Initialize
'
' description: Eventhandling
'
Private Sub UserControl_Initialize()
  nHeightDiff = Height - grdTermchars.Height
  Call UserControl_Resize
End Sub ' UserControl_Initialize

' *******************************************************************************
' Private Sub UserControl_Resize
'
' description: Eventhandling
'
Private Sub UserControl_Resize()
  If (Height - nHeightDiff > 0) Then
    grdTermchars.Height = Height - nHeightDiff
  End If
End Sub ' UserControl_Resize

' *******************************************************************************
' Private Sub Grid_EnterEdit
'
Private Sub Grid_EnterEdit()
  If (grdTermchars.Row >= grdTermchars.TopRow) Then
    
    If (grdTermchars.Col < FIRST_COL) Then
      grdTermchars.Col = FIRST_COL
    ElseIf (grdTermchars.Col > LAST_COL) Then
      grdTermchars.Col = LAST_COL
    Else
   
      nEdtRow = grdTermchars.Row
      nEdtCol = grdTermchars.Col
      
      ' setup cell edit field
      Call edtCell.Move(grdTermchars.CellLeft + grdTermchars.Left, _
                        grdTermchars.CellTop + grdTermchars.Top, _
                        grdTermchars.CellWidth)
      Select Case (nEdtCol)
        Case INTERN_COL
          edtCell.MaxLength = INTERN_SIZE
        Case EXTERN_COL
          edtCell.MaxLength = EXTERN_SIZE
        Case COMMENT_COL
          edtCell.MaxLength = COMMENT_SIZE
      End Select
      edtCell.Text = grdTermchars.TextMatrix(nEdtRow, nEdtCol)
      edtCell.SelStart = 0
      edtCell.SelLength = Len(edtCell.Text)
      edtCell.Visible = True
      If (edtCell.Visible) Then
        Call edtCell.SetFocus
      End If
    
    End If
  
  End If
End Sub ' Grid_EnterEdit

' *******************************************************************************
' Private Sub Grid_LeaveEdit
'
Private Sub Grid_LeaveEdit()
  If (edtCell.Visible) Then
    edtCell.Visible = False
    grdTermchars.TextMatrix(nEdtRow, nEdtCol) = edtCell.Text
  End If
End Sub ' Grid_LeaveEdit

' *******************************************************************************
' Private Function CalcLayout
'
' description: caculate the grid layout after init and resize
'
Private Sub CalcLayout()
  Dim nScrollWidth As Long
  
  ' Calculate fully visible rows
  nVisibleRows = CalcVisibleRows
      
  ' setting width
  If (nVisibleRows < (grdTermchars.Rows - 1)) Then
    nScrollWidth = Screen.TwipsPerPixelX * GetSystemMetrics(SM_CXVSCROLL)
  Else
    nScrollWidth = 0
  End If
 
  grdTermchars.ColWidth(INTERN_COL) = TextWidth(INTERN_HEAD) + COL_RESWIDTH
  grdTermchars.ColWidth(EXTERN_COL) = TextWidth(EXTERN_HEAD) + COL_RESWIDTH
  grdTermchars.ColWidth(COMMENT_COL) = grdTermchars.Width - nScrollWidth - _
                                    grdTermchars.ColWidth(INTERN_COL) - _
                                    grdTermchars.ColWidth(EXTERN_COL) - _
                                    (2 * Screen.TwipsPerPixelX * GetSystemMetrics(SM_CYEDGE))
End Sub ' CalcLayout

' *******************************************************************************
' Private Function CalcVisibleRows
'
Private Function CalcVisibleRows() As Long
  Dim nTopRow As Long
  Dim nCurRow As Long
  Dim bExit As Boolean
  
  nTopRow = grdTermchars.TopRow
  grdTermchars.TopRow = FIRST_ROW
  nCurRow = FIRST_ROW
  CalcVisibleRows = 0
  bExit = False
     
  While (Not bExit)
    If (nCurRow >= grdTermchars.Rows) Then
      bExit = True
    ElseIf (grdTermchars.RowPos(nCurRow) + grdTermchars.RowHeight(nCurRow)) > grdTermchars.Height Then
      bExit = True
    Else
      nCurRow = nCurRow + 1
      CalcVisibleRows = CalcVisibleRows + 1
    End If
  Wend

  grdTermchars.TopRow = nTopRow
End Function ' CalcVisibleRows
