VERSION 5.00
Begin VB.UserControl DrawText 
   AutoRedraw      =   -1  'True
   CanGetFocus     =   0   'False
   ClientHeight    =   2535
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3945
   ScaleHeight     =   169
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   263
End
Attribute VB_Name = "DrawText"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'''

'Const FW_BLACK = FW_HEAVY
Const FW_BOLD = 700
'Const FW_DEMIBOLD = FW_SEMIBOLD
'Const FW_DONTCARE = 0
'Const FW_EXTRABOLD = 800
'Const FW_EXTRALIGHT = 200
'Const FW_HEAVY = 900
'Const FW_LIGHT = 300
'Const FW_MEDIUM = 500
Const FW_NORMAL = 400
'Const FW_REGULAR = FW_NORMAL
'Const FW_SEMIBOLD = 600
'Const FW_THIN = 100
'Const FW_ULTRABOLD = FW_EXTRABOLD
'Const FW_ULTRALIGHT = FW_EXTRALIGHT

Const LF_FACESIZE = 32

Private Type LOGFONT
    lfHeight As Long
    lfWidth As Long
    lfEscapement As Long
    lfOrientation As Long
    lfWeight As Long
    lfItalic As Byte
    lfUnderline As Byte
    lfStrikeOut As Byte
    lfCharSet As Byte
    lfOutPrecision As Byte
    lfClipPrecision As Byte
    lfQuality As Byte
    lfPitchAndFamily As Byte
    lfFaceName(LF_FACESIZE) As Byte
End Type

Private Declare Function CreateFontIndirect Lib "gdi32.dll" Alias "CreateFontIndirectA" ( _
    lpLogFont As LOGFONT) As Long


Private Declare Function SelectObject Lib "gdi32.dll" ( _
    ByVal hDC As Long, _
    ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32.dll" ( _
    ByVal hObject As Long) As Integer

'''

Private Declare Function DrawText Lib "User32.dll" Alias "DrawTextA" ( _
    ByVal hDC As Long, _
    ByVal lpStr As String, _
    ByVal nCount As Long, _
    lpRect As RECT, _
    ByVal wFormat As Long) As Long

Const DT_LEFT = &H0
Const DT_TOP = &H0
Const DT_CENTER = &H1
Const DT_RIGHT = &H2
Const DT_VCENTER = &H4
Const DT_BOTTOM = &H8
Const DT_WORDBREAK = &H10
Const DT_SINGLELINE = &H20
Const DT_EXPANDTABS = &H40
Const DT_TABSTOP = &H80
Const DT_NOCLIP = &H100
Const DT_EXTERNALLEADING = &H200
Const DT_CALCRECT = &H400
Const DT_NOPREFIX = &H800
Const DT_INTERNAL = &H1000
Const DT_EDITCONTROL = &H2000
Const DT_PATH_ELLIPSIS = &H4000
Const DT_END_ELLIPSIS = &H8000
Const DT_MODIFYSTRING = &H10000
Const DT_RTLREADING = &H20000
Const DT_WORD_ELLIPSIS = &H40000

'''

Private bAutoHeight As Boolean
Private sCaption As String
Private lBackColor As OLE_COLOR
Private lForeColor As OLE_COLOR
Private hFont As Long
'''

'
' Properties
'
Public Property Get AutoHeight() As Boolean
    AutoHeight = bAutoHeight
End Property
Public Property Let AutoHeight(ByVal NewVal As Boolean)
    bAutoHeight = NewVal
    PropertyChanged "AutoHeight"
    DrawCaption
End Property

Public Property Get Caption() As String
    Caption = sCaption
End Property
Public Property Let Caption(NewVal As String)
    sCaption = NewVal
    PropertyChanged "Caption"
    DrawCaption
End Property

Public Property Get BackColor() As OLE_COLOR
    BackColor = lBackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    lBackColor = NewVal
    PropertyChanged "BackColor"
    UserControl.BackColor = lBackColor
    DrawCaption
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = lForeColor
End Property
Public Property Let ForeColor(ByVal NewVal As OLE_COLOR)
    lForeColor = NewVal
    PropertyChanged "ForeColor"
    UserControl.ForeColor = lForeColor
    DrawCaption
End Property

Public Property Get Font() As StdFont
    Set Font = UserControl.Font
End Property
Public Property Set Font(NewVal As StdFont)
    Set UserControl.Font = NewVal
    PropertyChanged "Font"
    SetCurrentFont
    DrawCaption
End Property

Public Sub Refresh()
    DrawCaption
End Sub
'
' Events UserControl
'
Private Sub UserControl_Initialize()
    bAutoHeight = True
    sCaption = ""
    lBackColor = vb3DFace
    lForeColor = vbWindowText
    hFont = 0
End Sub

Private Sub UserControl_Terminate()
    If hFont <> 0 Then DeleteObject hFont
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        AutoHeight = .ReadProperty("AutoHeight", True)
        Caption = .ReadProperty("Caption", "")
        BackColor = .ReadProperty("BackColor", vb3DFace)
        ForeColor = .ReadProperty("ForeColor", vbWindowText)
        Set Font = .ReadProperty("Font")
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "AutoHeight", AutoHeight, True
        .WriteProperty "Caption", Caption, ""
        .WriteProperty "BackColor", BackColor, vb3DFace
        .WriteProperty "ForeColor", ForeColor, vbWindowText
        .WriteProperty "Font", Font
    End With
End Sub

Private Sub UserControl_Resize()
    DrawCaption
End Sub
'
' Private Sub/Function
'
Private Sub DrawCaption()
    Dim r As RECT
    Dim hOldFont As Long
    
    With r
        .Left = 0
        .Top = 0
        .Right = ScaleWidth
        .Bottom = ScaleHeight
    End With
    
    UserControl.Cls
    
    If bAutoHeight Then
        DrawText UserControl.hDC, sCaption, Len(sCaption), r, DT_WORDBREAK + DT_NOPREFIX + DT_CALCRECT
        UserControl.Height = ScaleY(r.Bottom, vbPixels, vbTwips)
    End If
    
    hOldFont = 0
    If hFont <> 0 Then hOldFont = SelectObject(UserControl.hDC, hFont)
    DrawText UserControl.hDC, sCaption, Len(sCaption), r, DT_WORDBREAK + DT_NOPREFIX
    If hOldFont <> 0 Then SelectObject UserControl.hDC, hOldFont
End Sub

Private Sub SetCurrentFont()
    Dim lf As LOGFONT
    Dim i As Integer
    Dim s As String

    If hFont <> 0 Then DeleteObject hFont
    hFont = 0
    
    s = Font.Name
        
    With lf
        For i = 0 To LF_FACESIZE - 1
            .lfFaceName(i) = 0
        Next
        For i = 1 To Len(s)
            .lfFaceName(i - 1) = Asc(Mid$(s, i, 1))
        Next
        .lfHeight = Font.Size
        If Font.Bold Then
            .lfWeight = FW_BOLD
        Else
            .lfWeight = FW_NORMAL
        End If
        If Font.Italic Then .lfItalic = 1
        If Font.Underline Then .lfUnderline = 1
        If Font.Strikethrough Then .lfStrikeOut = 1
    End With
    
    hFont = CreateFontIndirect(lf)
End Sub


