Attribute VB_Name = "modCmdInit"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Const CMD_INST_OLTP = &H1
Public Const CMD_INST_LVC = &H2
Public Const CMD_INST_CS = &H4
Public Const CMD_INST_BW = &H8

'''

Const CMD_ITUNING = True

Const CMD_IDEVENTMONITOR = True
Const CMD_ICEVENTS = False

'''

Public Enum DBMGUICommandConstants
    cmdFile
      cmdFOpen
      '---
      cmdFSave
      cmdFSaveAs
      '---
      cmdFNewFolder
      cmdFRegister
      '---
      cmdFPrint
      cmdFPrintSetup
      '---
      cmdFMessages
        cmdFMProperties
        '---
        cmdFMClearItem
        cmdFMClearAll
      '---
      cmdFUnregister
      cmdFDelete
      cmdFRename
      cmdFProperties
      '---
      cmdFExit
    
    cmdEdit
      cmdEUndo
      '---
      cmdECut
      cmdECopy
      cmdEPaste
      cmdEDelete
    
    cmdView
      cmdVRefresh
      '---
      cmdVLargeIcons
      cmdVSmallIcons
      cmdVList
      cmdVDetails
      '---
      cmdVTree
      cmdVMenu
      '---
      cmdVOptions
    
    cmdInstance
      cmdIViewDetails
      '---
      cmdIInstall
      '---
      cmdIDisconnect
      '---
      cmdIOffline
      cmdICold
      cmdIOnline
      '---
      cmdIRestartUntil
      '---
      cmdIInfo
        cmdIIHistory
        cmdIICaches
        cmdIIData
        cmdIIIO
        cmdIILog
        cmdIILocks
        cmdIISessions
        cmdIIVersions
        cmdIIOMSCaches
        cmdIIOMSMonitor
        cmdIIOMSClasscontainers
      cmdIBackup
        cmdIBComplete
        cmdIBIncremental
        cmdIBLog
        cmdIBAutoLog
      cmdIRecovery
        cmdIRDatabase
        cmdIRIndexes
        cmdIRDevspaces
      cmdITuning
        cmdITOptStat
        cmdITIndexUse
      cmdICheck
        cmdICDatabase
        cmdICBackup
        cmdICEventMonitor
        cmdICServer
        cmdICFiles
        cmdICKernelTrace
      cmdIConfiguration
        cmdICMedia
        cmdICDevSpaceData
        cmdICDevSpaceLog
        cmdICParameters
        cmdICLogMode
        cmdICUsers
        cmdICMapcharSets
        cmdICTermcharSets
        cmdICLoadSysTabs
        cmdICEvents
      '---
      cmdICommandLine
      cmdISessions
      '---
      cmdIAutoLogOn
      cmdIAutoLogOff
      '---
      cmdIDrop
      '---
      cmdICancel
      
    cmdTools
      cmdTSQLStudio
      
    cmdHelp
      cmdHContents
      cmdHSearch
      '---
      cmdHWeb
      '---
      cmdHAbout
      cmdHInfo
      cmdHFiles
        
    cmdRefreshFolder
    cmdRefreshDatabase
    
    cmdDocuments
    cmdNextDocument
    cmdPrevDocument
    
    cmdDebugTrace
    
    cmdSeperator
End Enum

Public Enum ControlPopupConstants
    popFolders = 1
    popFolder
    popDatabases
    popDatabase
    popReport
    popReportItem
    popDebug
End Enum

Public Sub CommandsInit()
    Dim oItem As DBMCmd.CommandItem
    
    Set FRM.CML.ImageList = RES.Bitmaps16
    
    With FRM.CML.CommandItems
        ' File
        Set oItem = .Add(cmdTypeSubCommand, cmdFile, "&File")
        Set oItem = .Add(cmdTypeDefault, cmdFOpen, "&Open", RES.Bitmap16ID(IDB_16_FILE_OPEN))
        Set oItem = .Add(cmdTypeDefault, cmdFSave, "&Save", RES.Bitmap16ID(IDB_16_FILE_SAVE))
        Set oItem = .Add(cmdTypeDefault, cmdFSaveAs, "Save &As", RES.Bitmap16ID(IDB_16_FILE_SAVE))
        
        Set oItem = .Add(cmdTypeDefault, cmdFNewFolder, "New &Folder", RES.Bitmap16ID(IDB_16_FOLDER_NEW))
        Set oItem = .Add(cmdTypeDefault, cmdFRegister, "&Register...", RES.Bitmap16ID(IDB_16_DB_REGISTER))
        Set oItem = .Add(cmdTypeDefault, cmdFPrint, "&Print...", RES.Bitmap16ID(IDB_16_PRINT))
        Set oItem = .Add(cmdTypeDefault, cmdFPrintSetup, "Print S&etup...")
        
        Set oItem = .Add(cmdTypeSubCommand, cmdFMessages, "&Messages")
        Set oItem = .Add(cmdTypeDefault, cmdFMProperties, "&Properties")
        Set oItem = .Add(cmdTypeDefault, cmdFMClearItem, "C&lear Message")
        Set oItem = .Add(cmdTypeDefault, cmdFMClearAll, "Clear &All Messages")
        
        Set oItem = .Add(cmdTypeDefault, cmdFUnregister, "&Unregister", RES.Bitmap16ID(IDB_16_DELETE))
        Set oItem = .Add(cmdTypeDefault, cmdFDelete, "&Delete", RES.Bitmap16ID(IDB_16_DELETE))
        Set oItem = .Add(cmdTypeDefault, cmdFRename, "Re&name", RES.Bitmap16ID(IDB_16_RENAME))
        Set oItem = .Add(cmdTypeDefault, cmdFProperties, "Proper&ties...", RES.Bitmap16ID(IDB_16_PROPERTIES))
        Set oItem = .Add(cmdTypeDefault, cmdFExit, "E&xit")
        
        ' Edit
        Set oItem = .Add(cmdTypeSubCommand, cmdEdit, "&Edit")
        Set oItem = .Add(cmdTypeDefault, cmdEUndo, "&Undo", RES.Bitmap16ID(IDB_16_UNDO))
        Set oItem = .Add(cmdTypeDefault, cmdECut, "Cu&t", RES.Bitmap16ID(IDB_16_CUT))
        Set oItem = .Add(cmdTypeDefault, cmdECopy, "&Copy", RES.Bitmap16ID(IDB_16_COPY))
        Set oItem = .Add(cmdTypeDefault, cmdEPaste, "&Paste", RES.Bitmap16ID(IDB_16_PASTE))
        Set oItem = .Add(cmdTypeDefault, cmdEDelete, "&Delete", RES.Bitmap16ID(IDB_16_DELETE))
                
        'View
        Set oItem = .Add(cmdTypeSubCommand, cmdView, "&View")
        Set oItem = .Add(cmdTypeDefault, cmdVRefresh, "&Refresh", RES.Bitmap16ID(IDB_16_REFRESH))
        Set oItem = .Add(cmdTypeDefault, cmdVLargeIcons, "Large &Icons", RES.Bitmap16ID(IDB_16_VIEW_LARGE))
        Set oItem = .Add(cmdTypeDefault, cmdVSmallIcons, "&Small Icons", RES.Bitmap16ID(IDB_16_VIEW_SMALL))
        Set oItem = .Add(cmdTypeDefault, cmdVList, "&List", RES.Bitmap16ID(IDB_16_VIEW_LIST))
        Set oItem = .Add(cmdTypeDefault, cmdVDetails, "&Details", RES.Bitmap16ID(IDB_16_VIEW_DETAILS))
        
        Set oItem = .Add(cmdTypeDefault, cmdNextDocument, "&Next Window", RES.Bitmap16ID(IDB_16_WIN_NEXT))
        Set oItem = .Add(cmdTypeDefault, cmdPrevDocument, "Pr&evious Window", RES.Bitmap16ID(IDB_16_WIN_PREV))
        Set oItem = .Add(cmdTypeDefault, cmdDocuments, "List of &Windows...", RES.Bitmap16ID(IDB_16_WINDOWS))
        
        Set oItem = .Add(cmdTypeCheck, cmdVTree, "&Tree")
        If REG.Settings.ViewTree Then
            oItem.Checked = cmdItemChecked
        Else
            oItem.Checked = cmdItemUnchecked
        End If
        Set oItem = .Add(cmdTypeCheck, cmdVMenu, "&Menu")
        If REG.Settings.ViewMenu Then
            oItem.Checked = cmdItemChecked
        Else
            oItem.Checked = cmdItemUnchecked
        End If
        Set oItem = .Add(cmdTypeDefault, cmdVOptions, "O&ptions")
        
        'Instance
        Set oItem = .Add(cmdTypeSubCommand, cmdInstance, "&Instance")
        Set oItem = .Add(cmdTypeDefault, cmdIViewDetails, "&Database Details", RES.Bitmap16ID(IDB_16_DB))
        Set oItem = .Add(cmdTypeDefault, cmdIInstall, "&Install...", RES.Bitmap16ID(IDB_16_DB_WIZARD))
        Set oItem = .Add(cmdTypeDefault, cmdIDisconnect, "Dis&connect", RES.Bitmap16ID(IDB_16_DISCONNECT))
        Set oItem = .Add(cmdTypeDefault, cmdIOffline, "Set &Offline", RES.Bitmap16ID(IDB_16_BALL_RED))
        Set oItem = .Add(cmdTypeDefault, cmdICold, "Set &Admin", RES.Bitmap16ID(IDB_16_BALL_YELLOW))
        Set oItem = .Add(cmdTypeDefault, cmdIOnline, "Set O&nline", RES.Bitmap16ID(IDB_16_BALL_GREEN))
        Set oItem = .Add(cmdTypeDefault, cmdIRestartUntil, "&Restart &Until", RES.Bitmap16ID(IDB_16_CLOCK))
        
        'Instance\Info
        Set oItem = .Add(cmdTypeSubCommand, cmdIInfo, "In&formation", RES.Bitmap16ID(IDB_16_INFOS))
        Set oItem = .Add(cmdTypeDefault, cmdIIHistory, "&Backup History", RES.Bitmap16ID(IDB_16_BACKUP_HISTORY))
        Set oItem = .Add(cmdTypeDefault, cmdIICaches, "&Caches", RES.Bitmap16ID(IDB_16_INFO_CACHE))
        Set oItem = .Add(cmdTypeDefault, cmdIIData, "&Data Area", RES.Bitmap16ID(IDB_16_INFO_DATA))
        Set oItem = .Add(cmdTypeDefault, cmdIIIO, "&I/O", RES.Bitmap16ID(IDB_16_INFO_IO))
        Set oItem = .Add(cmdTypeDefault, cmdIILog, "&Log Area", RES.Bitmap16ID(IDB_16_INFO_LOG))
        Set oItem = .Add(cmdTypeDefault, cmdIILocks, "L&ocks", RES.Bitmap16ID(IDB_16_INFO_LOCKS))
        Set oItem = .Add(cmdTypeDefault, cmdIISessions, "&Sessions", RES.Bitmap16ID(IDB_16_INFO_USERS))
        Set oItem = .Add(cmdTypeDefault, cmdIIVersions, "&Versions", RES.Bitmap16ID(IDB_16_INFO_VERSION))
        Set oItem = .Add(cmdTypeDefault, cmdIIOMSCaches, "OMS C&aches", RES.Bitmap16ID(IDB_16_INFO))
        Set oItem = .Add(cmdTypeDefault, cmdIIOMSMonitor, "OMS &Monitor", RES.Bitmap16ID(IDB_16_INFO))
        Set oItem = .Add(cmdTypeDefault, cmdIIOMSClasscontainers, "OMS Classco&ntainers", RES.Bitmap16ID(IDB_16_INFO))
        
        'Instance\Backup
        Set oItem = .Add(cmdTypeSubCommand, cmdIBackup, "&Backup", RES.Bitmap16ID(IDB_16_BACKUP_SAVE))
        Set oItem = .Add(cmdTypeDefault, cmdIBComplete, "&Complete Data", RES.Bitmap16ID(IDB_16_BACKUP_ST_DATA))
        Set oItem = .Add(cmdTypeDefault, cmdIBIncremental, "&Incremental Data", RES.Bitmap16ID(IDB_16_BACKUP_ST_PAGES))
        Set oItem = .Add(cmdTypeDefault, cmdIBLog, "&Log", RES.Bitmap16ID(IDB_16_BACKUP_ST_LOG))
        Set oItem = .Add(cmdTypeDefault, cmdIBAutoLog, "&Auto Log on/off", RES.Bitmap16ID(IDB_16_BACKUP_ST_AUTO))
        
        'Instance\Recovery
        Set oItem = .Add(cmdTypeSubCommand, cmdIRecovery, "&Recovery", RES.Bitmap16ID(IDB_16_BACKUP_RESTORE))
        Set oItem = .Add(cmdTypeDefault, cmdIRDatabase, "&Database", RES.Bitmap16ID(IDB_16_DB))
        Set oItem = .Add(cmdTypeDefault, cmdIRIndexes, "&Indexes", RES.Bitmap16ID(IDB_16_INDEXES))
        Set oItem = .Add(cmdTypeDefault, cmdIRDevspaces, "&Volumes", RES.Bitmap16ID(IDB_16_REINTEGRATE_DEVSPACE))
        
        'Instance\Tuning
        Set oItem = .Add(cmdTypeSubCommand, cmdITuning, "&Tuning", RES.Bitmap16ID(IDB_16_MAINTENANCE))
        Set oItem = .Add(cmdTypeDefault, cmdITOptStat, "&Optimizer Statistics", RES.Bitmap16ID(IDB_16_UPDSTAT))
        Set oItem = .Add(cmdTypeDefault, cmdITIndexUse, "&Index Use", RES.Bitmap16ID(IDB_16_INDEXES))
        
        'Instance\Check
        Set oItem = .Add(cmdTypeSubCommand, cmdICheck, "Ch&eck", RES.Bitmap16ID(IDB_16_DIAGNOSE))
        Set oItem = .Add(cmdTypeDefault, cmdICDatabase, "&Database Structure", RES.Bitmap16ID(IDB_16_VERIFY))
        Set oItem = .Add(cmdTypeDefault, cmdICBackup, "&Backup", RES.Bitmap16ID(IDB_16_CHECK_MEDIUM))
        Set oItem = .Add(cmdTypeDefault, cmdICEventMonitor, "&Events", RES.Bitmap16ID(IDB_16_EVENT_MONITOR))
        Set oItem = .Add(cmdTypeDefault, cmdICServer, "Database &Server", RES.Bitmap16ID(IDB_16_SHOWS))
        Set oItem = .Add(cmdTypeDefault, cmdICFiles, "Diagnosis &Files", RES.Bitmap16ID(IDB_16_FILES))
        Set oItem = .Add(cmdTypeDefault, cmdICKernelTrace, "&Kernel Trace", RES.Bitmap16ID(IDB_16_DIAG_KNLTRACE))
        
        'Instance\Config
        Set oItem = .Add(cmdTypeSubCommand, cmdIConfiguration, "Confi&guration", RES.Bitmap16ID(IDB_16_CONFIGURATION))
        Set oItem = .Add(cmdTypeDefault, cmdICMedia, "&Backup Medium", RES.Bitmap16ID(IDB_16_BACKUP_MEDIA))
        Set oItem = .Add(cmdTypeDefault, cmdICParameters, "&Parameters", RES.Bitmap16ID(IDB_16_PARAMETERS))
        Set oItem = .Add(cmdTypeDefault, cmdICDevSpaceData, "&Data Volumes", RES.Bitmap16ID(IDB_16_DEVSPACES))
        Set oItem = .Add(cmdTypeDefault, cmdICDevSpaceLog, "&Log Volumes", RES.Bitmap16ID(IDB_16_DEVSPACES))
        Set oItem = .Add(cmdTypeDefault, cmdICLogMode, "Log &Mode", RES.Bitmap16ID(IDB_16_LOGMODE_SINGLE))
        Set oItem = .Add(cmdTypeDefault, cmdICUsers, "&Users", RES.Bitmap16ID(IDB_16_USERS))
        Set oItem = .Add(cmdTypeDefault, cmdICMapcharSets, "M&apchar Sets", RES.Bitmap16ID(IDB_16_MAPCHARSETS))
        Set oItem = .Add(cmdTypeDefault, cmdICTermcharSets, "&Termchar Sets", RES.Bitmap16ID(IDB_16_TERMCHARSETS))
        Set oItem = .Add(cmdTypeDefault, cmdICLoadSysTabs, "Upgrade &System Tables", RES.Bitmap16ID(IDB_16_SYSTABLES))
        Set oItem = .Add(cmdTypeDefault, cmdICEvents, "&Events", RES.Bitmap16ID(IDB_16_EVENTS))
        
        Set oItem = .Add(cmdTypeDefault, cmdICommandLine, "Co&mmand Line", RES.Bitmap16ID(IDB_16_COMMAND))
        Set oItem = .Add(cmdTypeDefault, cmdISessions, "Sessi&ons", RES.Bitmap16ID(IDB_16_SESSIONS))
        
        Set oItem = .Add(cmdTypeDefault, cmdIAutoLogOn, "Set Auto &Log ON")
        Set oItem = .Add(cmdTypeDefault, cmdIAutoLogOff, "Set Auto &Log OFF")
        
        
        Set oItem = .Add(cmdTypeDefault, cmdIDrop, "&Drop", RES.Bitmap16ID(IDB_16_DELETE))
        Set oItem = .Add(cmdTypeDefault, cmdICancel, "&Stop Last Action", RES.Bitmap16ID(IDB_16_STOP))
        
        ' Tools
        Set oItem = .Add(cmdTypeSubCommand, cmdTools, "&Tools")
        Set oItem = .Add(cmdTypeDefault, cmdTSQLStudio, "S&QL Studio", RES.Bitmap16ID(IDB_16_SQL_STUDIO))
        
        ' Help
        Set oItem = .Add(cmdTypeSubCommand, cmdHelp, "&Help")
        Set oItem = .Add(cmdTypeDefault, cmdHContents, "&Contents")
        Set oItem = .Add(cmdTypeDefault, cmdHSearch, "&Search...", RES.Bitmap16ID(IDB_16_HELP_SEARCH))
        Set oItem = .Add(cmdTypeDefault, cmdHWeb, "www.sapdb.org")
        Set oItem = .Add(cmdTypeDefault, cmdHAbout, "&About Database Manager")
        Set oItem = .Add(cmdTypeDefault, cmdHInfo, "&Information")
        Set oItem = .Add(cmdTypeDefault, cmdHFiles, "&Files")
        
        Set oItem = .Add(cmdTypeDefault, cmdRefreshFolder, "&Refresh", RES.Bitmap16ID(IDB_16_REFRESH))
        Set oItem = .Add(cmdTypeDefault, cmdRefreshDatabase, "&Refresh", RES.Bitmap16ID(IDB_16_REFRESH))
        
        Set oItem = .Add(cmdTypeDefault, cmdDebugTrace, "&Trace")
        
        Set oItem = .Add(cmdTypeSeperator, cmdSeperator)
    
    End With
    
    SetInstance
    SetVersions
End Sub

Public Sub CommandsMake()
    MakeMenu
    MakeToolBar
    MakeOutMenu
    MakePopups
End Sub
'
' Menu
'
Private Sub MakeMenu()
    Dim oSub As DBMCmd.MenuBarItem
    Dim oSubSub As DBMCmd.MenuBarItem
    Dim oItem As DBMCmd.MenuBarItem
    
    Set FRM.MBR.CommandList = FRM.CML
        
    FRM.MBR.ImageChecked = RES.Bitmap16ID(IDB_16_SMALL_CHECK)
    FRM.MBR.ImageUnChecked = RES.Bitmap16ID(IDB_16_EMPTY)
    
    ' File
    
    With FRM.MBR.MenuBarItems
        Set oSub = .Add(cmdFile)
    End With
    With oSub.MenuBarItems
        If GUI.Mode = dbmGUIModeConfigFile Then
            Set oItem = .Add(cmdFOpen)
            Set oItem = .Add(cmdSeperator)
            Set oItem = .Add(cmdFSave)
            Set oItem = .Add(cmdFSaveAs)
            Set oItem = .Add(cmdSeperator)
            Set oItem = .Add(cmdFRegister)
            Set oItem = .Add(cmdSeperator)
        End If
        If GUI.Mode = dbmGUIModeDefault Then
            Set oItem = .Add(cmdFNewFolder)
            Set oItem = .Add(cmdFRegister)
            Set oItem = .Add(cmdSeperator)
        End If
'        Set oItem = .Add(cmdFPrint)
'        Set oItem = .Add(cmdFPrintSetup)
'        Set oItem = .Add(cmdSeperator)
    End With
    
    ' File\Messages
    
    With oSub.MenuBarItems
        Set oSubSub = .Add(cmdFMessages)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdFMProperties)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFMClearItem)
        Set oItem = .Add(cmdFMClearAll)
    End With
    
    ' File
    
    With oSub.MenuBarItems
        Set oItem = .Add(cmdSeperator)
        If GUI.Mode = dbmGUIModeDefault Or _
           GUI.Mode = dbmGUIModeConfigFile _
        Then
            Set oItem = .Add(cmdFUnregister)
            Set oItem = .Add(cmdFDelete)
            Set oItem = .Add(cmdFRename)
        End If
        Set oItem = .Add(cmdFProperties)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFExit)
    End With
        
    ' Edit
    
    With FRM.MBR.MenuBarItems
        Set oSub = .Add(cmdEdit)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdEUndo)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdECut)
        Set oItem = .Add(cmdECopy)
        Set oItem = .Add(cmdEPaste)
        Set oItem = .Add(cmdEDelete)
    End With
    
    ' View
    
    With FRM.MBR.MenuBarItems
        Set oSub = .Add(cmdView)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdVRefresh)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdVLargeIcons)
        Set oItem = .Add(cmdVSmallIcons)
        Set oItem = .Add(cmdVList)
        Set oItem = .Add(cmdVDetails)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdNextDocument)
        Set oItem = .Add(cmdPrevDocument)
        Set oItem = .Add(cmdDocuments)
        Set oItem = .Add(cmdSeperator)
        If GUI.Mode = dbmGUIModeDefault Then
            Set oItem = .Add(cmdVTree)
        End If
        Set oItem = .Add(cmdVMenu)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdVOptions)
    End With
    
    ' Instance
    
    With FRM.MBR.MenuBarItems
        Set oSub = .Add(cmdInstance)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdIViewDetails)
        Set oItem = .Add(cmdSeperator)
        If GUI.Mode = dbmGUIModeDefault Or _
           GUI.Mode = dbmGUIModeConfigFile _
        Then
            Set oItem = .Add(cmdIInstall)
            Set oItem = .Add(cmdSeperator)
        End If
        Set oItem = .Add(cmdIDisconnect)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIOffline)
        Set oItem = .Add(cmdICold)
        Set oItem = .Add(cmdIOnline)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIRestartUntil)
    End With
    
    ' Instance\Info
    
    With oSub.MenuBarItems
        Set oItem = .Add(cmdSeperator)
        Set oSubSub = .Add(cmdIInfo)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdIIHistory)
        Set oItem = .Add(cmdIICaches)
        Set oItem = .Add(cmdIIData)
        Set oItem = .Add(cmdIIIO)
        Set oItem = .Add(cmdIILog)
        Set oItem = .Add(cmdIILocks)
        Set oItem = .Add(cmdIISessions)
        Set oItem = .Add(cmdIIVersions)
        Set oItem = .Add(cmdIIOMSCaches)
        Set oItem = .Add(cmdIIOMSMonitor)
        Set oItem = .Add(cmdIIOMSClasscontainers)
    End With
    
    ' Instance\Backup
    
    With oSub.MenuBarItems
        Set oSubSub = .Add(cmdIBackup)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdIBComplete)
        Set oItem = .Add(cmdIBIncremental)
        Set oItem = .Add(cmdIBLog)
        Set oItem = .Add(cmdIBAutoLog)
    End With
    
    ' Instance\Recovery

    With oSub.MenuBarItems
        Set oSubSub = .Add(cmdIRecovery)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdIRDatabase)
        Set oItem = .Add(cmdIRIndexes)
        Set oItem = .Add(cmdIRDevspaces)
    End With
    
    ' Instance\Tuning
    
    If CMD_ITUNING Then
        With oSub.MenuBarItems
            Set oSubSub = .Add(cmdITuning)
        End With
        With oSubSub.MenuBarItems
            Set oItem = .Add(cmdITOptStat)
            Set oItem = .Add(cmdITIndexUse)
        End With
    End If
    
    ' Instance\Check

    With oSub.MenuBarItems
        Set oSubSub = .Add(cmdICheck)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdICDatabase)
        Set oItem = .Add(cmdICBackup)
        If CMD_IDEVENTMONITOR Then
            Set oItem = .Add(cmdICEventMonitor)
        End If
        Set oItem = .Add(cmdICServer)
        Set oItem = .Add(cmdICFiles)
        Set oItem = .Add(cmdICKernelTrace)
    End With
    
    ' Instance\Config

    With oSub.MenuBarItems
        Set oSubSub = .Add(cmdIConfiguration)
    End With
    With oSubSub.MenuBarItems
        Set oItem = .Add(cmdICMedia)
        Set oItem = .Add(cmdICParameters)
        Set oItem = .Add(cmdICDevSpaceData)
        Set oItem = .Add(cmdICDevSpaceLog)
        Set oItem = .Add(cmdICLogMode)
        Set oItem = .Add(cmdICUsers)
        Set oItem = .Add(cmdICMapcharSets)
        Set oItem = .Add(cmdICTermcharSets)
        Set oItem = .Add(cmdICLoadSysTabs)
        If CMD_ICEVENTS Then
            Set oItem = .Add(cmdICEvents)
        End If
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdICommandLine)
        Set oItem = .Add(cmdISessions)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIAutoLogOn)
        Set oItem = .Add(cmdIAutoLogOff)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIDrop)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdICancel)
    End With
    
    ' Tools
    
    With FRM.MBR.MenuBarItems
        Set oSub = .Add(cmdTools)
    End With
    With oSub.MenuBarItems
        Set oItem = .Add(cmdTSQLStudio)
    End With
    
    ' Help
    
    With FRM.MBR.MenuBarItems
        Set oSub = .Add(cmdHelp)
    End With
    With oSub.MenuBarItems
'        Set oItem = .Add(cmdHContents)
'        Set oItem = .Add(cmdHSearch)
'        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdHWeb)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdHAbout)
        Set oItem = .Add(cmdHInfo)
        Set oItem = .Add(cmdHFiles)
    End With
    
End Sub
'
' Toolbar
'
Private Sub MakeToolBar()
    Dim oItem As DBMCmd.ToolbarItem

    Set FRM.TBR.CommandList = FRM.CML

    With FRM.TBR.ToolbarItems
        If GUI.Mode = dbmGUIModeDefault Or _
           GUI.Mode = dbmGUIModeConfigFile _
        Then
            Set oItem = .Add(cmdFRegister)
            Set oItem = .Add(cmdIInstall)
            Set oItem = .Add(cmdSeperator)
        End If
        Set oItem = .Add(cmdIDisconnect)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIOffline)
        Set oItem = .Add(cmdICold)
        Set oItem = .Add(cmdIOnline)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdVRefresh)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdICancel)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdVLargeIcons)
        Set oItem = .Add(cmdVSmallIcons)
        Set oItem = .Add(cmdVList)
        Set oItem = .Add(cmdVDetails)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdNextDocument)
        Set oItem = .Add(cmdPrevDocument)
        Set oItem = .Add(cmdDocuments)
    End With
End Sub
'
' OutMenu
'
Private Sub MakeOutMenu()
    Dim oSub As DBMCmd.OutMenuItem
    Dim oItem As DBMCmd.OutMenuItem

    Set FRM.OUT.CommandList = FRM.CML

    ' Info
    
    With FRM.OUT.OutMenuItems
        Set oSub = .Add(cmdIInfo)
    End With
    With oSub.OutMenuItems
        Set oItem = .Add(cmdIIHistory)
        Set oItem = .Add(cmdIICaches)
        Set oItem = .Add(cmdIIData)
        Set oItem = .Add(cmdIIIO)
        Set oItem = .Add(cmdIILog)
        Set oItem = .Add(cmdIILocks)
        Set oItem = .Add(cmdIISessions)
        Set oItem = .Add(cmdIIVersions)
        Set oItem = .Add(cmdIIOMSCaches)
        Set oItem = .Add(cmdIIOMSMonitor)
        Set oItem = .Add(cmdIIOMSClasscontainers)
    End With
    
    ' Backup
    
    With FRM.OUT.OutMenuItems
        Set oSub = .Add(cmdIBackup)
    End With
    With oSub.OutMenuItems
        Set oItem = .Add(cmdIBComplete)
        Set oItem = .Add(cmdIBIncremental)
        Set oItem = .Add(cmdIBLog)
        Set oItem = .Add(cmdIBAutoLog)
    End With

    ' Recovery
    
    With FRM.OUT.OutMenuItems
        Set oSub = .Add(cmdIRecovery)
    End With
    With oSub.OutMenuItems
        Set oItem = .Add(cmdIRDatabase)
        Set oItem = .Add(cmdIRIndexes)
        Set oItem = .Add(cmdIRDevspaces)
    End With
    
    ' Tuning

    If CMD_ITUNING Then
        With FRM.OUT.OutMenuItems
            Set oSub = .Add(cmdITuning)
        End With
        With oSub.OutMenuItems
            Set oItem = .Add(cmdITOptStat)
            Set oItem = .Add(cmdITIndexUse)
        End With
    End If
    
    ' Check

    With FRM.OUT.OutMenuItems
        Set oSub = .Add(cmdICheck)
    End With
    With oSub.OutMenuItems
        Set oItem = .Add(cmdICDatabase)
        Set oItem = .Add(cmdICBackup)
        If CMD_IDEVENTMONITOR Then
            Set oItem = .Add(cmdICEventMonitor)
        End If
        Set oItem = .Add(cmdICServer)
        Set oItem = .Add(cmdICFiles)
        Set oItem = .Add(cmdICKernelTrace)
    End With
    
    ' Config
    
    With FRM.OUT.OutMenuItems
        Set oSub = .Add(cmdIConfiguration)
    End With
    With oSub.OutMenuItems
        Set oItem = .Add(cmdICMedia)
        Set oItem = .Add(cmdICParameters)
        Set oItem = .Add(cmdICDevSpaceData)
        Set oItem = .Add(cmdICDevSpaceLog)
        Set oItem = .Add(cmdICLogMode)
        Set oItem = .Add(cmdICUsers)
        Set oItem = .Add(cmdICMapcharSets)
        Set oItem = .Add(cmdICTermcharSets)
        Set oItem = .Add(cmdICLoadSysTabs)
        If CMD_ICEVENTS Then
            Set oItem = .Add(cmdICEvents)
        End If
    End With
End Sub
'
' Popups
'
Private Sub MakePopups()
    Set FRM.POP.CommandList = FRM.CML

    MakePopupFolders
    MakePopupFolder
    MakePopupDatabases
    MakePopupDatabase
    MakePopupReport
    MakePopupReportItem
    MakePopupDebug
End Sub

Private Sub MakePopupFolders()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdFNewFolder)
    End With
End Sub

Private Sub MakePopupFolder()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdFNewFolder)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFDelete)
        Set oItem = .Add(cmdFRename)
        Set oItem = .Add(cmdFProperties)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdRefreshFolder)
    End With
End Sub

Private Sub MakePopupDatabases()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        If GUI.Mode = dbmGUIModeDefault Or _
           GUI.Mode = dbmGUIModeConfigFile _
        Then
            Set oItem = .Add(cmdFRegister)
            Set oItem = .Add(cmdIInstall)
            Set oItem = .Add(cmdSeperator)
        End If
        Set oItem = .Add(cmdRefreshFolder)
    End With
End Sub

Private Sub MakePopupDatabase()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdIViewDetails)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIDisconnect)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIOffline)
        Set oItem = .Add(cmdICold)
        Set oItem = .Add(cmdIOnline)
    End With
    With oMenu.PopupItems
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdIAutoLogOn)
        Set oItem = .Add(cmdIAutoLogOff)
        Set oItem = .Add(cmdSeperator)
        If GUI.Mode = dbmGUIModeDefault Or _
           GUI.Mode = dbmGUIModeConfigFile _
        Then
            Set oItem = .Add(cmdFUnregister)
            Set oItem = .Add(cmdFRename)
        End If
        Set oItem = .Add(cmdFProperties)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdRefreshDatabase)
    End With
End Sub

Private Sub MakePopupReport()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdFMClearAll)
    End With
End Sub

Private Sub MakePopupReportItem()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdFMProperties)
        Set oItem = .Add(cmdSeperator)
        Set oItem = .Add(cmdFMClearItem)
        Set oItem = .Add(cmdFMClearAll)
    End With
End Sub

Private Sub MakePopupDebug()
    Dim oMenu As DBMCmd.PopupMenu
    Dim oSub As DBMCmd.PopupItem
    Dim oItem As DBMCmd.PopupItem
    
    Set oMenu = FRM.POP.PopupMenus.Add
    
    With oMenu.PopupItems
        Set oItem = .Add(cmdDebugTrace)
    End With
End Sub

'''

Private Sub SetInstance()
    Dim oItem As DBMCmd.CommandItem
    Dim lNoLVC As Long
    
    lNoLVC = CMD_INST_OLTP + CMD_INST_CS + CMD_INST_BW
    
    With FRM.CML.CommandItems
        ' Info
        .Item(cmdIIOMSCaches).InstanceType = CMD_INST_LVC
        .Item(cmdIIOMSMonitor).InstanceType = CMD_INST_LVC
        .Item(cmdIIOMSClasscontainers).InstanceType = CMD_INST_LVC
        
        ' Backup
        .Item(cmdIBIncremental).InstanceType = lNoLVC
        .Item(cmdIBLog).InstanceType = lNoLVC
        .Item(cmdIBAutoLog).InstanceType = lNoLVC
        
        .Item(cmdIAutoLogOn).InstanceType = lNoLVC
        .Item(cmdIAutoLogOff).InstanceType = lNoLVC
        
        ' Restore
        .Item(cmdIRIndexes).InstanceType = lNoLVC
        .Item(cmdIRDevspaces).InstanceType = lNoLVC

        ' Tunning
        .Item(cmdITOptStat).InstanceType = lNoLVC
    End With
End Sub

Private Sub SetVersions()
    Dim oItem As DBMCmd.CommandItem
    
    With FRM.CML.CommandItems
        .Item(cmdIICaches).VersionNumber = V72
        .Item(cmdIIData).VersionNumber = V72
        .Item(cmdIIIO).VersionNumber = V72
        .Item(cmdIILog).VersionNumber = V72
        .Item(cmdIILocks).VersionNumber = V72
        .Item(cmdIISessions).VersionNumber = V72
        .Item(cmdIIVersions).VersionNumber = V72
        .Item(cmdIIOMSCaches).VersionNumber = V72
        .Item(cmdIIOMSMonitor).VersionNumber = V72
        .Item(cmdIIOMSClasscontainers).VersionNumber = V72
        
        .Item(cmdIRIndexes).VersionNumber = V72
        .Item(cmdIRDevspaces).VersionNumber = V72
        
        .Item(cmdITOptStat).VersionNumber = V72
        .Item(cmdITIndexUse).VersionNumber = V72
        
        .Item(cmdICDatabase).VersionNumber = V72
        .Item(cmdICBackup).VersionNumber = V72
        .Item(cmdICEventMonitor).VersionNumber = V72
        .Item(cmdICServer).VersionNumber = V72
        .Item(cmdICEvents).VersionNumber = V72
        
        .Item(cmdICUsers).VersionNumber = V72
    End With
End Sub

