Attribute VB_Name = "DBListView"
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'''

Const GWL_WNDPROC = (-4)

Private Declare Function GetWindowLong Lib "user32.dll" Alias "GetWindowLongA" ( _
    ByVal hWnd As Long, _
    ByVal nIndex As Long) As Long
    
Declare Function SetWindowLong Lib "user32.dll" Alias "SetWindowLongA" ( _
    ByVal hWnd As Long, _
    ByVal nIndex As Long, _
    ByVal dwNewLong As Long) As Long
    
Declare Function CallWindowProc Lib "user32.dll" Alias "CallWindowProcA" ( _
    ByVal lpPrevWndFunc As Long, _
    ByVal hWnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long) As Long

'''

Const NM_FIRST = -0&     ' (0U- 0U) ' // generic to all controls
Const NM_LAST = -99&     ' (0U- 99U)
Const NM_OUTOFMEMORY = (NM_FIRST - 1)
Const NM_CLICK = (NM_FIRST - 2)
Const NM_DBLCLK = (NM_FIRST - 3)
Const NM_RETURN = (NM_FIRST - 4)
Const NM_RCLICK = (NM_FIRST - 5)
Const NM_RDBLCLK = (NM_FIRST - 6)
Const NM_SETFOCUS = (NM_FIRST - 7)
Const NM_KILLFOCUS = (NM_FIRST - 8)
Const NM_CUSTOMDRAW = (NM_FIRST - 12)
Const NM_HOVER = (NM_FIRST - 13)

'''

Private Type NMHDR
    hwndFrom As Long
    idFrom As Long
    code As Long
End Type

Private Type NMCUSTOMDRAWINFO
    hdr As NMHDR
    dwDrawStage As Long
    hdc As Long
    RC As RECT
    dwItemSpec As Long
    iItemState As Long
    lItemlParam As Long
End Type

Private Type NMLVCUSTOMDRAW
    nmcmd As NMCUSTOMDRAWINFO
    clrText As Long
    clrTextBk As Long
    iSubItem As Integer
End Type

Const WM_NOTIFY& = &H4E

Const CDDS_PREPAINT& = &H1
Const CDDS_POSTPAINT& = &H2
Const CDDS_PREERASE& = &H3
Const CDDS_POSTERASE& = &H4
Const CDDS_ITEM& = &H10000
Const CDDS_ITEMPREPAINT& = CDDS_ITEM Or CDDS_PREPAINT
Const CDDS_ITEMPOSTPAINT& = CDDS_ITEM Or CDDS_POSTPAINT
Const CDDS_ITEMPREERASE& = CDDS_ITEM Or CDDS_PREERASE
Const CDDS_ITEMPOSTERASE& = CDDS_ITEM Or CDDS_POSTERASE
Const CDDS_SUBITEM& = &H20000

Const CDRF_DODEFAULT& = &H0
Const CDRF_NEWFONT& = &H2
Const CDRF_SKIPDEFAULT& = &H4
Const CDRF_NOTIFYPOSTPAINT& = &H10
Const CDRF_NOTIFYITEMDRAW& = &H20
Const CDRF_NOTIFYSUBITEMDRAW = &H20     ' flags are the same, we can distinguish by context
Const CDRF_NOTIFYPOSTERASE& = &H40
Const CDRF_NOTIFYITEMERASE& = &H80

Private Declare Sub CopyMemory Lib "Kernel32.dll" Alias "RtlMoveMemory" ( _
    pDest As Any, _
    pSource As Any, _
    ByVal dwLength As Long)

'''

Private Declare Function FillRect Lib "user32.dll" ( _
    ByVal hdc As Long, _
    lpRect As RECT, _
    ByVal hBrush As Long) As Long

Private Declare Function GetSysColor Lib "user32.dll" ( _
    ByVal nIndex As Long) As Long

Const COLOR_WINDOW = 5

Private Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" ( _
    ByVal hWnd As Long, _
    ByVal Msg As Long, _
    ByVal wParam As Long, _
    lParam As Any) As Long
    
Const LVM_FIRST = &H1000
Const LVM_GETSUBITEMRECT = (LVM_FIRST + 56)

'''

Private Declare Function CreatePen Lib "gdi32.dll" ( _
    ByVal nPenStyle As Long, _
    ByVal nWidth As Long, _
    ByVal crColor As Long) As Long

Private Declare Function CreateSolidBrush Lib "gdi32.dll" ( _
    ByVal crColor As Long) As Long

Private Declare Function DeleteObject Lib "gdi32.dll" ( _
    ByVal hObject As Long) As Integer


Private Declare Function LineTo Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal X As Long, _
    ByVal Y As Long) As Long

Private Declare Function MoveToEx Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    lpPoint As POINTAPI) As Long

Private Declare Function SelectObject Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal hObject As Long) As Long

Private Declare Function SetROP2 Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal nDrawMode As Long) As Long
    
Const R2_MERGEPENNOT = 14

Private Declare Function Rectangle Lib "gdi32.dll" ( _
    ByVal hdc As Long, _
    ByVal X1 As Long, _
    ByVal Y1 As Long, _
    ByVal X2 As Long, _
    ByVal Y2 As Long) As Long

'''

Private Declare Function DrawText Lib "user32.dll" Alias "DrawTextA" ( _
    ByVal hdc As Long, _
    ByVal lpStr As String, _
    ByVal nCount As Long, _
    lpRect As RECT, _
    ByVal wFormat As Long) As Long

Const DT_LEFT = &H0
Const DT_TOP = &H0
Const DT_CENTER = &H1
Const DT_RIGHT = &H2
Const DT_VCENTER = &H4
Const DT_BOTTOM = &H8
Const DT_WORDBREAK = &H10
Const DT_SINGLELINE = &H20
Const DT_EXPANDTABS = &H40
Const DT_TABSTOP = &H80
Const DT_NOCLIP = &H100
Const DT_EXTERNALLEADING = &H200
Const DT_CALCRECT = &H400
Const DT_NOPREFIX = &H800
Const DT_INTERNAL = &H1000
Const DT_EDITCONTROL = &H2000
Const DT_PATH_ELLIPSIS = &H4000
Const DT_END_ELLIPSIS = &H8000
Const DT_MODIFYSTRING = &H10000
Const DT_RTLREADING = &H20000
Const DT_WORD_ELLIPSIS = &H40000

'''

Private Type ColorBytesType
    bRed As Byte
    bGreen As Byte
    bBlue As Byte
    bDummy As Byte
End Type

Private Type ColorType
    lColor As Long
End Type

Private tColorBytes As ColorBytesType
Private tColor As ColorType

'''

Private lWinProc As Long
Private hWndHook As Long
Private oLVW As MSComctlLib.ListView

'''

Public Enum FloodbarTypeConstants
    fbtDefault
    fbtSimple
    fbtHot
End Enum
    
Public Enum SpecialColumnConstants
    colData
    colLog
    colSessions
    colBackup
End Enum

Private Type ColumnSetting
    iColPos As Integer
    lType As FloodbarTypeConstants
End Type

Const MAX_COL = 3

Private aCols(MAX_COL + 1) As ColumnSetting
    
'''

Public Sub SetCol(ByVal lCol As SpecialColumnConstants, _
                  ByVal iColPos As Integer, _
                  ByVal lType As FloodbarTypeConstants)
                  
    With aCols(lCol)
        .iColPos = iColPos
        .lType = lType
    End With
End Sub

Public Sub Hook(hWnd As Long, oListView As MSComctlLib.ListView)
    lWinProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf WinProc)
    hWndHook = hWnd
    Set oLVW = oListView
End Sub

Public Sub UnHook()
    Call SetWindowLong(hWndHook, GWL_WNDPROC, lWinProc)
End Sub

Public Function WinProc(ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim tMessage As NMHDR
    Dim tLVCustomDraw As NMLVCUSTOMDRAW
    Dim bDefault As Boolean
    Dim rcSubItem As RECT
    Dim bFound As Boolean
    Dim l As Long
    Dim lCol As SpecialColumnConstants
    Dim sValue As String
    Dim iValue As Integer

    Select Case Msg
        
        Case WM_NOTIFY:
            CopyMemory tMessage, ByVal lParam, Len(tMessage)
            
            Select Case tMessage.code
                Case NM_CUSTOMDRAW
                
                    If tMessage.hwndFrom <> oLVW.hWnd Then
                        WinProc = CallWindowProc(lWinProc, hWnd, Msg, wParam, lParam)
                        Exit Function
                    End If
                    
                    CopyMemory tLVCustomDraw, ByVal lParam, Len(tLVCustomDraw)
                    
                    If tLVCustomDraw.nmcmd.dwDrawStage = CDDS_PREPAINT Then
                        WinProc = CDRF_NOTIFYITEMDRAW
                        Exit Function
                    End If
                    
                    If tLVCustomDraw.nmcmd.dwDrawStage = CDDS_ITEMPREPAINT Then
                        WinProc = CDRF_NOTIFYSUBITEMDRAW
                    End If

                    If tLVCustomDraw.nmcmd.dwDrawStage = (CDDS_ITEMPREPAINT + CDDS_SUBITEM) Then
                        bDefault = True
                              
                        With tLVCustomDraw
                        
                            bFound = False
                            
                            For l = 0 To MAX_COL
                                If .iSubItem = aCols(l).iColPos And _
                                   aCols(l).iColPos _
                                Then
                                    lCol = l
                                    bFound = True
                                    Exit For
                                End If
                            Next
                            
                            If bFound Then
                                rcSubItem.Top = .iSubItem
                                rcSubItem.Left = 0 ' LVIR_BOUNDS
                                Call SendMessage(oLVW.hWnd, LVM_GETSUBITEMRECT, .nmcmd.dwItemSpec, rcSubItem)
                                sValue = oLVW.ListItems(.nmcmd.dwItemSpec + 1).SubItems(.iSubItem)
                                If Len(sValue) = 0 Then
                                    DrawNothing .nmcmd.hdc, rcSubItem
                                Else
                                    If IsNumeric(sValue) Then
                                        iValue = Val(sValue)
                                        DrawFloodBar .nmcmd.hdc, rcSubItem, iValue, aCols(lCol).lType
                                    Else
                                        DrawTextOnly .nmcmd.hdc, rcSubItem, sValue
                                    End If
                                End If
                                bDefault = False
                            End If
                        End With
                        
                        If Not bDefault Then
                            CopyMemory ByVal lParam, tLVCustomDraw, Len(tLVCustomDraw)
                            WinProc = CDRF_SKIPDEFAULT
                        Else
                            WinProc = CDRF_DODEFAULT
                        End If
                    End If

                Case Else
                    WinProc = CallWindowProc(lWinProc, hWnd, Msg, wParam, lParam)
                    Exit Function
                    
            End Select
    
        Case Else
            WinProc = CallWindowProc(lWinProc, hWnd, Msg, wParam, lParam)
            Exit Function
    
    End Select

End Function

Private Sub DrawNothing(hdc As Long, RC As RECT)
    Dim hBrush As Long
    Dim hBrushOld As Long
    hBrush = CreateSolidBrush(GetSysColor(COLOR_WINDOW))
    Call FillRect(hdc, RC, hBrush)
    Call DeleteObject(hBrush)
End Sub

Private Sub DrawTextOnly(hdc As Long, RC As RECT, sText As String)
    With RC
        .Left = .Left + 4
        .Top = .Top + 1
        .Right = .Right - 4
        .Bottom = .Bottom - 1
    End With
        
    Call DrawText(hdc, sText, Len(sText), RC, DT_SINGLELINE + DT_NOPREFIX + DT_NOCLIP + DT_VCENTER + DT_WORD_ELLIPSIS)
End Sub

Private Sub DrawFloodBar(hdc As Long, RC As RECT, iValue As Integer, lType As FloodbarTypeConstants)
    Dim hPenBlue As Long
    Dim hPenOld As Long
    Dim sText As String
    
    Dim rcLow As RECT
    Dim rcMed As RECT
    Dim rcHigh As RECT
    
    Dim lWidthLow As Long
    Dim lWidthMed As Long
    Dim lWidthHigh As Long

    Dim lWidth As Long
    
    Dim lBlue As Long
    Dim lYellow As Long
    Dim lRed As Long
    
    Dim nOldDrawMode  As Long
    
    lBlue = RGB(0, 0, 255)
    lYellow = RGB(255, 255, 0)
    lRed = RGB(255, 0, 0)
    
    With RC
        .Left = .Left + 1
        .Top = .Top + 1
        .Right = .Right - 1
        .Bottom = .Bottom - 1
    End With

    hPenBlue = CreatePen(0, 1, vbBlue)
    hPenOld = SelectObject(hdc, hPenBlue)
    Call Rectangle(hdc, RC.Left, RC.Top, RC.Right, RC.Bottom)
    Call SelectObject(hdc, hPenOld)
    Call DeleteObject(hPenBlue)
        
    sText = CStr(iValue) + " %"
    Call DrawText(hdc, sText, Len(sText), RC, DT_CENTER + DT_SINGLELINE + DT_NOPREFIX + DT_NOCLIP + DT_VCENTER + DT_WORD_ELLIPSIS)
    
    With RC
        .Left = .Left + 1
        .Top = .Top + 1
        .Right = .Right - 1
        .Bottom = .Bottom - 1
    End With
    
    lWidth = (iValue * RectWidth(RC)) / 100 - 1
    
    If lWidth > 0 Then
        nOldDrawMode = SetROP2(hdc, R2_MERGEPENNOT)

        Select Case lType
            Case fbtDefault:
                LSet rcLow = RC
                rcLow.Right = rcLow.Left + lWidth
                DrawBar hdc, rcLow, lBlue
            
            Case fbtSimple:
                lWidthLow = RectWidth(RC) * 50 / 100
                lWidthMed = RectWidth(RC) * 75 / 100
                lWidthHigh = RectWidth(RC)
                
                LSet rcLow = RC
                rcLow.Right = rcLow.Left + Min(lWidthLow, lWidth)
                DrawBar hdc, rcLow, lBlue
                    
                If lWidth >= lWidthLow Then
                    LSet rcMed = RC
                    rcMed.Left = rcLow.Right ' + 1
                    rcMed.Right = rcLow.Left + Min(lWidthMed, lWidth)
                    DrawBar hdc, rcMed, lYellow
                    
                    If lWidth >= lWidthMed Then
                        LSet rcHigh = RC
                        rcHigh.Left = rcMed.Right ' + 1
                        rcHigh.Right = rcLow.Left + Min(lWidthHigh, lWidth)
                        DrawBar hdc, rcHigh, lRed
                    End If
                End If
            
            Case fbtHot:
                LSet rcLow = RC
                LSet rcMed = RC
                LSet rcHigh = RC
            
                lWidthLow = RectWidth(RC) * 50 / 100
                lWidthMed = RectWidth(RC) * 75 / 100
                lWidthHigh = RectWidth(RC)
                
                rcLow.Right = rcLow.Left + lWidthLow
                rcMed.Left = rcLow.Right + 1
                rcMed.Right = rcLow.Left + lWidthMed
                rcHigh.Left = rcMed.Right + 1
                rcHigh.Right = rcLow.Left + lWidthHigh
    
                If lWidth < lWidthLow Then
                    DrawHotBar hdc, rcLow, lBlue, lBlue, lWidth
                Else
                    If lWidth < lWidthMed Then
                        DrawHotBar hdc, rcLow, lBlue, lBlue, lWidth
                        lWidth = lWidth - RectWidth(rcLow)
                        DrawHotBar hdc, rcMed, lBlue, lYellow, lWidth
                    Else
                        DrawHotBar hdc, rcLow, lBlue, lBlue, lWidth
                        lWidth = lWidth - RectWidth(rcLow)
                        DrawHotBar hdc, rcMed, lBlue, lYellow, lWidth
                        lWidth = lWidth - RectWidth(rcMed)
                        DrawHotBar hdc, rcHigh, lYellow, lRed, lWidth
                    End If
                End If
        End Select
        
        Call SetROP2(hdc, nOldDrawMode)

    End If
End Sub

Private Sub DrawBar(hdc As Long, RC As RECT, lColor As Long)
    Dim hPen As Long
    Dim hPenOld As Long
    Dim hBrush As Long
    Dim hBrushOld As Long

    Dim p As POINTAPI

    hPen = CreatePen(0, 1, lColor)
    hBrush = CreateSolidBrush(lColor)
                
    hPenOld = SelectObject(hdc, hPen)
    hBrushOld = SelectObject(hdc, hBrush)
    
    If RC.Right = RC.Left + 1 Then
        Call MoveToEx(hdc, RC.Left, RC.Top, p)
        Call LineTo(hdc, RC.Left, RC.Bottom)
    Else
        Call Rectangle(hdc, RC.Left, RC.Top, RC.Right, RC.Bottom)
    End If
    Call SelectObject(hdc, hBrushOld)
    Call SelectObject(hdc, hPenOld)

    Call DeleteObject(hPen)
    Call DeleteObject(hBrush)
End Sub

Private Sub DrawHotBar(hdc As Long, RC As RECT, lFirstColor As Long, lLastColor As Long, lWidth As Long)
    Dim sRedStep As Single
    Dim sGreenStep As Single
    Dim sBlueStep As Single
    
    Dim sRed As Single
    Dim sGreen As Single
    Dim sBlue As Single
    
    Dim lPos As Long
    Dim lMaxPos As Long
    Dim lColor As Long
    
    Dim hPen As Long
    Dim hPenOld As Long
    
    Dim p As POINTAPI
    
    lMaxPos = RectWidth(RC)
    
    sRedStep = GetRedStep(lFirstColor, lLastColor, lMaxPos)
    sGreenStep = GetGreenStep(lFirstColor, lLastColor, lMaxPos)
    sBlueStep = GetBlueStep(lFirstColor, lLastColor, lMaxPos)

    sRed = CSng(GetRed(lFirstColor))
    sGreen = CSng(GetGreen(lFirstColor))
    sBlue = CSng(GetBlue(lFirstColor))
    
    If lWidth < lMaxPos Then
        lMaxPos = lWidth
    End If
    
    For lPos = RC.Left To RC.Left + lMaxPos - 1
        lColor = RGB(CLng(sRed), CLng(sGreen), CLng(sBlue))
        hPen = CreatePen(0, 1, lColor)
        hPenOld = SelectObject(hdc, hPen)
        Call MoveToEx(hdc, lPos, RC.Top, p)
        Call LineTo(hdc, lPos, RC.Bottom)
        Call SelectObject(hdc, hPenOld)
        Call DeleteObject(hPen)
        
        sRed = sRed + sRedStep
        sGreen = sGreen + sGreenStep
        sBlue = sBlue + sBlueStep
    Next
End Sub

Private Function GetRedStep(ByVal lColor1 As Long, ByVal lColor2 As Long, ByVal lWidth As Long) As Single
    GetRedStep = (CSng(GetRed(lColor2) - GetRed(lColor1))) / CSng(lWidth)
End Function

Private Function GetGreenStep(ByVal lColor1 As Long, ByVal lColor2 As Long, ByVal lWidth As Long) As Single
    GetGreenStep = (CSng(GetGreen(lColor2) - GetGreen(lColor1))) / CSng(lWidth)
End Function

Private Function GetBlueStep(ByVal lColor1 As Long, ByVal lColor2 As Long, ByVal lWidth As Long) As Single
    GetBlueStep = (CSng(GetBlue(lColor2) - GetBlue(lColor1))) / CSng(lWidth)
End Function

Private Function GetRed(ByVal lColor As Long) As Long
    tColor.lColor = lColor
    LSet tColorBytes = tColor
    GetRed = CLng(tColorBytes.bRed)
End Function

Private Function GetGreen(ByVal lColor As Long) As Long
    tColor.lColor = lColor
    LSet tColorBytes = tColor
    GetGreen = CLng(tColorBytes.bGreen)
End Function

Private Function GetBlue(ByVal lColor As Long) As Long
    tColor.lColor = lColor
    LSet tColorBytes = tColor
    GetBlue = CLng(tColorBytes.bBlue)
End Function

Private Function RectWidth(RC As RECT) As Long
    RectWidth = RC.Right - RC.Left + 1
End Function

Private Function Min(l1 As Long, l2 As Long) As Long
    If l1 <= l2 Then
        Min = l1
    Else
        Min = l2
    End If
End Function

Private Function Max(l1 As Long, l2 As Long) As Long
    If l1 > l2 Then
        Max = l1
    Else
        Max = l2
    End If
End Function

