VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DatabaseCols"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const COL_NAM = "Name"
Const COL_STA = "State"
Const COL_DAT = "Data"
Const COL_LOG = "Log"
Const COL_SES = "Sessions"
Const COL_DCH = "Data Cache Hit Rate"
Const COL_CCH = "Converter Cache Hit Rate"
Const COL_AUT = "AutoLog"
Const COL_BAK = "Backup"
Const COL_SRV = "Server Name"
Const COL_DBN = "Database Name"
Const COL_DOS = "DB on Server"
Const COL_PAT = "Path"
Const COL_VER = "Version"
Const COL_BUI = "Build"
Const COl_KNL = "Kernel"
Const COl_OPS = "Operating System"
Const COL_BDE = "Bad Devspaces"
Const COL_BIN = "Bad Indexes"
Const COL_WAR = "Warning"
Const COL_DCO = "Data Cache OMS Hit Rate"
Const COL_DOL = "Data Cache OMS Log Hit Rate"

Public Enum DatabaseColumnConstants
    dbcolNone
    dbcolState
    dbcolData
    dbcolLog
    dbcolSessions
    dbcolDataHit
    dbcolConvHit
    dbcolAutoLog
    dbcolBackup
    dbcolServerName
    dbcolDatabaseName
    dbcolDBOnServer
    dbcolPath
    dbcolVersion
    dbcolBuild
    dbcolKernel
    dbcolOS
    dbcolBadDevspaces
    dbcolBadIndexes
    dbcolWarning
    dbcolDataHitOMS
    dbcolDataHitOMSLog
End Enum

Const FIRST_COL = dbcolState
Const MAX_COL = dbcolDataHitOMSLog

Private aColOrder(MAX_COL) As DatabaseColumnConstants

Private aColNumber(MAX_COL) As DatabaseColumnConstants

Public Property Get ColOrder(ByVal Index As Integer) As DatabaseColumnConstants
    If Index >= 0 And Index <= MAX_COL Then
        ColOrder = aColOrder(Index)
    Else
        ColOrder = dbcolNone
    End If
End Property
Public Property Let ColOrder(ByVal Index As Integer, ByVal NewVal As DatabaseColumnConstants)
    If Index >= 0 And Index <= MAX_COL Then
        aColOrder(Index) = NewVal
    End If
End Property

Public Property Get ColOrderString() As String
    Dim i As Integer
    Dim s As String
    s = ""
    For i = 0 To MAX_COL
        If aColOrder(i) >= FIRST_COL Then
            s = s + CStr(aColOrder(i)) + " "
        Else
            Exit For
        End If
    Next
    ColOrderString = Trim$(s)
End Property

Public Property Let ColOrderString(ByVal NewVal As String)
    Dim sCols As String
    Dim iPos1 As Integer
    Dim iPos2 As Integer
    Dim sCol As String
    Dim lCol As DatabaseColumnConstants
    Dim i As Integer
    Dim iCol As Integer
    
    sCols = Trim$(NewVal)
    
    If Len(sCols) = 0 Then
        SetDefault
    Else
        Clear
        
        i = 0
        iPos1 = 1
        Do While (iPos1 <= Len(sCols))
            iPos2 = InStr(iPos1, sCols, " ")
            If iPos2 > 0 Then
                sCol = Mid$(sCols, iPos1, iPos2 - iPos1)
                iPos1 = iPos2 + 1
            Else
                sCol = Mid$(sCols, iPos1)
                iPos1 = Len(sCols) + 1
            End If
            If IsNumeric(sCol) Then
                lCol = CLng(sCol)
            Else
                lCol = dbcolNone
                iPos1 = Len(sCols) + 1
            End If
        
            ColOrder(i) = lCol
            i = i + 1
        Loop
        
        iCol = 1
        For i = 0 To MAX_COL
            aColNumber(ColOrder(i)) = iCol
            iCol = iCol + 1
        Next
    End If
End Property

Public Property Get ColNameByOrder(ByVal Index As Integer) As String
    Dim s As String
    
    s = ""
    
    If Index >= 0 And Index <= MAX_COL Then
        s = ColNameByConst(aColOrder(Index))
    End If
    
    ColNameByOrder = s
End Property

Public Property Get ColNumberByConst(ByVal Column As DatabaseColumnConstants) As Integer
    ColNumberByConst = aColNumber(Column)
End Property

Public Property Get ColWidthString(ByVal oLVW As MSComctlLib.ListView) As String
    Dim i As Integer
    Dim s As String
    
    s = ""
    For i = 1 To oLVW.ColumnHeaders.Count
        s = s + CStr(CInt(FRM.ScaleX(oLVW.ColumnHeaders(i).Width, vbTwips, vbPixels))) + " "
    Next
    
    ColWidthString = Trim$(s)
End Property

Public Property Let ColWidthString(ByVal oLVW As MSComctlLib.ListView, ByVal NewVal As String)
    Dim sWidths As String
    Dim sWidth As String
    Dim lWidth As Long
    Dim iPos1 As Integer
    Dim iPos2 As Integer
    Dim iCol As Integer
    
    sWidths = Trim$(NewVal)
    
    If Len(sWidths) > 0 Then
        iCol = 1
        iPos1 = 1
        Do While (iPos1 <= Len(sWidths))
            iPos2 = InStr(iPos1, sWidths, " ")
            If iPos2 > 0 Then
                sWidth = Mid$(sWidths, iPos1, iPos2 - iPos1)
                iPos1 = iPos2 + 1
            Else
                sWidth = Mid$(sWidths, iPos1)
                iPos1 = Len(sWidths) + 1
            End If
            If IsNumeric(sWidth) Then
                lWidth = CLng(sWidth)
                If iCol <= oLVW.ColumnHeaders.Count Then
                    oLVW.ColumnHeaders(iCol).Width = FRM.ScaleX(lWidth, vbPixels, vbTwips)
                Else
                    iPos1 = Len(sWidths) + 1
                End If
            Else
                iPos1 = Len(sWidths) + 1
            End If
            
            iCol = iCol + 1
        Loop
    End If
End Property

'''

Public Sub SetDefault()
    Dim i As Integer
    Dim iCol As Integer
    
    Clear
    
    ColOrder(0) = dbcolState
    ColOrder(1) = dbcolData
    ColOrder(2) = dbcolLog
    ColOrder(3) = dbcolSessions
    ColOrder(4) = dbcolDataHit
    ColOrder(5) = dbcolConvHit
    ColOrder(6) = dbcolAutoLog
    ColOrder(7) = dbcolBackup
    
    iCol = 1
    For i = 0 To MAX_COL
        aColNumber(ColOrder(i)) = iCol
        iCol = iCol + 1
    Next
End Sub

Public Sub Clear()
    Dim i As Integer
    
    For i = 0 To MAX_COL
        aColOrder(i) = dbcolNone
        aColNumber(i) = 0
    Next
End Sub

Public Sub SetColumns(ByVal oLVW As MSComctlLib.ListView)
    Dim oItem As MSComctlLib.ColumnHeader
    Dim i As Integer
    
    oLVW.ListItems.Clear
    
    With oLVW.ColumnHeaders
        .Clear
        
        Set oItem = .Add(, , COL_NAM)
        
        For i = 0 To MAX_COL
            If ColOrder(i) > dbcolNone Then
                Set oItem = .Add(, , ColNameByOrder(i))
            Else
                Exit For
            End If
        Next
    End With
End Sub

Public Sub SetItem(ByVal oItem As MSComctlLib.ListItem, _
                   ByVal lColumn As DatabaseColumnConstants, _
                   ByVal sText As String, _
                   Optional ByVal lSubImage As Long = 0)
                   
    Dim iCol As Integer
                   
    iCol = aColNumber(lColumn)
    
    If iCol > 0 Then
        oItem.SubItems(iCol) = sText
'        If lSubImage > 0 Then
            oItem.ListSubItems(iCol).ReportIcon = lSubImage
'        End If
    End If
End Sub

Public Function GetItemText(ByVal oItem As MSComctlLib.ListItem, _
                            ByVal lColumn As DatabaseColumnConstants) As String
    Dim iCol As Integer
                   
    GetItemText = ""
    
    iCol = aColNumber(lColumn)
    
    If iCol > 0 Then
        GetItemText = oItem.SubItems(iCol)
    End If
End Function

''

Public Sub ConfigColsFill(ByVal lstLeft As ListBox, _
                          ByVal lstRight As ListBox)
    Dim i As Integer
    Dim lCol As DatabaseColumnConstants
    
    lstLeft.Clear
    lstRight.Clear
    
    For lCol = FIRST_COL To MAX_COL
        If Not ColSelected(lCol) Then
            lstLeft.AddItem ColNameByConst(lCol)
            lstLeft.ItemData(lstLeft.ListCount - 1) = lCol
        End If
    Next
    
    ' fixed column
    lstRight.AddItem COL_NAM
    lstRight.ItemData(lstRight.ListCount - 1) = -1
    
    For i = 0 To MAX_COL
        If ColOrder(i) > dbcolNone Then
            lstRight.AddItem ColNameByOrder(i)
            lstRight.ItemData(lstRight.ListCount - 1) = ColOrder(i)
        End If
    Next
End Sub

Public Sub ConfigColsSelect(ByVal lstLeft As ListBox, _
                            ByVal lstRight As ListBox)
    Dim iLeft As Integer
    Dim iRight As Integer
    
    If lstLeft.ListCount > 0 Then
        If lstLeft.ListIndex >= 0 Then
            If lstRight.ListIndex >= 0 Then
                iRight = lstRight.ListIndex + 1
            Else
                iRight = lstRight.ListCount
            End If
            lstRight.AddItem lstLeft.List(lstLeft.ListIndex), iRight
            lstRight.ItemData(iRight) = lstLeft.ItemData(lstLeft.ListIndex)
            lstRight.ListIndex = iRight
            
            iLeft = lstLeft.ListIndex
            lstLeft.RemoveItem iLeft
            If iLeft < lstLeft.ListCount Then
                lstLeft.ListIndex = iLeft
            Else
                lstLeft.ListIndex = lstLeft.ListCount - 1
            End If
        End If
    End If
End Sub

Public Sub ConfigColsSelectAll(ByVal lstLeft As ListBox, _
                               ByVal lstRight As ListBox)
    Dim i As Integer
    Dim iLeft As Integer
    Dim iRight As Integer
    
    If lstLeft.ListCount > 0 Then
        If lstRight.ListIndex >= 0 Then
            iRight = lstRight.ListIndex + 1
        Else
            iRight = lstRight.ListCount
        End If
        
        For i = 0 To lstLeft.ListCount - 1
            lstRight.AddItem lstLeft.List(i), iRight
            lstRight.ItemData(iRight) = lstLeft.ItemData(i)
            iRight = iRight + 1
        Next
        
        If iRight < lstRight.ListCount Then
            lstRight.ListIndex = iRight
        Else
            lstRight.ListIndex = lstRight.ListCount - 1
        End If
            
        lstLeft.Clear
    End If
End Sub

Public Sub ConfigColsUnselect(ByVal lstLeft As ListBox, _
                              ByVal lstRight As ListBox)
                          
    Dim lCol As DatabaseColumnConstants
    Dim i As Integer
    Dim iLeft As Integer
    Dim iRight As Integer
    
    If lstRight.ListCount > 0 Then
        If lstRight.ListIndex > 0 Then
            lCol = lstRight.ItemData(lstRight.ListIndex)
            
            iLeft = lstLeft.ListCount
            
            For i = 0 To lstLeft.ListCount - 1
                If lstLeft.ItemData(i) > lCol Then
                    iLeft = i
                    Exit For
                End If
            Next
            
            lstLeft.AddItem lstRight.List(lstRight.ListIndex), iLeft
            lstLeft.ItemData(iLeft) = lstRight.ItemData(lstRight.ListIndex)
            lstLeft.ListIndex = iLeft
            
            iRight = lstRight.ListIndex
            lstRight.RemoveItem iRight
            If iRight < lstRight.ListCount Then
                lstRight.ListIndex = iRight
            Else
                lstRight.ListIndex = lstRight.ListCount - 1
            End If
        End If
    End If
End Sub

Public Sub ConfigColsUnselectAll(ByVal lstLeft As ListBox, _
                                 ByVal lstRight As ListBox)
                          
    Dim lCol As DatabaseColumnConstants
    Dim i As Integer
    Dim j As Integer
    Dim iLeft As Integer
    Dim iRight As Integer
    
    If lstRight.ListCount > 0 Then
        For i = 1 To lstRight.ListCount - 1
            lCol = lstRight.ItemData(i)
            
            iLeft = lstLeft.ListCount
            
            For j = 0 To lstLeft.ListCount - 1
                If lstLeft.ItemData(j) > lCol Then
                    iLeft = j
                    Exit For
                End If
            Next
            
            lstLeft.AddItem lstRight.List(i), iLeft
            lstLeft.ItemData(iLeft) = lstRight.ItemData(i)
            
            If iLeft < lstLeft.ListCount Then
                lstLeft.ListIndex = iLeft
            Else
                lstLeft.ListIndex = lstLeft.ListCount - 1
            End If
        Next
        
        lstRight.Clear
        
        ' fixed column
        lstRight.AddItem COL_NAM
        lstRight.ItemData(lstRight.ListCount - 1) = -1
    End If
End Sub

Public Sub ConfigColsDown(ByVal lstRight As ListBox)
    Dim i As Integer
    Dim s As String
    Dim l As Long
    If lstRight.ListCount > 1 Then
        If lstRight.ListIndex > 0 And _
           lstRight.ListIndex < lstRight.ListCount - 1 _
        Then
            i = lstRight.ListIndex
            s = lstRight.List(i)
            l = lstRight.ItemData(i)
            lstRight.List(i) = lstRight.List(i + 1)
            lstRight.ItemData(i) = lstRight.ItemData(i + 1)
            lstRight.List(i + 1) = s
            lstRight.ItemData(i + 1) = l
            lstRight.ListIndex = i + 1
        End If
    End If
End Sub

Public Sub ConfigColsUp(ByVal lstRight As ListBox)
    Dim i As Integer
    Dim s As String
    Dim l As Long
    If lstRight.ListCount > 1 Then
        If lstRight.ListIndex > 1 Then
            i = lstRight.ListIndex
            s = lstRight.List(i)
            l = lstRight.ItemData(i)
            lstRight.List(i) = lstRight.List(i - 1)
            lstRight.ItemData(i) = lstRight.ItemData(i - 1)
            lstRight.List(i - 1) = s
            lstRight.ItemData(i - 1) = l
            lstRight.ListIndex = i - 1
        End If
    End If
End Sub

Public Sub ConfigColsGet(ByVal lstRight As ListBox)
    Dim iCol As Integer
    Dim i As Integer
    
    Clear
    
    If lstRight.ListCount > 1 Then
        For i = 1 To lstRight.ListCount - 1
            ColOrder(i - 1) = lstRight.ItemData(i)
        Next
    End If

    iCol = 1
    For i = 0 To MAX_COL
        aColNumber(ColOrder(i)) = iCol
        iCol = iCol + 1
    Next
End Sub

'''

Private Sub Class_Initialize()
    SetDefault
End Sub

'''

Private Function ColNameByConst(ByVal lCol As DatabaseColumnConstants) As String
    Dim s As String
    
    s = ""
    
    Select Case lCol
        Case dbcolState:            s = COL_STA
        Case dbcolData:             s = COL_DAT
        Case dbcolLog:              s = COL_LOG
        Case dbcolSessions:         s = COL_SES
        Case dbcolDataHit:          s = COL_DCH
        Case dbcolConvHit:          s = COL_CCH
        Case dbcolAutoLog:          s = COL_AUT
        Case dbcolBackup:           s = COL_BAK
        Case dbcolServerName:       s = COL_SRV
        Case dbcolDatabaseName:     s = COL_DBN
        Case dbcolDBOnServer:       s = COL_DOS
        Case dbcolPath:             s = COL_PAT
        Case dbcolVersion:          s = COL_VER
        Case dbcolBuild:            s = COL_BUI
        Case dbcolKernel:           s = COl_KNL
        Case dbcolOS:               s = COl_OPS
        Case dbcolBadDevspaces:     s = COL_BDE
        Case dbcolBadIndexes:       s = COL_BIN
        Case dbcolWarning:          s = COL_WAR
        Case dbcolDataHitOMS:       s = COL_DCO
        Case dbcolDataHitOMSLog:    s = COL_DOL
    End Select

    ColNameByConst = s
End Function

Private Function ColSelected(ByVal lCol As DatabaseColumnConstants) As Boolean
    Dim i As Integer
    Dim b As Boolean
    
    b = False
    
    For i = 0 To MAX_COL
        If ColOrder(i) > dbcolNone Then
            If lCol = ColOrder(i) Then
                b = True
                Exit For
            End If
        Else
            Exit For
        End If
    Next
        
    ColSelected = b
End Function
