VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Databases"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oAppServers As New Collection

'''

Public Property Get Count() As Long
    Count = oAppServers.Count
End Property

Public Property Get Item(Index As Variant) As DBMLib.Database
Attribute Item.VB_UserMemId = 0
    Set Item = oAppServers(Index).Database
End Property

Public Property Get AppServerItem(Index As Variant) As DBMAPP.Application
    Set AppServerItem = oAppServers(Index)
End Property

'''

Public Function Add(Name As String) As DBMLib.Database
    Dim oAppServer As New DBMAPP.Application
    
    oAppServers.Add oAppServer, Name
    
    oAppServer.Index = oAppServers.Count
    Set oAppServer.DBMGui = GUI
    
    Set Add = oAppServer.Database
End Function

Public Sub Remove(Index As Variant)
    Dim lStart As Long
    
    lStart = oAppServers(Index).Index
    
    oAppServers(Index).CleanUp
    oAppServers.Remove Index
    
    SetIndex lStart
End Sub

Public Sub Clear()
    Dim lCount As Long
    Dim l As Long
    
    lCount = oAppServers.Count
    For l = 1 To lCount
        On Error Resume Next
        oAppServers(1).CleanUp
        On Error GoTo 0
        oAppServers.Remove 1
    Next
End Sub

Public Sub CleanUp()
    Clear
End Sub

Public Function Exists(Index As Variant) As Boolean
    Dim oAppServer As DBMAPP.Application
    
    On Error Resume Next

    Set oAppServer = oAppServers(Index)
    
    If Err.Number Then
        Exists = False
    Else
        Exists = True
    End If
End Function

Public Sub Rename(Index As Variant, NewName As String)
    Dim oAppServer As DBMAPP.Application
        
    Set oAppServer = oAppServers(Index)
    
    oAppServers.Remove Index
    
    oAppServers.Add oAppServer, NewName
    
    oAppServer.Database.Name = NewName
End Sub

'''

Private Sub SetIndex(ByVal lStart As Long)
    Dim lCount As Long
    Dim l As Long
    
    lCount = oAppServers.Count
    
    For l = lStart To lCount
        oAppServers(l).Index = l
    Next
End Sub


