VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Registry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const REG_ROOTKEY = "Software\SAP\SAP DBTech"
Const REG_APPKEY = "Applications"
Const REG_APPNAMEKEY = "Database Manager"
Const REG_OLDAPPNAMEKEY = "Control"

Private sRootKey As String ' HCU|HLM\Software\SAP\SAP DBTech

Private oReg As DBMReg.Registry

Private oSettings As RegSettings
Private oTree As RegTree
Private oDatabases As RegDatabases

'''

Public Property Get Settings() As RegSettings
    Set Settings = oSettings
End Property

Public Property Get Tree() As RegTree
    Set Tree = oTree
End Property

Public Property Get Databases() As RegDatabases
    Set Databases = oDatabases
End Property

'''

Public Sub Init(Optional ByVal InitSettings As Boolean = True, _
                Optional ByVal InitTree As Boolean = True, _
                Optional ByVal InitDatabases As Boolean = True)
                
    RenameOldRoot

    sRootKey = REG_ROOTKEY + "\" + REG_APPKEY + "\" + REG_APPNAMEKEY

    Set oReg = New DBMReg.Registry
    
    If InitSettings Then
        Set oSettings = New RegSettings
        Set oSettings.Registry = oReg
        oSettings.Root = sRootKey
        oSettings.Init
    End If
    
    If InitTree Then
        Set oTree = New RegTree
        Set oTree.Registry = oReg
        oTree.Root = sRootKey
        oTree.Init
    End If
    
    If InitDatabases Then
        Set oDatabases = New RegDatabases
        Set oDatabases.Registry = oReg
        oDatabases.Root = sRootKey
        oDatabases.Init
    End If
End Sub

'''

' Key "Control" nach "Database Manager" umbenennen.

Private Sub RenameOldRoot()
    Dim sOldName As String
    Dim sNewName As String
    Dim oReg As New DBMReg.Registry
    Dim oOldKey As DBMReg.Key
    Dim oNewKey As DBMReg.Key

    sOldName = REG_ROOTKEY + "\" + REG_APPKEY + "\" + REG_OLDAPPNAMEKEY
    sNewName = REG_ROOTKEY + "\" + REG_APPKEY + "\" + REG_APPNAMEKEY

    Set oOldKey = oReg.Keys.Add(HKEY_CURRENT_USER, sOldName)
    Set oNewKey = oReg.Keys.Add(HKEY_CURRENT_USER, sNewName)
    
    If Not oNewKey.Check(False, False) Then
        If oOldKey.Check(False, False) Then
            If oOldKey.EnumKeys(True, True) Then
                If oOldKey.Rename(sNewName) Then
                    MsgBox "Rename old registry entry ""Control"" to ""Database Manager"" !", vbInformation, TXT_APPLICATION
                End If
            End If
        End If
    End If
End Sub
