VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "Mscomctl.ocx"
Object = "{BAA397ED-F377-11D4-B32D-0050DADEFE1A}#1.1#0"; "DBMDrt.ocx"
Begin VB.UserControl InfoPanel 
   Alignable       =   -1  'True
   BackColor       =   &H80000005&
   CanGetFocus     =   0   'False
   ClientHeight    =   1125
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1515
   ControlContainer=   -1  'True
   ScaleHeight     =   1125
   ScaleWidth      =   1515
   Begin DBMDrt.DrawText drtInfo 
      Height          =   195
      Left            =   360
      Top             =   60
      Width           =   1035
      _ExtentX        =   1826
      _ExtentY        =   344
      Caption         =   "<Info>"
      BackColor       =   -2147483643
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSComctlLib.ImageList imlInfo 
      Left            =   60
      Top             =   420
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   16711935
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   4
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "InfoPanel.ctx":0000
            Key             =   ""
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "InfoPanel.ctx":0552
            Key             =   ""
         EndProperty
         BeginProperty ListImage3 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "InfoPanel.ctx":0AA4
            Key             =   ""
         EndProperty
         BeginProperty ListImage4 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "InfoPanel.ctx":0FF6
            Key             =   ""
         EndProperty
      EndProperty
   End
   Begin VB.Image imgInfo 
      Height          =   240
      Left            =   60
      Picture         =   "InfoPanel.ctx":1548
      Top             =   60
      Visible         =   0   'False
      Width           =   240
   End
End
Attribute VB_Name = "InfoPanel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---

Option Explicit

Public Enum InfoPanelIconConstants
    ipaNone
    ipaInformation
    ipaExclamation
    ipaQuestion
    ipaError
End Enum

Public Event Resize()

Const BORDER_L = 120
Const BORDER_T = 240
Const BORDER_R = 120
Const BORDER_B = 120

Private sClientLeft As Single
Private sClientTop As Single
Private sClientWidth As Single
Private sClientHeight As Single

Private lIcon As InfoPanelIconConstants

Public Property Get Text() As String
    Text = drtInfo.Caption
End Property
Public Property Let Text(ByVal NewVal As String)
    drtInfo.Caption = NewVal
    PropertyChanged "Text"
    UserControl_Resize
End Property

Public Property Get ClientLeft() As Single
    ClientLeft = sClientLeft
End Property
Public Property Get ClientTop() As Single
    ClientTop = sClientTop
End Property
Public Property Get ClientWidth() As Single
    ClientWidth = sClientWidth
End Property
Public Property Get ClientHeight() As Single
    ClientHeight = sClientHeight
End Property

Public Property Get Icon() As InfoPanelIconConstants
    Icon = lIcon
End Property
Public Property Let Icon(ByVal NewVal As InfoPanelIconConstants)
    If NewVal = lIcon Then Exit Property
    
    lIcon = NewVal
    
    If lIcon = ipaNone Then
        imgInfo.Visible = False
    Else
        Set imgInfo.Picture = imlInfo.ListImages(lIcon).ExtractIcon
        imgInfo.Visible = True
    End If
    
    PropertyChanged "Icon"

    UserControl_Resize
End Property

Public Property Get Font() As StdFont
    Set Font = drtInfo.Font
End Property
Public Property Set Font(NewVal As StdFont)
    Set drtInfo.Font = NewVal
    PropertyChanged "Font"
End Property

Public Sub Refresh()
    drtInfo.Refresh
End Sub

Private Sub UserControl_Initialize()
    Text = ""
    Icon = ipaNone
End Sub

Private Sub UserControl_Resize()
    Dim iWidth  As Integer
    Dim iLeft As Integer
    
    If lIcon = ipaNone Then
        iLeft = BORDER_L
    Else
        imgInfo.Move BORDER_L, BORDER_T
        iLeft = imgInfo.Left + imgInfo.Width + 120
    End If
    
    iWidth = ScaleWidth - iLeft - BORDER_R
    If iWidth < 0 Then iWidth = 0
    drtInfo.Move iLeft, BORDER_T, iWidth
    
    sClientLeft = BORDER_L
    sClientTop = BORDER_T + drtInfo.Height + BORDER_T / 2
    sClientWidth = ScaleWidth - BORDER_L - BORDER_R
    If sClientWidth < 0 Then sClientWidth = 0
    sClientHeight = ScaleHeight - sClientTop - BORDER_B
    If sClientHeight < 0 Then sClientHeight = 0
    
    RaiseEvent Resize
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        Text = .ReadProperty("Text", "")
        Icon = .ReadProperty("Icon", "")
        Set Font = .ReadProperty("Font")
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "Text", Text, ""
        .WriteProperty "Icon", Icon, ipaNone
        .WriteProperty "Font", Font
    End With
End Sub


