VERSION 5.00
Begin VB.UserControl DateInput 
   ClientHeight    =   1695
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4455
   ScaleHeight     =   113
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   297
   ToolboxBitmap   =   "DateInput.ctx":0000
   Begin VB.TextBox txtDay 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   60
      MaxLength       =   2
      TabIndex        =   0
      Top             =   60
      Width           =   555
   End
   Begin VB.TextBox txtMonth 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   720
      MaxLength       =   2
      TabIndex        =   1
      Top             =   60
      Width           =   555
   End
   Begin VB.TextBox txtYear 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   1380
      MaxLength       =   4
      TabIndex        =   2
      Top             =   60
      Width           =   555
   End
   Begin VB.Label lblPointMY 
      AutoSize        =   -1  'True
      Caption         =   "."
      Height          =   195
      Left            =   1320
      TabIndex        =   4
      Top             =   120
      Width           =   45
   End
   Begin VB.Label lblPointDM 
      AutoSize        =   -1  'True
      Caption         =   "."
      Height          =   195
      Left            =   660
      TabIndex        =   3
      Top             =   120
      Width           =   45
   End
End
Attribute VB_Name = "DateInput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum InputBorderStyleConstants
    inpBorderStyleNone
    inpBorderStyleSingle
    ingBorderStyleSunken
    inpBorderStyleRaised
End Enum

Private lBackColor As OLE_COLOR
Private lBorderStyle As InputBorderStyleConstants
Private dDateMin As Date
Private dDateValue As Date
Private dDateMax As Date
Private lForeColor As OLE_COLOR
Private bLocked As Boolean

'''

Public Event Change()

'
' Public Properties
'
Public Property Get BackColor() As OLE_COLOR
    BackColor = lBackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    lBackColor = NewVal
    
    UserControl_Format
    
    PropertyChanged "BackColor"
End Property

Public Property Get BorderStyle() As InputBorderStyleConstants
    BorderStyle = lBorderStyle
End Property
Public Property Let BorderStyle(ByVal NewVal As InputBorderStyleConstants)
    lBorderStyle = NewVal
    
    UserControl_Format
    UserControl_Resize
    UserControl_Paint
    
    PropertyChanged "BorderStyle"
End Property

Public Property Get DateMin() As Date
    DateMin = dDateMin
End Property
Public Property Let DateMin(ByVal NewVal As Date)
    dDateMin = NewVal
    
    PropertyChanged "DateMin"
End Property

Public Property Get DateValue() As Date
    Dim iYear As Integer
    Dim iDay As Integer
    Dim iMonth As Integer
    
    iYear = Val(txtYear.Text)
    iMonth = Val(txtMonth.Text)
    iDay = Val(txtDay.Text)
    
    DateValue = DateSerial(iYear, iMonth, iDay)
End Property
Public Property Let DateValue(ByVal NewVal As Date)
    Dim iYear As Integer
    Dim iDay As Integer
    Dim iMonth As Integer
    
    dDateValue = NewVal
    
    iDay = Day(dDateValue)
    iMonth = Month(dDateValue)
    iYear = Year(dDateValue)
    
    If iDay < 10 Then
        txtDay.Text = "0" & CStr(iDay)
    Else
        txtDay.Text = Day(dDateValue)
    End If
    
    If iMonth < 10 Then
        txtMonth.Text = "0" & CStr(iMonth)
    Else
        txtMonth.Text = Month(dDateValue)
    End If
    
    txtYear.Text = Year(dDateValue)
    
    PropertyChanged "DateValue"
End Property

Public Property Get DateMax() As Date
    DateMax = dDateMax
End Property
Public Property Let DateMax(ByVal NewVal As Date)
    dDateMax = NewVal

    PropertyChanged "DateMax"
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    UserControl.Enabled = NewVal
    
    UserControl_Format

    PropertyChanged "Eanbled"
End Property

Public Property Get Font() As Font
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal NewVal As Font)
    Set UserControl.Font = NewVal
    Set txtDay.Font = NewVal
    Set lblPointDM.Font = NewVal
    Set txtMonth.Font = NewVal
    Set lblPointMY.Font = NewVal
    Set txtYear.Font = NewVal
    
    UserControl_Format
    UserControl_Resize
    
    PropertyChanged "Font"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = lForeColor
End Property
Public Property Let ForeColor(ByVal NewVal As OLE_COLOR)
    lForeColor = NewVal
    
    UserControl_Format

    PropertyChanged "ForeColor"
End Property

Public Property Get Locked() As Boolean
    Locked = bLocked
End Property
Public Property Let Locked(ByVal NewVal As Boolean)
    bLocked = NewVal
    
    txtDay.Locked = NewVal
    txtMonth.Locked = NewVal
    txtYear.Locked = NewVal
    
    PropertyChanged "Locked"
End Property
'
' Private
'
Private Sub txtDay_Change()
    RaiseEvent Change
End Sub

Private Sub txtDay_GotFocus()
    GotFocus txtDay
End Sub

Private Sub txtDay_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub txtDay_LostFocus()
    Dim iDay As Integer
    iDay = Val(txtDay.Text)
    If iDay < 1 Or iDay > 31 Then
        Beep
        txtDay.SetFocus
    End If
    If iDay < 10 Then
        txtDay.Text = "0" & CStr(iDay)
    End If
End Sub

Private Sub txtMonth_Change()
    RaiseEvent Change
End Sub

Private Sub txtMonth_GotFocus()
    GotFocus txtMonth
End Sub

Private Sub txtMonth_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub txtMonth_LostFocus()
    Dim iMonth As Integer
    iMonth = Val(txtMonth.Text)
    If iMonth < 1 Or iMonth > 12 Then
        Beep
        txtMonth.SetFocus
        Exit Sub
    End If
    If iMonth < 10 Then
        txtMonth.Text = "0" & CStr(iMonth)
    End If
End Sub

Private Sub txtYear_Change()
    RaiseEvent Change
End Sub

Private Sub txtYear_GotFocus()
    GotFocus txtYear
End Sub

Private Sub txtYear_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub txtYear_LostFocus()
    Dim iYear As Integer
    iYear = Val(txtYear.Text)
    If iYear < 100 Then
        iYear = (Year(Date) \ 100) * 100 + iYear
        txtYear.Text = CStr(iYear)
    End If
End Sub
'
'
'
Private Sub UserControl_Initialize()
    lBackColor = vbWindowBackground
    DateMin = DateSerial(100, 1, 1)
    DateValue = Date
    DateMax = DateSerial(9999, 12, 31)
    lForeColor = vbWindowText
    
    UserControl_Format
End Sub

Private Sub UserControl_Resize()
    Dim iBorderSize As Integer
    Dim lWidth As Long
    Dim lHeight As Long
    
    iBorderSize = BorderSize()
    
    lWidth = ScaleX(txtDay.Width + 2 + lblPointDM.Width + 2 + txtMonth.Width + 2 + lblPointMY.Width + 2 + txtYear.Width + 2 * iBorderSize, vbPixels, vbTwips)
    lHeight = ScaleY(txtDay.Height + 2 * iBorderSize, vbPixels, vbTwips)
    
    Size lWidth, lHeight
End Sub

Private Sub UserControl_Format()
    Dim iBorderSize As Integer
    
    txtDay.Width = TextWidth("00|")
    txtMonth.Width = TextWidth("00|")
    txtYear.Width = TextWidth("0000|")
    txtDay.Height = TextHeight("00|")
    txtMonth.Height = TextHeight("00|")
    txtYear.Height = TextHeight("0000|")
    
    lblPointDM.Height = txtDay.Height
    lblPointMY.Height = txtDay.Height
    
    iBorderSize = BorderSize()
    
    txtDay.Move iBorderSize, iBorderSize
    lblPointDM.Move txtDay.Left + txtDay.Width + 2, iBorderSize
    txtMonth.Move lblPointDM.Left + lblPointDM.Width + 2, iBorderSize
    lblPointMY.Move txtMonth.Left + txtMonth.Width + 2, iBorderSize
    txtYear.Move lblPointMY.Left + lblPointMY.Width + 2, iBorderSize
    
    If UserControl.Enabled Then
        txtDay.BackColor = lBackColor
        txtMonth.BackColor = lBackColor
        txtYear.BackColor = lBackColor
        txtDay.ForeColor = lForeColor
        txtMonth.ForeColor = lForeColor
        txtYear.ForeColor = lForeColor
    Else
        txtDay.BackColor = vb3DFace
        txtMonth.BackColor = vb3DFace
        txtYear.BackColor = vb3DFace
        txtDay.ForeColor = vbGrayText
        txtMonth.ForeColor = vbGrayText
        txtYear.ForeColor = vbGrayText
    End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        BackColor = .ReadProperty("BackColor", vbWindowBackground)
        BorderStyle = .ReadProperty("BorderStyle", inpBorderStyleNone)
        DateMin = .ReadProperty("DateMin", DateSerial(100, 1, 1))
        DateValue = .ReadProperty("DateValue", Date)
        DateMax = .ReadProperty("DateMax", DateSerial(9999, 12, 31))
        Enabled = .ReadProperty("Enabled", True)
        Set Font = .ReadProperty("Font")
        ForeColor = .ReadProperty("ForeColor", vbWindowText)
        Locked = .ReadProperty("Locked", False)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "BackColor", BackColor, vbWindowBackground
        .WriteProperty "BorderStyle", BorderStyle, inpBorderStyleNone
        .WriteProperty "DateMin", DateMin, DateSerial(100, 1, 1)
        .WriteProperty "DateValue", DateValue, Date
        .WriteProperty "DateMax", DateMax, DateSerial(9999, 12, 31)
        .WriteProperty "Enabled", Enabled, True
        .WriteProperty "Font", Font
        .WriteProperty "ForeColor", ForeColor, vbWindowText
        .WriteProperty "Locked", Locked, False
    End With
End Sub

Private Sub UserControl_ExitFocus()
    Dim iYear As Integer
    Dim iDay As Integer
    Dim iMonth As Integer
    Dim dDate As Date
    
    iYear = Val(txtYear.Text)
    iMonth = Val(txtMonth.Text)
    iDay = Val(txtDay.Text)
    
    dDate = DateSerial(iYear, iMonth, iDay)
    
    DateValue = dDate
    
    If dDate < dDateMin Or dDate > dDateMax Then
        Beep
        txtDay.SetFocus
    End If
End Sub

Private Sub UserControl_Paint()
    Dim r As RECT
    
    With r
        .Left = 0
        .Top = 0
        .Right = UserControl.ScaleWidth
        .Bottom = UserControl.ScaleHeight
    End With

    Select Case lBorderStyle
        Case inpBorderStyleNone:
        Case inpBorderStyleSingle:
            UserControl.Line (r.Left, r.Top)-(r.Right - 1, r.Bottom - 1), vbBlack, B
        Case ingBorderStyleSunken:
            DrawEdge UserControl.hdc, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
        Case inpBorderStyleRaised:
            DrawEdge UserControl.hdc, r, EDGE_RAISED, BF_RECT + BF_SOFT
    End Select
End Sub
'
'
'
Private Sub GotFocus(txt As TextBox)
    txt.SelStart = 0
    txt.SelLength = Len(txt.Text)
End Sub

Private Sub KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyBack Then Exit Sub
    If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
        KeyAscii = 0
    End If
End Sub

Private Function BorderSize() As Integer
    Select Case lBorderStyle
        Case inpBorderStyleNone:    BorderSize = 0
        Case inpBorderStyleSingle:  BorderSize = 1
        Case ingBorderStyleSunken:  BorderSize = 2
        Case inpBorderStyleRaised:  BorderSize = 2
    End Select
End Function
