VERSION 5.00
Begin VB.UserControl SizeInput 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   Begin VB.TextBox txtSize 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   555
   End
   Begin VB.Image imgDown 
      Height          =   240
      Left            =   1200
      Picture         =   "SizeInput.ctx":0000
      Top             =   60
      Width           =   240
   End
   Begin VB.Label lblUnit 
      Caption         =   "KB"
      Height          =   195
      Left            =   660
      TabIndex        =   1
      Top             =   60
      Width           =   495
   End
   Begin VB.Menu mnuPopup 
      Caption         =   "Pupup"
      Begin VB.Menu mnuUnit 
         Caption         =   "KB"
         Checked         =   -1  'True
         Index           =   0
      End
      Begin VB.Menu mnuUnit 
         Caption         =   "MB"
         Index           =   1
      End
      Begin VB.Menu mnuUnit 
         Caption         =   "GB"
         Index           =   2
      End
      Begin VB.Menu mnuUnit 
         Caption         =   "Pages"
         Index           =   3
      End
   End
End
Attribute VB_Name = "SizeInput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum InputUnitConstants
    inpUnitKB
    inpUnitMB
    inpUnitGB
    inpUnitPages
End Enum

Private lBorderStyle As InputBorderStyleConstants
Private lUnit As InputUnitConstants
Private lPageSizeKB As Long

'''

Private lMinWidth As Long
Private lMinHeight As Long
Private iBorderSize As Integer

'''

Public Event Change()
Public Event ChangeUnit()

'
' Public Properties
'
Public Property Get BackColor() As OLE_COLOR
    BackColor = txtSize.BackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    txtSize.BackColor = NewVal
    
    PropertyChanged "BackColor"
End Property

Public Property Get BorderStyle() As InputBorderStyleConstants
    BorderStyle = lBorderStyle
End Property
Public Property Let BorderStyle(ByVal NewVal As InputBorderStyleConstants)
    lBorderStyle = NewVal

    UserControl_Format
    UserControl_Resize
    UserControl_Paint

    PropertyChanged "BorderStyle"
End Property

Public Property Get SizeValue() As Double
    Dim lSize As Double
        
    lSize = 0#
    
    If Len(Trim(txtSize.Text)) > 0 Then
        If IsNumeric(txtSize.Text) Then
            lSize = CDbl(txtSize.Text)
        End If
    End If
    
    SizeValue = lSize
End Property
Public Property Let SizeValue(ByVal NewVal As Double)
    txtSize.Text = Format(NewVal, "General Number")
    mnuUnit_Click CInt(lUnit)
    
    PropertyChanged "SizeValue"
End Property

Public Property Get Unit() As InputUnitConstants
    Unit = lUnit
End Property
Public Property Let Unit(ByVal NewVal As InputUnitConstants)
    mnuUnit_Click CInt(NewVal)
    
    PropertyChanged "Unit"
End Property

Public Property Get SizeValueKB() As Double
    SizeValueKB = GetSizeValue(inpUnitKB)
End Property
Public Property Get SizeValueMB() As Double
    SizeValueMB = GetSizeValue(inpUnitMB)
End Property
Public Property Get SizeValueGB() As Double
    SizeValueGB = GetSizeValue(inpUnitGB)
End Property
Public Property Get SizeValuePages() As Double
    SizeValuePages = GetSizeValue(inpUnitPages)
End Property

Public Property Get PageSizeKB() As Long
    PageSizeKB = lPageSizeKB
End Property
Public Property Let PageSizeKB(ByVal NewVal As Long)
    lPageSizeKB = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    UserControl.Enabled = NewVal
    
    UserControl_Format
    
    PropertyChanged "Enabled"
End Property

Public Property Get Font() As Font
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal NewVal As Font)
    Set UserControl.Font = NewVal
    Set txtSize.Font = NewVal
    Set lblUnit.Font = NewVal
    
    UserControl_Format
    UserControl_Resize
    
    PropertyChanged "Font"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = txtSize.ForeColor
End Property
Public Property Let ForeColor(ByVal NewVal As OLE_COLOR)
    txtSize.ForeColor = NewVal
    PropertyChanged "ForeColor"
End Property

Public Property Get Locked() As Boolean
    Locked = txtSize.Locked
End Property
Public Property Let Locked(ByVal NewVal As Boolean)
    txtSize.Locked = NewVal
    PropertyChanged "Locked"
End Property

Public Property Get Text() As Variant
Attribute Text.VB_UserMemId = 0
    Text = txtSize.Text
End Property
Public Property Let Text(ByVal NewVal As Variant)
    If IsNumeric(NewVal) Then
        SizeValue = CDbl(NewVal)
    Else
        txtSize.Text = 0
    End If
End Property

Public Property Get UnitSelector() As Boolean
    UnitSelector = imgDown.Visible
End Property
Public Property Let UnitSelector(ByVal NewVal As Boolean)
    imgDown.Visible = NewVal
    UserControl_Resize
    PropertyChanged "UnitSelector"
End Property

Public Property Get FullText() As String
    FullText = Text & " " & lblUnit.Caption
End Property
'
' Private
'
Private Sub txtSize_Change()
    RaiseEvent Change
End Sub

Private Sub txtSize_GotFocus()
    GotFocus txtSize
End Sub

Private Sub txtSize_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub lblUnit_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    SetPopupMenu
    PopupMenu mnuPopup
End Sub

Private Sub imgDown_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    SetPopupMenu
    PopupMenu mnuPopup
End Sub

'''

Private Sub UserControl_Initialize()
    lUnit = inpUnitKB
    lPageSizeKB = 8
    
    UserControl_Format
End Sub

Private Sub UserControl_Resize()
    Dim lWidth As Long
    Dim lHeight As Long
    Dim lImage As Long
    
    If ScaleWidth < lMinWidth Then
        lWidth = ScaleX(lMinWidth, vbPixels, vbTwips)
    Else
        lWidth = ScaleX(ScaleWidth, vbPixels, vbTwips)
    End If
    
    lHeight = ScaleY(lMinHeight, vbPixels, vbTwips)
    
    Size lWidth, lHeight
        
    If imgDown.Visible Then
        lImage = imgDown.Width
    Else
        lImage = 0
    End If
    
    txtSize.Move iBorderSize, iBorderSize, ScaleWidth - lblUnit.Width - 3 - lImage - iBorderSize
    lblUnit.Move txtSize.Left + txtSize.Width + 2, iBorderSize
    imgDown.Move lblUnit.Left + lblUnit.Width, iBorderSize
End Sub

Private Sub UserControl_Format()
    iBorderSize = BorderSize()
    
    lMinWidth = TextWidth("00") + 3 + TextWidth("Pages") + imgDown.Width + 2 * iBorderSize
    lMinHeight = TextHeight("0") + 2 * iBorderSize
    
    lblUnit.Width = TextWidth("Pages")
    lblUnit.Height = TextHeight("Pages")
    txtSize.Height = TextHeight("0")
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        BackColor = .ReadProperty("BackColor", vbWindowBackground)
        BorderStyle = .ReadProperty("BorderStyle", inpBorderStyleNone)
        SizeValue = .ReadProperty("SizeValue", 0)
        Unit = .ReadProperty("Unit", inpUnitKB)
        PageSizeKB = .ReadProperty("PageSizeKB", 8)
        Enabled = .ReadProperty("Enabled", True)
        Set Font = .ReadProperty("Font")
        ForeColor = .ReadProperty("ForeColor", vbWindowText)
        Locked = .ReadProperty("Locked", False)
        UnitSelector = .ReadProperty("UnitSelector", True)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "BackColor", BackColor, vbWindowBackground
        .WriteProperty "BorderStyle", BorderStyle, inpBorderStyleNone
        .WriteProperty "SizeValue", SizeValue, 0
        .WriteProperty "Unit", Unit, inpUnitKB
        .WriteProperty "PageSizeKB", PageSizeKB, 8
        .WriteProperty "Enabled", Enabled, True
        .WriteProperty "Font", Font
        .WriteProperty "ForeColor", ForeColor, vbWindowText
        .WriteProperty "Locked", Locked, False
        .WriteProperty "UnitSelector", UnitSelector, True
    End With
End Sub

Private Sub UserControl_Paint()
    Dim r As RECT
    
    With r
        .Left = 0
        .Top = 0
        .Right = UserControl.ScaleWidth
        .Bottom = UserControl.ScaleHeight
    End With

    Select Case lBorderStyle
        Case inpBorderStyleNone:
        Case inpBorderStyleSingle:
            UserControl.Line (r.Left, r.Top)-(r.Right - 1, r.Bottom - 1), vbBlack, B
        Case ingBorderStyleSunken:
            DrawEdge UserControl.hdc, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
        Case inpBorderStyleRaised:
            DrawEdge UserControl.hdc, r, EDGE_RAISED, BF_RECT + BF_SOFT
    End Select
End Sub

'''

Private Sub mnuUnit_Click(Index As Integer)
    Dim lUnitNew As InputUnitConstants
    Dim lSize As Double
    Dim lSizeKB As Double
    Dim lSizeNew As Double
    
    lUnitNew = Index
    
    mnuUnit(lUnit).Checked = False
    
    lblUnit.Caption = mnuUnit(lUnitNew).Caption
    mnuUnit(lUnitNew).Checked = True
    
    txtSize.Text = Format(GetSizeValue(lUnitNew), "General Number")
    
    lUnit = lUnitNew
    
    RaiseEvent ChangeUnit
End Sub

'''

Private Sub GotFocus(txt As TextBox)
    txt.SelStart = 0
    txt.SelLength = Len(txt.Text)
End Sub

Private Sub KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyBack Then Exit Sub
    If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
        If KeyAscii <> Asc(",") And _
           KeyAscii <> Asc(".") And _
           KeyAscii <> Asc("+") And _
           KeyAscii <> Asc("-") And _
           KeyAscii <> Asc("E") And _
           KeyAscii <> Asc("e") _
        Then
            KeyAscii = 0
        End If
    End If
End Sub

Private Function BorderSize() As Integer
    Select Case lBorderStyle
        Case inpBorderStyleNone:    BorderSize = 0
        Case inpBorderStyleSingle:  BorderSize = 1
        Case ingBorderStyleSunken:  BorderSize = 2
        Case inpBorderStyleRaised:  BorderSize = 2
    End Select
End Function

Private Function GetSizeValue(ByVal lUnitGet As InputUnitConstants) As Double
    Dim lSize As Double
    Dim lSizeKB As Double
    Dim lSizeGet As Double
    
    If Len(Trim(txtSize.Text)) > 0 Then
    
        If IsNumeric(txtSize.Text) Then
            lSize = CDbl(txtSize.Text)
        Else
            lSize = 0
        End If
        
        Select Case lUnit
            Case inpUnitKB:     lSizeKB = lSize
            Case inpUnitMB:     lSizeKB = lSize * 1024#
            Case inpUnitGB:     lSizeKB = lSize * 1024# * 1024#
            Case inpUnitPages:  lSizeKB = lSize * CDbl(lPageSizeKB)
        End Select
        
        Select Case lUnitGet
            Case inpUnitKB:     lSizeGet = lSizeKB
            Case inpUnitMB:     lSizeGet = lSizeKB / 1024#
            Case inpUnitGB:     lSizeGet = (lSizeKB / 1024#) / 1024#
            Case inpUnitPages:  lSizeGet = lSizeKB / CDbl(lPageSizeKB)
        End Select
    Else
        lSizeGet = 0
    End If
    
    GetSizeValue = lSizeGet
End Function

Private Function SetPopupMenu()
    mnuUnit(inpUnitKB).Caption = "KB (" + Format$(GetSizeValue(inpUnitKB), "General Number") + ")"
    mnuUnit(inpUnitMB).Caption = "MB (" + Format$(GetSizeValue(inpUnitMB), "General Number") + ")"
    mnuUnit(inpUnitGB).Caption = "GB (" + Format$(GetSizeValue(inpUnitGB), "General Number") + ")"
    mnuUnit(inpUnitPages).Caption = "Pages (" + Format$(GetSizeValue(inpUnitPages), "General Number") + ")"
End Function
