VERSION 5.00
Begin VB.UserControl TimeInput 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "TimeInput.ctx":0000
   Begin VB.TextBox txtSecond 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   1380
      MaxLength       =   4
      TabIndex        =   2
      Top             =   60
      Width           =   555
   End
   Begin VB.TextBox txtMinute 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   720
      MaxLength       =   2
      TabIndex        =   1
      Top             =   60
      Width           =   555
   End
   Begin VB.TextBox txtHour 
      BorderStyle     =   0  'None
      Height          =   225
      Left            =   60
      MaxLength       =   2
      TabIndex        =   0
      Top             =   60
      Width           =   555
   End
   Begin VB.Label lblPointHM 
      AutoSize        =   -1  'True
      Caption         =   ":"
      Height          =   195
      Left            =   660
      TabIndex        =   4
      Top             =   120
      Width           =   45
   End
   Begin VB.Label lblPointMS 
      AutoSize        =   -1  'True
      Caption         =   ":"
      Height          =   195
      Left            =   1320
      TabIndex        =   3
      Top             =   120
      Width           =   45
   End
End
Attribute VB_Name = "TimeInput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1998-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private lBackColor As OLE_COLOR
Private lBorderStyle As InputBorderStyleConstants
Private dTimeMin As Date
Private dTimeValue As Date
Private dTimeMax As Date
Private lForeColor As OLE_COLOR
Private bLocked As Boolean

'''

Public Event Change()

'
' Public Properties
'
Public Property Get BackColor() As OLE_COLOR
    BackColor = lBackColor
End Property
Public Property Let BackColor(ByVal NewVal As OLE_COLOR)
    lBackColor = NewVal
    
    UserControl_Format
    
    PropertyChanged "BackColor"
End Property

Public Property Get BorderStyle() As InputBorderStyleConstants
    BorderStyle = lBorderStyle
End Property
Public Property Let BorderStyle(ByVal NewVal As InputBorderStyleConstants)
    lBorderStyle = NewVal

    UserControl_Format
    UserControl_Resize
    UserControl_Paint

    PropertyChanged "BorderStyle"
End Property

Public Property Get TimeMin() As Date
    TimeMin = dTimeMin
End Property
Public Property Let TimeMin(ByVal NewVal As Date)
    dTimeMin = NewVal

    PropertyChanged "TimeMin"
End Property

Public Property Get TimeValue() As Date
    Dim iSecond As Integer
    Dim iHour As Integer
    Dim iMinute As Integer
    
    iSecond = Val(txtSecond.Text)
    iMinute = Val(txtMinute.Text)
    iHour = Val(txtHour.Text)
    
    TimeValue = TimeSerial(iHour, iMinute, iSecond)
End Property
Public Property Let TimeValue(ByVal NewVal As Date)
    Dim iHour As Integer
    Dim iMinute As Integer
    Dim iSecond As Integer
    
    dTimeValue = NewVal
    
    iHour = Hour(dTimeValue)
    iMinute = Minute(dTimeValue)
    iSecond = Second(dTimeValue)
    
    If iHour < 10 Then
        txtHour.Text = "0" & CStr(iHour)
    Else
        txtHour.Text = Hour(dTimeValue)
    End If
    
    If iMinute < 10 Then
        txtMinute.Text = "0" & CStr(iMinute)
    Else
        txtMinute.Text = Minute(dTimeValue)
    End If
    
    If iSecond < 10 Then
        txtSecond.Text = "0" & CStr(iSecond)
    Else
        txtSecond.Text = Second(dTimeValue)
    End If

    PropertyChanged "TimeValue"
End Property

Public Property Get TimeMax() As Date
    TimeMax = dTimeMax
End Property
Public Property Let TimeMax(ByVal NewVal As Date)
    dTimeMax = NewVal

    PropertyChanged "TimeMax"
End Property

Public Property Get TimeHour() As Integer
    
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    UserControl.Enabled = NewVal
    
    UserControl_Format
    
    PropertyChanged "Enabled"
End Property

Public Property Get Font() As Font
    Set Font = UserControl.Font
End Property
Public Property Set Font(ByVal NewVal As Font)
    Set UserControl.Font = NewVal
    Set txtHour.Font = NewVal
    Set lblPointHM.Font = NewVal
    Set txtMinute.Font = NewVal
    Set lblPointMS.Font = NewVal
    Set txtSecond.Font = NewVal
    
    UserControl_Format
    UserControl_Resize
    
    PropertyChanged "Font"
End Property

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = lForeColor
End Property
Public Property Let ForeColor(ByVal NewVal As OLE_COLOR)
    lForeColor = NewVal
    
    UserControl_Format

    PropertyChanged "ForeColor"
End Property

Public Property Get Locked() As Boolean
    Locked = bLocked
End Property
Public Property Let Locked(ByVal NewVal As Boolean)
    bLocked = NewVal
    
    txtHour.Locked = NewVal
    txtMinute.Locked = NewVal
    txtSecond.Locked = NewVal
    
    PropertyChanged "Locked"
End Property
'
' Private
'
Private Sub txtHour_Change()
    RaiseEvent Change
End Sub

Private Sub txtHour_GotFocus()
    GotFocus txtHour
End Sub

Private Sub txtHour_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub txtHour_LostFocus()
    Dim iHour As Integer
    iHour = Val(txtHour.Text)
    If iHour > 23 Then
        Beep
        txtHour.SetFocus
    End If
    If iHour < 10 Then
        txtHour.Text = "0" & CStr(iHour)
    End If
End Sub

Private Sub txtMinute_Change()
    RaiseEvent Change
End Sub

Private Sub txtMinute_GotFocus()
    GotFocus txtMinute
End Sub

Private Sub txtMinute_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub txtMinute_LostFocus()
    Dim iMinute As Integer
    iMinute = Val(txtMinute.Text)
    If iMinute > 59 Then
        Beep
        txtMinute.SetFocus
        Exit Sub
    End If
    If iMinute < 10 Then
        txtMinute.Text = "0" & CStr(iMinute)
    End If
End Sub

Private Sub txtSecond_Change()
    RaiseEvent Change
End Sub

Private Sub txtSecond_GotFocus()
    GotFocus txtSecond
End Sub

Private Sub txtSecond_KeyPress(KeyAscii As Integer)
    KeyPress KeyAscii
End Sub

Private Sub txtSecond_LostFocus()
    Dim iSecond As Integer
    iSecond = Val(txtSecond.Text)
    If iSecond < 10 Then
        txtSecond.Text = "0" & CStr(iSecond)
    End If
End Sub
'
'
'
Private Sub UserControl_Initialize()
    lBackColor = vbWindowBackground
    TimeMin = TimeSerial(0, 0, 0)
    TimeValue = Time
    TimeMax = TimeSerial(23, 59, 59)
    lForeColor = vbWindowText
    
    UserControl_Format
End Sub

Private Sub UserControl_Resize()
    Dim iBorderSize As Integer
    Dim lWidth As Long
    Dim lHeight As Long
    
    iBorderSize = BorderSize()

    lWidth = ScaleX(txtHour.Width + 2 + lblPointHM.Width + 2 + txtMinute.Width + 2 + lblPointMS.Width + 2 + txtSecond.Width + 2 * iBorderSize, vbPixels, vbTwips)
    lHeight = ScaleY(txtHour.Height + 2 * iBorderSize, vbPixels, vbTwips)
    
    Size lWidth, lHeight
End Sub

Private Sub UserControl_Format()
    Dim iBorderSize As Integer
    
    txtHour.Width = TextWidth("00|")
    txtMinute.Width = TextWidth("00|")
    txtSecond.Width = TextWidth("00|")
    txtHour.Height = TextHeight("00|")
    txtMinute.Height = TextHeight("00|")
    txtSecond.Height = TextHeight("00|")
    
    lblPointHM.Height = txtHour.Height
    lblPointMS.Height = txtHour.Height
    
    iBorderSize = BorderSize()

    txtHour.Move iBorderSize, iBorderSize
    lblPointHM.Move txtHour.Left + txtHour.Width + 2, iBorderSize
    txtMinute.Move lblPointHM.Left + lblPointHM.Width + 2, iBorderSize
    lblPointMS.Move txtMinute.Left + txtMinute.Width + 2, iBorderSize
    txtSecond.Move lblPointMS.Left + lblPointMS.Width + 2, iBorderSize

    If UserControl.Enabled Then
        txtHour.BackColor = lBackColor
        txtMinute.BackColor = lBackColor
        txtSecond.BackColor = lBackColor
        txtHour.ForeColor = lForeColor
        txtMinute.ForeColor = lForeColor
        txtSecond.ForeColor = lForeColor
    Else
        txtHour.BackColor = vb3DFace
        txtMinute.BackColor = vb3DFace
        txtSecond.BackColor = vb3DFace
        txtHour.ForeColor = vbGrayText
        txtMinute.ForeColor = vbGrayText
        txtSecond.ForeColor = vbGrayText
    End If
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        BackColor = .ReadProperty("BackColor", vbWindowBackground)
        BorderStyle = .ReadProperty("BorderStyle", inpBorderStyleNone)
        TimeMin = .ReadProperty("DateMin", TimeSerial(0, 0, 0))
        TimeValue = .ReadProperty("DateValue", Date)
        TimeMax = .ReadProperty("DateMax", TimeSerial(23, 59, 59))
        Enabled = .ReadProperty("Enabled", True)
        Set Font = .ReadProperty("Font")
        ForeColor = .ReadProperty("ForeColor", vbWindowText)
        Locked = .ReadProperty("Locked", False)
    End With
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "BackColor", BackColor, vbWindowBackground
        .WriteProperty "BorderStyle", BorderStyle, inpBorderStyleNone
        .WriteProperty "DateMin", TimeMin, TimeSerial(0, 0, 0)
        .WriteProperty "DateValue", TimeValue, Time
        .WriteProperty "DateMax", TimeMax, TimeSerial(23, 59, 59)
        .WriteProperty "Enabled", Enabled, True
        .WriteProperty "Font", Font
        .WriteProperty "ForeColor", ForeColor, vbWindowText
        .WriteProperty "Locked", Locked, False
    End With
End Sub

Private Sub UserControl_ExitFocus()
    Dim iHour As Integer
    Dim iMinute As Integer
    Dim iSecond As Integer
    Dim dTime As Date
    
    iHour = Val(txtHour.Text)
    iMinute = Val(txtMinute.Text)
    iSecond = Val(txtSecond.Text)
    
    dTime = TimeSerial(iHour, iMinute, iSecond)
    
    TimeValue = dTime
    
    If dTime < dTimeMin Or dTime > dTimeMax Then
        Beep
        txtHour.SetFocus
    End If
End Sub

Private Sub UserControl_Paint()
    Dim r As RECT
    
    With r
        .Left = 0
        .Top = 0
        .Right = UserControl.ScaleWidth
        .Bottom = UserControl.ScaleHeight
    End With

    Select Case lBorderStyle
        Case inpBorderStyleNone:
        Case inpBorderStyleSingle:
            UserControl.Line (r.Left, r.Top)-(r.Right - 1, r.Bottom - 1), vbBlack, B
        Case ingBorderStyleSunken:
            DrawEdge UserControl.hdc, r, EDGE_SUNKEN, BF_RECT + BF_SOFT
        Case inpBorderStyleRaised:
            DrawEdge UserControl.hdc, r, EDGE_RAISED, BF_RECT + BF_SOFT
    End Select
End Sub
'
'
'
Private Sub GotFocus(txt As TextBox)
    txt.SelStart = 0
    txt.SelLength = Len(txt.Text)
End Sub

Private Sub KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyBack Then Exit Sub
    If KeyAscii < Asc("0") Or KeyAscii > Asc("9") Then
        KeyAscii = 0
    End If
End Sub

Private Function BorderSize() As Integer
    Select Case lBorderStyle
        Case inpBorderStyleNone:    BorderSize = 0
        Case inpBorderStyleSingle:  BorderSize = 1
        Case ingBorderStyleSunken:  BorderSize = 2
        Case inpBorderStyleRaised:  BorderSize = 2
    End Select
End Function

