VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Backup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F5500F4"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_MEDIASAVE = "SaveMedia"
Const FUNC_MEDIAOPEN = "OpenMedia"
Const FUNC_MEDIADELETE = "DeleteMedia"

Const FUNC_INITFORBACKUP = "InitForBackup"
Const FUNC_INITFORRESTOREINIT = "InitForRestoreInit"
Const FUNC_INITFORRESTORE = "InitForRestore"
Const FUNC_INITFORCHECK = "InitForCheck"

Const FUNC_GETEXTERNALIDS = "GetExternalIDs"

Const PARAM_BACKUP_BLOCK_CNT = "BACKUP_BLOCK_CNT"

Const DEVTYPE_TAPE = "TAPE"
Const DEVTYPE_FILE = "FILE"
Const DEVTYPE_PIPE = "PIPE"
Const DEVTYPE_UNKNOWN = "UNKNOWN"
Const DEVTYPE_NOREWIND = "NOREWIND"

Const DEVTYPE_HIST_TAPE = "VFTTAPEREW"
Const DEVTYPE_HIST_FILE = "VFTFILE"
Const DEVTYPE_HIST_PIPE = "VFTPIPE"
Const DEVTYPE_HIST_UNKNOWN = "VFTUNKNOWN"
Const DEVTYPE_HIST_NOREWIND = "VFTTAPENOREW"

Const OVERWRITE_NO = "NO"
Const OVERWRITE_YES = "YES"

Const AUTOLOADER_NO = "NO"
Const AUTOLOADER_YES = "YES"

Const BACKUPTYPE_DATA = "DATA"
Const BACKUPTYPE_PAGES = "PAGES"
Const BACKUPTYPE_LOG = "LOG"
Const BACKUPTYPE_AUTO = "AUTO"
Const BACKUPTYPE_UNKNOWN = "UNKNOWN"

Const BACKUPACTION_SAVE = "SAVE"
Const BACKUPACTION_RESTORE = "RESTORE"

Const BACKUPFOR_RECOVERY = "RECOVERY"
Const BACKUPFOR_MIGRATION = "MIGRATION"

Const BACKUPACTIONKIND_SINGLE = "S"
Const BACKUPACTIONKIND_MULTIPLE = "M"
Const BACKUPACTIONKIND_REPLACE = "R"
Const BACKUPACTIONKIND_UNKNOWN = " "

Public Enum DBMBackupActionConstants
    dbmBANone
    dbmBASave
    dbmBARestore
    dbmBAHistLost
    dbmBACheck
End Enum

Public Enum DBMDeviceTypeConstants
    dbmDTFile
    dbmDTTape
    dbmDTPipe
    dbmDTUnknown
    dbmDTNoRewind
End Enum

Public Enum DBMOverwriteConstants
    dbmOverwriteNo
    dbmOverwriteYes
End Enum

Public Enum DBMAutoLoaderConstants
    dbmAutoLoaderNo
    dbmAutoLoaderYes
End Enum

Public Enum DBMBackupTypeConstants
    dbmBTData
    dbmBTPages
    dbmBTLog
    dbmBTAuto
    dbmBTUnknown
End Enum

Public Enum DBMBackupForConstants
    dbmSaveForRecovery = 0
    dbmSaveForMigration
End Enum

Public Enum DBMBackupActionKindConstants
    dbmBAKUnknown
    dbmBAKSingle
    dbmBAKMultiple
    dbmBAKReplace
End Enum

Const KEY_LBRK = "["
Const KEY_RBRK = "]"
Const KEY_BSLA = "\"
Const KEY_EQUA = "="
Const KEY_LOCA = "LOCATION"
Const KEY_SIZE = "SIZE"
Const KEY_TYPE = "TYPE"
Const KEY_OVER = "OVERWRITE"
Const KEY_SEMI = ";"

Private oParent As Object

Private oMedia As Media
Private oMediaGroups As MediaGroups

Private oHistory As History

Private oExternalIDs As ExternalIDs

Private oBackupManager As BackupManager
Private oRestoreManager As RestoreManager

Private oBackupResult As BackupResult
Private oBackupError As BackupError
Private oBackupState As BackupState

Private lBackupAction As DBMBackupActionConstants
Private lBackupType As DBMBackupTypeConstants
Private lBackupFor As DBMBackupForConstants
Private oBackupUsedMedia As Object

'''

Private oBackup As Object 'DBMApp.Backup

'''

Private bAlways As Boolean
Private bInitForBackupAlways As Boolean
Private bInitForRestoreAlways As Boolean
Private bInitForCheckAlways As Boolean
Private sMediumName As String
Private sDatabase As String
Private sServer As String

'''

Private lDefaultBlocksize As Long

'''

Private dAt As Date

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTBackup
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Media() As Media
    Set Media = oMedia
End Property

Public Property Get MediaGroups() As MediaGroups
    Set MediaGroups = oMediaGroups
End Property

'''

Public Property Get BackupAction() As DBMBackupActionConstants
    BackupAction = lBackupAction
End Property

Public Property Get BackupFor() As DBMBackupForConstants
    BackupFor = lBackupFor
End Property

Public Property Get BackupType() As DBMBackupTypeConstants
    BackupType = lBackupType
End Property

Public Property Get BackupUsedMedia() As Object
    Set BackupUsedMedia = oBackupUsedMedia
End Property

Public Property Get BackupResult() As BackupResult
    If oBackupResult Is Nothing Then
        Set oBackupResult = New BackupResult
        Set oBackupResult.Parent = Me
    End If
    Set BackupResult = oBackupResult
End Property

Public Property Get BackupError() As BackupError
    If oBackupError Is Nothing Then
        Set oBackupError = New BackupError
        Set oBackupError.Parent = Me
    End If
    Set BackupError = oBackupError
End Property

Public Property Get BackupState() As BackupState
    If oBackupState Is Nothing Then
        Set oBackupState = New BackupState
        Set oBackupState.Parent = Me
    End If
    Set BackupState = oBackupState
End Property

'''

Public Property Get History() As History
    If oHistory Is Nothing Then
        Set oHistory = New History
        Set oHistory.Parent = Me
    End If
    Set History = oHistory
End Property

Public Property Get ExternalIDs() As ExternalIDs
    If oExternalIDs Is Nothing Then
        Set oExternalIDs = New ExternalIDs
    End If
    Set ExternalIDs = oExternalIDs
End Property

Public Property Get BackupManager() As BackupManager
    If oBackupManager Is Nothing Then
        Set oBackupManager = New BackupManager
        Set oBackupManager.Parent = Me
    End If
    Set BackupManager = oBackupManager
End Property

Public Property Get RestoreManager() As RestoreManager
    If oRestoreManager Is Nothing Then
        Set oRestoreManager = New RestoreManager
        Set oRestoreManager.Parent = Me
    End If
    Set RestoreManager = oRestoreManager
End Property

Public Property Get DefaultBlocksize() As Long
    DefaultBlocksize = lDefaultBlocksize
End Property

Public Property Get At() As Date
    At = dAt
End Property

'''

Public Function CreateMediaGroup(ByVal Name As String) As MediaGroup
    Dim oMediaGroup As New MediaGroup
    
    With oMediaGroup
        Set .Parent = Me
        .Name = Name
    End With
    
    oMediaGroups.Add oMediaGroup
    
    Set CreateMediaGroup = oMediaGroup
End Function

Public Function CopyMediaGroup(Name As String, NewName As String) As MediaGroup
    Dim oMediaGroup As MediaGroup
    Dim oMedium As Medium
    Dim oNewMediaGroup As MediaGroup
    Dim oNewMedium As Medium
    
    Set oNewMediaGroup = Nothing
    
    Set oMediaGroup = oMediaGroups.ItemByName(Name)
    
    If Not oMediaGroup Is Nothing Then
        Set oNewMediaGroup = CreateMediaGroup(NewName)
        For Each oMedium In oMediaGroup.Media
            With oMedium
                Set oNewMedium = oNewMediaGroup.CreateMedium(.Name, .Location, .DeviceType, .SaveType)
                oNewMedium.SizePages = .SizePages
                oNewMedium.Overwrite = .Overwrite
                oNewMedium.Blocksize = .Blocksize
                oNewMedium.AutoLoader = .AutoLoader
                oNewMedium.OSCommand = .OSCommand
            End With
        Next
    End If
    
    Set CopyMediaGroup = oNewMediaGroup
End Function

Public Function CreateMedium(ByVal Name As String, _
                             ByVal Location As String, _
                             ByVal DeviceType As DBMDeviceTypeConstants, _
                             ByVal SaveType As DBMBackupTypeConstants) As Medium
                             
    Dim oMedium As New Medium
    
    With oMedium
        Set .Parent = Me
        .InGroup = False
        .Name = Name
        .Location = Location
        .DeviceType = DeviceType
        .SaveType = SaveType
    End With
    
    oMedia.Add oMedium
    
    Set CreateMedium = oMedium
End Function

Public Function OpenMedia(Optional ByVal Always As Boolean = False, _
                          Optional ByVal Asynchron As Boolean = False, _
                          Optional ByVal SenderID As Long = 0) As Boolean
                     
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        bAlways = Always
        
        If Not Asynchron Then
            bOK = Execute(FUNC_MEDIAOPEN, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_MEDIAOPEN, SenderID
            bOK = True
        End If
    End If
    
    OpenMedia = bOK
End Function

Public Function SaveMedia(Optional ByVal Asynchron As Boolean = False, _
                          Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_MEDIASAVE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_MEDIASAVE, SenderID
            bOK = True
        End If
    End If
    
    SaveMedia = bOK
End Function

Public Function DeleteMedia(Optional ByVal Asynchron As Boolean = False, _
                            Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_MEDIADELETE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_MEDIADELETE, SenderID
            bOK = True
        End If
    End If
    
    DeleteMedia = bOK
End Function

'''

Public Function InitForBackup(Optional ByVal Always As Boolean = False, _
                            Optional ByVal Asynchron As Boolean = False, _
                            Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        
        bInitForBackupAlways = Always
        
        If Not Asynchron Then
            bOK = Execute(FUNC_INITFORBACKUP, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_INITFORBACKUP, SenderID
            bOK = True
        End If
    End If
    
    InitForBackup = bOK
End Function

Public Function InitForRestoreInit(Optional ByVal Always As Boolean = False, _
                                   Optional ByVal Asynchron As Boolean = False, _
                                   Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        
        bInitForRestoreAlways = Always
        
        If Not Asynchron Then
            bOK = Execute(FUNC_INITFORRESTOREINIT, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_INITFORRESTOREINIT, SenderID
            bOK = True
        End If
    End If
    
    InitForRestoreInit = bOK
End Function

Public Function InitForRestore(Optional ByVal Always As Boolean = False, _
                               Optional ByVal Asynchron As Boolean = False, _
                               Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        
        bInitForRestoreAlways = Always
        
        If Not Asynchron Then
            bOK = Execute(FUNC_INITFORRESTORE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_INITFORRESTORE, SenderID
            bOK = True
        End If
    End If
    
    InitForRestore = bOK
End Function

Public Function InitForCheck(Optional ByVal Always As Boolean = False, _
                             Optional ByVal Asynchron As Boolean = False, _
                             Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        
        bInitForCheckAlways = Always
        
        If Not Asynchron Then
            bOK = Execute(FUNC_INITFORCHECK, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_INITFORCHECK, SenderID
            bOK = True
        End If
    End If
    
    InitForCheck = bOK
End Function

Public Function GetExternalIDs(ByVal MediumName As String, _
                               Optional ByVal DatabaseName As String = "", _
                               Optional ByVal ServerName As String = "", _
                               Optional ByVal Asynchron As Boolean = False, _
                               Optional ByVal SenderID As Long = 0) As Boolean
                     
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        sMediumName = MediumName
        sDatabase = DatabaseName
        sServer = ServerName
        
        If Not Asynchron Then
            bOK = Execute(FUNC_GETEXTERNALIDS, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_GETEXTERNALIDS, SenderID
            bOK = True
        End If
    End If
    
    GetExternalIDs = bOK
End Function

'''

Public Function Save(ByVal Media As Object, _
                     ByVal SaveType As DBMBackupTypeConstants, _
                     Optional ByVal SaveFor As DBMBackupForConstants = dbmSaveForRecovery, _
                     Optional ByVal Asynchron As Boolean = False) As Boolean
                
    If oBackup Is Nothing Then
        Set oBackup = CreateObject("DBMApp.Backup")
    End If
    
    #If DBG Then
        Set oBackup.DebugTrace = Database.DebugTrace
    #End If
            
    Set oBackup.Parent = Me
    Set oBackup.Database = Database
   
    
    lBackupAction = dbmBASave
    lBackupType = SaveType
    lBackupFor = SaveFor
    Set oBackupUsedMedia = Media
    
    Save = oBackup.Save(Media, SaveType, SaveFor, Asynchron)
End Function

Public Function SaveReplace(ByVal Medium As Medium, _
                            Optional ByVal Asynchron As Boolean = False) As Boolean
    SaveReplace = False
    
    If lBackupAction <> dbmBASave Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    SaveReplace = oBackup.SaveReplace(Medium, Asynchron)
End Function

Public Function SaveIgnore(ByVal Medium As Medium, _
                           Optional ByVal Asynchron As Boolean = False) As Boolean
    SaveIgnore = False
    
    If lBackupAction <> dbmBASave Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    SaveIgnore = oBackup.SaveIgnore(Medium, Asynchron)
End Function

Public Function SaveCancel(Optional ByVal Asynchron As Boolean = False) As Boolean
    SaveCancel = False
    
    If lBackupAction <> dbmBASave Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    SaveCancel = oBackup.SaveCancel(Asynchron)
End Function

'''

Public Function Restore(ByVal Media As Object, _
                        ByVal RestoreType As DBMBackupTypeConstants, _
                        Optional ByVal LogNumber As Long = 0, _
                        Optional ByVal UseUntildate As Boolean = False, _
                        Optional ByVal UntilDate As Date = Empty, _
                        Optional ByVal Asynchron As Boolean = False) As Boolean
    If oBackup Is Nothing Then
        Set oBackup = CreateObject("DBMApp.Backup")
    End If
    
    #If DBG Then
        Set oBackup.DebugTrace = Database.DebugTrace
    #End If
    
    Set oBackup.Parent = Me
    Set oBackup.Database = Database
    
    lBackupAction = dbmBARestore
    lBackupType = RestoreType
    Set oBackupUsedMedia = Media
    
    Restore = oBackup.Restore(Media, RestoreType, LogNumber, UseUntildate, UntilDate, Asynchron)
End Function

Public Function RestoreReplace(ByVal Medium As Medium, _
                               Optional ByVal LogNumber As Long = 0, _
                               Optional ByVal Asynchron As Boolean = False) As Boolean
    RestoreReplace = False
    
    If lBackupAction <> dbmBARestore Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    RestoreReplace = oBackup.RestoreReplace(Medium, LogNumber, Asynchron)
End Function

Public Function RestoreIgnore(ByVal Medium As Medium, _
                              Optional ByVal Asynchron As Boolean = False) As Boolean
    RestoreIgnore = False
    
    If lBackupAction <> dbmBARestore Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    RestoreIgnore = oBackup.RestoreIgnore(Medium, Asynchron)
End Function

Public Function RestoreCancel(Optional ByVal Asynchron As Boolean = False) As Boolean
    RestoreCancel = False
    
    If lBackupAction <> dbmBARestore Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    RestoreCancel = oBackup.RestoreCancel(Asynchron)
End Function

'''

Public Function Check(ByVal Media As Object, _
                      ByVal CheckType As DBMBackupTypeConstants, _
                      Optional ByVal LogNumber As Long = 0, _
                      Optional ByVal Asynchron As Boolean = False) As Boolean
                      
    If oBackup Is Nothing Then
        Set oBackup = CreateObject("DBMApp.Backup")
    End If
    
    #If DBG Then
        Set oBackup.DebugTrace = Database.DebugTrace
    #End If
    
    Set oBackup.Parent = Me
    Set oBackup.Database = Database
    
    lBackupAction = dbmBACheck
    lBackupType = CheckType
    Set oBackupUsedMedia = Media
    
    Check = oBackup.Check(Media, CheckType, LogNumber, Asynchron)
End Function

Public Function CheckReplace(ByVal Medium As Medium, _
                             Optional ByVal LogNumber As Long = 0, _
                             Optional ByVal Asynchron As Boolean = False) As Boolean
    CheckReplace = False
    
    If lBackupAction <> dbmBACheck Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    CheckReplace = oBackup.CheckReplace(Medium, LogNumber, Asynchron)
End Function

Public Function CheckIgnore(ByVal Medium As Medium, _
                            Optional ByVal Asynchron As Boolean = False) As Boolean
    CheckIgnore = False
    
    If lBackupAction <> dbmBACheck Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    CheckIgnore = oBackup.CheckIgnore(Medium, Asynchron)
End Function

Public Function CheckCancel(Optional ByVal Asynchron As Boolean = False) As Boolean
    CheckCancel = False
    
    If lBackupAction <> dbmBACheck Then Exit Function
    If oBackup Is Nothing Then Exit Function
        
    CheckCancel = oBackup.CheckCancel(Asynchron)
End Function

'''

Public Sub BackupCancel()
    If lBackupAction = dbmBANone Then Exit Sub
    If oBackup Is Nothing Then Exit Sub
    
    oBackup.Cancel
End Sub

Public Sub BackupReset()
    lBackupAction = dbmBANone
    
    If Not oBackupResult Is Nothing Then oBackupResult.CleanUp
    If Not oBackupState Is Nothing Then oBackupState.CleanUp
    
    Set oBackupResult = Nothing
    Set oBackupState = Nothing
    
    Set oBackupUsedMedia = Nothing
End Sub

Public Sub BackupClose()
    If Not oBackup Is Nothing Then oBackup.CleanUp
    Set oBackup = Nothing
    
    BackupReset
End Sub

Public Function CanIgnore(ByVal Medium As Medium) As Boolean
    Dim iIgnored As Integer
    Dim oMedium As Medium
    
    CanIgnore = False
    
    If lBackupAction = dbmBANone Then Exit Function
    If oBackupUsedMedia.ObjectType <> dbmOTMediaGroup Then Exit Function
    If Medium.Ignored = True Then Exit Function
        
    iIgnored = 0
    For Each oMedium In oBackupUsedMedia.Media
        If oMedium.Ignored Then
            iIgnored = iIgnored + 1
        End If
    Next
        
    ' es koennen max. n-1 medien ignoriert werden
    If iIgnored < (oBackupUsedMedia.Media.Count - 1) Then
        CanIgnore = True
    End If
End Function

' Beim RestoreLog nach einem Totalverlust weiss der Kern
' nicht, wann das RestoreLog abgeschlossen ist. Er kehrt
' dann mit einem Fehler -8020 (next volume) zurueck. Ueber
' "restore log ignore" wird dem Kern mitgeteilt, dass nichts
' mehr da ist. CanEnd ist dann True, wenn eine RestoreLog
' mit nur (noch) einem Medium aktiv ist.
Public Function CanEnd(ByVal Medium As Medium) As Boolean

    Dim iActive As Integer
    Dim oMedium As Medium
    Dim sText As String
    
    CanEnd = False
    
    If lBackupAction <> dbmBARestore Then Exit Function
    If lBackupType <> dbmBTLog And lBackupType <> dbmBTPages Then Exit Function
    If Medium.Ignored = True Then Exit Function
        
    iActive = 0
    If (oBackupUsedMedia.ObjectType = dbmOTMediaGroup) Then
      For Each oMedium In oBackupUsedMedia.Media
        If Not oMedium.Ignored Then
          iActive = iActive + 1
        End If
      Next
      ' nur noch 1 aktive?
      CanEnd = (iActive = 1)
    ElseIf (oBackupUsedMedia.ObjectType = dbmOTMedium) Then
      CanEnd = True
    End If

End Function

'''

Public Function RestoreConfig(MediumName As String) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .ServiceConnect Then
            If DBMSRVBackup.RestoreConfig(.ServerObject, MediumName) Then
                bOK = True
            Else
                .LastError.SetByServerObject .ServerObject
            End If
            .ServiceRelease
        End If
    End With
    
    RestoreConfig = bOK
End Function

'''

Public Function DeviceTypeName(ByVal lDeviceType As DBMDeviceTypeConstants) As String
    Dim sName As String
    Select Case lDeviceType
        Case dbmDTFile:     sName = DEVTYPE_FILE
        Case dbmDTTape:     sName = DEVTYPE_TAPE
        Case dbmDTPipe:     sName = DEVTYPE_PIPE
        Case dbmDTUnknown:  sName = DEVTYPE_UNKNOWN
        Case dbmDTNoRewind: sName = DEVTYPE_NOREWIND
    End Select
    DeviceTypeName = sName
End Function

Public Function DeviceType(ByVal sDeviceTypeName As String, _
                           Optional ByVal bFromHistory As Boolean = False) As DBMDeviceTypeConstants
    Dim lType As DBMDeviceTypeConstants
    If Not bFromHistory Then
        Select Case UCase$(Trim$(sDeviceTypeName))
            Case DEVTYPE_FILE:      lType = dbmDTFile
            Case DEVTYPE_TAPE:      lType = dbmDTTape
            Case DEVTYPE_PIPE:      lType = dbmDTPipe
            Case DEVTYPE_UNKNOWN:   lType = dbmDTUnknown
            Case DEVTYPE_NOREWIND:  lType = dbmDTNoRewind
        End Select
    Else
        Select Case UCase$(Trim$(sDeviceTypeName))
            Case DEVTYPE_HIST_FILE:      lType = dbmDTFile
            Case DEVTYPE_HIST_TAPE:      lType = dbmDTTape
            Case DEVTYPE_HIST_PIPE:      lType = dbmDTPipe
            Case DEVTYPE_HIST_UNKNOWN:   lType = dbmDTUnknown
            Case DEVTYPE_HIST_NOREWIND:  lType = dbmDTNoRewind
        End Select
    End If
    DeviceType = lType
End Function

Public Function OverwriteString(ByVal lOverwrite As DBMOverwriteConstants) As String
    Dim s As String
    Select Case lOverwrite
        Case dbmOverwriteNo:      s = OVERWRITE_NO
        Case dbmOverwriteYes:     s = OVERWRITE_YES
    End Select
    OverwriteString = s
End Function

Public Function Overwrite(ByVal sOverwriteString As String) As DBMOverwriteConstants
    Dim l As DBMOverwriteConstants
    Select Case UCase(Trim(sOverwriteString))
        Case OVERWRITE_NO:      l = dbmOverwriteNo
        Case OVERWRITE_YES:     l = dbmOverwriteYes
    End Select
    Overwrite = l
End Function

Public Function AutoLoaderString(ByVal lAutoLoader As DBMAutoLoaderConstants) As String
    Dim s As String
    Select Case lAutoLoader
        Case dbmAutoLoaderNo:      s = AUTOLOADER_NO
        Case dbmAutoLoaderYes:     s = AUTOLOADER_YES
    End Select
    AutoLoaderString = s
End Function

Public Function AutoLoaderConstant(ByVal sAutoLoaderString As String) As DBMAutoLoaderConstants
    Dim l As DBMAutoLoaderConstants
    Select Case UCase(Trim(sAutoLoaderString))
        Case AUTOLOADER_NO:      l = dbmAutoLoaderNo
        Case AUTOLOADER_YES:     l = dbmAutoLoaderYes
    End Select
    AutoLoaderConstant = l
End Function

Public Function BackupActionString(ByVal BackupAction As DBMBackupActionConstants) As String
    Dim s As String
    Select Case BackupAction
        Case dbmBASave:     s = BACKUPACTION_SAVE
        Case dbmBARestore:  s = BACKUPACTION_RESTORE
    End Select
    BackupActionString = s
End Function

Public Function BackupActionConstant(ByVal BackupActionString As String) As DBMBackupActionConstants
    Dim l As DBMBackupActionConstants
    Select Case UCase(Trim(BackupActionString))
        Case BACKUPACTION_SAVE:     l = dbmBASave
        Case BACKUPACTION_RESTORE:  l = dbmBARestore
    End Select
    BackupActionConstant = l
End Function

Public Function BackupTypeString(ByVal BackupType As DBMBackupTypeConstants) As String
    Dim s As String
    Select Case BackupType
        Case dbmBTData:     s = BACKUPTYPE_DATA
        Case dbmBTPages:    s = BACKUPTYPE_PAGES
        Case dbmBTLog:      s = BACKUPTYPE_LOG
        Case dbmBTAuto:     s = BACKUPTYPE_AUTO
        Case dbmBTUnknown:  s = BACKUPTYPE_UNKNOWN
    End Select
    BackupTypeString = s
End Function

Public Function BackupTypeConstant(ByVal BackupTypeString As String) As DBMBackupTypeConstants
    Dim l As DBMBackupTypeConstants
    Select Case UCase(Trim(BackupTypeString))
        Case BACKUPTYPE_DATA:       l = dbmBTData
        Case BACKUPTYPE_PAGES:      l = dbmBTPages
        Case BACKUPTYPE_LOG:        l = dbmBTLog
        Case BACKUPTYPE_AUTO:       l = dbmBTAuto
        Case BACKUPTYPE_UNKNOWN:    l = dbmBTUnknown
    End Select
    BackupTypeConstant = l
End Function

Public Function BackupForString(ByVal BackupFor As DBMBackupForConstants) As String
    Dim s As String
    Select Case BackupFor
        Case dbmSaveForRecovery:     s = BACKUPFOR_RECOVERY
        Case dbmSaveForMigration:    s = BACKUPFOR_MIGRATION
    End Select
    BackupForString = s
End Function

Public Function BackupForConstant(ByVal BackupForString As String) As DBMBackupForConstants
    Dim l As DBMBackupForConstants
    Select Case UCase(Trim(BackupForString))
        Case BACKUPFOR_RECOVERY:  l = dbmSaveForRecovery
        Case BACKUPFOR_MIGRATION: l = dbmSaveForMigration
    End Select
    BackupForConstant = l
End Function

'''

Public Sub CleanUp()
    If Not oBackup Is Nothing Then oBackup.CleanUp
    
    If Not oMedia Is Nothing Then oMedia.CleanUp
    If Not oMediaGroups Is Nothing Then oMediaGroups.CleanUp
    
    If Not oHistory Is Nothing Then oHistory.CleanUp
    
    If Not oExternalIDs Is Nothing Then oExternalIDs.CleanUp
    
    If Not oBackupManager Is Nothing Then oBackupManager.CleanUp
    If Not oRestoreManager Is Nothing Then oRestoreManager.CleanUp
    
    If Not oBackupResult Is Nothing Then oBackupResult.CleanUp
    If Not oBackupError Is Nothing Then oBackupError.CleanUp
    If Not oBackupState Is Nothing Then oBackupState.CleanUp

    Set oBackup = Nothing

    Set oMedia = Nothing
    Set oMediaGroups = Nothing
    
    Set oHistory = Nothing
    
    Set oExternalIDs = Nothing
    
    Set oBackupManager = Nothing
    Set oRestoreManager = Nothing
    
    Set oBackupResult = Nothing
    Set oBackupError = Nothing
    Set oBackupState = Nothing
    
    Set oBackupUsedMedia = Nothing

    Set oParent = Nothing
End Sub

Public Function BackupActionKindString(ByVal BackupActionKind As DBMBackupActionKindConstants) As String
    Dim s As String
    Select Case BackupActionKind
        Case dbmBAKSingle:      s = BACKUPACTIONKIND_SINGLE
        Case dbmBAKMultiple:    s = BACKUPACTIONKIND_MULTIPLE
        Case dbmBAKReplace:     s = BACKUPACTIONKIND_REPLACE
        Case dbmBAKUnknown:     s = BACKUPACTIONKIND_UNKNOWN
    End Select
    BackupActionKindString = s
End Function

Public Function BackupActionKindConstant(ByVal BackupActionKindString As String) As DBMBackupActionKindConstants
    Dim l As DBMBackupActionKindConstants
    Select Case UCase(Trim(BackupActionKindString))
        Case BACKUPACTIONKIND_SINGLE:   l = dbmBAKSingle
        Case BACKUPACTIONKIND_MULTIPLE: l = dbmBAKMultiple
        Case BACKUPACTIONKIND_REPLACE:  l = dbmBAKReplace
        Case Else:                      l = dbmBAKUnknown
    End Select
    BackupActionKindConstant = l
End Function

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    Set oMedia = New Media
    Set oMediaGroups = New MediaGroups
    
    lBackupAction = dbmBANone
    lBackupType = dbmBTData
    Set oBackupUsedMedia = Nothing
    
    Set oBackupResult = Nothing
    Set oBackupError = Nothing
    Set oBackupState = Nothing
    
    Set oHistory = Nothing
    
    Set oExternalIDs = Nothing
    
    Set oBackupManager = Nothing
    Set oRestoreManager = Nothing
    
    Set oBackup = Nothing
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
'
' Media File
'
Private Sub GetMedia()
    With Database
        If DBMSRVMedia.GetMedia(.ServerObject, Me) Then
        End If
    End With
End Sub

Private Sub PutMedia()
    Dim sRemoteFile As String
    Dim sLocalFile As String
    Dim sError As String
    Dim lRC As Long
    
    With Database
        If DBMSRVMedia.PutMedia(.ServerObject, Me) Then
        End If
    End With
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim oDB As DBMLib.Database
    
    Set oDB = Database
    
    oDB.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_MEDIAOPEN:            bOK = ExecuteOpenMedia(Asynchron, SenderID)
        Case FUNC_MEDIASAVE:            bOK = ExecuteSaveMedia(Asynchron, SenderID)
        Case FUNC_MEDIADELETE:          bOK = ExecuteDeleteMedia(Asynchron, SenderID)
        
        Case FUNC_INITFORBACKUP:        bOK = ExecuteInitForBackup(Asynchron, SenderID)
        Case FUNC_INITFORRESTOREINIT:   bOK = ExecuteInitForRestoreInit(Asynchron, SenderID)
        Case FUNC_INITFORRESTORE:       bOK = ExecuteInitForRestore(Asynchron, SenderID)
        Case FUNC_INITFORCHECK:         bOK = ExecuteInitForCheck(Asynchron, SenderID)
        
        Case FUNC_GETEXTERNALIDS:       bOK = ExecuteGetExternalIDs(Asynchron, SenderID)
    End Select
            
    oDB.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteOpenMedia(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim bGet As Boolean
    
    bOK = False
    
    bGet = False
    
    With Database
        If .Check() Then
            If bAlways = True Then
                bGet = True
            Else
                If oMediaGroups.Count = 0 And oMedia.Count = 0 Then
                    bGet = True
                End If
            End If
            
            If bGet Then
            
                oMediaGroups.Clear
                oMedia.Clear
                
                .ServerObject.ErrorRaise = False
                If DBMSRVMedia.GetMedia(.ServerObject, Me) Then
                    .ServerObject.ErrorRaise = True
                    bOK = True
                Else
                    .ServerObject.ErrorRaise = True
                    If .ServerObject.ReturnCode = DBMSOB_ERR_NOMEDIA Then
                        bOK = True
                    Else
                        .ServerObject.RaiseError
                        .LastError.SetByServerObject .ServerObject
                    End If
                End If
                
            Else
                bOK = True
            End If
            
            If bOK Then
                lDefaultBlocksize = Val(.Parameters.GetValue(PARAM_BACKUP_BLOCK_CNT))
                If lDefaultBlocksize = 0 Then lDefaultBlocksize = 8
            End If
        End If
        
        If bOK Then dAt = Now()
        
        If bAsynchron Then
            .EventMediaAction lSenderID, Not bOK, dbmMediaActionOpen
        End If
    End With
    
    ExecuteOpenMedia = bOK
End Function

Private Function ExecuteSaveMedia(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVMedia.PutMedia(.ServerObject, Me) Then
                bOK = True
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventMediaAction lSenderID, Not bOK, dbmMediaActionSave
        End If
    End With

    ExecuteSaveMedia = bOK
End Function

Private Function ExecuteDeleteMedia(ByVal bAsynchron As Boolean, ByVal lSenderID As Long)
    Dim oMediaGroup As MediaGroup
    Dim oMedium As Medium
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            For Each oMediaGroup In oMediaGroups
                bOK = oMediaGroup.Delete()
                If Not bOK Then Exit For
            Next
            
            If bOK Then
                For Each oMedium In oMedia
                    bOK = oMedium.Delete()
                    If Not bOK Then Exit For
                Next
            End If
    
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventMediaAction lSenderID, Not bOK, dbmMediaActionDelete
        End If
    End With
    
    ExecuteDeleteMedia = bOK
End Function

'''

Private Function ExecuteInitForBackup(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    bOK = Database.State.Refresh
    bOK = BackupManager.BackupHistory.Refresh(dbmHFBackup, bInitForBackupAlways, False, lSenderID)
    bOK = OpenMedia(bInitForBackupAlways, False, lSenderID)
    
    If bAsynchron Then
        Database.EventBackupInitAction lSenderID, Not bOK, dbmBackupInitActionInitForBackup
    End If
End Function

Private Function ExecuteInitForRestoreInit(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False

    bOK = RestoreManager.RestoreHistory.Refresh(dbmHFRestoreInit, bInitForRestoreAlways)
    bOK = OpenMedia(bInitForRestoreAlways)
    bOK = Database.RestartInfo.Refresh()
    
    If bAsynchron Then
        Database.EventBackupInitAction lSenderID, Not bOK, dbmBackupInitActionInitForRestoreInit
    End If
End Function

Private Function ExecuteInitForRestore(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False

    bOK = RestoreManager.RestoreHistory.Refresh(dbmHFRestore, bInitForRestoreAlways)
    
    If bAsynchron Then
        Database.EventBackupInitAction lSenderID, Not bOK, dbmBackupInitActionInitForRestore
    End If
End Function

Private Function ExecuteInitForCheck(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False

    bOK = OpenMedia(bInitForCheckAlways, False, lSenderID)
    
    If bAsynchron Then
        Database.EventBackupInitAction lSenderID, Not bOK, dbmBackupInitActionInitForCheck
    End If
End Function

Private Function ExecuteGetExternalIDs(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            ExternalIDs.Clear
            If DBMSRVExternalIDs.ExternalIDsOpen(Database, sMediumName, sDatabase, sServer) Then
                If DBMSRVExternalIDs.ExternalIDsGet(Database, ExternalIDs) Then
                    bOK = True
                Else
                   .LastError.SetByServerObject .ServerObject
                End If
                
                DBMSRVExternalIDs.ExternalIDsClose Database
            Else
               .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventExternalIDsAction lSenderID, Not bOK, dbmExternalIDsActionRefresh
        End If
    End With
    
    ExecuteGetExternalIDs = bOK
End Function

