VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BackupManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

Private oBackupHistory As History

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTBackupManager
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get BackupHistory() As History
    If oBackupHistory Is Nothing Then
        Set oBackupHistory = New History
        Set oBackupHistory.Parent = Me
    End If
    Set BackupHistory = oBackupHistory
End Property

Public Property Get HistoryItems() As HistoryItems
    Set HistoryItems = BackupHistory.HistoryItems
End Property

'''

Public Property Get LastSaveData() As HistoryItem
    Dim lCount As Long
    Dim lItem As Long
    Dim oItem As HistoryItem
    
    Set LastSaveData = Nothing
    
    If Not HistoryItems Is Nothing Then
        lCount = HistoryItems.Count
        
        For lItem = lCount To 1 Step -1
            
            Set oItem = HistoryItems.Item(lItem)
            
            If oItem.ActionType = dbmBAHistLost Then
                Exit For
            Else
                If oItem.ActionType = dbmBASave And _
                   oItem.BackupType = dbmBTData And _
                   oItem.ReturnCode = 0 _
                Then
                    Set LastSaveData = oItem
                    Exit For
                End If
            End If
        Next
    End If
End Property

Public Sub CleanUp()
    If Not oBackupHistory Is Nothing Then oBackupHistory.CleanUp

    Set oBackupHistory = Nothing

    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    Reset
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

