VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BadDevSpaces"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

Private bOpen As Boolean

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTBadDevSpaces
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

'''

Public Function OpenBadDevSpaces(Header As String, _
                                 Result As String, _
                                 Continue As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sWhere As String
    
    bOK = False
    
    sWhere = ""
    
    Database.Busy = True
    
    If Database.Check() Then
        With Database
            If DBMSRVSQL.Connect(.ServerObject) Then
                If DBMSRVInfo.InfoSelect(.ServerObject, "BADDEVSPACES", sWhere, Header, Result, Continue) Then
                    bOpen = True
                    bOK = True
                Else
                    DBMSRVSQL.Release .ServerObject
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End With
    End If
    
    Database.Busy = False
    
    OpenBadDevSpaces = bOK
End Function

Public Function FetchBadDevSpaces(Header As String, _
                                  Result As String, _
                                  Continue As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If bOpen Then
        Database.Busy = True
        
        If Database.Check() Then
            With Database
                If DBMSRVInfo.InfoFetch(.ServerObject, Header, Result, Continue) Then
                    bOK = True
                Else
                    .LastError.SetByServerObject .ServerObject
                End If
            End With
        End If
        
        Database.Busy = False
    End If
    
    FetchBadDevSpaces = bOK
End Function

Public Function CloseBadDevSpaces() As Boolean
    Dim bOK As Boolean

    If Not bOpen Then
        CloseBadDevSpaces = True
        Exit Function
    End If

    bOK = False
    
    Database.Busy = True
    
    If Database.Check() Then
        With Database
            If DBMSRVSQL.Release(.ServerObject) Then
                bOpen = False
            End If
        End With
    End If

    Database.Busy = False
    
    CloseBadDevSpaces = bOK
End Function

Public Function ReintegrateBadDevSpace(Name As String) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    
    bOK = False
    
    Database.Busy = True
    
    If Database.Check() Then
        With Database
            If .UtilConnect Then
                If .ServerObject.Command(DBMSRV_CMD_RESTORE_DEVSPACE + " " + Name, sData) Then
                    bOK = True
                Else
                    .LastError.SetByServerObject .ServerObject
                End If
                .UtilRelease
            End If
        End With
    End If
    
    Database.Busy = False
    
    ReintegrateBadDevSpace = bOK
End Function

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

Private Sub Class_Initialize()
    InitObject ObjectType
    bOpen = False
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
