VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Catalog"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

Private oTables As Tables
Private oColumns As Columns
Private oIndexes As Indexes
Private oUpdStat As UpdStat
Private oBadDevSpaces As BadDevSpaces

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTCatalog
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

'''

Public Property Get Tables() As Tables
    If oTables Is Nothing Then
        Set oTables = New Tables
        Set oTables.Parent = Me
    End If
    Set Tables = oTables
End Property

Public Property Get Columns() As Columns
    If oColumns Is Nothing Then
        Set oColumns = New Columns
        Set oColumns.Parent = Me
    End If
    Set Columns = oColumns
End Property

Public Property Get Indexes() As Indexes
    If oIndexes Is Nothing Then
        Set oIndexes = New Indexes
        Set oIndexes.Parent = Me
    End If
    Set Indexes = oIndexes
End Property

Public Property Get UpdStat() As UpdStat
    If oUpdStat Is Nothing Then
        Set oUpdStat = New UpdStat
        Set oUpdStat.Parent = Me
    End If
    Set UpdStat = oUpdStat
End Property

Public Property Get BadDevSpaces() As BadDevSpaces
    If oBadDevSpaces Is Nothing Then
        Set oBadDevSpaces = New BadDevSpaces
        Set oBadDevSpaces.Parent = Me
    End If
    Set BadDevSpaces = oBadDevSpaces
End Property

'''

Public Sub CleanUp()
    If Not oTables Is Nothing Then oTables.CleanUp
    If Not oColumns Is Nothing Then oColumns.CleanUp
    If Not oIndexes Is Nothing Then oIndexes.CleanUp
    If Not oUpdStat Is Nothing Then oUpdStat.CleanUp
    If Not oBadDevSpaces Is Nothing Then oBadDevSpaces.CleanUp
    
    Set oTables = Nothing
    Set oColumns = Nothing
    Set oIndexes = Nothing
    Set oUpdStat = Nothing
    Set oBadDevSpaces = Nothing
    
    Set oParent = Nothing
End Sub

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType
End Sub



