Attribute VB_Name = "DBMSRVInclude"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Const DBMSRV_CMD_INST_ENUM = "installation_enum"
Public Const DBMSRV_CMD_DB_ENUM = "db_enum"
Public Const DBMSRV_CMD_DB_REG = "db_register"
Public Const DBMSRV_CMD_DB_UNREG = "db_unregister"
Public Const DBMSRV_CMD_DB_CREATE = "db_create"
Public Const DBMSRV_CMD_DB_DROP = "db_drop"

Public Const DBMSRV_CMD_VERSION = "version"
Public Const DBMSRV_CMD_DBM_VERSION = "dbm_version"

Public Const DBMSRV_CMD_DBM_CONFIGGET = "dbm_configget"
Public Const DBMSRV_CONFIGGET_KEYDBM = "sapdb12"
Public Const DBMSRV_CONFIGGET_KEYDBA = "sapdb5"

Public Const DBMSRV_CMD_DB_STATE = "db_state"
Public Const DBMSRV_CMD_DB_RESTART = "db_restart"

Public Const DBMSRV_CMD_DB_CLEAR = "db_clear"

Public Const DBMSRV_CMD_DB_START = "db_start"
Public Const DBMSRV_CMD_DB_STOP = "db_stop"

Public Const DBMSRV_CMD_DB_OFFLINE = "db_offline"
Public Const DBMSRV_CMD_DB_COLD = "db_cold"
Public Const DBMSRV_CMD_DB_WARM = "db_warm"
Public Const DBMSRV_CMD_DB_ONLINE = "db_warm"

Public Const DBMSRV_OPT_START_FAST = "-f"
Public Const DBMSRV_OPT_START_QUICK = "-q"
Public Const DBMSRV_OPT_START_SLOW = "-s"

Public Const DBMSRV_CMD_ADDDEVICE = "db_adddevice"

Public Const DBMSRV_CMD_DB_CONS = "db_cons"
Public Const DBMSRV_CMD_DB_CONS_KILL = "db_cons kill"

' BABCKUP Commands

Public Const DBMSRV_CMD_MEDIA_GET = "backup_media_get"
Public Const DBMSRV_CMD_MEDIA_GETALL = "backup_media_getall"
Public Const DBMSRV_CMD_MEDIA_PUT = "backup_media_put"
Public Const DBMSRV_CMD_MEDIA_DELETE = "backup_media_delete"
Public Const DBMSRV_CMD_MEDIA_DATE = "nbackup_media_date"

Public Const DBMSRV_CMD_BACKUP = "backup_save"
Public Const DBMSRV_CMD_BACKUP_REPLACE = "backup_save_replace"
Public Const DBMSRV_CMD_BACKUP_IGNORE = "backup_save_ignore"
Public Const DBMSRV_CMD_BACKUP_CANCEL = "backup_save_cancel"
Public Const DBMSRV_CMD_BACKUP_STATE = "backup_save_state"
Public Const DBMSRV_CMD_RESTORE = "backup_restore"
Public Const DBMSRV_CMD_RESTORE_CHECK = "backup_restore_check"
Public Const DBMSRV_CMD_RESTORE_REPLACE = "backup_restore_replace"
Public Const DBMSRV_CMD_RESTORE_IGNORE = "backup_restore_ignore"
Public Const DBMSRV_CMD_RESTORE_CANCEL = "backup_restore_cancel"
Public Const DBMSRV_CMD_RESTORE_STATE = "backup_restore_state"
Public Const DBMSRV_CMD_RESTORE_STATE_CHECK = "backup_restore_state_check"
Public Const DBMSRV_CMD_BACKUP_RESTART_INFO = "backup_restart_info"
Public Const DBMSRV_CMD_BACKUP_LABEL = "backup_label"
Public Const DBMSRV_CMD_BACKUP_LABELOFFLINE = "backup_labeloffline"
Public Const DBMSRV_CMD_BACKUP_COMMAND = "backup_command"
Public Const DBMSRV_CMD_RESTORE_CONFIG = "backup_restore_config"
Public Const DBMSRV_CMD_RESTORE_DEVSPACE = "backup_restore_devspace"

' AUTOSAVE Commands

Public Const DBMSRV_CMD_AUTOSAVE_ON = "autosave_on"
Public Const DBMSRV_CMD_AUTOSAVE_OFF = "autosave_off"
Public Const DBMSRV_CMD_AUTOSAVE_CANCEL = "autosave_cancel"
Public Const DBMSRV_CMD_AUTOSAVE_SHOW = "autosave_show"

' PARAM Commands


Public Const DBMSRV_CMD_EXEC_XLOAD = "exec_xload"
Public Const DBMSRV_CMD_LOAD_SYSTAB = "load_systab"

' UTIL Commands

Public Const DBMSRV_CMD_UTIL_START = "util_start"
Public Const DBMSRV_CMD_UTIL_CONNECT = "util_connect"
Public Const DBMSRV_CMD_UTIL_EXECUTE = "util_execute"
Public Const DBMSRV_CMD_UTIL_RELEASE = "util_release"
Public Const DBMSRV_CMD_UTIL_ACTIVATE = "util_activate"

' SQL Commands

Public Const DBMSRV_CMD_SQL_CONNECT = "sql_connect"
Public Const DBMSRV_CMD_SQL_EXECUTE = "sql_execute"
Public Const DBMSRV_CMD_SQL_RELEASE = "sql_release"
Public Const DBMSRV_CMD_SQL_INFO = "sql_info"
Public Const DBMSRV_CMD_SQL_FETCH = "sql_fetch"
Public Const DBMSRV_CMD_SQL_RECREATEINDEX = "sql_recreateindex"
Public Const DBMSRV_CMD_SQL_UPDATESTAT = "sql_updatestat"

' INFO Commands

Public Const DBMSRV_CMD_INFO = "info"
Public Const DBMSRV_CMD_INFO_NEXT = "info_next"


' DIR Commands

Public Const DBMSRV_CMD_DIR_OPEN = "dir_open"
Public Const DBMSRV_CMD_DIR_READNEXT = "dir_readnext"
Public Const DBMSRV_CMD_DIR_CLOSE = "dir_close"
Public Const DBMSRV_CMD_DIR_CREATE = "dir_create"

'''

Public Const DBMSRV_PPROP_VISIBLE_CONTROL = "VISIBLE=CONTROL"

' USER Commands

Public Const DBMSRV_CMD_USER_GETALL = "user_getall"
Public Const DBMSRV_CMD_USER_GET = "user_get"
Public Const DBMSRV_CMD_USER_PUT = "user_put"
Public Const DBMSRV_CMD_USER_CREATE = "user_create"
Public Const DBMSRV_CMD_USER_DELETE = "user_delete"
Public Const DBMSRV_CMD_USER_LOGON = "user_logon"
Public Const DBMSRV_CMD_USER_GETRIGHTS = "user_getrights"

Public Const DBMSRV_OPT_USERRIGHTS_SERVER = "SERVERRIGHTS"
Public Const DBMSRV_OPT_USERRIGHTS_GUI = "GUIRIGHTS"

Public Const DBMSRV_CMD_USER_SYSTEM = "user_system"

' SERVICE Commands

Public Const DBMSRV_CMD_SERVICE_CONNECT = "service_connect"
Public Const DBMSRV_CMD_SERVICE_RELEASE = "service_release"

' TRACE Commands
Public Const DBMSRV_CMD_TRACE_PROT = "trace_prot"
Public Const DBMSRV_CMD_TRACE_PROTOPT = "trace_protopt"
Public Const DBMSRV_CMD_TRACE_SHOW = "trace_show"
Public Const DBMSRV_CMD_TRACE_ON = "trace_on"
Public Const DBMSRV_CMD_TRACE_OFF = "trace_off"
Public Const DBMSRV_CMD_TRACE_CLEAR = "trace_clear"
Public Const DBMSRV_CMD_TRACE_FLUSH = "trace_flush"


' SHOW Commands
Public Const DBMSRV_CMD_SHOW_LIST = "show_list"
Public Const DBMSRV_CMD_SHOW = "show"
Public Const DBMSRV_CMD_SHOW_NEXT = "show_next"

' Return Codes

Public Const DBMSRV_RC_OK = 0                 ' everything works fine
Public Const DBMSRV_RC_USR_UNKNOWN = -1       ' user not exist
Public Const DBMSRV_RC_USR_FALSE = -2         ' wrong username password combination
Public Const DBMSRV_RC_MEMORY = -3            ' memory error
Public Const DBMSRV_RC_COMMERR = -4           ' tsp01_CommErr is set
Public Const DBMSRV_RC_TOSMALL = -5           ' communication buffer to small
Public Const DBMSRV_RC_INVSESSION = -6        ' invalid session
Public Const DBMSRV_RC_NOMOREDATA = -7        ' no more data in packet
Public Const DBMSRV_RC_RELEASED = -8          ' session released
Public Const DBMSOB_RC_NOT_OK = -100          ' common error

' Errors

Public Const DBMSRV_ERR_ = -24999
Public Const DBMSRV_ERR_NOTIMPL = -24998
Public Const DBMSRV_ERR_FILE = -24997
Public Const DBMSRV_ERR_PARAM = -24996
Public Const DBMSRV_ERR_MEM = -24995
Public Const DBMSRV_ERR_RTE = -24994
Public Const DBMSRV_ERR_RTEEXT = -24993
Public Const DBMSRV_ERR_NOUTILSESSION = -24992
Public Const DBMSRV_ERR_NOSQLUSERSESSION = -24991
Public Const DBMSRV_ERR_NOBACKUPSESSION = -24990

Public Const DBMSRV_ERR_NOHISTORYSESSION = -24989
Public Const DBMSRV_ERR_SQL = -24988
Public Const DBMSRV_ERR_TOSMALL = -24987
Public Const DBMSRV_ERR_NOMEDIA = -24986
Public Const DBMSRV_ERR_MENOTFOUND = -24985
Public Const DBMSRV_ERR_MENOVALID = -24984
Public Const DBMSRV_ERR_BANOVALIDTYPE = -24983
Public Const DBMSRV_ERR_NOHISTORY = -24982
Public Const DBMSRV_ERR_HIENTRYNOTFOUND = -24981
Public Const DBMSRV_ERR_NOHELP = -24980

Public Const DBMSRV_ERR_XPNOTFOUND = -24979
Public Const DBMSRV_ERR_XPSYNTAX = -24978
Public Const DBMSRV_ERR_COMMAND = -24977
Public Const DBMSRV_ERR_PARAMEXIST = -24976
Public Const DBMSRV_ERR_NOXPSESSION = -24975
Public Const DBMSRV_ERR_XPSESSION = -24974
Public Const DBMSRV_ERR_XPCHECK = -24973
Public Const DBMSRV_ERR_XPINVCONF = -24972
Public Const DBMSRV_ERR_XPNOCHECK = -24971
Public Const DBMSRV_ERR_XPNOMODIFY = -24970

Public Const DBMSRV_ERR_XPDIRTY = -24969
Public Const DBMSRV_ERR_XPREADONLY = -24968
Public Const DBMSRV_ERR_SYSTEM = -24967
Public Const DBMSRV_ERR_LOGON = -24966
Public Const DBMSRV_ERR_SYSLOGON = -24965
Public Const DBMSRV_ERR_EXECUTE = -24964
Public Const DBMSRV_ERR_DEVCHECK = -24963
Public Const DBMSRV_ERR_DEVTYPE = -24962
Public Const DBMSRV_ERR_STATE = -24961
Public Const DBMSRV_ERR_DBRUN = -24960

Public Const DBMSRV_ERR_XPOVERFLOW = -24959
Public Const DBMSRV_ERR_BAOVERWRITE = -24958
Public Const DBMSRV_ERR_NOUSER = -24957
Public Const DBMSRV_ERR_BASAVETYPECON = -24956
Public Const DBMSRV_ERR_BANOSAVETYPE = -24955
Public Const DBMSRV_ERR_BANOAUTOMED = -24954
Public Const DBMSRV_ERR_DBEXIST = -24953
Public Const DBMSRV_ERR_USRSAVE = -24952
Public Const DBMSRV_ERR_USRREAD = -24951
Public Const DBMSRV_ERR_USRFAIL = -24950

Public Const DBMSRV_ERR_USREXISTS = -24949
Public Const DBMSRV_ERR_NODBNAME = -24948
Public Const DBMSRV_ERR_DBNAME = -24947
Public Const DBMSRV_ERR_TOMANYPARAM = -24946
Public Const DBMSRV_ERR_TOFEWPARAM = -24945
Public Const DBMSRV_ERR_USRDELSELF = -24944
Public Const DBMSRV_ERR_USRDELCOLD = -24943
Public Const DBMSRV_ERR_USRDELSDBA = -24942
Public Const DBMSRV_ERR_NEEDLOGON = -24941
Public Const DBMSRV_ERR_NEEDSYSLOGON = -24940

Public Const DBMSRV_ERR_LASTREG = -24939
Public Const DBMSRV_ERR_NOENTRY = -24938
Public Const DBMSRV_ERR_MISSRIGHT = -24937
Public Const DBMSRV_ERR_DBNORUN = -24936
Public Const DBMSRV_ERR_NOUSERS = -24935
Public Const DBMSRV_ERR_VERSION = -24934
Public Const DBMSRV_ERR_NOSERVICESESSION = -24933
Public Const DBMSRV_ERR_XPMIN = -24932
Public Const DBMSRV_ERR_XPMAX = -24931
Public Const DBMSRV_ERR_XPVALUESET = -24930

Public Const DBMSRV_ERR_UNKNOWN = -24000

