Attribute VB_Name = "DBMSRVUtil"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Function Connect(oServerObject As DBMSOB.ServerObject, _
                        Optional sUsername As String = "", _
                        Optional sPassword As String = "") As Boolean
    Dim sCmd As String
    Dim sData As String

    Connect = False

    sCmd = DBMSRV_CMD_UTIL_CONNECT
    If Len(sUsername) > 0 And Len(sPassword) > 0 Then
        sCmd = sCmd + " " + sUsername + "," + sPassword
    End If

    If oServerObject.Command(sCmd, sData) Then
        Connect = True
    End If
End Function

Public Function Execute(oServerObject As DBMSOB.ServerObject, _
                        sStatement As String, _
                        Optional sResult As String = "") As Boolean
    Execute = False
    
    If oServerObject.Command(DBMSRV_CMD_UTIL_EXECUTE + " " + sStatement, sResult) Then
        Execute = True
    End If
End Function

Public Function Release(oServerObject As DBMSOB.ServerObject) As Boolean
    Dim sData As String
    
    Release = False
    
    If oServerObject.Command(DBMSRV_CMD_UTIL_RELEASE, sData) Then
        Release = True
    End If
End Function
