VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DatabaseEvent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oParent As Object

Private lIndex As Long
Private sKey As String

Private sName As String
Private lState As DBMDatabaseEventStateConstants
Private lPriority As DBMDatabaseEventPrioConstants
Private lValue1 As Long
Private lValue2 As Long
Private sDescription As String

Private lEventType As DBMDatabaseEventTypeConstants

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTDatabaseEvent
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

Public Property Get Key() As String
    Key = sKey
End Property

Public Property Get Name() As String
    Name = sName
End Property
Friend Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get State() As DBMDatabaseEventStateConstants
    State = lState
End Property
Friend Property Let State(ByVal NewVal As DBMDatabaseEventStateConstants)
    lState = NewVal
End Property

Public Property Get StateString() As String
    StateString = Database.DatabaseEvents.GetStateString(lState)
End Property
Friend Property Let StateString(NewVal As String)
    lState = Database.DatabaseEvents.GetStateValue(NewVal)
End Property

Public Property Get Priority() As DBMDatabaseEventPrioConstants
    Priority = lPriority
End Property
Public Property Let Priority(ByVal NewVal As DBMDatabaseEventPrioConstants)
    lPriority = NewVal
End Property

Public Property Get PriorityString() As String
    PriorityString = Database.DatabaseEvents.GetPriorityString(lPriority)
End Property
Public Property Let PriorityString(NewVal As String)
    lPriority = Database.DatabaseEvents.GetPriorityValue(NewVal)
End Property

Public Property Get Value1() As Long
    Value1 = lValue1
End Property
Public Property Let Value1(ByVal NewVal As Long)
    lValue1 = NewVal
End Property

Public Property Get Value2() As Long
    Value2 = lValue2
End Property
Public Property Let Value2(ByVal NewVal As Long)
    lValue2 = NewVal
End Property

Public Property Get Description() As String
    Description = sDescription
End Property
Friend Property Let Description(NewVal As String)
    sDescription = NewVal
End Property

Public Property Get EventType() As DBMDatabaseEventTypeConstants
    EventType = lEventType
End Property
Friend Property Let EventType(NewVal As DBMDatabaseEventTypeConstants)
    lEventType = NewVal
End Property

'''

Public Function EventOn(Optional ByVal Priority As DBMDatabaseEventPrioConstants = dbmDBEventPrioNIL, _
                        Optional ByVal Value1 As Long = -1, _
                        Optional ByVal Value2 As Long = -1) As Boolean
    Dim sCmd As String
    Dim sData As String
                        
    EventOn = False

    With Database
        If .UtilConnect Then
        
            sCmd = DBMSRV_CMD_EVENT_SET
            sCmd = sCmd + " " + Name
            If Priority <> dbmDBEventPrioNIL Then
                sCmd = sCmd + " " + Database.DatabaseEvents.GetPriorityString(Priority)
            Else
                sCmd = sCmd + " " + PriorityString
            End If

            If Value1 > 0 Then
                sCmd = sCmd + " " + CStr(Value1)
            Else
                If lValue1 > 0 Then
                    sCmd = sCmd + " " + CStr(lValue1)
                End If
            End If

            If Value2 > 0 Then
                sCmd = sCmd + " " + CStr(Value2)
            Else
                If lValue2 > 0 Then
                    sCmd = sCmd + " " + CStr(lValue2)
                End If
            End If

            If .ServerObject.Command(sCmd, sData) Then
                EventOn = True
                
                lState = dbmDBEventStateOn
                lPriority = Priority
                lValue1 = Value1
                lValue2 = Value2
            End If
            
            .UtilRelease
        End If
    End With
End Function

Public Function EventOff() As Boolean
    Dim sCmd As String
    Dim sData As String
    
    EventOff = False
    
    With Database
        If .UtilConnect Then
            
            sCmd = DBMSRV_CMD_EVENT_DELETE
            sCmd = sCmd + " " + Name

            If Value1 > 0 Then
                sCmd = sCmd + " " + CStr(Value1)
            End If

            If Value2 > 0 Then
                sCmd = sCmd + " " + CStr(Value2)
            End If

            If .ServerObject.Command(sCmd, sData) Then
                EventOff = True
                
                lState = dbmDBEventStateOff
            End If
            
            .UtilRelease
        End If
    End With
End Function

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    sKey = GetUniqueKeyStr()
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
