VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DevSpace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F23017E"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "RefreshDevSpace"
Const FUNC_SAVE = "SaveDevSpace"
Const FUNC_DELETE = "DeleteDevSpace"

'''

Const UTIL_CMD_ADDDATDEV = "ADD DATA DEVSPACE"
Const UTIL_CMD_ADDLOGDEV = "ADD LOG DEVSPACE"
Const UTIL_CMD_PAGES = "PAGES"

'''

Const MAX_CONV_REC_BD00 = 1855
Const SYS_DEV_BLOCK_CNT_BD01 = 8
Const OF_CONV_0_BD15 = 4

'''

Public Enum DBMDevSpaceClassConstans
    dbmDSCUnknown
    dbmDSCSys
    dbmDSCLog
    dbmDSCData
End Enum

Public Enum DBMDevSpaceTypeConstants
    dbmDSTUnknown
    dbmDSTFile
    dbmDSTRaw
    dbmDSTLink
End Enum

Const DEVCLASS_SYS = "System"
Const DEVCLASS_LOG = "Log"
Const DEVCLASS_DATA = "Data"
Const DEVCLASS_UNKNOWN = "Unknown"

Const DEVTYPE_FILE = "File"
Const DEVTYPE_RAW = "Raw"
Const DEVTYPE_LINK = "Link"
Const DEVTYPESHORT_FILE = "F"
Const DEVTYPESHORT_RAW = "R"
Const DEVTYPESHORT_LINK = "L"
Const DEVTYPE_UNKNOWN = "Unknown"

Const FORMAT_SYS = "000"
Const FORMAT_LOG = "000"
Const FORMAT_DATA = "0000"

Const VIEW_SYS = "SYS"
Const VIEW_LOG = "LOG"
Const VIEW_DATA = "DATA"

Const CLASS_SYS = "SYS"
Const CLASS_LOG = "LOG"
Const CLASS_DAT = "DATA"

Const MIRROR_PREFIX = "M"

Private oParent As Object

Private lNumber As Long
Private lClass As DBMDevSpaceClassConstans

Private lType As DBMDevSpaceTypeConstants
Private sLocation As String
Private lSizePages As Long

Private bMirrored As Boolean

Private lMirroredType As DBMDevSpaceTypeConstants
Private sMirroredLocation As String

Private lOldType As DBMDevSpaceTypeConstants
Private sOldLocation As String
Private lOldSizePages As Long

Private lOldMirroredType As DBMDevSpaceTypeConstants
Private sOldMirroredLocation As String

Private bDirty As Boolean
Private bExists As Boolean
Private bMirroredExists As Boolean

Private bReintegrate As Boolean

Private bParamsOnly As Boolean

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTDevSpace
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

'''

Public Property Get Name() As String
    Select Case lClass
        Case dbmDSCSys:     Name = VIEW_SYS & Format(Number, FORMAT_SYS)
        Case dbmDSCLog:     Name = VIEW_LOG & Format(Number, FORMAT_LOG)
        Case dbmDSCData:    Name = VIEW_DATA & Format(Number, FORMAT_DATA)
    End Select
End Property

'''

Public Property Get Number() As Long
    Number = lNumber
End Property
Friend Property Let Number(ByVal NewVal As Long)
    lNumber = NewVal
End Property

Public Property Get DeviceClass() As DBMDevSpaceClassConstans
    DeviceClass = lClass
End Property
Friend Property Let DeviceClass(ByVal NewVal As DBMDevSpaceClassConstans)
    lClass = NewVal
End Property

Public Property Get DeviceClassName() As String
    Select Case lClass
        Case dbmDSCSys:     DeviceClassName = DEVCLASS_SYS
        Case dbmDSCLog:     DeviceClassName = DEVCLASS_LOG
        Case dbmDSCData:    DeviceClassName = DEVCLASS_DATA
        Case dbmDSCUnknown: DeviceClassName = DEVCLASS_UNKNOWN
    End Select
End Property

Public Property Get DeviceType() As DBMDevSpaceTypeConstants
    DeviceType = lType
End Property
Public Property Let DeviceType(ByVal NewVal As DBMDevSpaceTypeConstants)
    lType = NewVal
End Property

Public Property Get DeviceTypeName() As String
    DeviceTypeName = GetDeviceTypeName(lType)
End Property

Public Property Get DeviceTypeShortName() As String
    DeviceTypeShortName = GetDeviceTypeShortName(lType)
End Property

Public Property Get Location() As String
    Location = sLocation
End Property
Public Property Let Location(NewVal As String)
    sLocation = NewVal
End Property

Public Property Get SizePages() As Long
    Select Case lClass
        Case dbmDSCSys:
            SizePages = CalcSysDevSize()
        Case dbmDSCLog:
            SizePages = lSizePages
        Case dbmDSCData:
            SizePages = lSizePages
    End Select
End Property
Public Property Let SizePages(ByVal NewVal As Long)
    Select Case lClass
        Case dbmDSCSys:
            lSizePages = 0
        Case dbmDSCLog:
            lSizePages = NewVal
        Case dbmDSCData:
            lSizePages = NewVal
    End Select
End Property

Public Property Get SizeKB() As Long
    SizeKB = SizePages * (Database.PageSize \ 1024)
End Property
Public Property Let SizeKB(ByVal NewVal As Long)
    SizePages = NewVal \ (Database.PageSize \ 1024)
End Property

Public Property Get Mirrored() As Boolean
    Mirrored = bMirrored
End Property
Public Property Let Mirrored(ByVal NewVal As Boolean)
    bMirrored = NewVal
End Property

Public Property Get MirroredDeviceType() As DBMDevSpaceTypeConstants
    MirroredDeviceType = lMirroredType
End Property
Public Property Let MirroredDeviceType(ByVal NewVal As DBMDevSpaceTypeConstants)
    lMirroredType = NewVal
End Property

Public Property Get MirroredDeviceTypeName() As String
    MirroredDeviceTypeName = GetDeviceTypeName(lMirroredType)
End Property

Public Property Get MirroredDeviceTypeShortName() As String
    MirroredDeviceTypeShortName = GetDeviceTypeShortName(lMirroredType)
End Property

Public Property Get MirroredLocation() As String
    MirroredLocation = sMirroredLocation
End Property
Public Property Let MirroredLocation(NewVal As String)
    sMirroredLocation = NewVal
End Property

Public Property Get Reintegrate() As Boolean
    Reintegrate = bReintegrate
End Property
Public Property Let Reintegrate(ByVal NewVal As Boolean)
    bReintegrate = NewVal
End Property

'''

Public Property Get Exists() As Boolean
    Exists = bExists
End Property

Public Property Get MirroredExists() As Boolean
    MirroredExists = bMirroredExists
End Property

Public Property Get Dirty() As Boolean
    If lType <> lOldType Or _
       UCase$(sLocation) <> UCase$(sOldLocation) Or _
       lSizePages <> lOldSizePages Or _
       lMirroredType <> lOldMirroredType Or _
       UCase$(sLocation) <> UCase$(sOldMirroredLocation) _
    Then
        Dirty = True
    Else
        Dirty = False
    End If
End Property

Public Property Get Complete() As Boolean
    Complete = False
    
    Select Case lClass
        Case dbmDSCSys:
            If lType <> dbmDSTUnknown And Len(sLocation) > 0 Then
                If bMirrored Then
                    If lMirroredType <> dbmDSTUnknown And Len(sMirroredLocation) > 0 Then
                        Complete = True
                    End If
                Else
                    Complete = True
                End If
            End If
        
        Case dbmDSCLog, dbmDSCData:
            If lType <> dbmDSTUnknown And Len(sLocation) > 0 And lSizePages > 0 Then
                If bMirrored Then
                    If lMirroredType <> dbmDSTUnknown And Len(sMirroredLocation) > 0 Then
                        Complete = True
                    End If
                Else
                    Complete = True
                End If
            End If
        
        Case Else:
            Complete = False
            
    End Select
End Property

Public Property Get CompleteMirrored() As Boolean
    CompleteMirrored = False
    
    Select Case lClass
        Case dbmDSCSys:
            If lType <> dbmDSTUnknown And Len(sLocation) > 0 Then
                If lMirroredType <> dbmDSTUnknown And Len(sMirroredLocation) > 0 Then
                    CompleteMirrored = True
                End If
            End If
        
        Case dbmDSCLog, dbmDSCData:
            If lType <> dbmDSTUnknown And Len(sLocation) > 0 And lSizePages > 0 Then
                If lMirroredType <> dbmDSTUnknown And Len(sMirroredLocation) > 0 Then
                    CompleteMirrored = True
                End If
            End If
        
        Case Else:
            CompleteMirrored = False
    End Select
End Property

'''

Public Function Refresh(Optional ByVal Asynchron As Boolean = False, _
                        Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_REFRESH, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_REFRESH, SenderID
            bOK = True
        End If
    End If
    
    Refresh = bOK
End Function

Public Function Save(Optional ByVal ParametersOnly As Boolean = False, _
                     Optional ByVal Asynchron As Boolean = False, _
                     Optional ByVal SenderID As Long = 0) As Boolean
                     
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        
        bParamsOnly = ParametersOnly
        
        If Not Asynchron Then
            bOK = Execute(FUNC_SAVE, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_SAVE, SenderID
            bOK = True
        End If
    End If
    
    Save = bOK
End Function

Public Function Delete(Optional ByVal Asynchron As Boolean = False, _
                       Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_DELETE, False, SenderID)
        Else
            QUEUE.QueueItems.Add Me, FUNC_DELETE, SenderID
            bOK = True
        End If
    End If
    
    Delete = bOK
End Function

Public Function CleanUp()
    Set oParent = Nothing
End Function

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    bExists = False
    bMirroredExists = False
    bDirty = False
    
    bReintegrate = False
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    
    Database.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_REFRESH:  bOK = ExecuteRefresh(Asynchron, SenderID)
        Case FUNC_SAVE:     bOK = ExecuteSave(Asynchron, SenderID)
        Case FUNC_DELETE:   bOK = ExecuteDelete(Asynchron, SenderID)
    End Select
            
    Database.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteRefresh(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sType As String
    Dim sSize As String
    
    bOK = False
    
    With Database
        If .Check() Then
            lType = dbmDSTUnknown
            sLocation = ""
            lSizePages = 0
            
            lMirroredType = dbmDSTUnknown
            sMirroredLocation = ""
            
            lOldType = dbmDSTUnknown
            sOldLocation = ""
            lOldSizePages = 0
            
            lOldMirroredType = dbmDSTUnknown
            sOldMirroredLocation = ""
            
            If DBMSRVParam.GetDevspace(Database, lNumber, GetDeviceClassShortName(lClass, False), sLocation, sType, sSize) Then
                
                Select Case sType
                    Case DEVTYPESHORT_FILE: lType = dbmDSTFile
                    Case DEVTYPESHORT_RAW:  lType = dbmDSTRaw
                    Case DEVTYPESHORT_LINK: lType = dbmDSTLink
                    Case Else:
                        If lClass = dbmDSCSys Then
                            lType = dbmDSTFile
                        Else
                            lType = dbmDSTUnknown
                        End If
                End Select
                
                If Len(sSize) > 0 Then
                    lSizePages = Val(sSize)
                End If
                
                If bMirrored Then
                    If DBMSRVParam.GetDevspace(Database, lNumber, GetDeviceClassShortName(lClass, True), sMirroredLocation, sType, sSize) Then
                        Select Case sType
                            Case DEVTYPESHORT_FILE: lMirroredType = dbmDSTFile
                            Case DEVTYPESHORT_RAW:  lMirroredType = dbmDSTRaw
                            Case DEVTYPESHORT_LINK: lMirroredType = dbmDSTLink
                            Case Else:
                                If lClass = dbmDSCSys Then
                                    lMirroredType = dbmDSTFile
                                Else
                                    lMirroredType = dbmDSTUnknown
                                End If
                        End Select
                        
                        bOK = True
                    End If
                Else
                    bOK = True
                End If
                
            End If
        End If
        
        bExists = (Len(Trim$(sLocation)) > 0)
        bMirroredExists = (Len(Trim$(sMirroredLocation)) > 0)
        
        lOldType = lType
        sOldLocation = sLocation
        lOldSizePages = lSizePages
        
        lOldMirroredType = lMirroredType
        sOldMirroredLocation = sMirroredLocation
        
        If bAsynchron Then
            .EventDevSpaceAction lSenderID, Not bOK, dbmDevSpaceActionRefresh, Me
        End If
    End With
    
    ExecuteRefresh = bOK
End Function

Private Function ExecuteSave(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim sCmd As String
    Dim sData As String
    Dim bError As Boolean
    Dim bParamAdd As Boolean
    Dim bDeviceAdd As Boolean
    
    bError = False
    
    With Database
        If .Check() Then
            If Complete Then
            
                If .State.Refresh(False, False) Then
                
                    If Database.Version.Number >= dbmVersion725 Then
                    
                        If Not bParamsOnly And _
                           Not bExists _
                        Then
                            sCmd = DBMSRV_CMD_ADDDEVICE
                            sCmd = sCmd + " " + GetDeviceClassShortName(lClass, False)
                            sCmd = sCmd + " " + sLocation
                            sCmd = sCmd + " " + GetDeviceTypeShortName(lType)
                            sCmd = sCmd + " " + CStr(lSizePages)
                            If bMirrored Then
                                sCmd = sCmd + " " + sMirroredLocation
                                sCmd = sCmd + " " + GetDeviceTypeShortName(lMirroredType)
                            End If
                            
                            If Not .ServerObject.Command(sCmd, sData) Then
                                .LastError.SetByServerObject .ServerObject
                                bError = True
                            End If
                        Else
                            If DBMSRVParam.AddDevspace(Database, lNumber, GetDeviceClassShortName(lClass, False), sLocation, GetDeviceTypeShortName(lType), CStr(lSizePages)) Then
                                If bMirrored Then
                                    If DBMSRVParam.AddDevspace(Database, lNumber, GetDeviceClassShortName(lClass, True), sMirroredLocation, GetDeviceTypeShortName(lMirroredType), CStr(lSizePages)) Then
                                        bParamAdd = True
                                    Else
                                        .LastError.SetByServerObject .ServerObject
                                        bError = True
                                    End If
                                Else
                                    bParamAdd = True
                                End If
                            Else
                                .LastError.SetByServerObject .ServerObject
                                bError = True
                            End If
                        End If
                        
                    Else
                    
                        bParamAdd = False
                        bDeviceAdd = False
                        
                        If bExists Or _
                           (Not bExists And (.State.Value = dbmDBStateCold Or .State.Value = dbmDBStateWarm)) Or _
                           (bParamsOnly And (.State.Value = dbmDBStateOffline Or .State.Value = dbmDBStateStoppedIncorrectly)) _
                        Then
                            If DBMSRVParam.AddDevspace(Database, lNumber, GetDeviceClassShortName(lClass, False), sLocation, GetDeviceTypeShortName(lType), CStr(lSizePages)) Then
                                If bMirrored Then
                                    If DBMSRVParam.AddDevspace(Database, lNumber, GetDeviceClassShortName(lClass, True), sMirroredLocation, GetDeviceTypeShortName(lMirroredType), CStr(lSizePages)) Then
                                        bParamAdd = True
                                    Else
                                        .LastError.SetByServerObject .ServerObject
                                        bError = True
                                    End If
                                Else
                                    bParamAdd = True
                                End If
                            Else
                                .LastError.SetByServerObject .ServerObject
                                bError = True
                            End If
                        End If
                        
                        If bParamAdd And _
                           Not bExists And _
                           Not bParamsOnly And _
                           (.State.Value = dbmDBStateCold Or .State.Value = dbmDBStateWarm) _
                        Then
                            Select Case lClass
                                Case dbmDSCData:    sCmd = UTIL_CMD_ADDDATDEV
                                Case dbmDSCLog:     sCmd = UTIL_CMD_ADDLOGDEV
                            End Select
                            
                            sCmd = sCmd + " '" + sLocation & "'"
                            
                            If bMirrored Then
                                sCmd = sCmd + " '" + sMirroredLocation + "'"
                            End If
                            
                            sCmd = sCmd + " " + UTIL_CMD_PAGES + " " + CStr(lSizePages)
                            
                            If .UtilConnect() Then
                                If .UtilExecute(sCmd) Then
                                    bDeviceAdd = True
                                Else
                                    .LastError.SetByServerObject .ServerObject
                                    bError = True
                                End If
                                .UtilRelease
                            Else
                                .LastError.SetByServerObject .ServerObject
                                bError = True
                            End If
                            
                            If Not bDeviceAdd Then
                                .Parameters.FileRestore 1
                            End If
                            
                        End If
                        
                    End If
                    
                End If
            End If
            
            Refresh
        End If
    
        If bAsynchron Then
            .EventDevSpaceAction lSenderID, bError, dbmDevSpaceActionSave, Me
        End If
    End With
    
    ExecuteSave = bError
End Function

Private Function ExecuteDelete(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
  
    bOK = False
  
    With Database
        If .Check() Then
            If DBMSRVParam.DeleteDevspace(Database, lNumber, GetDeviceClassShortName(lClass, False)) Then
                If bMirrored Then
                    If DBMSRVParam.DeleteDevspace(Database, lNumber, GetDeviceClassShortName(lClass, True)) Then
                        bOK = True
                    End If
                Else
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
            
            Refresh
        End If
    
        If bAsynchron Then
            .EventDevSpaceAction lSenderID, Not bOK, dbmDevSpaceActionDelete, Me
        End If
    End With
    
    ExecuteDelete = bOK
End Function

'''

Public Function GetDeviceClassShortName(lClass As DBMDevSpaceClassConstans, bMirrored As Boolean) As String
    Dim s As String
    
    Select Case lClass
        Case dbmDSCSys:     s = CLASS_SYS
        Case dbmDSCLog:     s = CLASS_LOG
        Case dbmDSCData:    s = CLASS_DAT
        Case dbmDSCUnknown: s = ""
    End Select
    
    If bMirrored Then s = MIRROR_PREFIX + s
    
    GetDeviceClassShortName = s
End Function

Public Function GetDeviceTypeName(lType As DBMDevSpaceTypeConstants) As String
    Dim s As String
    
    Select Case lType
        Case dbmDSTFile:    s = DEVTYPE_FILE
        Case dbmDSTRaw:     s = DEVTYPE_RAW
        Case dbmDSTLink:    s = DEVTYPE_LINK
        Case dbmDSTUnknown: s = DEVTYPE_UNKNOWN
    End Select
    
    GetDeviceTypeName = s
End Function

Public Function GetDeviceTypeShortName(lType As DBMDevSpaceTypeConstants) As String
    Dim s As String
    
    Select Case lType
        Case dbmDSTFile:    s = DEVTYPESHORT_FILE
        Case dbmDSTRaw:     s = DEVTYPESHORT_RAW
        Case dbmDSTLink:    s = DEVTYPESHORT_LINK
        Case dbmDSTUnknown: s = DEVTYPE_UNKNOWN
    End Select

    GetDeviceTypeShortName = s
End Function

'''

Private Function CalcSysDevSize() As Long
    Dim lRestartDataPages As Long
    Dim lMaxDataPages As Long
    Dim lDataPages As Long
    Dim lSingleConvSize As Long
    Dim lIOBlockSizeDelta As Long
    
    lRestartDataPages = Database.DevSpaces.AfterRestartDataPages
    lMaxDataPages = Val(Database.Parameters.GetValue(PARAM_MAXDATAPAGES))
    
    If lRestartDataPages > lMaxDataPages Then
        lDataPages = lRestartDataPages
    Else
        lDataPages = lMaxDataPages
    End If
    
    lSingleConvSize = (lMaxDataPages \ MAX_CONV_REC_BD00) + 1
    lIOBlockSizeDelta = SYS_DEV_BLOCK_CNT_BD01 - (lSingleConvSize Mod SYS_DEV_BLOCK_CNT_BD01)
    
    CalcSysDevSize = (lSingleConvSize * 2) + OF_CONV_0_BD15 + lIOBlockSizeDelta
End Function
