VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EnumDatabase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const SPEED_FAST = "FAST"
Const SPEED_QUICK = "QUICK"
Const SPEED_SLOW = "SLOW"

Private oParent As Object

Private lIndex As Long

Private sName As String
Private sInstRoot As String
Private oVersion As Version
Private sSpeed As String
Private sStatus As String

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTEnumDatabase
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

Public Property Get Name() As String
    Name = sName
End Property
Friend Property Let Name(Name As String)
    sName = Name
End Property

Public Property Get Version() As Version
    If oVersion Is Nothing Then
        Set oVersion = New Version
    End If
    Set Version = oVersion
End Property

Public Property Get InstRoot() As String
    InstRoot = sInstRoot
End Property
Friend Property Let InstRoot(InstRoot As String)
    sInstRoot = InstRoot
End Property

Public Property Get Speed() As String
    Speed = sSpeed
End Property
Friend Property Let Speed(Speed As String)
    sSpeed = Speed
End Property

Public Property Get Status() As String
    Status = sStatus
End Property
Friend Property Let Status(Status As String)
    sStatus = Status
End Property

Public Property Get Kernel() As DBMDatabaseKernelConstants
    Select Case UCase(sSpeed)
        Case SPEED_FAST:    Kernel = dbmFastKernel
        Case SPEED_QUICK:   Kernel = dbmQuickKernel
        Case SPEED_SLOW:    Kernel = dbmSlowKernel
        Case Else:          Kernel = dbmFastKernel
    End Select
End Property

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    sName = ""
    sInstRoot = ""
    sSpeed = ""
    sStatus = ""
End Sub

