VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EnumDatabases"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private oItems As New Collection
'
' Properties
'
Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTEnumDatabases
End Property

Public Property Get Count() As Long
    Count = oItems.Count
End Property

Public Property Get Item(Index As Long) As EnumDatabase
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property
'
' Methods
'
Friend Function Add(Name As String, _
                    InstRoot As String, _
                    Version As String, _
                    Optional Speed As String, _
                    Optional Status As String) As EnumDatabase
               
    Dim oEnumDatabase As New EnumDatabase
    
    With oEnumDatabase
        .Name = Name
        .InstRoot = InstRoot
        .Version = Version
        .Speed = Speed
        .Status = Status
    End With
            
    oItems.Add oEnumDatabase

    oEnumDatabase.Index = oItems.Count
    
    Set Add = oEnumDatabase
End Function

Public Sub Remove(Index As Long)
    Dim lStart As Long
    
    lStart = oItems(Index).Index
    
    oItems(Index).CleanUp
    oItems.Remove Index
    
    SetIndex lStart
End Sub

Public Sub Clear()
    Dim lCount As Long
    Dim l As Long
    
    lCount = oItems.Count
    
    For l = 1 To lCount
        oItems(1).CleanUp
        oItems.Remove 1
    Next
End Sub

Public Sub CleanUp()
    Clear
End Sub

Public Function Exists(Name As String) As Boolean
    Dim lItem As Long
    Dim lCount As Long
    Dim oEnumDB As EnumDatabase
    
    Exists = False
    
    lCount = oItems.Count
    
    For lItem = 1 To lCount
        Set oEnumDB = oItems(lItem)
        If UCase(Name) = UCase(oEnumDB.Name) Then
           Exists = True
           Exit For
        End If
    Next
End Function

Public Function Find(Name As String, _
                     Optional ByVal Kernel As DBMDatabaseKernelConstants = dbmFastKernel) As EnumDatabase
    Dim lItem As Long
    Dim lCount As Long
    Dim oEnumDB As EnumDatabase
    
    Set Find = Nothing
    
    lCount = oItems.Count
    
    For lItem = 1 To lCount
        Set oEnumDB = oItems(lItem)
        If UCase(Name) = UCase(oEnumDB.Name) And _
           Kernel = oEnumDB.Kernel _
        Then
           Set Find = oEnumDB
           Exit For
        End If
    Next
End Function

Public Function FindByName(Name As String) As EnumDatabase
    Dim lItem As Long
    Dim lCount As Long
    Dim oEnumDB As EnumDatabase
    
    Set FindByName = Nothing
    
    lCount = oItems.Count
    
    For lItem = 1 To lCount
        Set oEnumDB = oItems(lItem)
        If UCase(Name) = UCase(oEnumDB.Name) Then
           Set FindByName = oEnumDB
           Exit For
        End If
    Next
End Function

'''

Private Sub SetIndex(ByVal lStart As Long)
    Dim oEnumDatabase As EnumDatabase
    Dim lCount As Long
    Dim l As Long
    
    lCount = oItems.Count
    
    For l = lStart To lCount
        Set oEnumDatabase = oItems(l)
        oEnumDatabase.Index = l
    Next
End Sub






