VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ExternalID"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const STATE_NONE = "NONE"
Const STATE_AVAILABLE = "AVAI"
Const STATE_UNAVAILABLE = "UNAV"
Const STATE_UNKNOWN = "UNKN"

'''

Const BACKUP_TYPE_DATA = "DAT"
Const BACKUP_TYPE_PAGES = "PAG"
Const BACKUP_TYPE_LOG = "LOG"

'''

Private oParent As Object

Private lIndex As Long
Private sKey As String

Private sText As String
Private lState As DBMExternelIDStateConstants
Private sState As String
Private sAction As String
Private sStamp As String
Private lBackupType As DBMBackupTypeConstants

Private sOption As String

Private bSelected As Boolean

Private oMedium As Medium

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTMedium
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

Public Property Get Key() As String
    Key = sKey
End Property

'''

Public Property Get Text() As String
Attribute Text.VB_UserMemId = 0
    Text = sText
End Property
Public Property Let Text(NewVal As String)
    sText = NewVal
End Property

Public Property Get State() As DBMExternelIDStateConstants
    State = lState
End Property
Public Property Let State(ByVal NewVal As DBMExternelIDStateConstants)
    lState = NewVal
End Property

Public Property Get StateText() As String
    StateText = sState
End Property
Public Property Let StateText(NewVal As String)
    sState = NewVal
End Property

Public Property Get Action() As String
    Action = sAction
End Property
Public Property Let Action(NewVal As String)
    sAction = NewVal
End Property

Public Property Get Stamp() As String
    Stamp = sStamp
End Property
Public Property Let Stamp(NewVal As String)
    sStamp = NewVal
End Property

Public Property Get OptionText() As String
    OptionText = sOption
End Property
Public Property Let OptionText(NewVal As String)
    sOption = NewVal
End Property

Public Property Get Selected() As Boolean
    Selected = bSelected
End Property
Public Property Let Selected(ByVal NewVal As Boolean)
    bSelected = NewVal
End Property

Public Property Get Medium() As Medium
    Set Medium = oMedium
End Property
Public Property Set Medium(NewVal As Medium)
    Set oMedium = NewVal
End Property

Public Property Get BackupType() As DBMBackupTypeConstants
    BackupType = lBackupType
End Property
Public Property Let BackupType(ByVal NewVal As DBMBackupTypeConstants)
    lBackupType = NewVal
End Property

'''

Friend Sub SetPropertiesFromLine(ByVal sLine As String)
    Dim lPos1 As Long
    Dim lPos2 As Long
    
    lState = dbmEBIDNone
    sState = "None"
    sText = ""
    sAction = ""
    sStamp = ""
    lBackupType = dbmBTUnknown
    
'    Select Case UCase$(Left$(Mid$(sLine, EIDColPos(EID_COL_STATE), EIDColLen(EID_COL_STATE)), 4))
'        Case STATE_NONE:        lState = dbmEBIDNone
'                                sState = "None"
'        Case STATE_AVAILABLE:   lState = dbmEBIDAvailable
'                                sState = "Available"
'        Case STATE_UNAVAILABLE: lState = dbmEBIDUnavailable
'                                sState = "Unavailable"
'        Case STATE_UNKNOWN:     lState = dbmEBIDUnknown
'                                sState = "Unknown"
'    End Select
'
'    sText = Trim$(Mid$(sLine, EIDColPos(EID_COL_ID), EIDColLen(EID_COL_ID)))
'    sAction = Trim$(Mid$(sLine, EIDColPos(EID_COL_ACTION), EIDColLen(EID_COL_ACTION)))
'    sStamp = Trim$(Mid$(sLine, EIDColPos(EID_COL_STAMP), EIDColLen(EID_COL_STAMP)))
    
    Select Case UCase$(Left$(sLine, 4))
        Case STATE_NONE:        lState = dbmEBIDNone
                                sState = "None"
        Case STATE_AVAILABLE:   lState = dbmEBIDAvailable
                                sState = "Available"
        Case STATE_UNAVAILABLE: lState = dbmEBIDUnavailable
                                sState = "Unavailable"
        Case STATE_UNKNOWN:     lState = dbmEBIDUnknown
                                sState = "Unknown"
    End Select
    
    lPos1 = 1
    lPos2 = InStr(lPos1, sLine, "|")
    If lPos2 > 0 Then
        lPos1 = lPos2 + 1
        lPos2 = InStr(lPos1, sLine, "|")
        If lPos2 > 0 Then
            sText = Trim$(Mid$(sLine, lPos1, lPos2 - lPos1))
            lPos1 = lPos2 + 1
            lPos2 = InStr(lPos1, sLine, "|")
            If lPos2 > 0 Then
                sAction = Trim$(Mid$(sLine, lPos1, lPos2 - lPos1))
                lPos1 = lPos2 + 1
                lPos2 = InStr(lPos1, sLine, "|")
                If lPos2 > 0 Then
                    sStamp = Trim$(Mid$(sLine, lPos1, lPos2 - lPos1))
                Else
                    sStamp = Trim$(Mid$(sLine, lPos1))
                End If
            Else
                sAction = Trim$(Mid$(sLine, lPos1))
            End If
        Else
            sText = Trim$(Mid$(sLine, lPos1))
        End If
    End If
    
    Select Case UCase(Left$(sAction, 3))
        Case BACKUP_TYPE_DATA:  lBackupType = dbmBTData
        Case BACKUP_TYPE_PAGES: lBackupType = dbmBTPages
        Case BACKUP_TYPE_LOG:   lBackupType = dbmBTLog
        Case Else:              lBackupType = dbmBTUnknown
    End Select
        
    bSelected = False
End Sub

Friend Sub SetPropertiesFromHistoryLine(ByVal sLine As String)
    Dim lPos1 As Long
    Dim lPos2 As Long
    
    sText = ""
    lState = dbmEBIDNone
    sState = "None"
    
    Select Case UCase$(Left$(sLine, 4))
        Case STATE_NONE:        lState = dbmEBIDNone
                                sState = "None"
        Case STATE_AVAILABLE:   lState = dbmEBIDAvailable
                                sState = "Available"
        Case STATE_UNAVAILABLE: lState = dbmEBIDUnavailable
                                sState = "Unavailable"
        Case STATE_UNKNOWN:     lState = dbmEBIDUnknown
                                sState = "Unknown"
    End Select
    
    lPos1 = 1
    lPos2 = InStr(lPos1, sLine, "|")
    If lPos2 > 0 Then
        sText = Trim$(Mid$(sLine, lPos2 + 1, Len(sLine) - lPos2 - 1))
    End If
    
    sAction = ""
    sStamp = ""
    lBackupType = dbmBTUnknown
    
    bSelected = False
End Sub

Public Sub CleanUp()
    Set oMedium = Nothing
    
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    sKey = GetUniqueKeyStr()
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
