VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Infos"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01ED801F8"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum DBMInfoTypeConstants
    dbmInfoState = 1
    dbmInfoUsers
    dbmInfoDevSpaces
    dbmInfoIO
    dbmInfoCaches
    dbmInfoData
    dbmInfoLog
    dbmInfoLocks
    dbmInfoVersions
    dbmInfoBadDevspaces
    dbmInfoOMSCaches
    dbmInfoOMSMonitor
    dbmInfoOMSClasscontainers
End Enum

Public Enum DBMInfoColumnTypeConstants
    dbmInfoColTypeUnknown
    dbmInfoColTypeNumeric
    dbmInfoColTypeString
    dbmInfoColTypeDate
    dbmInfoColTypeBoolean
End Enum

Private oParent As Object

Private oItems As New Collection

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTInfos
End Property

Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Count() As Integer
    Count = oItems.Count
End Property

Public Property Get Item(ByVal Index As DBMInfoTypeConstants) As Info
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Property

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

'''

Friend Sub MakeCollection()
    Add dbmInfoState
    Add dbmInfoUsers
    Add dbmInfoDevSpaces
    Add dbmInfoIO
    Add dbmInfoCaches
    Add dbmInfoData
    Add dbmInfoLog
    Add dbmInfoLocks
    Add dbmInfoVersions
    Add dbmInfoBadDevspaces
    Add dbmInfoOMSCaches
    Add dbmInfoOMSMonitor
    Add dbmInfoOMSClasscontainers
End Sub

Friend Sub Clear()
    Dim iCount As Integer
    Dim i As Integer
    
    For i = 1 To iCount
        oItems(1).CleanUp
        oItems.Remove 1
    Next
End Sub

Public Sub CleanUp()
    Clear
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

Private Sub Add(ByVal InfoType As DBMInfoTypeConstants)
    Dim o As New Info
    
    With o
        Set .Parent = oParent
        .Index = oItems.Count + 1
        .InfoType = InfoType
    End With

    oItems.Add o
End Sub
