VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "KernelTrace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "Refresh"
Const FUNC_OPTIONSON = "OptionsOn"
Const FUNC_OPTIONSOFF = "OptionsOff"
Const FUNC_OPTIONSSHOW = "OptionsShow"
Const FUNC_SETADVANCED = "SetAdvanced"
Const FUNC_STOPONERROR = "StopOnError"
Const FUNC_AUDITSESSION = "AuditSession"
Const FUNC_CLEAR = "Clear"
Const FUNC_FLUSH = "Flush"
Const FUNC_PROTOPTSHOW = "ProtOptShow"
Const FUNC_PROTOCOLMAKE = "ProtocolMake"

'''

Const UTL_CMD_DIAGVTRACE = "DIAGNOSE VTRACE"
Const UTL_CMD_DIAGVTRACEON = "ON"
Const UTL_CMD_DIAGVTRACEOFF = "OFF"
Const UTL_CMD_DIAGVTRACECLEAR = "CLEAR"

Const UTL_CMD_DIAGVTRACEFLUSH = "VTRACE"

Const OPT_ADD = "OBJECT ADD"
Const OPT_ALTER = "OBJECT ALTER"
Const OPT_ANALYZE = "ANALYZE"
Const OPT_CHECK = "CHECK"
Const OPT_DEFAULT = "DEFAULT"
Const OPT_DELETE = "DELETE"
Const OPT_FREEPAGE = "OBJECT FREEPAGE"
Const OPT_GET = "OBJECT GET"
Const OPT_INDEX = "INDEX"
Const OPT_INSERT = "INSERT"
Const OPT_LOCK = "LOCK"
Const OPT_LONG = "LONG"
Const OPT_OBJECT = "OBJECT"
Const OPT_OPTIMIZE = "OPTIMIZE"
Const OPT_ORDER = "ORDER"
Const OPT_PAGES = "PAGES"
Const OPT_SELECT = "SELECT"
Const OPT_STANDARD = "ORDER STANDARD"
Const OPT_TABLE = "TABLE"
Const OPT_TIME = "TIME"
Const OPT_UPDATE = "UPDATE"

Const OPT_AUDIT = "AUDIT"
Const OPT_SESSION = "SESSION"
Const OPT_STOP = "STOP ON ERROR"

Const DESC_VTRACE = "VTRACE"
Const DESC_CHECK = "VTRACE CHECK"

Const VAL_ADD = "OBJECT ADD"
Const VAL_ALTER = "OBJECT ALTER"
Const VAL_ANALYZE = "AK"
Const VAL_CHECK = "ON"
Const VAL_DEFAULT = "DEFAULT"
Const VAL_DELETE = "DELETE"
Const VAL_FREEPAGE = "OBJECT FREE"
Const VAL_GET = "OBJECT GET"
Const VAL_INDEX = "INDEX"
Const VAL_INSERT = "INSERT"
Const VAL_LOCK = "LOCK"
Const VAL_LONG = "LONG"
Const VAL_OBJECT = "OBJECT"
Const VAL_OPTIMIZE = "OPTIMIZE"
Const VAL_ORDER = "ORDER"
Const VAL_PAGES = "PAGES"
Const VAL_SELECT = "SELECT"
Const VAL_STANDARD = "ORDER STNDRD"
Const VAL_TABLE = "TABLE"
Const VAL_TIME = "TIME"
Const VAL_UPDATE = "UPDATE"

Const SESSION_ALL = "*"
Const SESSION_CURRENT = "="

Private oParent As Object

Private sSession As String
Private sError As String

Private aProtOpt() As String
Private aProtOptName() As String
Private iProtOptCount As Integer
Private iProtOptMax As Integer

Private sProtOptions As String
Private sProtResult As String

'''

Private oKernelTraceOptions As KernelTraceOptions

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTKernelTrace
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get ValSession() As String
    ValSession = sSession
End Property
Public Property Get ValSessionAll() As String
    ValSessionAll = SESSION_ALL
End Property
Public Property Get ValSessionCurrent() As String
    ValSessionCurrent = SESSION_CURRENT
End Property

Public Property Get ValError() As String
    ValError = sError
End Property


'''

Public Property Get ProtOption(ByVal Index As Integer) As String
    If Index > 0 And Index <= iProtOptCount Then
        ProtOption = aProtOpt(Index)
    Else
        ProtOption = ""
    End If
End Property
Public Property Get ProtOptionName(ByVal Index As Integer) As String
    If Index > 0 And Index <= iProtOptCount Then
        ProtOptionName = aProtOptName(Index)
    Else
        ProtOptionName = ""
    End If
End Property
Public Property Get ProtOptionCount() As Integer
    ProtOptionCount = iProtOptCount
End Property

Public Property Get ProtResult() As String
    ProtResult = sProtResult
End Property
'
'
'
Public Property Get KernelTraceOptions() As KernelTraceOptions
    If oKernelTraceOptions Is Nothing Then
        Set oKernelTraceOptions = New KernelTraceOptions
        Set oKernelTraceOptions.Parent = Me
    End If
    Set KernelTraceOptions = oKernelTraceOptions
End Property
'
' Methods
'
Public Function Refresh(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Not Asynchron Then
        bOK = Execute(FUNC_REFRESH, False)
    Else
        QUEUE.QueueItems.Add Me, FUNC_REFRESH
        bOK = True
    End If
    
    Refresh = bOK
End Function

Public Sub OptionsReset()
    Dim oKernelTraceOption As KernelTraceOption
    
    For Each oKernelTraceOption In KernelTraceOptions
        oKernelTraceOption.State = False
        oKernelTraceOption.Checked = False
    Next
    
    sSession = "*"
    sError = ""
End Sub

Public Function OptionsOn(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_OPTIONSON, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_OPTIONSON
            bOK = True
        End If
    End If
    
    OptionsOn = bOK
End Function

Public Function OptionsOff(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_OPTIONSOFF, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_OPTIONSOFF
            bOK = True
        End If
    End If
    
    OptionsOff = bOK
End Function

Public Function OptionsShow(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_OPTIONSSHOW, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_OPTIONSSHOW
            bOK = True
        End If
    End If
    
    OptionsShow = bOK
End Function

Public Function SetAdvanced(ByVal Session As String, _
                            ByVal Error As String, _
                            Optional ByVal Asynchron As Boolean = False) As Boolean
                        
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        sSession = Session
        sError = Error
        
        If Not Asynchron Then
            bOK = Execute(FUNC_SETADVANCED, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_SETADVANCED
            bOK = True
        End If
    End If
    
    SetAdvanced = bOK
End Function

Public Function AuditSession(ByVal Session As String, _
                             Optional ByVal Asynchron As Boolean = False) As Boolean

    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        sSession = Session
        
        If Not Asynchron Then
            bOK = Execute(FUNC_AUDITSESSION, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_AUDITSESSION
            bOK = True
        End If
    End If
    
    AuditSession = bOK
End Function
                             
Public Function StopOnError(ByVal Error As String, _
                            Optional ByVal Asynchron As Boolean = False) As Boolean

    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        sError = Error
        
        If Not Asynchron Then
            bOK = Execute(FUNC_STOPONERROR, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_STOPONERROR
            bOK = True
        End If
    End If
    
    StopOnError = bOK
End Function

Public Function Clear(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CLEAR, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CLEAR
            bOK = True
        End If
    End If
    
    Clear = bOK
End Function

Public Function Flush(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_FLUSH, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_FLUSH
            bOK = True
        End If
    End If
    
    Flush = bOK
End Function

Public Function ProtOptionsShow(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_PROTOPTSHOW, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_PROTOPTSHOW
            bOK = True
        End If
    End If
    
    ProtOptionsShow = bOK
End Function

Public Function ProtocolMake(ByVal Options As String, _
                             Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        sProtOptions = Options
        If Not Asynchron Then
            bOK = Execute(FUNC_PROTOCOLMAKE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_PROTOCOLMAKE
            bOK = True
        End If
    End If
    
    ProtocolMake = bOK
End Function

Public Sub CleanUp()
    If Not oKernelTraceOptions Is Nothing Then oKernelTraceOptions.CleanUp

    Set oKernelTraceOptions = Nothing

    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    iProtOptCount = 0
    iProtOptMax = 0
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim oDB As DBMLib.Database
    
    Set oDB = Database
    
    oDB.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_REFRESH:      bOK = ExecuteRefresh(Asynchron)
        Case FUNC_OPTIONSON:    bOK = ExecuteOptionsOn(Asynchron)
        Case FUNC_OPTIONSOFF:   bOK = ExecuteOptionsOff(Asynchron)
        Case FUNC_OPTIONSSHOW:  bOK = ExecuteOptionsShow(Asynchron)
        Case FUNC_SETADVANCED:  bOK = ExecuteSetAdvanced(Asynchron)
        Case FUNC_AUDITSESSION: bOK = ExecuteAuditSession(Asynchron)
        Case FUNC_STOPONERROR:  bOK = ExecuteStopOnError(Asynchron)
        Case FUNC_CLEAR:        bOK = ExecuteClear(Asynchron)
        Case FUNC_FLUSH:        bOK = ExecuteFlush(Asynchron)
        Case FUNC_PROTOPTSHOW:  bOK = ExecuteProtOptShow(Asynchron)
        Case FUNC_PROTOCOLMAKE: bOK = ExecuteProtocolMake(Asynchron)
    End Select
            
    oDB.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteRefresh(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    If ExecuteOptionsShow(False) Then
        bOK = True
        ExecuteProtOptShow False
    End If
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionRefresh
    End If
    
    ExecuteRefresh = bOK
End Function

Private Function ExecuteOptionsOn(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    If Database.Version.Number < dbmversion74 Then
        bOK = ExecuteUtil(UTL_CMD_DIAGVTRACE & " " & OptionsSpecList(UTL_CMD_DIAGVTRACEON))
    Else
        bOK = KernelTraceOptions.OptionsOn(False)
    End If
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionOptionsOn
    End If
    
    ExecuteOptionsOn = bOK
End Function

Private Function ExecuteOptionsOff(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    If Database.Version.Number < dbmversion74 Then
        bOK = ExecuteUtil(UTL_CMD_DIAGVTRACE & " " & OptionsSpecList(UTL_CMD_DIAGVTRACEOFF))
    Else
        bOK = KernelTraceOptions.OptionsOff(False)
    End If
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionOptionsOff
    End If
    
    ExecuteOptionsOff = bOK
End Function

Private Function ExecuteOptionsShow(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sStmt As String
    Dim sResult As String
    Dim bContinue As Boolean
    Dim sLine As String
    Dim sDesc As String
    Dim sValue As String
    Dim lPos As Long
    Dim lPosField As Long

    bOK = False
    
    With Database
        If .Check() Then
            If .Version.Number < dbmversion74 Then
                
                MakeOptionList
            
                If .State.Value = dbmDBStateWarm Then
                    If DBMSRVSQL.Connect(.ServerObject) Then
        
                        sStmt = "SELECT"
                        sStmt = sStmt & " DESCRIPTION, VALUE"
                        sStmt = sStmt & " FROM SYSDD.SERVER_DB_STATE"
                        sStmt = sStmt & " WHERE UPPER(DESCRIPTION) LIKE 'VTRACE%'"
                        sStmt = sStmt & " OR UPPER(DESCRIPTION) = 'MONITORING'"
                    
                        If DBMSRVSQL.Execute(.ServerObject, sStmt, sResult, bContinue) Then
                    
                            bOK = True
                        
                            OptionsReset
                        
                            lPos = 1
                            Do While lPos < Len(sResult)
                                sLine = Trim$(.ServerObject.GetLine(sResult, lPos))
                                lPosField = 1
                                sDesc = Trim$(.ServerObject.GetField(sLine, ";", lPosField))
                                sValue = Trim$(.ServerObject.GetField(sLine, ";", lPosField))
                                sDesc = UCase$(Mid$(sDesc, 2, Len(sDesc) - 2))
                                sValue = UCase$(Mid$(sValue, 2, Len(sValue) - 2))
                                
                                Select Case sDesc
                                    Case DESC_VTRACE:
                                        Select Case sValue
                                            Case VAL_ADD:       KernelTraceOptions("OBJECTADD").State = True
                                            Case VAL_ALTER:     KernelTraceOptions("OBJECTALTER").State = True
                                            Case VAL_CHECK:     KernelTraceOptions("CHECK").State = True
                                            Case VAL_ANALYZE:   KernelTraceOptions("COMMANDS").State = True
                                            Case VAL_DEFAULT:   KernelTraceOptions("DEFAULT").State = True
                                            Case VAL_DELETE:    KernelTraceOptions("DELETE").State = True
                                            Case VAL_FREEPAGE:  KernelTraceOptions("OBJECTFREE").State = True
                                            Case VAL_GET:       KernelTraceOptions("OBJECTGET").State = True
                                            Case VAL_INDEX:     KernelTraceOptions("INDEX").State = True
                                            Case VAL_INSERT:    KernelTraceOptions("INSERT").State = True
                                            Case VAL_LOCK:      KernelTraceOptions("LOCK").State = True
                                            Case VAL_LONG:      KernelTraceOptions("LONG").State = True
                                            Case VAL_OBJECT:    KernelTraceOptions("OBJECT").State = True
                                            Case VAL_OPTIMIZE:  KernelTraceOptions("OPTIMIZER").State = True
                                            Case VAL_ORDER:     KernelTraceOptions("ORDER").State = True
                                            Case VAL_PAGES:     KernelTraceOptions("PAGES").State = True
                                            Case VAL_SELECT:    KernelTraceOptions("SELECT").State = True
                                            Case VAL_STANDARD:  KernelTraceOptions("STANDARD").State = True
                                            Case VAL_TABLE:     KernelTraceOptions("TABLE").State = True
                                            Case VAL_TIME:      KernelTraceOptions("TIME").State = True
                                            Case VAL_UPDATE:    KernelTraceOptions("UPDATE").State = True
                                        End Select
                                        
                                    Case DESC_CHECK:
                                        Select Case sValue
                                            Case VAL_CHECK:     KernelTraceOptions("CHECK").State = True
                                        End Select
                                End Select
                            Loop
                        Else
                            If .ServerObject.SQLErrorNumber = 100 Then
                                bOK = True
                                OptionsReset
                            Else
                                .LastError.SetByServerObject .ServerObject
                            End If
                        End If
                        DBMSRVSQL.Release .ServerObject
                    Else
                        .LastError.SetByServerObject .ServerObject
                    End If
                Else
                    bOK = True
                    OptionsReset
                End If
                
            Else
                bOK = KernelTraceOptions.Refresh(False)
            End If
            
        End If
        
        If bAsynchron Then
            .EventKernelTraceAction Not bOK, dbmKernelTraceActionOptionsShow
        End If
        
    End With
    
    ExecuteOptionsShow = bOK
End Function

Private Function ExecuteSetAdvanced(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If ExecuteAuditSession(False) Then
        If ExecuteStopOnError(False) Then
            bOK = True
        End If
    End If
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionSetAdvanced
    End If
End Function

Private Function ExecuteAuditSession(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sSpec As String
    
    bOK = False
    
    If Len(Trim$(sSession)) > 0 Then
        If Database.Version.Number < dbmVersion742 Then
            sSpec = OPT_AUDIT + " "
        Else
            sSpec = OPT_SESSION + " "
        End If
        
        Select Case Trim$(sSession)
            Case SESSION_ALL:     sSpec = sSpec + SESSION_ALL
            Case SESSION_CURRENT: sSpec = sSpec + SESSION_CURRENT
            Case Else:            sSpec = sSpec + "x'" + Trim$(sSession) + "'"
        End Select
        bOK = ExecuteUtil(UTL_CMD_DIAGVTRACE + " " + sSpec)
    Else
        bOK = True
    End If
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionAuditSession
    End If
    
    ExecuteAuditSession = bOK
End Function

Private Function ExecuteStopOnError(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sSpec As String
    
    bOK = False
    
    If Len(Trim$(sError)) > 0 Then
        sSpec = OPT_STOP + " " + sError
            
        bOK = ExecuteUtil(UTL_CMD_DIAGVTRACE + " " + sSpec)
    Else
        bOK = True
    End If
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionStopOnError
    End If
    
    ExecuteStopOnError = bOK
End Function


Private Function ExecuteClear(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    
    With Database
        If .Version.Number < dbmversion74 Then
            bOK = ExecuteUtil(UTL_CMD_DIAGVTRACE & " " & UTL_CMD_DIAGVTRACECLEAR)
        Else
            If .Check() Then
                bOK = .ServerObject.Command(DBMSRV_CMD_TRACE_CLEAR, sData, bAsynchron)
            End If
        End If
    End With
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionClear
    End If
    
    ExecuteClear = bOK
End Function

Private Function ExecuteFlush(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    
    With Database
        If .Version.Number < dbmversion74 Then
            Select Case .State.Value
                Case dbmDBStateCold: bOK = ExecuteUtil(UTL_CMD_DIAGVTRACEFLUSH)
                Case dbmDBStateWarm: bOK = ExecuteSQL(UTL_CMD_DIAGVTRACEFLUSH)
            End Select
        Else
            If .Check() Then
                bOK = .ServerObject.Command(DBMSRV_CMD_TRACE_FLUSH, sData, bAsynchron)
            End If
        End If
    End With
    
    If bAsynchron Then
        Database.EventKernelTraceAction Not bOK, dbmKernelTraceActionFlush
    End If
    
    ExecuteFlush = bOK
End Function

Private Function ExecuteProtOptShow(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    Dim sLine As String
    Dim lPos1 As Long
    Dim lPos2 As Long
    
    bOK = False
    
    With Database
        If .Check() Then
            If .ServerObject.Command(DBMSRV_CMD_TRACE_PROTOPT, sData, bAsynchron) Then
                bOK = True
                
                iProtOptCount = 0

                lPos1 = 1
                sLine = Trim$(.ServerObject.GetLine(sData, lPos1))
                Do While lPos1 < Len(sData)
                    sLine = Trim(.ServerObject.GetLine(sData, lPos1))
                    If Len(sLine) > 0 Then
                        iProtOptCount = iProtOptCount + 1
                        If iProtOptCount > iProtOptMax Then
                            iProtOptMax = iProtOptMax + 16
                            ReDim Preserve aProtOpt(iProtOptMax) As String
                            ReDim Preserve aProtOptName(iProtOptMax) As String
                        End If
                    
                        lPos2 = 1
                        aProtOpt(iProtOptCount) = Trim(.ServerObject.GetField(sLine, vbTab, lPos2))
                        aProtOptName(iProtOptCount) = Trim(.ServerObject.GetField(sLine, vbTab, lPos2))
                    End If
                Loop
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
     
        If bAsynchron Then
            .EventKernelTraceAction Not bOK, dbmKernelTraceActionProtOptionsShow
        End If
    End With
    
    ExecuteProtOptShow = bOK
End Function

Private Function ExecuteProtocolMake(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    
    bOK = False
    
    With Database
        If .Check() Then
            If .ServerObject.Command(DBMSRV_CMD_TRACE_PROT + " " + sProtOptions, sData, bAsynchron) Then
                bOK = True
                sProtResult = sData
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
     
        If bAsynchron Then
            .EventKernelTraceAction Not bOK, dbmKernelTraceActionProtocolMake
        End If
    End With
    
    ExecuteProtocolMake = bOK
End Function

'''

Private Function MakeOptionList()
    KernelTraceOptions.Clear
    
    AddOneOption "DEFAULT", "Includes Index, Lock, Long, Pages, Standard, Table", OPT_DEFAULT
    AddOneOption "INDEX", "Interfaces according accesses to indexes", OPT_INDEX
    AddOneOption "LOCK", "Lock collisions and their elimination", OPT_LOCK
    AddOneOption "LONG", "Accesses to LONG columns", OPT_LONG
    AddOneOption "PAGES", "I/O", OPT_PAGES
    AddOneOption "STANDARD", "Beginning of all parts of the packet interface", OPT_STANDARD
    AddOneOption "TABLE", "Accesses to primary data", OPT_TABLE
    AddOneOption "OBJECT", "Accesses to objects (includes add, get, alter, free)", OPT_OBJECT
    AddOneOption "OBJECTADD", "Accesses to objects", OPT_ADD
    AddOneOption "OBJECTGET", "Accesses to objects", OPT_GET
    AddOneOption "OBJECTALTER", "Accesses to objects", OPT_ALTER
    AddOneOption "OBJECTFREE", "Accesses to objects", OPT_FREEPAGE
    AddOneOption "SELECT", "Complete message buffer of SELECT, GET, FETCH, SELECT ROW and UNION", OPT_SELECT
    AddOneOption "INSERT", "Complete message buffer of INSERT", OPT_INSERT
    AddOneOption "UPDATE", "Complete message buffer of UPDATE", OPT_UPDATE
    AddOneOption "DELETE", "Complete message buffer of DELETE", OPT_DELETE
    AddOneOption "ORDER", "Complete order packet", OPT_ORDER
    AddOneOption "OPTIMIZER", "Optimizer output", OPT_OPTIMIZE
    AddOneOption "TIME", "Elapsed time in kernel underneath of the message buffer", OPT_TIME
    AddOneOption "CHECK", "Additional checks on correct state of the regions", OPT_CHECK
    AddOneOption "COMMANDS", "All order packets (including internal packets)", OPT_ANALYZE
End Function

Private Sub AddOneOption(sName As String, sDescription As String, sOptionName As String)
    Dim oKernelTraceOption As New KernelTraceOption
    
    With oKernelTraceOption
        .Name = sName
        .State = False
        .Level = -1
        .Description = sDescription
        .Checked = False
        .OptionName = sOptionName
    End With
    
    KernelTraceOptions.Add oKernelTraceOption, sName
End Sub

'''

Private Function OptionsSpecList(ByVal sAction As String) As String
    Dim oKernelTraceOption As New KernelTraceOption
    Dim sSpec As String
    
    sSpec = ""
    
    For Each oKernelTraceOption In KernelTraceOptions
        If oKernelTraceOption.Checked Then
            sSpec = sSpec + " " + oKernelTraceOption.OptionName
        End If
    Next
    
    sSpec = sSpec + " " + sAction
        
    If Len(sSpec) = 0 Then
        OptionsSpecList = OPT_DEFAULT
    Else
        OptionsSpecList = Mid$(sSpec, 2)
    End If
End Function

Private Function ExecuteUtil(ByVal sStmt As String) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If .UtilConnect Then
                If .UtilExecute(sStmt) Then
                    bOK = True
                End If
                .UtilRelease
            End If
        End If
    End With
    
    ExecuteUtil = bOK
End Function

Private Function ExecuteSQL(ByVal sStmt As String) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVSQL.Connect(.ServerObject) Then
                If DBMSRVSQL.Execute(.ServerObject, sStmt) Then
                    bOK = True
                Else
                    .LastError.SetByServerObject .ServerObject
                End If
                DBMSRVSQL.Release .ServerObject
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
    End With
    
    ExecuteSQL = bOK
End Function

