VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "LogMode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "Refresh"
Const FUNC_DEMO2SINGLE = "Demo2Single"
Const FUNC_DEMO2DUAL = "Demo2Dual"
Const FUNC_SINGLE2DEMO = "Single2Demo"
Const FUNC_SINGLE2DUAL = "Single2Dual"
Const FUNC_DUAL2DEMO = "Dual2Demo"
Const FUNC_DUAL2SINGLE = "Dual2Single"
Const FUNC_SINGLE2SINGLEDEMO = "Single2SingleDemo"
Const FUNC_DUAL2DUALDEMO = "Dual2DualDemo"
Const FUNC_SINGLE2SINGLEOFF = "Single2SingleOff"
Const FUNC_DUAL2DUALOFF = "Dual2DualOff"
Const FUNC_SINGLEOFF2SINGLE = "SingleOff2Single"
Const FUNC_DUALOFF2DUAL = "DualOff2Dual"

'''

Const PARAM_LOGMODE = "LOG_MODE"
Const PARAM_PARAMCHANGED = "__PARAM_CHANGED___"


'''

Const UTL_CMD_SETDEMOLOG = "SET LOG MODE DEMO"
Const UTL_CMD_SETLOGON = "SET LOG DEVSPACE ON"
Const UTL_CMD_SETLOGOFF = "SET LOG DEVSPACE OFF"
Const UTL_CMD_RESTARTVERSION = "GET RESTART VERSION"

'''

Const UTL_PROP_LOG_DEVSPACE_ENABLED = "LOG DEVSPACE ENABLED"
Const UTL_VAL_FALSE = "0"
Const UTL_VAL_TRUE = "1"

'''

Private oParent As Object

Private sText As String
Private lValue As DBMLogModeConstants

Private bDemoLog As Boolean
Private bSingleLog As Boolean
Private bDualLog As Boolean
Private bSingleDemoLog As Boolean
Private bDualDemoLog As Boolean

'''

Private bRestart As Boolean

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTLogMode
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Text() As String
    Text = sText
End Property

Public Property Get Value() As DBMLogModeConstants
    Value = lValue
End Property

Public Property Get DemoLog() As Boolean
    DemoLog = bDemoLog
End Property
Public Property Get SingleLog() As Boolean
    SingleLog = bSingleLog
End Property
Public Property Get DualLog() As Boolean
    DualLog = bDualLog
End Property
Public Property Get SingleDemoLog() As Boolean
    SingleDemoLog = bSingleDemoLog
End Property
Public Property Get DualDemoLog() As Boolean
    DualDemoLog = bDualDemoLog
End Property

'''

Public Function Refresh(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_REFRESH, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_REFRESH
            bOK = True
        End If
    End If
    
    Refresh = bOK
End Function

Public Function Change(NewLogMode As DBMLogModeConstants, _
                       Optional ByVal Restart As Boolean = True, _
                       Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    Dim sFunc As String
    
    bOK = False
    
    If Database.Check() Then
        Select Case Database.LogMode.Value
            Case dbmLogModeDemo:
                Select Case NewLogMode
                    Case dbmLogModeSingle:      sFunc = FUNC_DEMO2SINGLE
                    Case dbmLogModeDual:        sFunc = FUNC_DEMO2DUAL
                End Select
            Case dbmLogModeSingle:
                Select Case NewLogMode
                    Case dbmLogModeDemo:        sFunc = FUNC_SINGLE2DEMO
                    Case dbmLogModeDual:        sFunc = FUNC_SINGLE2DUAL
                    Case dbmLogModeSingleDemo:  sFunc = FUNC_SINGLE2SINGLEDEMO
                    Case dbmLogModeSingleOff:   sFunc = FUNC_SINGLE2SINGLEOFF
                    Case dbmLogModeSingle:      sFunc = FUNC_SINGLEOFF2SINGLE
                End Select
            Case dbmLogModeDual:
                Select Case NewLogMode
                    Case dbmLogModeDemo:        sFunc = FUNC_DUAL2DEMO
                    Case dbmLogModeSingle:      sFunc = FUNC_DUAL2SINGLE
                    Case dbmLogModeDualDemo:    sFunc = FUNC_DUAL2DUALDEMO
                    Case dbmLogModeDualOff:     sFunc = FUNC_DUAL2DUALOFF
                    Case dbmLogModeDual:        sFunc = FUNC_DUALOFF2DUAL
                End Select
            Case dbmLogModeSingleDemo:
                ' leave SingleDemo via cold backup
            Case dbmLogModeDualDemo:
                ' leave DualDemo via cold backup
            Case dbmLogModeSingleOff:
                Select Case NewLogMode
                    Case dbmLogModeSingle:      sFunc = FUNC_SINGLEOFF2SINGLE
                End Select
            Case dbmLogModeDualOff:
                Select Case NewLogMode
                    Case dbmLogModeDual:        sFunc = FUNC_DUALOFF2DUAL
                End Select
        End Select
        
        bRestart = Restart
    
        If Not Asynchron Then
            bOK = Execute(sFunc, False)
        Else
            QUEUE.QueueItems.Add Me, sFunc
            bOK = True
        End If
    End If
    
    Change = bOK
End Function

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim oDB As DBMLib.Database
    
    Set oDB = Database
    
    oDB.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_REFRESH:              bOK = ExecuteRefresh(Asynchron)
        Case FUNC_DEMO2SINGLE:          bOK = ExecuteDemo2Single(Asynchron)
        Case FUNC_DEMO2DUAL:            bOK = ExecuteDemo2Dual(Asynchron)
        Case FUNC_SINGLE2DEMO:          bOK = ExecuteSingle2Demo(Asynchron)
        Case FUNC_SINGLE2DUAL:          bOK = ExecuteSingle2Dual(Asynchron)
        Case FUNC_DUAL2DEMO:            bOK = ExecuteDual2Demo(Asynchron)
        Case FUNC_DUAL2SINGLE:          bOK = ExecuteDual2Single(Asynchron)
        Case FUNC_SINGLE2SINGLEDEMO:    bOK = ExecuteSingle2SingleDemo(Asynchron)
        Case FUNC_DUAL2DUALDEMO:        bOK = ExecuteDual2DualDemo(Asynchron)
        Case FUNC_SINGLE2SINGLEOFF:     bOK = ExecuteSingle2SingleOff(Asynchron)
        Case FUNC_DUAL2DUALOFF:         bOK = ExecuteDual2DualOff(Asynchron)
        Case FUNC_SINGLEOFF2SINGLE:     bOK = ExecuteSingleOff2Single(Asynchron)
        Case FUNC_DUALOFF2DUAL:         bOK = ExecuteDualOff2Dual(Asynchron)
    End Select
            
    oDB.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteRefresh(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    Dim lPos As Long
    Dim sValue As String
    Dim sProp As String
    
    bOK = False
    
    sText = ""
    lValue = dbmLogModeNone
    
    With Database
        If .Check() Then
            
            bDemoLog = False
            bSingleLog = False
            bDualLog = False
        
            If .ServerObject.Command(DBMSRV_CMD_PARAM_GETVALUE + " " + PARAM_LOGMODE, sData) Then
                bOK = True
                lPos = 1
                sText = UCase$(Trim$(.ServerObject.GetLine(sData, lPos)))
                Select Case sText
                    Case PARAM_LOGMODE_VAL_DEMO:
                        lValue = dbmLogModeDemo
                        bSingleLog = True
                        bDualLog = True
                        
                    Case PARAM_LOGMODE_VAL_SINGLE:
                        lValue = dbmLogModeSingle
                        bDemoLog = True
                        bDualLog = True
                        
                    Case PARAM_LOGMODE_VAL_DUAL:
                        lValue = dbmLogModeDual
                        bDemoLog = True
                        bSingleLog = True
                        
                End Select
                If lValue <> dbmLogModeDual Then
                    If .ServerObject.Command(DBMSRV_CMD_PARAM_GETVALUE + " " + PARAM_PARAMCHANGED, sData) Then
                        lPos = 1
                        sValue = UCase$(Trim$(.ServerObject.GetLine(sData, lPos)))
                        bDualLog = (sValue = "0")
                    End If
                End If
            Else
                .LastError.SetByServerObject .ServerObject
            End If
            
            If .State.Value = dbmDBStateWarm And (Value = dbmLogModeSingle Or Value = dbmLogModeDual) Then
              
              ' check info view
              If .Infos(dbmInfoLog).Refresh(False) Then
                Database.Infos(dbmInfoLog).BeginReadLines
                sText = GetValueString(Database.Infos(dbmInfoLog).ReadLine())
                Select Case sText
                    Case PARAM_LOGMODE_VAL_SINGLE_DEMO: lValue = dbmLogModeSingleDemo
                                                        sText = PARAM_LOGMODE_VAL_SINGLE_DEMO_X
                    Case PARAM_LOGMODE_VAL_DUAL_DEMO:   lValue = dbmLogModeDualDemo
                                                        sText = PARAM_LOGMODE_VAL_DUAL_DEMO_X
                    Case PARAM_LOGMODE_VAL_SINGLE_OFF:  lValue = dbmLogModeSingleOff
                    Case PARAM_LOGMODE_VAL_DUAL_OFF:    lValue = dbmLogModeDualOff
                End Select
              End If

            ElseIf .State.Value = dbmDBStateCold And _
                   (Value = dbmLogModeSingle Or Value = dbmLogModeDual) And _
                   .Version.Number >= dbmversion74 Then
                
                'check restart version
                If Database.UtilExecute(UTL_CMD_RESTARTVERSION, sData) Then
                    lPos = 1
                    Do While lPos < Len(sData)
                        sProp = Trim(.ServerObject.GetProp(Trim(.ServerObject.GetLine(sData, lPos)), 1, sValue))
                        If sProp = UTL_PROP_LOG_DEVSPACE_ENABLED Then
                            If sText = UTL_VAL_FALSE And lValue = dbmLogModeSingle Then
                                lValue = dbmLogModeSingleOff
                                sText = PARAM_LOGMODE_VAL_SINGLE_OFF
                            ElseIf sText = UTL_VAL_FALSE And lValue = dbmLogModeDual Then
                                lValue = dbmLogModeDualOff
                                sText = PARAM_LOGMODE_VAL_DUAL_OFF
                            End If
                        End If
                    Loop
                End If
            End If
            
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionRefresh
        End If
    End With
    
    ExecuteRefresh = bOK
End Function

Private Function ExecuteDemo2Single(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If SetNewLogMode(dbmLogModeSingle) Then
                If bRestart Then
                    If RestartDatabase() Then
                        .State.Refresh True
                        bOK = True
                    End If
                Else
                    bOK = True
                End If
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeSingle
            sText = PARAM_LOGMODE_VAL_SINGLE
        End If
                                                        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDemo2Single
        End If
    End With
    
    ExecuteDemo2Single = bOK
End Function

Private Function ExecuteDemo2Dual(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If AddMirroredLogs() Then
                If SetNewLogMode(dbmLogModeDual) Then
                    If bRestart Then
                        If RestartDatabase() Then
                            If ReintegrateMirroredLogs() Then
                                .State.Refresh True
                                bOK = True
                            End If
                        End If
                    Else
                        bOK = True
                    End If
                Else
                    .Parameters.FileRestore 1
                End If
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeDual
            sText = PARAM_LOGMODE_VAL_DUAL
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDemo2Dual
        End If
    End With
    
    ExecuteDemo2Dual = bOK
End Function

Private Function ExecuteSingle2Dual(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If AddMirroredLogs() Then
                If SetNewLogMode(dbmLogModeDual) Then
                    If bRestart Then
                        If RestartDatabase() Then
                            If ReintegrateMirroredLogs() Then
                                .State.Refresh True
                                bOK = True
                            End If
                        End If
                    Else
                        bOK = True
                    End If
                Else
                    .Parameters.FileRestore 1
                End If
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeDual
            sText = PARAM_LOGMODE_VAL_DUAL
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionSingle2Dual
        End If
    End With
    
    ExecuteSingle2Dual = bOK
End Function

Private Function ExecuteSingle2Demo(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If SetNewLogMode(dbmLogModeDemo) Then
                If bRestart Then
                    If RestartDatabase() Then
                        .State.Refresh True
                        bOK = True
                    End If
                Else
                    bOK = True
                End If
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeDemo
            sText = PARAM_LOGMODE_VAL_DEMO
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionSingle2Demo
        End If
    End With
    
    ExecuteSingle2Demo = bOK
End Function

Private Function ExecuteDual2Demo(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DeleteMirroredLogs() Then
                If SetNewLogMode(dbmLogModeDemo) Then
                    If bRestart Then
                        If RestartDatabase() Then
                            .State.Refresh True
                            bOK = True
                        End If
                    Else
                        bOK = True
                    End If
                Else
                    .Parameters.FileRestore 1
                End If
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeDemo
            sText = PARAM_LOGMODE_VAL_DEMO
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDual2Demo
        End If
    End With
    
    ExecuteDual2Demo = bOK
End Function

Private Function ExecuteDual2Single(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DeleteMirroredLogs() Then
                If SetNewLogMode(dbmLogModeSingle) Then
                    If bRestart Then
                        If RestartDatabase() Then
                            .State.Refresh True
                            bOK = True
                        End If
                    Else
                        bOK = True
                    End If
                Else
                    .Parameters.FileRestore 1
                End If
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeSingle
            sText = PARAM_LOGMODE_VAL_SINGLE
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDual2Single
        End If
    End With
    
    ExecuteDual2Single = bOK
End Function

Private Function ExecuteSingle2SingleDemo(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If .UtilConnect() Then
                If .UtilExecute(UTL_CMD_SETDEMOLOG) Then
                    bOK = True
                    
                    If .State.Value = dbmDBStateWarm Then
                        .State.Refresh True
                    End If
                Else
                    .LastError.SetByServerObject .ServerObject
                End If
                .UtilRelease
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeSingleDemo
            sText = PARAM_LOGMODE_VAL_SINGLE_DEMO_X
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionSingle2SingleDemo
        End If
    End With
    
    ExecuteSingle2SingleDemo = bOK
End Function

Private Function ExecuteDual2DualDemo(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If .UtilConnect() Then
                If .UtilExecute(UTL_CMD_SETDEMOLOG) Then
                    bOK = True
                    
                    If .State.Value = dbmDBStateWarm Then
                        .State.Refresh True
                    End If
                Else
                    .LastError.SetByServerObject .ServerObject
                End If
                .UtilRelease
            End If
        End If
        
        If bOK Then
            lValue = dbmLogModeDualDemo
            sText = PARAM_LOGMODE_VAL_DUAL_DEMO_X
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDual2DualDemo
        End If
    End With
    
    ExecuteDual2DualDemo = bOK
End Function

Private Function ExecuteSingle2SingleOff(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If ColdDatabase() Then
                If .UtilExecute(UTL_CMD_SETLOGOFF) Then
                    If bRestart Then
                        If WarmDatabase() Then
                            .State.Refresh True
                            bOK = True
                        End If
                    Else
                        .State.Refresh True
                        bOK = True
                    End If
                End If
            End If
        End If
    
        If bOK Then
            lValue = dbmLogModeSingleOff
            sText = PARAM_LOGMODE_VAL_SINGLE_OFF
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionSingle2SingleOff
        End If
    End With
    
    ExecuteSingle2SingleOff = bOK
End Function

Private Function ExecuteDual2DualOff(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If ColdDatabase() Then
                If .UtilExecute(UTL_CMD_SETLOGOFF) Then
                    If bRestart Then
                        If WarmDatabase() Then
                            .State.Refresh True
                            bOK = True
                        End If
                    Else
                        .State.Refresh True
                        bOK = True
                    End If
                End If
            End If
        End If
    
        If bOK Then
            lValue = dbmLogModeDualOff
            sText = PARAM_LOGMODE_VAL_DUAL_OFF
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDual2DualOff
        End If
    End With
    
    ExecuteDual2DualOff = bOK
End Function

Private Function ExecuteSingleOff2Single(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If ColdDatabase() Then
                If .UtilExecute(UTL_CMD_SETLOGON) Then
                    If bRestart Then
                        If WarmDatabase() Then
                            .State.Refresh True
                            bOK = True
                        End If
                    Else
                        .State.Refresh True
                        bOK = True
                    End If
                End If
            End If
        End If
    
        If bOK Then
            lValue = dbmLogModeSingle
            sText = PARAM_LOGMODE_VAL_SINGLE
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionSingleOff2Single
        End If
    End With
    
    ExecuteSingleOff2Single = bOK
End Function

Private Function ExecuteDualOff2Dual(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If ColdDatabase() Then
                If .UtilExecute(UTL_CMD_SETLOGON) Then
                    If bRestart Then
                        If WarmDatabase() Then
                            .State.Refresh True
                            bOK = True
                        End If
                    Else
                        .State.Refresh True
                        bOK = True
                    End If
                End If
            End If
        End If
    
        If bOK Then
            lValue = dbmLogModeDual
            sText = PARAM_LOGMODE_VAL_DUAL
        End If
        
        If bAsynchron Then
            .EventLogModeAction Not bOK, dbmLogModeActionDualOff2Dual
        End If
    End With
    
    ExecuteDualOff2Dual = bOK
End Function

'''

Private Function AddMirroredLogs() As Boolean
    Dim bOK As Boolean
    Dim oDevSpace As DevSpace
    Dim sCmd As String
    Dim sData As String
    Dim bAdd As Boolean
    
    bOK = False
    bAdd = True
    
    With Database
        For Each oDevSpace In .DevSpaces
            If oDevSpace.DeviceClass = dbmDSCLog Then
                If Not oDevSpace.MirroredExists And _
                   oDevSpace.Exists And _
                   Len(oDevSpace.MirroredLocation) > 0 And _
                   oDevSpace.MirroredDeviceType <> dbmDSTUnknown _
                Then
                
                    oDevSpace.Reintegrate = True
                    
                    If .Version.Number < dbmVersion744 Then
                        sCmd = DBMSRV_CMD_PARAM_ADDDEVSPACE
                    Else
                        sCmd = DBMSRV_CMD_PARAM_ADDVOLUME
                    End If
                    sCmd = sCmd + " " + CStr(oDevSpace.Number)
                    sCmd = sCmd + " " + oDevSpace.GetDeviceClassShortName(dbmDSCLog, True)
                    sCmd = sCmd + " " + oDevSpace.MirroredLocation
                    sCmd = sCmd + " " + oDevSpace.MirroredDeviceTypeShortName
                    If Not .ServerObject.Command(sCmd, sData) Then
                        bAdd = False
                        .LastError.SetByServerObject .ServerObject
                        Exit For
                    End If
                End If
            End If
        Next
        
        bOK = bAdd
    End With
    
    AddMirroredLogs = bOK
End Function

Private Function DeleteMirroredLogs() As Boolean
    Dim bOK As Boolean
    Dim oDevSpace As DevSpace
    Dim sCmd As String
    Dim sData As String
    Dim bDel As Boolean
    
    bOK = False
    bDel = True
    
    With Database
        For Each oDevSpace In .DevSpaces
            If oDevSpace.DeviceClass = dbmDSCLog Then
                If oDevSpace.MirroredExists And _
                   oDevSpace.Exists _
                Then
                    If .Version.Number < dbmVersion744 Then
                        sCmd = DBMSRV_CMD_PARAM_DELDEVSPACE
                    Else
                        sCmd = DBMSRV_CMD_PARAM_DELVOLUME
                    End If
                    sCmd = sCmd + " " + CStr(oDevSpace.Number)
                    sCmd = sCmd + " " + oDevSpace.GetDeviceClassShortName(dbmDSCLog, True)
                    If Not .ServerObject.Command(sCmd, sData) Then
                        .LastError.SetByServerObject .ServerObject
                        bDel = False
                        Exit For
                    End If
                End If
            End If
        Next
        
        bOK = bDel
    End With
    
    DeleteMirroredLogs = bOK
End Function

Private Function SetNewLogMode(ByVal lNewLogMode As DBMLogModeConstants) As Boolean
    Dim bOK As Boolean
    Dim sNewLogMode As String
    Dim sData As String
    Dim bSession As Boolean
    
    bOK = False
    bSession = False
    
    With Database
        If .ServerObject.Command(DBMSRV_CMD_PARAM_STARTSESSION, sData) Then
            bSession = True
            
            Select Case lNewLogMode
                Case dbmLogModeDemo:    sNewLogMode = PARAM_LOGMODE_VAL_DEMO
                Case dbmLogModeSingle:  sNewLogMode = PARAM_LOGMODE_VAL_SINGLE
                Case dbmLogModeDual:    sNewLogMode = PARAM_LOGMODE_VAL_DUAL
            End Select
                
            If .ServerObject.Command(DBMSRV_CMD_PARAM_PUT + " " + PARAM_LOGMODE + " " + sNewLogMode, sData) Then
                If .ServerObject.Command(DBMSRV_CMD_PARAM_CHECKALL, sData) Then
                    If .ServerObject.Command(DBMSRV_CMD_PARAM_COMMITSESSION, sData) Then
                        lValue = lNewLogMode
                        sText = sNewLogMode
                        bOK = True
                        bSession = False
                    End If
                End If
            End If
        End If
        
        If Not bOK Then
            .LastError.SetByServerObject .ServerObject
        End If
        
        If bSession Then
            .ServerObject.Command DBMSRV_CMD_PARAM_ABORTSESSION, sData
        End If
    End With
    
    SetNewLogMode = bOK
End Function

Private Function RestartDatabase() As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    
    bOK = False
    
    With Database
        sCmd = DBMSRV_CMD_DB_RESTART + " " + .KernelOption
        If .ServerObject.Command(sCmd, sData) Then
            bOK = True
        End If
        
        If Not bOK Then
            .LastError.SetByServerObject .ServerObject
        End If
        
    End With
    
    RestartDatabase = bOK
End Function

Private Function ColdDatabase() As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    
    bOK = False
    
    With Database
        sCmd = DBMSRV_CMD_DB_COLD + " " + .KernelOption
        If .ServerObject.Command(sCmd, sData) Then
            bOK = True
        End If
        
        If Not bOK Then
            .LastError.SetByServerObject .ServerObject
        End If
        
    End With
    
    ColdDatabase = bOK
End Function

Private Function WarmDatabase() As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    
    bOK = False
    
    With Database
        sCmd = DBMSRV_CMD_DB_WARM + " " + .KernelOption
        If .ServerObject.Command(sCmd, sData) Then
            bOK = True
        End If
        
        If Not bOK Then
            .LastError.SetByServerObject .ServerObject
        End If
        
    End With
    
    WarmDatabase = bOK
End Function

Private Function ReintegrateMirroredLogs() As Boolean
    Dim bOK As Boolean
    Dim oDevSpace As DevSpace
    Dim sCmd As String
    Dim sData As String
    Dim bRestore As Boolean
    
    bOK = False
    bRestore = True
    
    With Database
        If .UtilConnect() Then
            For Each oDevSpace In .DevSpaces
                If oDevSpace.DeviceClass = dbmDSCLog And _
                   oDevSpace.Reintegrate _
                Then
                    sCmd = DBMSRV_CMD_RESTORE_DEVSPACE + " " + oDevSpace.MirroredLocation
                    If Not .ServerObject.Command(sCmd, sData) Then
                        .LastError.SetByServerObject .ServerObject
                        bRestore = False
                        Exit For
                    End If
                End If
            Next
            .UtilRelease
        End If
        
        bOK = bRestore
    End With
    
    ReintegrateMirroredLogs = bOK
End Function

Private Function GetValueString(ByVal sLine As String) As String
    Dim iPos As Integer
    Dim sVal As String
    
    sVal = ""
    
    iPos = InStr(1, sLine, "=")
    If iPos > 0 Then
        sVal = Trim$(Mid$(sLine, iPos + 1))
    Else
        sVal = Trim$(sLine)
    End If
    
    GetValueString = sVal
End Function

