VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Medium"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F300136"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_SAVE = "MediumSave"
Const FUNC_DELETE = "MediumDelete"
Const FUNC_RENAME = "MediumRename"
Const FUNC_LABEL = "MediumReadLabel"

'''

Const LBL_DATA = "DAT"
Const LBL_PAGES = "PAG"
Const LBL_LOG = "LOG"

Const MIN_SIZE_PAGES = 32

Private oParent As Object

Private lIndex As Long
Private sKey As String

Private bInGroup As Boolean

Private sName As String
Private sLocation As String
Private lDeviceType As DBMDeviceTypeConstants
Private lSaveType As DBMBackupTypeConstants

Private lSizePages As Long
Private lBlockSize As Long
Private lOverwrite As DBMOverwriteConstants
Private lAutoLoader As DBMAutoLoaderConstants
Private sOSCommand As String
Private dCreated As Date
Private dModified As Date
Private bOldDefinition As Boolean

Private bFromHistory As Boolean

Private sSysKey As String
Private sLabel As String
Private lFileNumber As Long

Private sOldName As String

Private lReplaceCount As Long
Private bIgnored As Boolean
Private bRestored As Boolean
Private oRestoreItem As RestoreItem
Private bFirst As Boolean

Private sNewLocation As String

Private lActionKind As DBMBackupActionKindConstants
Private lRestoreStep As Long

Private oBackupResult As BackupResult

'''

Private sNewName As String
Private lLogNumber As Long

'''

Private sFirstName As String

'''

Private oExternalID As ExternalID

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTMedium
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

Public Property Get Key() As String
    Key = sKey
End Property

'''

Public Property Get InGroup() As Boolean
    InGroup = bInGroup
End Property
Friend Property Let InGroup(ByVal NewVal As Boolean)
    bInGroup = NewVal
End Property

'''

Public Property Get Name() As String
    Name = sName
End Property
Public Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get NameLenMax() As Long
    If Database.Version.Number >= dbmVersion72 Then
        NameLenMax = 64
    Else
        NameLenMax = 8
    End If
End Property

Public Property Get Location() As String
    Location = sLocation
End Property
Public Property Let Location(NewVal As String)
    sLocation = NewVal
End Property

Public Property Get DeviceType() As DBMDeviceTypeConstants
    DeviceType = lDeviceType
End Property
Public Property Let DeviceType(ByVal NewVal As DBMDeviceTypeConstants)
    lDeviceType = NewVal
End Property

Public Property Get DeviceTypeName() As String
    DeviceTypeName = Database.Backup.DeviceTypeName(lDeviceType)
End Property
Public Property Let DeviceTypeName(NewVal As String)
    DeviceType = Database.Backup.DeviceType(NewVal)
End Property

Public Property Get SaveType() As DBMBackupTypeConstants
    SaveType = lSaveType
End Property
Public Property Let SaveType(ByVal NewVal As DBMBackupTypeConstants)
     lSaveType = NewVal
End Property

Public Property Get SaveTypeString() As String
    SaveTypeString = Database.Backup.BackupTypeString(lSaveType)
End Property
Public Property Let SaveTypeString(NewVal As String)
    SaveType = Database.Backup.BackupTypeString(NewVal)
End Property

Public Property Get Blocksize() As Long
    Blocksize = lBlockSize
End Property
Public Property Let Blocksize(ByVal NewVal As Long)
    lBlockSize = NewVal
End Property

Public Property Get SizePages() As Long
    SizePages = lSizePages
End Property
Public Property Let SizePages(ByVal NewVal As Long)
    lSizePages = NewVal
End Property

Public Property Get SizeKB() As Long
    SizeKB = SizePages * (Database.PageSize \ 1024)
End Property
Public Property Let SizeKB(ByVal NewVal As Long)
    SizePages = NewVal \ (Database.PageSize \ 1024)
End Property

Public Property Get Overwrite() As DBMOverwriteConstants
    Overwrite = lOverwrite
End Property
Public Property Let Overwrite(ByVal NewVal As DBMOverwriteConstants)
     lOverwrite = NewVal
End Property

Public Property Get OverwriteString() As String
    OverwriteString = Database.Backup.OverwriteString(lOverwrite)
End Property
Public Property Let OverwriteString(NewVal As String)
    Overwrite = Database.Backup.Overwrite(NewVal)
End Property

Public Property Get AutoLoader() As DBMAutoLoaderConstants
    AutoLoader = lAutoLoader
End Property
Public Property Let AutoLoader(ByVal NewVal As DBMAutoLoaderConstants)
     lAutoLoader = NewVal
End Property

Public Property Get AutoLoaderString() As String
    AutoLoaderString = Database.Backup.AutoLoaderString(lAutoLoader)
End Property
Public Property Let AutoLoaderString(NewVal As String)
    AutoLoader = Database.Backup.AutoLoaderString(NewVal)
End Property

Public Property Get OSCommand() As String
    OSCommand = sOSCommand
End Property
Public Property Let OSCommand(NewVal As String)
    sOSCommand = NewVal
End Property

Public Property Get Created() As Date
    Created = dCreated
End Property
Friend Property Let Created(ByVal NewVal As Date)
    dCreated = NewVal
End Property

Public Property Get Modified() As Date
    Modified = dModified
End Property
Friend Property Let Modified(ByVal NewVal As Date)
    dModified = NewVal
End Property

Public Property Get OldDefinition() As Boolean
    OldDefinition = bOldDefinition
End Property
Public Property Let OldDefinition(ByVal NewVal As Boolean)
    bOldDefinition = NewVal
End Property

'''

Public Property Get FromHistory() As Boolean
    FromHistory = bFromHistory
End Property

Public Property Get SysKey() As String
    SysKey = sSysKey
End Property

Public Property Get Label() As String
    Label = sLabel
End Property

Public Property Get FileNumber() As Long
    FileNumber = lFileNumber
End Property

'''

Public Property Get OldName() As String
    OldName = sOldName
End Property
Public Property Let OldName(NewVal As String)
    sOldName = NewVal
End Property

Public Property Get ReplaceCount() As Long
    ReplaceCount = lReplaceCount
End Property
Public Property Let ReplaceCount(ByVal NewVal As Long)
    lReplaceCount = NewVal
End Property

Public Property Get Ignored() As Boolean
    Ignored = bIgnored
End Property
Public Property Let Ignored(ByVal Ignored As Boolean)
    bIgnored = Ignored
End Property

Public Property Get Restored() As Boolean
    Restored = bRestored
End Property
Public Property Let Restored(ByVal Restored As Boolean)
    bRestored = Restored
End Property

Public Property Get RestoreItem() As RestoreItem
    Set RestoreItem = oRestoreItem
End Property
Public Property Set RestoreItem(ByVal NewVal As RestoreItem)
    Set oRestoreItem = NewVal
End Property

Public Property Get First() As Boolean
    First = bFirst
End Property
Public Property Let First(ByVal NewVal As Boolean)
    bFirst = NewVal
End Property

'''

Public Property Get NewLocation() As String
    NewLocation = sNewLocation
End Property
Public Property Let NewLocation(NewVal As String)
    sNewLocation = NewVal
End Property

Public Property Get ActionKind() As DBMBackupActionKindConstants
    ActionKind = lActionKind
End Property
Public Property Let ActionKind(ByVal NewVal As DBMBackupActionKindConstants)
    lActionKind = NewVal
End Property

Public Property Get RestoreStep() As Long
    RestoreStep = lRestoreStep
End Property
Public Property Let RestoreStep(ByVal NewVal As Long)
    lRestoreStep = NewVal
End Property

'''

Public Property Get FirstName() As String
    FirstName = sFirstName
End Property
Public Property Let FirstName(NewVal As String)
    sFirstName = NewVal
End Property

Public Property Get ReadLabelName() As String
    If Len(sFirstName) > 0 Then
        ReadLabelName = sName + "\" + sFirstName
    Else
        ReadLabelName = sName
    End If
End Property

'''

Public Property Get BackupResult() As BackupResult
    If oBackupResult Is Nothing Then
        Set oBackupResult = New BackupResult
        Set oBackupResult.Parent = Me
    End If
    Set BackupResult = oBackupResult
End Property


'''

Public Property Get ExternalID() As ExternalID
    Set ExternalID = oExternalID
End Property
Public Property Set ExternalID(NewVal As ExternalID)
    Set oExternalID = NewVal
End Property

'''

Public Function Save(Optional ByVal Asynchron As Boolean = False, _
                     Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_SAVE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_SAVE, SenderID
            bOK = True
        End If
    End If
    
    Save = bOK
End Function

Public Function Delete(Optional ByVal Asynchron As Boolean = False, _
                       Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_DELETE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_DELETE, SenderID
            bOK = True
        End If
    End If
    
    Delete = bOK
End Function

Public Function Rename(NewName As String, _
                       Optional ByVal Asynchron As Boolean = False, _
                       Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        sNewName = NewName
    
        If Not Asynchron Then
            bOK = Execute(FUNC_RENAME, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_RENAME, SenderID
            bOK = True
        End If
    End If
    
    Rename = bOK
End Function

Public Function ReadLabel(Optional ByVal LogNumber As Long = 0, _
                          Optional ByVal Asynchron As Boolean = False, _
                          Optional ByVal SenderID As Long = 0) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        lLogNumber = LogNumber
        
        If Not Asynchron Then
            bOK = Execute(FUNC_LABEL, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_LABEL, SenderID
            bOK = True
        End If
    End If
    
    ReadLabel = bOK
End Function

'''

Friend Sub SetPropertiesFromHistoryLine(ByVal sLine As String)
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim s As String
    
    sSysKey = Trim$(Mid$(sLine, BMColPos(BM_COL_SYSKEY), BMColLen(BM_COL_SYSKEY)))
    sLabel = Trim$(Mid$(sLine, BMColPos(BM_COL_LABEL), BMColLen(BM_COL_LABEL)))
    
    Select Case UCase$(Left$(sLabel, 3))
        Case LBL_DATA:  lSaveType = dbmBTData
        Case LBL_PAGES: lSaveType = dbmBTPages
        Case LBL_LOG:   lSaveType = dbmBTLog
    End Select
    
    sName = Trim$(Mid$(sLine, BMColPos(BM_COL_MEDIANAME), BMColLen(BM_COL_MEDIANAME)))
    
    s = UCase$(Trim$(Mid$(sLine, BMColPos(BM_COL_DEVICETYPE), BMColLen(BM_COL_DEVICETYPE))))
    lDeviceType = Database.Backup.DeviceType(s, True)
    
    s = UCase$(Trim$(Mid$(sLine, BMColPos(BM_COL_OVERWRITE), BMColLen(BM_COL_OVERWRITE))))
    lOverwrite = Database.Backup.Overwrite(s)
    
    s = Trim$(Mid$(sLine, BMColPos(BM_COL_SIZE), BMColLen(BM_COL_SIZE)))
    If IsNumeric(s) Then
        lSizePages = CLng(s)
    Else
        lSizePages = 0
    End If

    s = Trim$(Mid$(sLine, BMColPos(BM_COL_BLOCKSIZE), BMColLen(BM_COL_BLOCKSIZE)))
    If IsNumeric(s) Then
        lBlockSize = CLng(s)
    Else
        lBlockSize = 0 '8
    End If
   
    If Database.Version.Number < dbmVersion72 Then
        sLocation = Trim$(Mid$(sLine, BMColPos(BM_71_COL_LOCATION), BMColLen(BM_71_COL_LOCATION)))
        lActionKind = dbmBAKSingle
    Else
        s = UCase$(Trim$(Mid$(sLine, BMColPos(BM_72_COL_ACTIONKIND), BMColLen(BM_72_COL_ACTIONKIND))))
        lActionKind = Database.Backup.BackupActionKindConstant(s)
    
        ' !!!
        If lSaveType = dbmBTLog Then
            lActionKind = dbmBAKSingle
        End If
        ' !!!
        
        sLocation = Trim$(Mid$(sLine, BMColPos(BM_72_COL_LOCATION), BMColLen(BM_72_COL_LOCATION)))
    End If

    If Left$(sLabel, 3) = "LOG" Then
        lPos1 = 0
        lPos2 = 0
        Do
            lPos2 = InStr(lPos1 + 1, sLocation, ".")
            If lPos2 > 0 Then lPos1 = lPos2
        Loop Until lPos2 = 0
        If lPos1 > 0 Then
            s = Mid$(sLocation, lPos1 + 1)
            If IsNumeric(s) Then
                lFileNumber = CLng(s)
                sLocation = Left$(sLocation, lPos1 - 1)
            End If
        End If
    End If

    bFromHistory = True
End Sub

Public Sub CleanUp()
    If Not oBackupResult Is Nothing Then oBackupResult.CleanUp
    
    Set oExternalID = Nothing
    
    Set oBackupResult = Nothing
    
    Set oRestoreItem = Nothing
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    sKey = GetUniqueKeyStr()
    
    bInGroup = False
    
    lSizePages = 0
    lBlockSize = 0 '8
    lOverwrite = dbmOverwriteNo
    lAutoLoader = dbmAutoLoaderNo
    sOSCommand = ""
    
    dCreated = Empty
    dModified = Empty
    
    bOldDefinition = False
    
    bFromHistory = False
    
    sOldName = ""
    
    lReplaceCount = 0
    bIgnored = False
    
    bRestored = False
    
    bFirst = True
    
    sNewLocation = ""
    
    lActionKind = dbmBAKUnknown
    lRestoreStep = 0
    
    Set oBackupResult = Nothing
    
    Set oExternalID = Nothing
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim oDB As DBMLib.Database
    
    Set oDB = Database
    
    oDB.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_SAVE:         bOK = ExecuteSave(Asynchron, SenderID)
        Case FUNC_DELETE:       bOK = ExecuteDelete(Asynchron, SenderID)
        Case FUNC_RENAME:       bOK = ExecuteRename(Asynchron, SenderID)
        Case FUNC_LABEL:        bOK = ExecuteReadLabel(Asynchron, SenderID)
    End Select
            
    oDB.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteSave(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVMedia.PutMedium(.ServerObject, Me) Then
                If DBMSRVMedia.GetMedium(.ServerObject, Me) Then
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventMediumAction lSenderID, Not bOK, dbmMediumActionSave, Me
        End If
    End With

    ExecuteSave = bOK
End Function

Private Function ExecuteDelete(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim oDB As Database
    Dim bOK As Boolean
    
    Set oDB = Database
    
    bOK = False
    
    With oDB
        If .Check() Then
            If DBMSRVMedia.DeleteMedium(.ServerObject, Me) Then
                oParent.Media.Remove lIndex
                bOK = True
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventMediumAction lSenderID, Not bOK, dbmMediumActionDelete, Me
        End If
    End With
    
    ExecuteDelete = bOK
End Function

Private Function ExecuteRename(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    Database.Busy = True
    
    With Database
        If .Check() Then
            If DBMSRVMedia.DeleteMedium(.ServerObject, Me) Then
                sName = sNewName
                If DBMSRVMedia.PutMedium(.ServerObject, Me) Then
                    If DBMSRVMedia.GetMedium(.ServerObject, Me) Then
                        bOK = True
                    End If
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
            
        If bAsynchron Then
            .EventMediumAction lSenderID, Not bOK, dbmMediumActionRename, Me
        End If
    End With
    
    Database.Busy = False
End Function

Private Function ExecuteReadLabel(ByVal bAsynchron As Boolean, ByVal lSenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If .State.Value = dbmDBStateWarm Or _
               .State.Value = dbmDBStateCold _
            Then
                If DBMSRVBackup.Label(.ServerObject, Me, lLogNumber) Then
                    bOK = True
                End If
            Else
                If (DBMSRVBackup.LabelOffline(.ServerObject, Me, lLogNumber)) Then
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventMediumAction lSenderID, Not bOK, dbmMediumActionReadLabel, Me
        End If
    End With

    ExecuteReadLabel = bOK
End Function

