VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Parameter"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F030132"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "RefreshParamter"
Const FUNC_CHECK = "CheckParameter"
Const FUNC_SAVE = "SaveParameter"
Const FUNC_PUTONLY = "PutOnlyParameter"
Const FUNC_PUTCONFIRM = "PutConfirmParameter"
Const FUNC_DIRECTPUT = "DirectPutParameter"
Const FUNC_DIRECTDEL = "DirectDeleteParameter"

Private oParent As Object

Const PARAM_TYPE_CHAR8 = "c8"
Const PARAM_TYPE_CHAR18 = "c18"
Const PARAM_TYPE_CHAR24 = "c24"
Const PARAM_TYPE_CHAR40 = "c40"
Const PARAM_TYPE_CHAR64 = "c64"
Const PARAM_TYPE_INT2 = "int2"
Const PARAM_TYPE_INT4 = "int4"
Const PARAM_TYPE_CRYPT = "crypt"

Const PARAM_MAX_INT2 = 32767
Const PARAM_MIN_INT2 = 0
Const PARAM_MAX_INT4 = 2147483647
Const PARAM_MIN_INT4 = 0

Const PARAM_LEN_CHAR8 = 8
Const PARAM_LEN_CHAR18 = 18
Const PARAM_LEN_CHAR24 = 24
Const PARAM_LEN_CHAR40 = 40
Const PARAM_LEN_CHAR64 = 64
Const PARAM_LEN_INT2 = 5
Const PARAM_LEN_INT4 = 10
Const PARAM_LEN_CRYPT = 0

Const PARAM_GROUP_GEN = "GENERAL"
Const PARAM_GROUP_EXT = "EXTENDED"
Const PARAM_GROUP_SUP = "SUPPORT"
Const PARAM_GROUP_INF = "INFO"

Const PROP_CLASS_CHANGE = "CHANGE"
Const PROP_CLASS_INTERN = "INTERN"
Const PROP_CLASS_MANDATORY = "MANDATORY"
Const PROP_CLASS_CLEAR = "CLEAR"
Const PROP_CLASS_DYNAMIC = "DYNAMIC"
Const PROP_CLASS_CASESENSITIVE = "CASESENSITIVE"
Const PROP_CLASS_OVERRIDE = "OVVERRIDE"
Const PROP_CLASS_DEVSPACE = "DEVSPACE"
Const PROP_CLASS_MODIFY = "MODIFY"
Const PROP_CLASS_GROUP = "GROUP"
Const PROP_CLASS_DISPLAYNAME = "DISPLAYNAME"
Const PROP_CLASS_VALUESET = "VALUESET"
Const PROP_CLASS_MIN = "MIN"
Const PROP_CLASS_MAX = "MAX"
Const PROP_CLASS_LASTVALUE = "LASTKNOWNGOOD"

Private Const PROP_VALUE_CONTROL = "CONTROL"
Private Const PROP_VALUE_SUPERUSER = "SUPERUSER"
Private Const PROP_VALUE_NOBODY = "NOBODY"
Private Const PROP_VALUE_YES = "YES"
Private Const PROP_VALUE_NO = "NO"
Private Const PROP_VALUE_HIGHER = "HIGHER"

Private sName As String
Private sType As String
Private sValue As String
Private sDefault As String
Private sHelp As String
Private sExplain As String

Private sPropChange As String
Private sPropIntern  As String
Private sPropMandatory  As String
Private sPropClear  As String
Private sPropDynamic As String
Private sPropCasesensitive As String
Private sPropOverride  As String
Private sPropDevspace  As String
Private sPropModify  As String
Private sPropGroup As String
Private sPropDisplayname As String
Private sPropValueset As String
Private sPropMin As String
Private sPropMax As String
Private sPropLastValue As String

Private bDirty As Boolean

'''

Private bValueOnly As Boolean

'''

Private lStatus As DBMParameterStatusConstants
Private sBadParam As String
Private sUserValue As String
Private sCompValue As String

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTParameter
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

'''

Public Property Get Dirty() As Boolean
    Dirty = bDirty
End Property
Friend Property Let Dirty(ByVal NewVal As Boolean)
    bDirty = NewVal
End Property

Public Property Get Name() As String
    Name = sName
End Property
Friend Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get Value() As String
    Value = sValue
End Property
Public Property Let Value(NewVal As String)
    If sValue <> NewVal Then
        sValue = NewVal
        bDirty = True
    End If
End Property

Public Property Get ParamType() As String
    ParamType = sType
End Property
Private Property Let ParamType(NewVal As String)
    sType = NewVal
End Property

Public Property Get Default() As String
    Default = sDefault
End Property
Private Property Let Default(NewVal As String)
    sDefault = NewVal
End Property

Public Property Get IsNumeric() As Boolean
    Select Case ParamType
        Case PARAM_TYPE_INT2, PARAM_TYPE_INT4:  IsNumeric = True
        Case Else:                              IsNumeric = False
    End Select
End Property

Public Property Get IsString() As Boolean
    Select Case ParamType
        Case PARAM_TYPE_CHAR8, _
             PARAM_TYPE_CHAR18, _
             PARAM_TYPE_CHAR24, _
             PARAM_TYPE_CHAR40, _
             PARAM_TYPE_CHAR64:
        
            IsString = True
            
        Case Else:
            IsString = False
    End Select
End Property

Public Property Get IsCrypt() As Boolean
    Select Case ParamType
        Case PARAM_TYPE_CRYPT:  IsCrypt = True
        Case Else:              IsCrypt = False
    End Select
End Property

Public Property Get MaxValue() As Long
    Select Case ParamType
        Case PARAM_TYPE_INT2:   MaxValue = PARAM_MAX_INT2
        Case PARAM_TYPE_INT4:   MaxValue = PARAM_MAX_INT4
        Case Else:              MaxValue = 0
    End Select
End Property

Public Property Get MinValue() As Long
    Select Case ParamType
        Case PARAM_TYPE_INT2:   MinValue = PARAM_MIN_INT2
        Case PARAM_TYPE_INT4:   MinValue = PARAM_MIN_INT4
        Case Else:              MinValue = 0
    End Select
End Property

Public Property Get MaxLength() As Long
    Select Case ParamType
        Case PARAM_TYPE_INT2:   MaxLength = PARAM_LEN_INT2
        Case PARAM_TYPE_INT4:   MaxLength = PARAM_LEN_INT4
        Case PARAM_TYPE_CHAR8:  MaxLength = PARAM_LEN_CHAR8
        Case PARAM_TYPE_CHAR18: MaxLength = PARAM_LEN_CHAR18
        Case PARAM_TYPE_CHAR24: MaxLength = PARAM_LEN_CHAR24
        Case PARAM_TYPE_CHAR40: MaxLength = PARAM_LEN_CHAR40
        Case PARAM_TYPE_CHAR64: MaxLength = PARAM_LEN_CHAR64
        Case PARAM_TYPE_CRYPT:  MaxLength = PARAM_LEN_CRYPT
        Case Else:              MaxLength = 0
    End Select
End Property

Public Property Get Help() As String
    Help = sHelp
End Property
Private Property Let Help(NewVal As String)
    sHelp = NewVal
End Property

Public Property Get Explain() As String
    Explain = sExplain
End Property
Private Property Let Explain(NewVal As String)
    sExplain = NewVal
End Property

'''

Public Property Get Changeable() As Boolean
    Changeable = (sPropChange = PROP_VALUE_YES)
End Property

Public Property Get Intern() As Boolean
    Intern = (sPropIntern = PROP_VALUE_YES)
End Property

Public Property Get Mandatory() As Boolean
    Mandatory = (sPropMandatory = PROP_VALUE_YES)
End Property

Public Property Get Clear() As Boolean
    Clear = (sPropClear = PROP_VALUE_YES)
End Property

Public Property Get Dynamic() As Boolean
    Dynamic = (sPropDynamic = PROP_VALUE_YES)
End Property

Public Property Get Casesensitive() As Boolean
    Casesensitive = (sPropCasesensitive = PROP_VALUE_YES)
End Property

Public Property Get Override() As Boolean
    Override = (sPropOverride = PROP_VALUE_YES)
End Property

Public Property Get DevSpace() As Boolean
    DevSpace = (sPropDevspace = PROP_VALUE_YES)
End Property

Public Property Get Modifyable() As Boolean
    Modifyable = (sPropModify = PROP_VALUE_YES)
End Property

Public Property Get Group() As DBMParameterGroupsConstants
    Select Case sPropGroup
        Case PARAM_GROUP_GEN: Group = dbmPGGeneral
        Case PARAM_GROUP_EXT: Group = dbmPGExtended
        Case PARAM_GROUP_SUP: Group = dbmPGSupport
        Case PARAM_GROUP_INF: Group = dbmPGInfo
        Case Else:            Group = dbmPGGeneral
    End Select
End Property

Public Property Get GroupString() As String
    GroupString = sPropGroup
End Property

Public Property Get Displayname() As String
    Displayname = sPropDisplayname
End Property

Public Property Get ValueSet() As String
    ValueSet = sPropValueset
End Property

Public Property Get Min() As String
    Min = sPropMin
End Property

Public Property Get Max() As String
    Max = sPropMax
End Property

Public Property Get LastValue() As String
    LastValue = sPropLastValue
End Property

'''

Public Property Get Status() As DBMParameterStatusConstants
    Status = lStatus
End Property
Public Property Get BadParam() As String
    BadParam = sBadParam
End Property
Public Property Get UserValue() As String
    UserValue = sUserValue
End Property
Public Property Get CompValue() As String
    CompValue = sCompValue
End Property


'''

Public Sub Reset()
    Value = ""
    ParamType = ""
    Default = ""
    Help = ""
    Explain = ""
        
    ' Properties
    sPropChange = ""
    sPropIntern = ""
    sPropMandatory = ""
    sPropClear = ""
    sPropDynamic = ""
    sPropCasesensitive = ""
    sPropOverride = ""
    sPropDevspace = ""
    sPropModify = ""
    sPropGroup = ""
    sPropDisplayname = ""
    sPropValueset = ""
    sPropMin = ""
    sPropMax = ""
    sPropLastValue = ""
    
    bDirty = False
End Sub

Public Function Refresh(Optional ValueOnly As Boolean = False, _
                        Optional ByVal Asynchron As Boolean = False) As Boolean
                        
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        bValueOnly = ValueOnly
        
        If Not Asynchron Then
            bOK = Execute(FUNC_REFRESH, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_REFRESH
            bOK = True
        End If
    End If
    
    Refresh = bOK
End Function

Public Function Check(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CHECK, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CHECK
            bOK = True
        End If
    End If
    
    Check = bOK
End Function

Public Function Save(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_SAVE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_SAVE
            bOK = True
        End If
    End If
    
    Save = bOK
End Function

Public Function PutOnly(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_PUTONLY, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_PUTONLY
            bOK = True
        End If
    End If
    
    PutOnly = bOK
End Function

Public Function PutConfirm(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_PUTCONFIRM, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_PUTCONFIRM
            bOK = True
        End If
    End If
    
    PutConfirm = bOK
End Function

Public Function DirectPut(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_DIRECTPUT, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_DIRECTPUT
            bOK = True
        End If
    End If

    DirectPut = bOK
End Function

Public Function DirectDel(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_DIRECTDEL, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_DIRECTDEL
            bOK = True
        End If
    End If
    
    DirectDel = bOK
End Function

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    Reset
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    
    Database.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_REFRESH:      bOK = ExecuteRefresh(Asynchron)
        Case FUNC_CHECK:        bOK = ExecuteCheck(Asynchron)
        Case FUNC_SAVE:         bOK = ExecuteSave(Asynchron)
        Case FUNC_PUTONLY:      bOK = ExecutePutOnly(Asynchron)
        Case FUNC_PUTCONFIRM:   bOK = ExecutePutConfirm(Asynchron)
        Case FUNC_DIRECTPUT:    bOK = ExecuteDirectPut(Asynchron)
        Case FUNC_DIRECTDEL:    bOK = ExecuteDirectDelete(Asynchron)
    End Select
            
    Database.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteRefresh(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim sValue As String
    Dim sType As String
    Dim sDefault As String
    Dim sHelp As String
    Dim sExplain As String
    Dim sProperties As String
    Dim bStatus As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If bValueOnly Then
                bOK = DBMSRVParam.GetValue(.ServerObject, Me.Name, sValue)
            Else
                bOK = DBMSRVParam.GetFullProp(.ServerObject, Me.Name, sValue, sType, sDefault, sHelp, sExplain, sProperties)
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
    End With
    
    If bOK Then
        If bValueOnly Then
            Value = sValue
            sPropLastValue = sValue
        Else
            Value = sValue
            sPropLastValue = sValue
            
            ParamType = sType
            Default = sDefault
            Help = sHelp ' FormatHelp(sHelp)
            Explain = sExplain
            AnalyzeProperties sProperties
        
            If Len(sPropLastValue) = 0 Then
                sPropLastValue = sValue
            End If
        End If
        
        bDirty = False
    Else
        Reset
    End If
    
    If Asynchron Then
        Database.EventParameterAction Not bOK, dbmParameterActionRefresh, Me
    End If
    
    ExecuteRefresh = bOK
End Function

Private Function ExecuteCheck(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim lItem As Long
    Dim oParameter As Parameter
    
    With Database
        If .Check() Then
    
            ' init return
            lStatus = dbmPSOK
            sBadParam = ""
            sUserValue = ""
            sCompValue = ""
    
            bOK = True
    
            If Dirty Then
                bOK = PutOnly(False)
            End If
    
            If bOK Then
                bOK = DBMSRVParam.CheckAll(Database.ServerObject, sPropGroup, lStatus, sBadParam, sUserValue, sCompValue)
                If Not bOK Then
                    Database.LastError.SetByServerObject Database.ServerObject
                End If
            End If
        End If
        
        If Asynchron Then
            .EventParameterAction Not bOK, dbmParameterActionCheck, Me
        End If
    End With
    
    ExecuteCheck = bOK
End Function

Private Function ExecuteSave(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    Dim lStatus As DBMParameterStatusConstants
    Dim sBadParam As String
    Dim sUserValue As String
    Dim sCompValue As String
    
    Dim lCount As Long
    Dim lItem As Long
    Dim oParam As Parameter
    
    bOK = False
    
    With Database
        If .Check() Then
            bOK = DBMSRVParam.CommitSession(Database.ServerObject, lStatus, sBadParam, sUserValue, sCompValue, True)
            
            If bOK Then
                Dirty = False
            End If

            If Not bOK Then
                Database.LastError.SetByServerObject Database.ServerObject
            End If
        End If
        
        If Asynchron Then
            .EventParameterAction Not bOK, dbmParameterActionSave, Me
        End If
    End With

    ExecuteSave = bOK
End Function

Private Function ExecutePutOnly(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False

    With Database
        If .Check() Then
            If Dirty Then
                If DBMSRVParam.PutOnly(.ServerObject, sName, sValue) Then
                    bOK = True
                Else
                    .LastError.SetByServerObject .ServerObject
                End If
            Else
                bOK = True
            End If
        End If
        
        If Asynchron Then
            .EventParameterAction Not bOK, dbmParameterActionPutOnly, Me
        End If
    End With
    
    ExecutePutOnly = bOK
End Function

Private Function ExecutePutConfirm(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
        
    With Database
        If .Check() Then
            If DBMSRVParam.PutConfirm(.ServerObject, sName, sValue) Then
                bOK = Refresh()
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If Asynchron Then
            .EventParameterAction Not bOK, dbmParameterActionPutConfirm, Me
        End If
    End With
    
    ExecutePutConfirm = bOK
End Function

Private Function ExecuteDirectPut(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If (DBMSRVParam.DirectPut(.ServerObject, sName, sValue)) Then
                bOK = True
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If Asynchron Then
            .EventParameterAction Not bOK, dbmParameterActionDirectPut, Me
        End If
    End With

    ExecuteDirectPut = bOK
End Function

Private Function ExecuteDirectDelete(ByVal Asynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVParam.DirectDelete(.ServerObject, sName) Then
                bOK = True
            Else
                .LastError.SetByServerObject .LastError
            End If
        End If
        
        If Asynchron Then
            .EventParameterAction Not bOK, dbmParameterActionDirectDelete, Me
        End If
    End With
    
    ExecuteDirectDelete = bOK
End Function

'''

Private Sub AnalyzeProperties(ByVal sProperties As String)
    Dim sLine As String
    Dim nPropPos As Long
    Dim nLinePos As Long
    Dim sPropClass As String
    
    nPropPos = 1
    
    With Database.ServerObject
        While nPropPos < Len(sProperties)
            sLine = Trim$(.GetLine(sProperties, nPropPos))
            nLinePos = 1
            sPropClass = Trim$(.GetField(sLine, vbTab, nLinePos))
            
            Select Case sPropClass
                Case PROP_CLASS_CHANGE:         sPropChange = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_INTERN:         sPropIntern = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_MANDATORY:      sPropMandatory = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_CLEAR:          sPropClear = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_DYNAMIC:        sPropDynamic = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_CASESENSITIVE:  sPropCasesensitive = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_OVERRIDE:       sPropOverride = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_DEVSPACE:       sPropDevspace = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_MODIFY:         sPropModify = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_GROUP:          sPropGroup = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_DISPLAYNAME:    sPropDisplayname = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_VALUESET:       sPropValueset = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_MIN:            sPropMin = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_MAX:            sPropMax = Trim$(.GetField(sLine, vbTab, nLinePos))
                Case PROP_CLASS_LASTVALUE:      sPropLastValue = Trim$(.GetField(sLine, vbTab, nLinePos))
            End Select
        Wend
    End With
End Sub

Private Function FormatHelp(sHelp As String) As String
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim sNew As String
    Dim sPart As String
    
    sNew = ""
    lPos1 = 1
    Do
        lPos2 = InStr(lPos1, sHelp, vbCrLf)
        If lPos2 > 0 Then
            sPart = Trim$(Mid$(sHelp, lPos1, lPos2 - lPos1))
            If Right$(sNew, 1) = "-" Then
                sNew = Left(sNew, Len(sNew) - 1) + sPart
            Else
                sNew = sNew + " " + sPart
            End If
            lPos1 = lPos2 + 2
        Else
            sPart = Mid$(sHelp, lPos1)
            If Right$(sNew, 1) = "-" Then
                sNew = Left(sNew, Len(sNew) - 1) + sPart
            Else
                sNew = sNew + " " + sPart
            End If
        End If
    Loop Until lPos2 = 0
    
    lPos1 = InStr(1, sNew, "(man")
    If lPos1 > 0 Then
        sNew = Left$(sNew, lPos1 - 1)
    End If
    
    FormatHelp = sNew
End Function

