VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Server"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum DBMObjectTypeConstants
    dbmOTServer
    dbmOTEnumInstallations
    dbmOTEnumInstallation
    dbmOTEnumDatabases
    dbmOTEnumDatabase
    
    dbmOTDatabase
    
    dbmOTState
    
    dbmOTRestartInfo
    
    dbmOTBackup
    dbmOTMedia
    dbmOTMedium
    dbmOTMediaGroups
    dbmOTMediaGroup
    
    dbmOTHistory
    dbmOTHistoryItems
    dbmOTHistoryItem
    
    dbmOTBackupManager
    
    dbmOTRestoreManager
    dbmOTRestoreItems
    dbmOTRestoreItem
    dbmOTRestoreMedia
    
    dbmOTRestoreCommands
    dbmOTRestoreCommand
    
    dbmOTAutosave
    
    dbmOTSave
    dbmOTRestore
    dbmOTBackupState
    dbmOTLabel
    dbmOTVolumes
    dbmOTVolume
    
    dbmOTBackupResult
    dbmOTBackupError
    
    dbmOTInfos
    dbmOTInfo
    dbmOTInfoState
    
    dbmOTShows
    dbmOTShow
    
    dbmOTParameters
    dbmOTParameter
    dbmOTDevSpaces
    dbmOTDevSpace
    dbmOTTermcharSets
    dbmOTTermcharSet
    dbmOTMapcharSets
    dbmOTMapcharSet
    
    dbmOTConnections
    dbmOTConnectionControl
    dbmOTConnectionUtility
    
    dbmOTKernelTrace
    dbmOTKernelTraceOptions
    dbmOTKernelTraceOption
    
    dbmOTQueueItems
    dbmOTQueueItem
    
    dbmOTUsers
    dbmOTUser
    dbmOTUserRights
    dbmOTUserRight
    
    dbmOTFiles
    dbmOTFile
    
    dbmOTDatabaseEvents
    dbmOTDatabaseEvent
    dbmOTDatabaseEventArray
    
    dbmOTCatalog
    dbmOTTables
    dbmOTColumns
    dbmOTIndexes
    dbmOTUpdStat
    dbmOTBadDevSpaces
    dbmOTLogMode
    
    dbmOTExternalIDs
    dbmOTExternalID
    
    dbmOTSessions
    dbmOTSession
End Enum

'''

Const OS_WIN32 = "WIN32"
Const OS_UNIX = "UNIX"

Public Enum DBMOSConstants
    dbmOSUnknown
    dbmOSWin32
    dbmOSUnix
End Enum

Private oServerObject As New DBMSOB.ServerObject

Private sName As String

Private oVersion As Version
Private sOSString As String
Private sInstRoot As String
Private lOS As DBMOSConstants

Private bConnected As Boolean

Private oEnumInstallations As EnumInstallations
Private oEnumDatabases As EnumDatabases

Private oLastError As LastError

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTServer
End Property

Public Property Get Name() As String
    Name = sName
End Property
Public Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get Version() As Version
    If oVersion Is Nothing Then
        Set oVersion = New Version
    End If
    Set Version = oVersion
End Property

Public Property Get InstRoot() As String
    InstRoot = sInstRoot
End Property
Public Property Let InstRoot(NewVal As String)
    sInstRoot = NewVal
End Property

Public Property Get OSString() As String
    OSString = sOSString
End Property
Public Property Let OSString(NewVal As String)
    sOSString = NewVal
End Property

Public Property Get OS() As DBMOSConstants
    OS = lOS
End Property
Public Property Let OS(ByVal NewVal As DBMOSConstants)
    lOS = NewVal
End Property

Public Property Get EnumInstallations() As EnumInstallations
    If oEnumInstallations Is Nothing Then
        Set oEnumInstallations = New EnumInstallations
    End If
    Set EnumInstallations = oEnumInstallations
End Property

Public Property Get EnumDatabases() As EnumDatabases
    If oEnumDatabases Is Nothing Then
        Set oEnumDatabases = New EnumDatabases
    End If
    Set EnumDatabases = oEnumDatabases
End Property

Public Property Get LastError() As LastError
    If oLastError Is Nothing Then
        Set oLastError = New LastError
    End If
    Set LastError = oLastError
End Property

'''

Public Function OpenSession(Optional DatabaseName As String = "", _
                            Optional UserName As String = "", _
                            Optional Password As String = "", _
                            Optional InstRoot As String = "") As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If oServerObject.OpenSession(sName, DatabaseName, UserName, Password, InstRoot) Then
        bOK = True
        bConnected = True
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    OpenSession = bOK
End Function

Public Function CloseSession() As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    oServerObject.CloseSession
    
    bOK = True
    
    bConnected = False

    CloseSession = bOK
End Function

Public Function GetInfos() As Boolean
    Dim bOK As Boolean
    Dim bClose As Boolean
    Dim sData As String
    Dim sLine As String
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim sProp As String
    Dim sValue As String
    
    bOK = False
    bClose = False
    
    If Not bConnected Then
        If OpenSession() Then
            bOK = True
            bClose = True
        End If
    End If
    
    If bOK Then
        bOK = False
        If oServerObject.Command(DBMSRV_CMD_DBM_VERSION, sData) Then
            bOK = True
            lPos1 = 1
            Do While (lPos1 <= Len(sData))
                sProp = oServerObject.GetProp(sData, lPos1, sValue)
                Select Case UCase$(sProp)
                    Case "VERSION":
                        Version.Text = sValue
                
                    Case "BUILD":
                        sValue = UCase$(sValue)
                        lPos2 = InStr(1, sValue, "BUILD")
                        If lPos2 > 0 Then
                            Version.Build = Trim$(Mid$(sValue, lPos2 + 5))
                        Else
                            Version.Build = sValue
                        End If
                        
                    Case "OS":
                        sOSString = sValue
                        
                    Case "INSTROOT":
                        sInstRoot = sValue
                End Select
            Loop
        Else
            If oServerObject.Command(DBMSRV_CMD_VERSION, sData) Then
                bOK = True
                lPos1 = 1
                sLine = oServerObject.GetLine(sData, lPos1)  ' Header
                sLine = oServerObject.GetLine(sData, lPos1)  ' Value
                lPos1 = 1
                Version.Text = RemoveDblQuotes(UCase$(Trim$(oServerObject.GetField(sLine, ",", lPos1))))
                Version.Build = ""
                sOSString = RemoveDblQuotes(UCase$(Trim$(oServerObject.GetField(sLine, ",", lPos1))))
                sInstRoot = RemoveDblQuotes(UCase$(Trim$(oServerObject.GetField(sLine, ",", lPos1))))
                
                Select Case sOSString
                    Case OS_WIN32: lOS = dbmOSWin32
                    Case Else:     lOS = dbmOSUnix
                End Select
            Else
                LastError.SetByServerObject oServerObject
            End If
        End If
        
        If bClose Then
            CloseSession
        End If
    End If
    
    GetInfos = bOK
End Function

Public Function EnumerateInstallations() As Boolean
    Dim bOK As Boolean
    Dim oInst As EnumInstallation
    Dim sData As String
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim sLine As String
    Dim sVersion As String
    Dim sInstRoot As String
    Dim bClose As Boolean
    
    EnumInstallations.Clear
    
    bOK = False
    bClose = False
    
    If Not bConnected Then
        If OpenSession() Then
            bOK = True
            bClose = True
        End If
    End If
    
    If bOK Then
        If oServerObject.Command(DBMSRV_CMD_VERSION, sData) Then
            ' 2. line
            lPos1 = 1
            sLine = Trim(oServerObject.GetLine(sData, lPos1))
            sLine = Trim(oServerObject.GetLine(sData, lPos1))
            ' 1. and 3. field
            lPos2 = 1
            sVersion = Trim(oServerObject.GetField(sLine, ",", lPos2))
            sInstRoot = Trim(oServerObject.GetField(sLine, ",", lPos2))
            sInstRoot = Trim(oServerObject.GetField(sLine, ",", lPos2))
        
            sVersion = Mid(sVersion, 2, Len(sVersion) - 2)
            sInstRoot = Mid(sInstRoot, 2, Len(sInstRoot) - 2)
            
            Set oInst = EnumInstallations.Add(sVersion, sInstRoot)
        Else
            bOK = False
            LastError.SetByServerObject oServerObject
        End If
        
        If bOK Then
            If oServerObject.Command(DBMSRV_CMD_INST_ENUM, sData) Then
                lPos1 = 1
                Do While lPos1 < Len(sData)
                    sLine = Trim(oServerObject.GetLine(sData, lPos1))
                    If Len(sLine) > 0 Then
                        lPos2 = 1
                        sVersion = Trim(oServerObject.GetField(sLine, " ", lPos2))
                        oServerObject.GetBlanks sLine, lPos2
                        sInstRoot = Trim(oServerObject.GetLine(sLine, lPos2))
                        
                        If Not EnumInstallations.Exists(sInstRoot) Then
                            Set oInst = EnumInstallations.Add(sVersion, sInstRoot)
                        End If
                    End If
                Loop
            Else
                bOK = False
                LastError.SetByServerObject oServerObject
            End If
        End If
        
        If bClose Then
            CloseSession
        End If
    End If
    
    EnumerateInstallations = bOK
End Function

Public Function EnumerateDatabases() As Boolean
    Dim bOK As Boolean
    Dim oDB As EnumDatabase
    Dim sData As String
    Dim lPos1 As Long
    Dim lPos2 As Long
    Dim sLine As String
    Dim sDatabaseName As String
    Dim sInstRoot As String
    Dim sVersion As String
    Dim sSpeed As String
    Dim sStatus As String
    Dim bClose As Boolean
    
    EnumDatabases.Clear
    
    bOK = False
    bClose = False
    
    If Not bConnected Then
        If OpenSession() Then
            bOK = True
            bClose = True
        End If
    End If
    
    If bOK Then
        If oServerObject.Command(DBMSRV_CMD_DB_ENUM, sData) Then
            lPos1 = 1
            Do While lPos1 < Len(sData)
                sLine = Trim(oServerObject.GetLine(sData, lPos1))
                If Len(sLine) > 0 Then
                    lPos2 = 1
                    sDatabaseName = Trim(oServerObject.GetField(sLine, vbTab, lPos2))
                    sInstRoot = Trim(oServerObject.GetField(sLine, vbTab, lPos2))
                    sVersion = Trim(oServerObject.GetField(sLine, vbTab, lPos2))
                    
                    sSpeed = Trim(oServerObject.GetField(sLine, vbTab, lPos2))
                    sStatus = Trim(oServerObject.GetField(sLine, vbTab, lPos2))
                    Set oDB = EnumDatabases.Add(sDatabaseName, sInstRoot, sVersion, sSpeed, sStatus)
                End If
            Loop
        Else
            bOK = False
            LastError.SetByServerObject oServerObject
        End If
        
        If bClose Then
            CloseSession
        End If
    End If
    
    EnumerateDatabases = bOK
End Function

Public Function CheckSystemLogon(ByVal SystemUser As String, _
                                 ByVal SystemPassword As String) As Boolean

    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    Dim bClose As Boolean
    
    bOK = False
    bClose = False
    
    If bConnected Then CloseSession
    
    If OpenSession() Then
        bClose = True
    
        sCmd = DBMSRV_CMD_USER_SYSTEM + " " + SystemUser + "," + SystemPassword
        
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            If oServerObject.ReturnCode = DBMSOB_ERR_COMMAND Then
                bOK = True
            Else
                LastError.SetByServerObject oServerObject
            End If
        End If
    Else
        LastError.SetByServerObject oServerObject
    End If
    
    If bClose Then CloseSession
   
    CheckSystemLogon = bOK
End Function

Public Function DatabaseCreate(DatabaseName As String, _
                               UserName As String, _
                               Password As String, _
                               Optional SystemUser As String = "", _
                               Optional SystemPassword As String = "", _
                               Optional InstRoot As String = "") As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    Dim bClose As Boolean
    
    bOK = False
    bClose = False
    
    If Not bConnected Then
        If OpenSession(, , , InstRoot) Then
            bOK = True
            bClose = True
        End If
    End If
    
    If bOK Then
        bOK = False
    
        sCmd = DBMSRV_CMD_DB_CREATE + " " + DatabaseName
        sCmd = sCmd + " " + UserName + "," + Password
        
        If Len(SystemUser) > 0 And _
           Len(SystemPassword) > 0 _
        Then
            sCmd = sCmd + " " + SystemUser + "," + SystemPassword
        End If
        
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
        
        If bClose Then
            CloseSession
        End If
    End If
    
    DatabaseCreate = bOK
End Function

Public Function DatabaseDrop(DatabaseName As String, _
                             UserName As String, _
                             Password As String, _
                             Optional WithoutFiles As Boolean = False) As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String
    Dim bClose As Boolean
    
    bOK = False
    bClose = False
    
    If Not bConnected Then
        If OpenSession(DatabaseName, UserName, Password) Then
            bOK = True
            bClose = True
        End If
    End If

    If bOK Then
        bOK = False
    
        sCmd = DBMSRV_CMD_DB_DROP
        If WithoutFiles Then sCmd = sCmd + " WITHOUTFILES"
        If oServerObject.Command(sCmd, sData) Then
            bOK = True
        Else
            LastError.SetByServerObject oServerObject
        End If
        
        If bClose Then
            CloseSession
        End If
    End If
    
    DatabaseDrop = bOK
End Function

'''

Public Sub CleanUp()
    If Not oEnumInstallations Is Nothing Then oEnumInstallations.CleanUp
    If Not oEnumDatabases Is Nothing Then oEnumDatabases.CleanUp

    Set oEnumInstallations = Nothing
    Set oEnumDatabases = Nothing
    Set oLastError = Nothing

    Set oServerObject = Nothing
End Sub

'''

#If DBG Then

Public Property Get DebugTrace() As Object
    Set DebugTrace = oDbgTrace
End Property
Public Property Set DebugTrace(NewVal As Object)
    Set oDbgTrace = NewVal
    If Not oServerObject Is Nothing Then
        Set oServerObject.DebugTrace = oDbgTrace
    End If
End Property

#End If

