VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Show"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "RefreshShow"

Private oParent As Object

Private lIndex As Long

Private dAt As Date

Private sName As String
Private sDescription As String
Private sText As String

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTShow
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property

'''

Public Property Get At() As Date
    At = dAt
End Property

Public Property Get Name() As String
    Name = sName
End Property
Friend Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Get Description() As String
    Description = sDescription
End Property
Friend Property Let Description(NewVal As String)
    sDescription = NewVal
End Property

Public Property Get Text() As String
    Text = sText
End Property

'''

Public Function Refresh(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Database.State.Value <> dbmDBStateOffline Then
            If Not Asynchron Then
                bOK = Execute(FUNC_REFRESH, False)
            Else
                QUEUE.QueueItems.Add Me, FUNC_REFRESH
                bOK = True
            End If
        End If
    End If
    
    Refresh = bOK
End Function

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    Database.Busy = True
            
    With Database
        If .Check() Then
            If .ServerObject.Command(DBMSRV_CMD_SHOW + " " + sName, sText) Then
                dAt = Now()
                bOK = True
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
            
        .EventShowRefreshed Not bOK, Me
    End With
    
    Database.Busy = False
    
    Execute = bOK
End Function

'''

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    dAt = Empty
    
    sName = ""
    sDescription = ""
    sText = ""
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub
