VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "State"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01EC9028D"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "RefreshState"

Const STATE_UNKNOWN = "UNKNOWN"
Const STATE_STPINC = "STOPPED INCORRECTLY"
Const STATE_OFFLINE = "OFFLINE"
Const STATE_COLD = "COLD"
Const STATE_WARM = "WARM"
Const STATE_ONLINE = "ONLINE"
Const STATE_ADMIN = "ADMIN"

Public Enum DBMDatabaseStateConstants
    dbmDBStateUnknown
    dbmDBStateStoppedIncorrectly
    dbmDBStateOffline
    dbmDBStateCold
    dbmDBStateWarm
End Enum

Const VAL_YES = "YES"
Const VAL_NO = "NO"
Const VAL_ON = "ON"
Const VAL_OFF = "OFF"

Private oParent As Object

Private dAt As Date

Private lState As DBMDatabaseStateConstants

'''

Private bWithInfo As Boolean

Const CONVCACHE_71_OK = 98
Const CONVCACHE_72_OK = 100

Const DATACACHE_71_OK = 98
Const DATACACHE_72_OK = 98 '100 MR 11.02.2000

Private lDataKB As Long
Private lPermDataKB As Long
Private lTempDataKB As Long

Private lDataPages As Long
Private lPermDataPages As Long
Private lTempDataPages As Long

Private lDataPercent As Long
Private lPermDataPercent As Long
Private lTempDataPercent As Long

Private lLogKB As Long
Private lLogPages As Long
Private lLogPercent As Long

Private lSessions As Long
Private lSessionsPercent As Long

Private lDataCache As Long
Private lConverterCache As Long

Private lDataMaxKB As Long
Private lLogMaxKB As Long
Private lDataMaxPages As Long
Private lLogMaxPages As Long
Private lSessionsMax As Long

Private bDatabaseFull As Boolean
Private bConnectPossible As Boolean
Private bCommandMonitoring As Boolean
Private bDatabaseMonitoring As Boolean
Private bKernelTrace As Boolean
Private bAutosave As Boolean
Private lBadIndexes As Long
Private lBadDevspaces As Long
Private lReintegrationDevspaces As Long

Private sLogMode As String
Private lLogMode As DBMLogModeConstants

Private lOMSDataCache As Long
Private lOMSLogDataCache As Long

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTState
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent
End Property
'
'
'
Public Property Get At() As Date
    At = dAt
End Property

Public Property Get Value(Optional ByVal RefreshStateValue As Boolean = False) As DBMDatabaseStateConstants
    If RefreshStateValue Then
        Refresh False, False
    End If
    Value = lState
End Property

Public Property Get Text() As String
Attribute Text.VB_UserMemId = 0
    Select Case lState
        Case dbmDBStateOffline:             Text = STATE_OFFLINE
        Case dbmDBStateCold:                Text = STATE_ADMIN
        Case dbmDBStateWarm:                Text = STATE_ONLINE
        Case dbmDBStateStoppedIncorrectly:  Text = STATE_STPINC
        Case Else:                          Text = STATE_UNKNOWN
    End Select
End Property

Public Property Get SubState() As String
    SubState = ""
End Property

'''

Public Property Get DataKB() As Long
    DataKB = lDataKB
End Property
Public Property Get PermDataKB() As Long
    PermDataKB = lPermDataKB
End Property
Public Property Get TempDataKB() As Long
    TempDataKB = lTempDataKB
End Property
Public Property Get DataPages() As Long
    DataPages = lDataPages
End Property
Public Property Get PermDataPages() As Long
    PermDataPages = lPermDataPages
End Property
Public Property Get TempDataPages() As Long
    TempDataPages = lTempDataPages
End Property
Public Property Get DataPercent() As Long
    DataPercent = lDataPercent
End Property
Public Property Get PermDataPercent() As Long
    PermDataPercent = lPermDataPercent
End Property
Public Property Get TempDataPercent() As Long
    TempDataPercent = lTempDataPercent
End Property
Public Property Get LogKB() As Long
    LogKB = lLogKB
End Property
Public Property Get LogPages() As Long
    LogPages = lLogPages
End Property
Public Property Get LogPercent() As Long
    LogPercent = lLogPercent
End Property
Public Property Get Sessions() As Long
    Sessions = lSessions
End Property
Public Property Get SessionsPercent() As Long
    SessionsPercent = lSessionsPercent
End Property

Public Property Get DataCacheHitRate() As Long
    DataCacheHitRate = lDataCache
End Property
Public Property Get DataCacheHitRateOK() As Boolean
    Select Case Database.Version.NumberHi
        Case dbmVersion71: DataCacheHitRateOK = (lDataCache >= DATACACHE_71_OK)
        Case dbmVersion72: DataCacheHitRateOK = (lDataCache >= DATACACHE_72_OK)
        Case Else:         DataCacheHitRateOK = (lDataCache >= 100)
    End Select
End Property

Public Property Get ConverterCacheHitRate() As Long
    ConverterCacheHitRate = lConverterCache
End Property
Public Property Get ConverterCacheHitRateOK() As Boolean
    Select Case Database.Version.NumberHi
        Case dbmVersion71: ConverterCacheHitRateOK = (lConverterCache >= CONVCACHE_71_OK)
        Case dbmVersion72: ConverterCacheHitRateOK = (lConverterCache >= CONVCACHE_72_OK)
        Case Else:         ConverterCacheHitRateOK = (lConverterCache >= 100)
    End Select
End Property

Public Property Get DataMaxKB() As Long
    DataMaxKB = lDataMaxKB
End Property
Public Property Get LogMaxKB() As Long
    LogMaxKB = lLogMaxKB
End Property
Public Property Get DataMaxPages() As Long
    DataMaxPages = lDataMaxPages
End Property
Public Property Get LogMaxPages() As Long
    LogMaxPages = lLogMaxPages
End Property
Public Property Get SessionsMax() As Long
    SessionsMax = lSessionsMax
End Property

Public Property Get DatabaseFull() As Boolean
    DatabaseFull = bDatabaseFull
End Property
Public Property Get ConnectPossible() As Boolean
    ConnectPossible = bConnectPossible
End Property
Public Property Get CommandMonitoring() As Boolean
    CommandMonitoring = bCommandMonitoring
End Property
Public Property Get DatabaseMonitoring() As Boolean
    DatabaseMonitoring = bDatabaseMonitoring
End Property
Public Property Get KernelTrace() As Boolean
    KernelTrace = bKernelTrace
End Property
Public Property Get Autosave() As Boolean
    Autosave = bAutosave
End Property
Friend Property Let Autosave(ByVal NewVal As Boolean)
    bAutosave = NewVal
End Property
Public Property Get BadIndexes() As Long
    BadIndexes = lBadIndexes
End Property
Public Property Get BadDevSpaces() As Long
    BadDevSpaces = lBadDevspaces
End Property
Public Property Get ReintegrationDevSpaces() As Long
    ReintegrationDevSpaces = lReintegrationDevspaces
End Property

'''

Public Property Get LogMode() As DBMLogModeConstants
    LogMode = lLogMode
End Property
Public Property Get LogModeString() As String
    LogModeString = sLogMode
End Property

'''

Public Property Get OMSDataCacheHitRate() As Long
    OMSDataCacheHitRate = lOMSDataCache
End Property

Public Property Get OMSLogDataCacheHitRate() As Long
    OMSLogDataCacheHitRate = lOMSLogDataCache
End Property

'''

Public Function Refresh(Optional ByVal WithInfo As Boolean = True, _
                        Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    bWithInfo = WithInfo
    
    If Not Asynchron Then
        bOK = Execute(FUNC_REFRESH, False)
    Else
        QUEUE.QueueItems.Add Me, FUNC_REFRESH
        bOK = True
    End If
    
    Refresh = bOK
End Function

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim sData As String
    Dim lPos1 As Long
    Dim sState As String
    Dim lOldState As DBMDatabaseStateConstants
    
    bOK = False
    
    Database.Busy = True

    lOldState = lState
    
    lState = dbmDBStateUnknown
            
    If Database.Check() Then
        With Database
            If .ServerObject.Command(DBMSRV_CMD_DB_STATE, sData) Then
                dAt = Now()

                sState = STATE_UNKNOWN
                lPos1 = 1
                If UCase$(Trim$(.ServerObject.GetLine(sData, lPos1))) = "STATE" Then
                    sState = UCase$(Trim$(.ServerObject.GetLine(sData, lPos1)))
                End If
            
                Select Case sState
                    Case STATE_STPINC: lState = dbmDBStateStoppedIncorrectly
                    Case STATE_OFFLINE: lState = dbmDBStateOffline
                    Case STATE_COLD: lState = dbmDBStateCold
                    Case STATE_ADMIN: lState = dbmDBStateCold
                    Case STATE_WARM: lState = dbmDBStateWarm
                    Case STATE_ONLINE: lState = dbmDBStateWarm
                End Select
                
                If bWithInfo And lState = dbmDBStateWarm Then
                    If .Infos(dbmInfoState).Refresh(False) Then
                        bOK = True
                        
                        GetValues
                        
                        If Database.Version.Number >= dbmVersion72 Then
                            Select Case bAutosave
                                Case True:  Database.Autosave.State = dbmAutosaveOn
                                Case False: Database.Autosave.State = dbmAutosaveOff
                            End Select
                        Else
                            bOK = False
                            bAutosave = False
                            If Database.Autosave.Refresh Then
                                bOK = True
                                bAutosave = (Database.Autosave.State = dbmAutosaveOn)
                            End If
                        End If
                        
                        If bOK Then
                            bOK = False
                            If .Infos(dbmInfoLog).Refresh(False) Then
                                bOK = True
                                GetLogValues
                            End If
                        End If
                        
                        If bOK Then
                            bOK = False
                            If .Infos(dbmInfoBadDevspaces).Refresh(False) Then
                                bOK = True
                                GetBadAndReintegrationDevspacesValues
                            End If
                        End If
                        
                        If bOK Then
                            bOK = GetExtraValues
                        End If
                        
                    End If
                Else
                    bOK = True
                End If
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End With
    End If
    
    Database.EventStateRefreshed
    
    If lOldState <> lState Then
        Database.EventStateChanged
    End If
    
    Database.Busy = False
    
    Execute = bOK
End Function

Public Sub CleanUp()
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    dAt = Empty
    
    lState = dbmDBStateUnknown
    
    '''
    
    lDataKB = 0
    lPermDataKB = 0
    lTempDataKB = 0
    
    lDataPages = 0
    lPermDataPages = 0
    lTempDataPages = 0
    
    lDataPercent = 0
    lPermDataPercent = 0
    lTempDataPercent = 0
    
    lLogKB = 0
    lLogPages = 0
    lLogPercent = 0
    
    lSessions = 0
    lSessionsPercent = 0
    
    lDataCache = 0
    lConverterCache = 0
    
    lDataMaxKB = 0
    lLogMaxKB = 0
    lDataMaxPages = 0
    lLogMaxPages = 0
    lSessionsMax = 0
    
    bDatabaseFull = False
    bConnectPossible = False
    bCommandMonitoring = False
    bDatabaseMonitoring = False
    bKernelTrace = False
    bAutosave = False
    lBadIndexes = 0
    lBadDevspaces = 0
    lReintegrationDevspaces = 0
    
    sLogMode = ""
    lLogMode = dbmLogModeNone
    
    lOMSDataCache = 0
    lOMSLogDataCache = 0
End Sub

Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Private Sub GetValues()
    With Database.Infos(dbmInfoState)
        .BeginReadLines
    
        lDataKB = GetValue(.ReadLine())
        lPermDataKB = GetValue(.ReadLine())
        lTempDataKB = GetValue(.ReadLine())
        
        lDataPages = GetValue(.ReadLine())
        lPermDataPages = GetValue(.ReadLine())
        lTempDataPages = GetValue(.ReadLine())
        
        lDataPercent = GetValue(.ReadLine())
        lPermDataPercent = GetValue(.ReadLine())
        lTempDataPercent = GetValue(.ReadLine())
        
        lLogKB = GetValue(.ReadLine())
        lLogPages = GetValue(.ReadLine())
        lLogPercent = GetValue(.ReadLine())
        
        lSessions = GetValue(.ReadLine())
        lSessionsPercent = GetValue(.ReadLine())
        
        lDataCache = GetValue(.ReadLine())
        lConverterCache = GetValue(.ReadLine())
        
        If Database.Version.Number >= dbmVersion72 Then
            lDataMaxKB = GetValue(.ReadLine())
            lLogMaxKB = GetValue(.ReadLine())
            lDataMaxPages = GetValue(.ReadLine())
            lLogMaxPages = GetValue(.ReadLine())
            lSessionsMax = GetValue(.ReadLine())
            
            bDatabaseFull = GetValueYesNo(.ReadLine())
            bConnectPossible = GetValueYesNo(.ReadLine())
            bCommandMonitoring = GetValueOnOff(.ReadLine())
            bDatabaseMonitoring = GetValueOnOff(.ReadLine())
            bKernelTrace = GetValueOnOff(.ReadLine())
            bAutosave = GetValueOnOff(.ReadLine())
            lBadIndexes = GetValue(.ReadLine())
            
            If Database.Version.Number >= dbmVersion742 Then
                lOMSDataCache = GetValue(.ReadLine())
                lOMSLogDataCache = GetValue(.ReadLine())
            End If
        End If
    End With
End Sub

Private Sub GetLogValues()
    With Database.Infos(dbmInfoLog)
        .BeginReadLines
        sLogMode = GetValueString(.ReadLine())
        
        Select Case sLogMode
            Case PARAM_LOGMODE_VAL_DEMO:        lLogMode = dbmLogModeDemo
            Case PARAM_LOGMODE_VAL_SINGLE:      lLogMode = dbmLogModeSingle
            Case PARAM_LOGMODE_VAL_DUAL:        lLogMode = dbmLogModeDual
            Case PARAM_LOGMODE_VAL_SINGLE_DEMO: lLogMode = dbmLogModeSingleDemo
                                                sLogMode = "SINGLE/DEMO"
            Case PARAM_LOGMODE_VAL_DUAL_DEMO:   lLogMode = dbmLogModeDualDemo
                                                sLogMode = "DUAL/DEMO"
            Case PARAM_LOGMODE_VAL_SINGLE_OFF:  lLogMode = dbmLogModeSingleOff
            Case PARAM_LOGMODE_VAL_DUAL_OFF:    lLogMode = dbmLogModeDualOff
            Case Else:                          lLogMode = dbmLogModeNone
        End Select
    End With
End Sub

Private Sub GetBadAndReintegrationDevspacesValues()
    Dim oInfo As Info
    Dim sLine As String
    Dim lPos As Long
    Dim sName As String
    Dim sState As String
    
    lBadDevspaces = 0
    lReintegrationDevspaces = 0
    
    With Database
        Set oInfo = .Infos(dbmInfoBadDevspaces)
        oInfo.BeginReadLines
        Do While Not oInfo.EndOfReadLines
            sLine = oInfo.ReadLine
            lPos = 1
            sName = Trim$(.ServerObject.GetField(sLine, "|", lPos))
            sState = Trim$(.ServerObject.GetField(sLine, "|", lPos))
            If sState = "BAD" Then
                lBadDevspaces = lBadDevspaces + 1
            ElseIf sState = "REINTEGRATION" Then
                lReintegrationDevspaces = lReintegrationDevspaces + 1
            End If
            sName = ""
            sState = ""
        Loop
    End With
End Sub

Private Function GetValue(ByVal sLine As String) As Long
    Dim iPos As Integer
    Dim sVal As String
    Dim lVal As Long
    
    lVal = 0
    
    iPos = InStr(1, sLine, "=")
    If iPos > 0 Then
        sVal = Trim$(Mid$(sLine, iPos + 1))
        If IsNumeric(sVal) Then
            lVal = Val(sVal)
        End If
    Else
        sVal = Trim$(sLine)
        If IsNumeric(sVal) Then
            lVal = Val(sVal)
        End If
    End If
    
    GetValue = lVal
End Function

Private Function GetValueString(ByVal sLine As String) As String
    Dim iPos As Integer
    Dim sVal As String
    
    sVal = ""
    
    iPos = InStr(1, sLine, "=")
    If iPos > 0 Then
        sVal = Trim$(Mid$(sLine, iPos + 1))
    Else
        sVal = Trim$(sLine)
    End If
    
    GetValueString = sVal
End Function

Private Function GetValueYesNo(ByVal sLine As String) As Boolean
    Dim iPos As Integer
    Dim sVal As String
    Dim bVal As Boolean
    
    bVal = False
    
    iPos = InStr(1, sLine, "=")
    If iPos > 0 Then
        sVal = UCase$(Trim$(Mid$(sLine, iPos + 1)))
        bVal = (sVal = VAL_YES)
    Else
        sVal = UCase$(Trim$(sLine))
        bVal = (sVal = VAL_YES)
    End If
    
    GetValueYesNo = bVal
End Function

Private Function GetValueOnOff(ByVal sLine As String) As Boolean
    Dim iPos As Integer
    Dim sVal As String
    Dim bVal As Boolean
    
    bVal = False
    
    iPos = InStr(1, sLine, "=")
    If iPos > 0 Then
        sVal = UCase$(Trim$(Mid$(sLine, iPos + 1)))
        bVal = (sVal = VAL_ON)
    Else
        sVal = UCase$(Trim$(sLine))
        bVal = (sVal = VAL_ON)
    End If
    
    GetValueOnOff = bVal
End Function

Private Function GetExtraValues() As Boolean
    Dim bOK As Boolean
    Dim sCmd As String
    Dim sData As String

    bOK = False
    
    lOMSDataCache = 0
    lOMSLogDataCache = 0
    
    With Database
        If .Check() Then
        
            If .Version.Number < dbmVersion742 Then
        
                If .SQLConnect Then
                    bOK = True
                
                    sCmd = "SELECT VALUE FROM SYSDD.MONITOR "
                    sCmd = sCmd + "WHERE UPPER(TYPE) = 'CACHES' "
                    sCmd = sCmd + "AND UPPER(DESCRIPTION) = 'DATA CACHE OMS HIT RATE (%)'"
                    If bOK Then
                        .ServerObject.ErrorRaise = False
                        bOK = .SQLExecute(sCmd, sData)
                        .ServerObject.ErrorRaise = True
                        If bOK Then
                            lOMSDataCache = 0
                            On Error Resume Next
                            lOMSDataCache = CLng(sData)
                            On Error GoTo 0
                        End If
                    End If
                    
                    sCmd = "SELECT VALUE FROM SYSDD.MONITOR "
                    sCmd = sCmd + "WHERE UPPER(TYPE) = 'CACHES' "
                    sCmd = sCmd + "AND UPPER(DESCRIPTION) = 'DATA CACHE OMS LOG HIT RATE (%)'"
                    If bOK Then
                        .ServerObject.ErrorRaise = False
                        bOK = .SQLExecute(sCmd, sData)
                        .ServerObject.ErrorRaise = True
                        If bOK Then
                            lOMSLogDataCache = 0
                            On Error Resume Next
                            lOMSLogDataCache = CLng(sData)
                            On Error GoTo 0
                        End If
                    End If
                
                    .SQLRelease
                End If
                
            End If
            
        End If
    End With
    
    GetExtraValues = bOK
End Function
