VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TermcharSets"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F0603DF"
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Const TERMCHAR_SQL_SETS = "SELECT DISTINCT ASCII(TERMCHARSETNAME) FROM TERMCHARSETS"

Private oParent As Object

Private oItems As New Collection

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTTermcharSets
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Count() As Integer
    Count = oItems.Count
End Property

Public Function Item(ByVal Index As Variant) As TermcharSet
Attribute Item.VB_UserMemId = 0
    Set Item = oItems(Index)
End Function

Public Property Get NewEnum()
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = oItems.[_NewEnum]
End Property

'''

Public Sub Clear()
    Dim iCount As Integer
    Dim i As Integer
    
    iCount = oItems.Count
    For i = 1 To iCount
        oItems(1).CleanUp
        oItems.Remove 1
    Next
End Sub

Public Sub CleanUp()
    Clear
    Set oParent = Nothing
End Sub

Friend Sub Remove(ByVal sSet As String)
    oItems(sSet).CleanUp
    oItems.Remove sSet
End Sub

Public Function AddNewSet(ByVal sSet As String) As TermcharSet
  Dim oTermcharSet As New TermcharSet
  
  If (Not oTermcharSet Is Nothing) Then
    Set oTermcharSet.Parent = Me
    oTermcharSet.Name = sSet
    Call oItems.Add(oTermcharSet, oTermcharSet.Name)
  End If

    Set AddNewSet = oTermcharSet
End Function

Public Function Refresh() As Boolean
    Clear
    Refresh = GetSetsFromDB()
End Function

'''

Private Function GetSetsFromDB() As Boolean
    Dim bOK As Boolean
    Dim sResult As String
    Dim sList As String
    Dim bStatus As Boolean
    Dim bContinue As Boolean
    Dim sRow As String
    Dim sSet As String
    Dim oTermcharSet As TermcharSet
    
    bOK = False
    
    With Database
        If DBMSRVSQL.Connect(.ServerObject) Then
            If (DBMSRVSQL.Execute(.ServerObject, TERMCHAR_SQL_SETS, sResult, bContinue)) Then
                sList = sResult
                bOK = True
                While bContinue And bOK
                    bOK = DBMSRVSQL.Fetch(.ServerObject, sResult, bContinue)
                    If bOK Then
                        sList = sList & vbCrLf & sResult
                    Else
                        .LastError.SetByServerObject .ServerObject
                    End If
                Wend
            Else
                If DBMSRVSQL.LastError(.ServerObject) = DBMSRVSQL.DBMSRV_SQL_ROWNOTFOUND Then
                    sList = ""
                    bOK = True
                End If
            End If
            DBMSRVSQL.Release .ServerObject
        Else
            .LastError.SetByServerObject .ServerObject
        End If
    
        If bOK Then
            sRow = DBMSRVSQL.NextRow(sList)
    
            While Len(sRow) > 0 And bOK
                sSet = DBMSRVSQL.NextField(sRow)
        
                Set oTermcharSet = New TermcharSet
        
                If Not oTermcharSet Is Nothing Then
                    Set oTermcharSet.Parent = Me
                    oTermcharSet.Name = sSet
                    bOK = oTermcharSet.Refresh()
                    oItems.Add oTermcharSet, oTermcharSet.Name
                Else
                    bOK = False
                End If
        
                sRow = DBMSRVSQL.NextRow(sList)
            Wend
        End If
    End With
    
    GetSetsFromDB = bOK
End Function

Private Sub Class_Initialize()
    InitObject ObjectType
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

