VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "User"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1997-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const FUNC_REFRESH = "UserRefresh"
Const FUNC_CREATE = "UserCreate"
Const FUNC_SAVE = "UserSave"
Const FUNC_CHANGEPWD = "UserChangePassword"
Const FUNC_CHANGESEC = "UserChangeSecondPassword"
Const FUNC_CHANGESYS = "UserChangeSystemPassword"
Const FUNC_DELETE = "UserDelete"

'''

Public Enum DBMUserTypeConstants
    dbmUTDefault
    dbmUTDBM
    dbmUTDBA
End Enum

'''

Const KEY_SQLUM_DBA = "DBA"
Const KEY_SQLUM_RES = "RESOURCE"
Const KEY_SQLUM_STD = "STANDARD"

Public Enum SQLUserModeConstants
    dbmSQLUMDBA
    dbmSQLUMResource
    dbmSQLUMStandard
End Enum

Private oParent As Object

Private lIndex As Long

Private sName As String
Private sPassword As String
Private oServerRights As UserRights
Private oGUIRights As UserRights
Private bSecondPwdEnabled As Boolean
Private sSecondPwd As String
Private bDBMUser As Boolean
Private bSQLUser As Boolean
Private lSQLUserMode As SQLUserModeConstants
Private bDisabled As Boolean
Private sSystemName As String
Private sSystemPwd As String
Private sComment As String

'''

Private bSecondPwd As Boolean
Private bSystemPwd As Boolean

'''

Private lUserType As DBMUserTypeConstants

'''

Public Property Get ObjectType() As DBMObjectTypeConstants
    ObjectType = dbmOTUser
End Property

Public Property Get Parent() As Object
    Set Parent = oParent
End Property
Friend Property Set Parent(NewVal As Object)
    Set oParent = NewVal
End Property

Public Property Get Database() As Database
    Set Database = oParent.Database
End Property

Public Property Get Index() As Long
    Index = lIndex
End Property
Friend Property Let Index(ByVal NewVal As Long)
    lIndex = NewVal
End Property
'''

Public Property Get Name() As String
    Name = sName
End Property
Public Property Let Name(NewVal As String)
    sName = NewVal
End Property

Public Property Let Password(NewVal As String)
    sPassword = NewVal
End Property
Public Property Get Password() As String
    Password = sPassword
End Property

Public Property Get ServerRights() As UserRights
    If oServerRights Is Nothing Then
        Set oServerRights = New UserRights
        Set oServerRights.Parent = Me
    End If
    Set ServerRights = oServerRights
End Property

Public Property Get GUIRights() As UserRights
    If oGUIRights Is Nothing Then
        Set oGUIRights = New UserRights
        Set oGUIRights.Parent = Me
    End If
    Set GUIRights = oGUIRights
End Property

Public Property Get SecondPwdEnabled() As Boolean
    SecondPwdEnabled = bSecondPwdEnabled
End Property
Public Property Let SecondPwdEnabled(ByVal NewVal As Boolean)
    bSecondPwdEnabled = NewVal
End Property

Public Property Get SecondPwd() As String
    SecondPwd = sSecondPwd
End Property
Public Property Let SecondPwd(NewVal As String)
    sSecondPwd = NewVal
End Property

Public Property Get DBMUser() As Boolean
    DBMUser = bDBMUser
End Property
Public Property Let DBMUser(ByVal NewVal As Boolean)
    bDBMUser = NewVal
End Property

Public Property Get SQLUser() As Boolean
    SQLUser = bSQLUser
End Property
Public Property Let SQLUser(ByVal NewVal As Boolean)
    bSQLUser = NewVal
End Property

Public Property Get SQLUserMode() As SQLUserModeConstants
    SQLUserMode = lSQLUserMode
End Property
Public Property Let SQLUserMode(ByVal NewVal As SQLUserModeConstants)
    lSQLUserMode = NewVal
End Property

Public Property Get SQLUserModeString() As String
    Dim s As String
    Select Case lSQLUserMode
        Case dbmSQLUMDBA: s = KEY_SQLUM_DBA
        Case dbmSQLUMResource: s = KEY_SQLUM_RES
        Case dbmSQLUMStandard: s = KEY_SQLUM_STD
    End Select
    SQLUserModeString = s
End Property

Public Property Let SQLUserModeString(NewVal As String)
    Select Case UCase$(NewVal)
        Case KEY_SQLUM_DBA: lSQLUserMode = dbmSQLUMDBA
        Case KEY_SQLUM_RES: lSQLUserMode = dbmSQLUMResource
        Case KEY_SQLUM_STD: lSQLUserMode = dbmSQLUMStandard
    End Select
End Property

Public Property Get Disabled() As Boolean
    Disabled = bDisabled
End Property
Public Property Let Disabled(ByVal NewVal As Boolean)
    bDisabled = NewVal
End Property

Public Property Get SystemName() As String
    SystemName = sSystemName
End Property
Public Property Let SystemName(NewVal As String)
    sSystemName = NewVal
End Property

Public Property Get SystemPwd() As String
    SystemPwd = sSystemPwd
End Property
Public Property Let SystemPwd(NewVal As String)
    sSystemPwd = NewVal
End Property

Public Property Get Comment() As String
    Comment = sComment
End Property
Public Property Let Comment(NewVal As String)
    sComment = NewVal
End Property

Friend Property Get ServerRightString() As String
    Dim oRight As UserRight
    Dim s As String
    
    s = ""
    
    If Not oServerRights Is Nothing Then
        For Each oRight In oServerRights
            s = s + oRight.Right + ","
        Next
        If Len(s) > 0 Then
            s = Left$(s, Len(s) - 1)
        End If
    End If
    
    ServerRightString = s
End Property

Friend Property Get GUIRightString() As String
    Dim oRight As UserRight
    Dim s As String
    
    s = ""
    
    If Not oGUIRights Is Nothing Then
        For Each oRight In oGUIRights
            s = s + oRight.Right + ","
        Next
        If Len(s) > 0 Then
            s = Left$(s, Len(s) - 1)
        End If
    End If
    
    GUIRightString = s
End Property

Public Property Get UserType() As DBMUserTypeConstants
    UserType = lUserType
End Property
Public Property Let UserType(ByVal NewVal As DBMUserTypeConstants)
    lUserType = NewVal
End Property

'''

Public Function Refresh(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_REFRESH, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_REFRESH
            bOK = True
        End If
    End If
    
    Refresh = bOK
End Function

Public Function Create(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CREATE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CREATE
            bOK = True
        End If
    End If
    
    Create = bOK
End Function

Public Function Save(Optional ByVal SecondPwd As Boolean = False, _
                     Optional ByVal SystemPwd As Boolean = False, _
                     Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
    
        bSecondPwd = SecondPwd
        bSystemPwd = SystemPwd
    
        If Not Asynchron Then
            bOK = Execute(FUNC_SAVE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_SAVE
            bOK = True
        End If
    End If
    
    Save = bOK
End Function

Public Function ChangePassword(Optional ByVal Asynchron As Boolean = False)
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CHANGEPWD, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CHANGEPWD
            bOK = True
        End If
    End If
    
    ChangePassword = bOK
End Function

Public Function ChangeSecondPassword(Optional ByVal Asynchron As Boolean = False)
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CHANGESEC, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CHANGESEC
            bOK = True
        End If
    End If
    
    ChangeSecondPassword = bOK
End Function

Public Function ChangeSystemPassword(Optional ByVal Asynchron As Boolean = False)
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_CHANGESYS, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_CHANGESYS
            bOK = True
        End If
    End If
    
    ChangeSystemPassword = bOK
End Function

Public Function Delete(Optional ByVal Asynchron As Boolean = False) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    If Database.Check() Then
        If Not Asynchron Then
            bOK = Execute(FUNC_DELETE, False)
        Else
            QUEUE.QueueItems.Add Me, FUNC_DELETE
            bOK = True
        End If
    End If
    
    Delete = bOK
End Function

'''

Public Function InitServerRights(ByVal User As User)
    Dim oRight As UserRight
    Dim oNew As UserRight
    
    ServerRights.Clear
    
    For Each oRight In User.ServerRights
        Set oNew = New UserRight
        With oNew
            .Name = oRight.Name
            .Value = oRight.Value
            .Description = oRight.Description
        End With
        ServerRights.Add oNew, oNew.Name
    Next
End Function

Public Function InitGUIRights(ByVal User As User)
    Dim oRight As UserRight
    Dim oNew As UserRight
    
    GUIRights.Clear
    
    For Each oRight In User.GUIRights
        Set oNew = New UserRight
        With oNew
            .Name = oRight.Name
            .Value = oRight.Value
            .Description = oRight.Description
        End With
        GUIRights.Add oNew, oNew.Name
    Next
End Function

'''

Public Sub CleanUp()
    If Not oServerRights Is Nothing Then oServerRights.CleanUp
    If Not oGUIRights Is Nothing Then oGUIRights.CleanUp
    
    Set oServerRights = Nothing
    Set oGUIRights = Nothing
    
    Set oParent = Nothing
End Sub

'''

Private Sub Class_Initialize()
    InitObject ObjectType
    
    Set oServerRights = Nothing
    Set oGUIRights = Nothing
End Sub
Private Sub Class_Terminate()
    TermObject ObjectType
End Sub

'''

Public Function Execute(ByVal FunctionName As String, ByVal Asynchron As Boolean, Optional ByVal SenderID As Long) As Boolean
    Dim bOK As Boolean
    Dim oDB As DBMLib.Database
    
    Set oDB = Database
    
    oDB.Busy = True
    
    bOK = False
    
    Select Case FunctionName
        Case FUNC_REFRESH:      bOK = ExecuteRefresh(Asynchron)
        Case FUNC_CREATE:       bOK = ExecuteCreate(Asynchron)
        Case FUNC_SAVE:         bOK = ExecuteSave(Asynchron)
        Case FUNC_CHANGEPWD:    bOK = ExecuteChangePassword(Asynchron)
        Case FUNC_CHANGESEC:    bOK = ExecuteChangeSecondPassword(Asynchron)
        Case FUNC_CHANGESYS:    bOK = ExecuteChangeSystemPassword(Asynchron)
        Case FUNC_DELETE:       bOK = ExecuteDelete(Asynchron)
    End Select
            
    oDB.Busy = False
    
    Execute = bOK
End Function

Private Function ExecuteRefresh(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVUser.GetUser(.ServerObject, Me) Then
                bOK = True
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionRefresh, Me
        End If
    End With
    
    ExecuteRefresh = bOK
End Function

Private Function ExecuteCreate(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVUser.CreateUser(.ServerObject, Me) Then
                If Save(True, True) Then
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionCreate, Me
        End If
    End With
    
    ExecuteCreate = bOK
End Function

Private Function ExecuteSave(ByVal bAsynchron As Boolean) As Boolean
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVUser.PutUser(.ServerObject, Me, bSecondPwd, bSystemPwd) Then
                If Refresh() Then
                    bOK = True
                End If
            End If
                
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionSave, Me
        End If
    End With
    
    ExecuteSave = bOK
End Function

Private Function ExecuteChangePassword(ByVal bAsynchron As Boolean)
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVUser.PutUserPassword(.ServerObject, Me) Then
                If Refresh() Then
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionChangePassword, Me
        End If
    End With
    
    ExecuteChangePassword = bOK
End Function

Private Function ExecuteChangeSecondPassword(ByVal bAsynchron As Boolean)
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVUser.PutUserSecondPassword(.ServerObject, Me) Then
                If Refresh() Then
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionChangeSecondPassword, Me
        End If
    End With
    
    ExecuteChangeSecondPassword = bOK
End Function

Private Function ExecuteChangeSystemPassword(ByVal bAsynchron As Boolean)
    Dim bOK As Boolean
    
    bOK = False
    
    With Database
        If .Check() Then
            If DBMSRVUser.PutUserSystemPassword(.ServerObject, Me) Then
                If Refresh() Then
                    bOK = True
                End If
            End If
            
            If Not bOK Then
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionChangeSystemPassword, Me
        End If
    End With
    
    ExecuteChangeSystemPassword = bOK
End Function

Private Function ExecuteDelete(ByVal bAsynchron As Boolean) As Boolean
    Dim oDB As Database
    Dim bOK As Boolean
    
    Set oDB = Database
    
    bOK = False
    
    With oDB
        If .Check() Then
            If DBMSRVUser.DeleteUser(.ServerObject, Me) Then
                .Users.Remove sName
                bOK = True
            Else
                .LastError.SetByServerObject .ServerObject
            End If
        End If
        
        If bAsynchron Then
            .EventUserAction Not bOK, dbmUserActionDelete, Me
        End If
    End With
    
    ExecuteDelete = bOK
End Function

