VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Crypt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Const MAXCRYPT = 6

Private Type TYPE_PW_STRING
    s As String * 18
End Type

Private Type TYPE_PW_LONG
    l(1 To MAXCRYPT) As Long
End Type

Public Function Encrypt(ClearPwd As String) As String
    Dim pw_clear As TYPE_PW_STRING
    Dim pw_long As TYPE_PW_LONG
    
    Dim i As Integer
    Dim s As String
    Dim vp1 As Long
    Dim vp2 As Long
    Dim vp3 As Long
    Dim nleft As Long
    Dim nright As Long
    
    pw_clear.s = left(ClearPwd, 18)
    
    vp1 = 2
    vp2 = 521
    vp3 = 133379
    
    For i = 1 To MAXCRYPT
        pw_long.l(i) = Asc(Mid(pw_clear.s, 3 * i - 2, 1)) * vp3 + Asc(Mid$(pw_clear.s, 3 * i - 1, 1)) * vp2 + Asc(Mid(pw_clear.s, 3 * i, 1)) * vp1
    Next
    
    pw_clear.s = ""
    
    For i = 1 To MAXCRYPT
        If i > 1 Then
           nleft = pw_long.l(i - 1)
        Else
           nleft = vp3
        End If
        pw_long.l(i) = pw_long.l(i) + ((nleft Mod 61) * (vp3 * 126 - 1))
    Next
    
    For i = MAXCRYPT To 1 Step -1
        If i < MAXCRYPT - 1 Then
           nright = pw_long.l(i + 1)
        Else
           nright = vp2
        End If
        pw_long.l(i) = pw_long.l(i) + ((nright Mod 61) * (vp3 * 128 - 1))
    Next
    
    For i = 1 To MAXCRYPT
        If pw_long.l(i) Mod 2 <> 0 Then
           pw_long.l(i) = -pw_long.l(i)
        End If
    Next
    
    s = ""
    For i = 1 To MAXCRYPT
        s = s & Format$(Hex(pw_long.l(i)), "@@@@@@@@")
    Next
    For i = 1 To 24
        If Mid(s, i, 1) = " " Then Mid(s, i) = "0"
    Next

    Encrypt = s
End Function

Public Function Decrypt(CrypePwd As String) As String
    Dim pw_clear As TYPE_PW_STRING
    Dim pw_long As TYPE_PW_LONG
    
    Dim i As Integer
    Dim s As String
    Dim vp1 As Long
    Dim vp2 As Long
    Dim vp3 As Long
    Dim nleft As Long
    Dim nright As Long
    Dim exp1 As Long
    Dim exp2 As Long
    Dim exp3 As Long
    Dim notnull As Integer
    
    s = left(CrypePwd, 48)
    For i = 1 To MAXCRYPT
        pw_long.l(i) = Val("&H" & Mid(s, (i - 1) * 8 + 1, 8))
    Next
    
    vp1 = 2
    vp2 = 521
    vp3 = 133379
    
    For i = 1 To MAXCRYPT
        notnull = ((pw_long.l(i) <> 0) Or notnull)
    Next
    
    If Not notnull Then
        pw_clear.s = Space$(18)
    Else
        For i = 1 To MAXCRYPT
            If pw_long.l(i) Mod 2 <> 0 Then
                pw_long.l(i) = -pw_long.l(i)
            End If
        Next
    
        For i = 1 To MAXCRYPT
            If i < MAXCRYPT - 1 Then
                nright = pw_long.l(i + 1)
            Else
                nright = vp2
            End If
            pw_long.l(i) = pw_long.l(i) - ((nright Mod 61) * (vp3 * 128 - 1))
        Next
        
        For i = MAXCRYPT To 1 Step -1
            If i > 1 Then
                nleft = pw_long.l(i - 1)
            Else
                nleft = vp3
            End If
            pw_long.l(i) = pw_long.l(i) - ((nleft Mod 61) * (vp3 * 126 - 1))
        Next
        
        For i = 1 To MAXCRYPT
            exp3 = pw_long.l(i)
            exp1 = exp3 \ vp3
            exp2 = exp3 Mod vp3
            Mid$(pw_clear.s, 3 * i - 2) = Chr(exp1)
            exp3 = exp2
            exp1 = exp3 \ vp2
            exp2 = exp3 Mod vp2
            Mid$(pw_clear.s, 3 * i - 1) = Chr(exp1)
            exp3 = exp2
            exp1 = exp3 \ vp1
            exp2 = exp3 Mod vp1
            Mid$(pw_clear.s, 3 * i) = Chr(exp1)
        Next
    End If

    Decrypt = pw_clear.s
End Function
