VERSION 5.00
Begin VB.UserControl ResizeBox 
   Alignable       =   -1  'True
   ClientHeight    =   4260
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4620
   ControlContainer=   -1  'True
   ScaleHeight     =   284
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   308
End
Attribute VB_Name = "ResizeBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Function SetWindowPos Lib "user32.dll" ( _
    ByVal hWnd As Long, _
    ByVal hWndInsertAfter As Long, _
    ByVal X As Long, _
    ByVal Y As Long, _
    ByVal cx As Long, _
    ByVal cy As Long, _
    ByVal wFlags As Long) As Long

Const IDC_HO = 101
Const IDC_VE = 102
Const IDC_NE = 103
Const IDC_NW = 104

Private Enum RegionConstants
    regNone
    regLeft
    regTop
    regRight
    regBottom
    regLeftTop
    regRightTop
    regLeftBottom
    regRightBottom
End Enum

Private bResizeLeft As Boolean
Private bResizeTop As Boolean
Private bResizeRight As Boolean
Private bResizeBottom As Boolean
Private iResizerSize As Integer
Private iMinWidth As Integer
Private iMinHeight As Integer
Private bAutosize As Boolean

Private iScaleMode As Integer
Private iBorderSize As Integer

Private nRegion As RegionConstants

Private bSize As Boolean
Private iSizeX As Integer
Private iSizeY As Integer

'''

Public Event Resize(ByVal Left As Integer, _
                    ByVal Top As Integer, _
                    ByVal Width As Integer, _
                    ByVal Height As Integer)

'''

Public Property Get ResizeLeft() As Boolean
    ResizeLeft = bResizeLeft
End Property
Public Property Let ResizeLeft(ByVal NewVal As Boolean)
    bResizeLeft = NewVal
End Property

Public Property Get ResizeTop() As Boolean
    ResizeTop = bResizeTop
End Property
Public Property Let ResizeTop(ByVal NewVal As Boolean)
    bResizeTop = NewVal
End Property

Public Property Get ResizeRight() As Boolean
    ResizeRight = bResizeRight
End Property
Public Property Let ResizeRight(ByVal NewVal As Boolean)
    bResizeRight = NewVal
End Property

Public Property Get ResizeBottom() As Boolean
    ResizeBottom = bResizeBottom
End Property
Public Property Let ResizeBottom(ByVal NewVal As Boolean)
    bResizeBottom = NewVal
End Property

Public Property Get ResizerSize() As Integer
    ResizerSize = iResizerSize
End Property
Public Property Let ResizerSize(ByVal NewVal As Integer)
    iResizerSize = NewVal
End Property

Public Property Get MinWidth() As Integer
    MinWidth = iMinWidth
End Property
Public Property Let MinWidth(ByVal NewVal As Integer)
    iMinWidth = NewVal
End Property

Public Property Get MinHeight() As Integer
    MinHeight = iMinHeight
End Property
Public Property Let MinHeight(ByVal NewVal As Integer)
    iMinHeight = NewVal
End Property

Public Property Get Autosize() As Boolean
    Autosize = bAutosize
End Property
Public Property Let Autosize(ByVal NewVal As Boolean)
    bAutosize = NewVal
End Property

'''

Private Sub UserControl_Initialize()
    iBorderSize = 0
    iScaleMode = GetScaleMode()
    
    bResizeLeft = True
    bResizeTop = True
    bResizeRight = True
    bResizeBottom = True
    iResizerSize = 4
    iMinWidth = ScaleX(10, vbPixels, iScaleMode)
    iMinHeight = ScaleY(10, vbPixels, iScaleMode)
    bAutosize = True
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    ResizeLeft = PropBag.ReadProperty("ResizeLeft", True)
    ResizeTop = PropBag.ReadProperty("ResizeTop", True)
    ResizeRight = PropBag.ReadProperty("ResizeRight", True)
    ResizeBottom = PropBag.ReadProperty("ResizeBottom", True)
    ResizerSize = PropBag.ReadProperty("ResizerSize", 4)
    MinWidth = PropBag.ReadProperty("MinWidth", 10)
    MinHeight = PropBag.ReadProperty("MinHeight", 10)
    Autosize = PropBag.ReadProperty("Autosize", True)
End Sub

Private Sub UserControl_Show()
    If Extender.Align <> vbAlignNone Then
        bResizeLeft = False
        bResizeTop = False
        bResizeRight = False
        bResizeBottom = False
    
        Select Case Extender.Align
            Case vbAlignLeft:   bResizeRight = True
            Case vbAlignTop:    bResizeBottom = True
            Case vbAlignRight:  bResizeLeft = True
            Case vbAlignBottom: bResizeTop = True
        End Select
        UserControl_Resize
    End If
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    PropBag.WriteProperty "ResizeLeft", ResizeLeft, True
    PropBag.WriteProperty "ResizeTop", ResizeTop, True
    PropBag.WriteProperty "ResizeRight", ResizeRight, True
    PropBag.WriteProperty "ResizeBottom", ResizeBottom, True
    PropBag.WriteProperty "ResizerSize", ResizerSize, 4
    PropBag.WriteProperty "MinWidth", MinWidth, 10
    PropBag.WriteProperty "MinHeight", MinHeight, 10
    PropBag.WriteProperty "Autosize", Autosize, 10
End Sub

Private Sub UserControl_Resize()
    Dim iLeft As Integer
    Dim iTop As Integer
    Dim iWidth As Integer
    Dim iHeight As Integer
    
    iLeft = 0
    iTop = 0
    iWidth = ScaleWidth
    iHeight = ScaleHeight
    
    If bResizeLeft Then
        iLeft = iResizerSize
        iWidth = iWidth - iResizerSize
    End If
    If bResizeTop Then
        iTop = iResizerSize
        iHeight = iHeight - iResizerSize
    End If
    If bResizeRight Then
        iWidth = iWidth - iResizerSize
    End If
    If bResizeBottom Then
        iHeight = iHeight - iResizerSize
    End If
    
    If iWidth < 0 Then iWidth = 0
    If iHeight < 0 Then iHeight = 0
    
    If bAutosize Then
        If ContainedControls.Count > 0 Then
            With ContainedControls(0)
                Call SetWindowPos(.hWnd, 0, iLeft, iTop, iWidth, iHeight, 0)
            End With
        End If
    End If
    
    iLeft = ScaleX(iLeft, vbPixels, iScaleMode)
    iTop = ScaleY(iTop, vbPixels, iScaleMode)
    iWidth = ScaleX(iWidth, vbPixels, iScaleMode)
    iHeight = ScaleY(iHeight, vbPixels, iScaleMode)
    
    RaiseEvent Resize(iLeft, iTop, iWidth, iHeight)
End Sub


Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    nRegion = GetRegion(X, Y)
    
    Select Case nRegion
        Case regLeft:
            iSizeX = X
        Case regRight:
            iSizeX = ScaleWidth - X
        Case regTop:
            iSizeY = Y
        Case regBottom:
            iSizeY = ScaleHeight - Y
        Case regLeftTop:
            iSizeX = X
            iSizeY = Y
        Case regRightBottom:
            iSizeX = ScaleWidth - X
            iSizeY = ScaleHeight - Y
        Case regRightTop:
            iSizeX = ScaleWidth - X
            iSizeY = Y
        Case regLeftBottom:
            iSizeX = X
            iSizeY = ScaleHeight - Y
    End Select
    
    BackColor = vbApplicationWorkspace
    
    If nRegion <> regNone Then
        bSize = True
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim iX As Integer
    Dim iY As Integer
    Dim iW As Integer
    Dim iH As Integer
    Dim iAlign As Integer
    
    Dim iCursor As Integer
    
    If Not bSize Then
        iCursor = 0
        Select Case GetRegion(X, Y)
            Case regLeft, regRight: iCursor = IDC_VE
            Case regTop, regBottom: iCursor = IDC_HO
            Case regLeftTop, regRightBottom: iCursor = IDC_NW
            Case regRightTop, regLeftBottom: iCursor = IDC_NE
        End Select
            
        If iCursor = vbDefault Then
            MousePointer = vbDefault
        Else
            MousePointer = vbCustom
            MouseIcon = LoadResPicture(iCursor, vbResCursor)
        End If
    Else
        iX = ScaleX(X - iSizeX, vbPixels, iScaleMode)
        iY = ScaleY(Y - iSizeY, vbPixels, iScaleMode)
        iW = ScaleX(X + iSizeX, vbPixels, iScaleMode)
        iH = ScaleY(Y + iSizeY, vbPixels, iScaleMode)
        
        With Extender
            If .Width - iX < (iMinWidth + 2 * iBorderSize + 2) Then iX = 0
            If .Height - iY < (iMinHeight + 2 * iBorderSize + 2) Then iY = 0
            If iW < (iMinWidth + 2 * iBorderSize + 2) Then iW = (iMinWidth + 2 * iBorderSize + 2)
            If iH < (iMinHeight + 2 * iBorderSize + 2) Then iH = (iMinHeight + 2 * iBorderSize + 2)
                        
            If Extender.Align = vbAlignNone Then
                If (.Left + iX) < 0 Then iX = -.Left
                If (.Top + iY) < 0 Then iY = -.Top
                If (.Left + iW) > .Parent.ScaleWidth Then iW = .Parent.ScaleWidth - .Left
                If (.Top + iH) > .Parent.ScaleHeight Then iH = .Parent.ScaleHeight - .Top
            End If
            
            Select Case nRegion
                Case regLeft:           If (.Width - iX) < (.Width + .Parent.ScaleWidth) Then .Move .Left + iX, .Top, .Width - iX
                Case regRight:          If iW < (.Width + .Parent.ScaleWidth) Then .Width = iW
                Case regTop:            If (.Height - iY) < (.Height + .Parent.ScaleHeight) Then .Move .Left, .Top + iY, .Width, .Height - iY
                Case regBottom:         If iH < (.Height + .Parent.ScaleHeight) Then .Height = iH
                Case regLeftTop:        .Move .Left + iX, .Top + iY, .Width - iX, .Height - iY
                Case regRightBottom:    .Move .Left, .Top, iW, iH
                Case regRightTop:       .Move .Left, .Top + iY, iW, .Height - iY
                Case regLeftBottom:     .Move .Left + iX, .Top, .Width - iX, iH
            End Select
        End With
    End If
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    BackColor = vbButtonFace
    nRegion = regNone
    bSize = False
End Sub

'''

Private Function GetRegion(X As Single, Y As Single) As RegionConstants
    Dim nRegion As RegionConstants
    Dim nAlign As AlignConstants
    
    nRegion = regNone
    nAlign = Extender.Align
    
    If X < iResizerSize Then
        If Y < iResizerSize Then
            If nAlign = vbAlignNone Then
                nRegion = regLeftTop
            Else
                Select Case nAlign
                    Case vbAlignRight: nRegion = regLeft
                    Case vbAlignBottom: nRegion = regTop
                End Select
            End If
        Else
            If Y > ScaleHeight - iResizerSize Then
                If nAlign = vbAlignNone Then
                    nRegion = regLeftBottom
                Else
                    Select Case nAlign
                        Case vbAlignTop: nRegion = regBottom
                        Case vbAlignRight: nRegion = regLeft
                    End Select
                End If
            Else
                nRegion = regLeft
            End If
        End If
    Else
        If X > ScaleWidth - iResizerSize Then
            If Y < iResizerSize Then
                If nAlign = vbAlignNone Then
                    nRegion = regRightTop
                Else
                    Select Case nAlign
                        Case vbAlignLeft: nRegion = regRight
                        Case vbAlignBottom: nRegion = regTop
                    End Select
                End If
            Else
                If Y > ScaleHeight - iResizerSize Then
                    If nAlign = vbAlignNone Then
                        nRegion = regRightBottom
                    Else
                        Select Case nAlign
                            Case vbAlignLeft: nRegion = regRight
                            Case vbAlignTop: nRegion = regBottom
                        End Select
                    End If
                Else
                    nRegion = regRight
                End If
            End If
        Else
            If Y < iResizerSize Then
                nRegion = regTop
            Else
                If Y > ScaleHeight - iResizerSize Then
                    nRegion = regBottom
                End If
            End If
        End If
    End If
    
    GetRegion = nRegion
End Function

Private Function GetScaleMode() As Integer
    On Error Resume Next
    GetScaleMode = Extender.Container.ScaleMode
    If Err.Number Then
        GetScaleMode = vbTwips
    End If
End Function

