VERSION 5.00
Begin VB.UserControl ScrollBox 
   Alignable       =   -1  'True
   ClientHeight    =   1860
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   2535
   ControlContainer=   -1  'True
   ScaleHeight     =   124
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   169
   Begin VB.PictureBox picRightBottom 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   255
      Left            =   1920
      ScaleHeight     =   17
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   17
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   1260
      Width           =   255
   End
   Begin VB.VScrollBar scrV 
      Height          =   1095
      Left            =   1920
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   60
      Width           =   255
   End
   Begin VB.HScrollBar scrH 
      Height          =   255
      Left            =   60
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   1260
      Width           =   1815
   End
End
Attribute VB_Name = "ScrollBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum ScrollBoxScrollBarConstants
    scbScrollBarNone
    scbScrollBarHorizontal
    scbScrollBarVertical
    scbScrollBarBoth
End Enum

'''

Private Declare Function GetSystemMetrics Lib "user32.dll" (ByVal nIndex As Long) As Long

Const SM_CXVSCROLL = 2
Const SM_CYHSCROLL = 3

'''

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Declare Function DrawFrameControl Lib "user32.dll" (ByVal hDC&, lpRect As RECT, ByVal un1 As Long, ByVal un2 As Long) As Boolean

Const DFC_SCROLL = 3
Const DFCS_SCROLLSIZEGRIP = &H8

'''

Private lScrollBars As ScrollBoxScrollBarConstants

Private sControl As String

Private iMinWidth As Integer
Private iMinHeight As Integer

Private iCtlWidth As Integer
Private iCtlHeight As Integer

Private iMaxWidth As Integer
Private iMaxHeight As Integer

Private bReduce As Boolean
Private bEnlarge As Boolean

Private bSizeGrip As Boolean

Private tRect As RECT

'''

Public Property Get ScrollBars() As ScrollBoxScrollBarConstants
    ScrollBars = lScrollBars
End Property
Public Property Let ScrollBars(ByVal NewVal As ScrollBoxScrollBarConstants)
    lScrollBars = NewVal
    PropertyChanged "ScrollBars"
End Property

Public Property Get ControlName() As String
    ControlName = sControl
End Property
Public Property Let ControlName(NewValue As String)
    Dim oControl  As Object

    sControl = NewValue

    If Len(sControl) > 0 Then
        Set oControl = UserControl.ContainedControls(0)
        iCtlWidth = ScaleX(oControl.Width, vbTwips, vbPixels)
        iCtlHeight = ScaleY(oControl.Height, vbTwips, vbPixels)
        oControl.Move 0, 0
        SetScrollBars

        scrH.ZOrder 0
        scrV.ZOrder 0
        picRightBottom.ZOrder 0
    End If
End Property

Public Property Get MinWidth() As Integer
    MinWidth = ScaleX(iMinWidth, vbPixels, vbTwips)
End Property
Public Property Let MinWidth(ByVal NewVal As Integer)
    iMinWidth = ScaleX(NewVal, vbTwips, vbPixels)
    PropertyChanged "MinWidth"
End Property

Public Property Get MinHeight() As Integer
    MinHeight = ScaleY(iMinHeight, vbPixels, vbTwips)
End Property
Public Property Let MinHeight(ByVal NewVal As Integer)
    iMinHeight = ScaleY(NewVal, vbTwips, vbPixels)
    PropertyChanged "MinHeight"
End Property

Public Property Get MaxWidth() As Integer
    MaxWidth = ScaleX(iMaxWidth, vbPixels, vbTwips)
End Property
Public Property Let MaxWidth(ByVal NewVal As Integer)
    iMaxWidth = ScaleX(NewVal, vbTwips, vbPixels)
    PropertyChanged "MaxWidth"
End Property

Public Property Get MaxHeight() As Integer
    MaxHeight = ScaleY(iMaxHeight, vbPixels, vbTwips)
End Property
Public Property Let MaxHeight(ByVal NewVal As Integer)
    iMaxHeight = ScaleY(NewVal, vbTwips, vbPixels)
    PropertyChanged "MaxHeight"
End Property

Public Property Get Reduce() As Boolean
    Reduce = bReduce
End Property
Public Property Let Reduce(ByVal NewVal As Boolean)
    bReduce = NewVal
    PropertyChanged "Reduce"
    UserControl_Resize
End Property

Public Property Get Enlarge() As Boolean
    Enlarge = bEnlarge
End Property
Public Property Let Enlarge(ByVal NewVal As Boolean)
    bEnlarge = NewVal
    PropertyChanged "Enlarge"
    UserControl_Resize
End Property

Public Property Get SizeGrip() As Boolean
    SizeGrip = bSizeGrip
End Property
Public Property Let SizeGrip(ByVal NewVal As Boolean)
    bSizeGrip = NewVal
    PropertyChanged "SizeGrip"
    UserControl_Show
End Property

'''

Private Sub UserControl_Initialize()
    scrV.Width = GetSystemMetrics(SM_CXVSCROLL)
    scrH.Height = GetSystemMetrics(SM_CYHSCROLL)
    
    picRightBottom.Width = scrV.Width
    picRightBottom.Height = scrH.Height
    
    lScrollBars = scbScrollBarBoth
    
    sControl = ""
    
    iMinWidth = 0
    iMinHeight = 0
    
    iMaxWidth = 0
    iMaxHeight = 0
    
    bReduce = False
    bEnlarge = False

    bSizeGrip = False
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        ScrollBars = .ReadProperty("ScrollBars", scbScrollBarBoth)
        MinWidth = .ReadProperty("MinWidth", 0)
        MinHeight = .ReadProperty("MinHeight", 0)
        MaxWidth = .ReadProperty("MaxWidth", 0)
        MaxHeight = .ReadProperty("MaxHeight", 0)
        Reduce = .ReadProperty("Reduce", False)
        Enlarge = .ReadProperty("Enlarge", False)
        SizeGrip = .ReadProperty("SizeGrip", False)
    End With
End Sub

Private Sub UserControl_Show()
    If bSizeGrip Then
        With tRect
            .Left = 0
            .Top = 0
            .Right = scrV.Width
            .Bottom = scrH.Height
        End With
    
        DrawFrameControl picRightBottom.hDC, tRect, DFC_SCROLL, DFCS_SCROLLSIZEGRIP
        picRightBottom.Refresh
    Else
        picRightBottom.Cls
    End If

    scrH.ZOrder 0
    scrV.ZOrder 0
    picRightBottom.ZOrder 0
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    With PropBag
        .WriteProperty "ScrollBars", ScrollBars, scbScrollBarBoth
        .WriteProperty "MinWidth", MinWidth, 0
        .WriteProperty "MinHeight", MinHeight, 0
        .WriteProperty "MaxWidth", MaxWidth, 0
        .WriteProperty "MaxHeight", MaxHeight, 0
        .WriteProperty "Reduce", Reduce, False
        .WriteProperty "Enlarge", Enlarge, False
        .WriteProperty "SizeGrip", SizeGrip, False
    End With
End Sub

Private Sub UserControl_Resize()
    Dim iLeft As Integer
    Dim iTop As Integer
    Dim iWidth As Integer
    Dim iHeight As Integer
    Dim bSet As Boolean
    
    iTop = ScaleHeight - scrH.Height
    If iTop < 0 Then iTop = 0
    
    iWidth = ScaleWidth - scrV.Width
    If iWidth < 0 Then iWidth = 0
    
    scrH.Move 0, iTop, iWidth
    
    iLeft = ScaleWidth - scrV.Width
    If iLeft < 0 Then iLeft = 0
    
    iHeight = ScaleHeight - scrH.Height
    If iHeight < 0 Then iHeight = 0
    
    scrV.Move iLeft, 0, scrV.Width, iHeight
    
    picRightBottom.Move ScaleWidth - picRightBottom.Width, ScaleHeight - picRightBottom.Height
    
    If Not Ambient.UserMode Then Exit Sub
    
    If UserControl.ContainedControls.Count = 0 Then Exit Sub
    
    bSet = False
    
    If iCtlWidth > ScaleWidth Then
        If bReduce Then
            If ScaleWidth > iMinWidth Then
                SetControlWidth ScaleX(ScaleWidth, vbPixels, vbTwips)
            Else
                SetControlWidth ScaleX(iMinWidth, vbPixels, vbTwips)
                bSet = True
            End If
        Else
            SetControlWidth ScaleX(iCtlWidth, vbPixels, vbTwips)
            bSet = True
        End If
    Else
        If bEnlarge Then
            If (ScaleWidth < iMaxWidth) Or (iMaxWidth = 0) Then
                SetControlWidth ScaleX(ScaleWidth, vbPixels, vbTwips)
            Else
                SetControlWidth ScaleX(iMaxWidth, vbPixels, vbTwips)
                bSet = True
            End If
        Else
            SetControlWidth ScaleX(iCtlWidth, vbPixels, vbTwips)
            bSet = True
        End If
    End If
    
    If iCtlHeight > ScaleHeight Then
        If bReduce Then
            If ScaleHeight > iMinHeight Then
                SetControlHeight ScaleY(ScaleHeight, vbPixels, vbTwips)
            Else
                SetControlHeight ScaleY(iMinHeight, vbPixels, vbTwips)
                bSet = True
            End If
        Else
            SetControlHeight ScaleY(iCtlHeight, vbPixels, vbTwips)
            bSet = True
        End If
    Else
        If bEnlarge Then
            If (ScaleHeight < iMaxHeight) Or (iMaxHeight = 0) Then
                SetControlHeight ScaleY(ScaleHeight, vbPixels, vbTwips)
            Else
                SetControlHeight ScaleY(iMaxHeight, vbPixels, vbTwips)
                bSet = True
            End If
        Else
            SetControlHeight ScaleY(iCtlHeight, vbPixels, vbTwips)
            bSet = True
        End If
    End If

    If bSet Then
        SetScrollBars
    Else
        UserControl.ContainedControls(0).Move 0, 0
        scrV.Visible = False
        scrH.Visible = False
        picRightBottom.Visible = False
    End If
End Sub
'
' scrV
'
Private Sub scrV_Change()
    If UserControl.ContainedControls.Count > 0 Then
        UserControl.ContainedControls(0).Top = ScaleY(-scrV.Value, vbPixels, vbTwips)
    End If
End Sub

Private Sub scrV_Scroll()
    If UserControl.ContainedControls.Count > 0 Then
        UserControl.ContainedControls(0).Top = ScaleY(-scrV.Value, vbPixels, vbTwips)
    End If
End Sub
'
' scrH
'
Private Sub scrH_Change()
    If UserControl.ContainedControls.Count > 0 Then
        UserControl.ContainedControls(0).Left = ScaleX(-scrH.Value, vbPixels, vbTwips)
    End If
End Sub

Private Sub scrH_Scroll()
    If UserControl.ContainedControls.Count > 0 Then
        UserControl.ContainedControls(0).Left = ScaleX(-scrH.Value, vbPixels, vbTwips)
    End If
End Sub

'''

Private Sub SetControlWidth(ByVal iWidth As Integer)
    If UserControl.ContainedControls.Count > 0 Then
        If UserControl.ContainedControls(0).Width <> iWidth Then
            UserControl.ContainedControls(0).Width = iWidth
        End If
    End If
End Sub

Private Sub SetControlHeight(ByVal iHeight As Integer)
    If UserControl.ContainedControls.Count > 0 Then
        If UserControl.ContainedControls(0).Height <> iHeight Then
            UserControl.ContainedControls(0).Height = iHeight
        End If
    End If
End Sub

Private Sub SetScrollBars()
    Dim iWidth As Integer
    Dim iHeight As Integer
    Dim bScrH As Boolean
    Dim bScrV As Boolean
    Dim iScrWidth As Integer
    Dim iScrHeight As Integer
    Dim i As Integer
    Dim iHeightSum
    
    If UserControl.ContainedControls.Count = 0 Then Exit Sub
    
    iWidth = ScaleX(UserControl.ContainedControls(0).Width, vbTwips, vbPixels)
    iHeight = ScaleY(UserControl.ContainedControls(0).Height, vbTwips, vbPixels)
    
    bScrH = False
    bScrV = False
    
    scrV.Visible = False
    scrH.Visible = False
    
    ' scrV / scrH ?
    
    iScrWidth = 0
    iScrHeight = 0
    
    If ScaleHeight < iHeight Then
        bScrV = True
        scrV.Visible = True
        If (ScaleWidth - scrV.Width) < iWidth Then
            If (lScrollBars And scbScrollBarHorizontal) = scbScrollBarHorizontal Then
                bScrH = True
                scrH.Visible = True
            End If
        End If
    End If
    
    If ScaleWidth < iWidth Then
        bScrH = True
        scrH.Visible = True
        If (ScaleHeight - scrH.Height) < iHeight Then
            If (lScrollBars And scbScrollBarVertical) = scbScrollBarVertical Then
                bScrV = True
                scrV.Visible = True
            End If
        End If
    End If
    
    If (lScrollBars And scbScrollBarVertical) = 0 Then scrH.Visible = False
    If (lScrollBars And scbScrollBarHorizontal) = 0 Then scrH.Visible = False
    
    If scrV.Visible Then iScrWidth = scrV.Width
    If scrH.Visible Then iScrHeight = scrH.Height
    
    If (ScaleHeight - iScrHeight) > 0 Then
        scrV.Height = ScaleHeight - iScrHeight
    End If
    If (ScaleWidth - iScrWidth) > 0 Then
        scrH.Width = ScaleWidth - iScrWidth
    End If
    
    If scrV.Visible And scrH.Visible Then
        picRightBottom.Visible = True
    Else
        picRightBottom.Visible = False
    End If
    
    ' scrV
        
    If (ScaleHeight - iScrHeight) < iHeight Then
        scrV.Max = iHeight - (ScaleHeight - iScrHeight)
        If (ScaleHeight - iScrHeight) > 0 Then
            scrV.LargeChange = (ScaleHeight - iScrHeight)
        Else
            scrV.LargeChange = 1
        End If
    Else
        scrV.Max = 0
    End If
    
    ' scrH
    
    If (ScaleWidth - iScrWidth) < iWidth Then
        scrH.Max = iWidth - (ScaleWidth - iScrWidth)
        If (ScaleWidth - iScrWidth) > 0 Then
            scrH.LargeChange = (ScaleWidth - iScrWidth)
        Else
            scrH.LargeChange = 1
        End If
    Else
        scrH.Max = 0
    End If
End Sub

