VERSION 5.00
Begin VB.UserControl SepLine 
   CanGetFocus     =   0   'False
   ClientHeight    =   360
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3405
   ScaleHeight     =   24
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   227
   Begin VB.Line Line2 
      X1              =   4
      X2              =   220
      Y1              =   8
      Y2              =   8
   End
   Begin VB.Line Line1 
      X1              =   4
      X2              =   220
      Y1              =   4
      Y2              =   4
   End
End
Attribute VB_Name = "SepLine"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum SepLineTypeConstants
    sepTypeHorizontal
    sepTypeVertical
End Enum

Private lType As SepLineTypeConstants

Public Property Get SepLineType() As SepLineTypeConstants
    SepLineType = lType
End Property
Public Property Let SepLineType(ByVal NewVal As SepLineTypeConstants)
    If NewVal <> lType Then
        lType = NewVal
    
        Select Case lType
            Case sepTypeHorizontal: UserControl.Width = UserControl.Height
            Case sepTypeVertical:   UserControl.Height = UserControl.Width
        End Select
        
        UserControl_Resize
        
        PropertyChanged "SepLineType"
    End If
End Property

Public Property Get HighlightColor() As OLE_COLOR
    HighlightColor = Line2.BorderColor
End Property
Public Property Let HighlightColor(ByVal NewVal As OLE_COLOR)
    Line2.BorderColor = NewVal
    PropertyChanged "HighlightColor"
End Property

Public Property Get ShadowColor() As OLE_COLOR
    ShadowColor = Line1.BorderColor
End Property
Public Property Let ShadowColor(ByVal NewVal As OLE_COLOR)
    Line1.BorderColor = NewVal
    PropertyChanged "ShadowColor"
End Property

Private Sub UserControl_Initialize()
    Line1.BorderColor = vb3DShadow
    Line2.BorderColor = vb3DHighlight
End Sub

Private Sub UserControl_Resize()
    Select Case lType
                    
        Case sepTypeHorizontal:
        
            If UserControl.Height <> ScaleY(2, vbPixels, vbTwips) Then
                UserControl.Height = ScaleY(2, vbPixels, vbTwips)
            End If
            
            With Line1
                .X1 = 0
                .X2 = UserControl.ScaleWidth
                .Y1 = 0
                .Y2 = 0
            End With
        
            With Line2
                .X1 = 0
                .X2 = UserControl.ScaleWidth
                .Y1 = 1
                .Y2 = 1
            End With
            
        Case sepTypeVertical:
            If UserControl.Width <> ScaleY(2, vbPixels, vbTwips) Then
                UserControl.Width = ScaleY(2, vbPixels, vbTwips)
            End If
            
            With Line1
                .X1 = 0
                .X2 = 0
                .Y1 = 0
                .Y2 = UserControl.ScaleHeight
            End With
        
            With Line2
                .X1 = 1
                .X2 = 1
                .Y1 = 0
                .Y2 = UserControl.ScaleHeight
            End With
    End Select
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    On Error Resume Next
    lType = PropBag.ReadProperty("SepLineType", sepTypeHorizontal)
    HighlightColor = PropBag.ReadProperty("HighlightColor", vb3DHighlight)
    ShadowColor = PropBag.ReadProperty("ShadowColor", vb3DShadow)
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    On Error Resume Next
    PropBag.WriteProperty "SepLineType", SepLineType, sepTypeHorizontal
    PropBag.WriteProperty "HighlightColor", HighlightColor, vb3DHighlight
    PropBag.WriteProperty "ShadowColor", ShadowColor, vb3DShadow
End Sub

