VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ServerObject"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
 Option Explicit

' Return Codes

Public Enum DBMSOBRCConstants
    DBMSOB_RC_OK = 0                 ' everything works fine
    DBMSOB_RC_USR_UNKNOWN = -1       ' user not exist
    DBMSOB_RC_USR_FALSE = -2         ' wrong username password combination
    DBMSOB_RC_MEMORY = -3            ' memory error
    DBMSOB_RC_COMMERR = -4           ' tsp01_CommErr is set
    DBMSOB_RC_TOSMALL = -5           ' communication buffer to small
    DBMSOB_RC_INVSESSION = -6        ' invalid session
    DBMSOB_RC_NOMOREDATA = -7        ' no more data in packet
    DBMSOB_RC_RELEASED = -8          ' session released
    DBMSOB_RC_NOT_OK = -100          ' common error
End Enum

' Error Codes

Public Enum DBMSOBERRConstants
    DBMSOB_ERR_ = -24999
    DBMSOB_ERR_NOTIMPL = -24998
    DBMSOB_ERR_FILE = -24997
    DBMSOB_ERR_PARAM = -24996
    DBMSOB_ERR_MEM = -24995
    DBMSOB_ERR_RTE = -24994
    DBMSOB_ERR_RTEEXT = -24993
    DBMSOB_ERR_NOUTILSESSION = -24992
    DBMSOB_ERR_NOSQLUSERSESSION = -24991
    DBMSOB_ERR_NOBACKUPSESSION = -24990
    
    DBMSOB_ERR_NOHISTORYSESSION = -24989
    DBMSOB_ERR_SQL = -24988
    DBMSOB_ERR_TOSMALL = -24987
    DBMSOB_ERR_NOMEDIA = -24986
    DBMSOB_ERR_MENOTFOUND = -24985
    DBMSOB_ERR_MENOVALID = -24984
    DBMSOB_ERR_BANOVALIDTYPE = -24983
    DBMSOB_ERR_NOHISTORY = -24982
    DBMSOB_ERR_HIENTRYNOTFOUND = -24981
    DBMSOB_ERR_NOHELP = -24980
    
    DBMSOB_ERR_XPNOTFOUND = -24979
    DBMSOB_ERR_XPSYNTAX = -24978
    DBMSOB_ERR_COMMAND = -24977
    DBMSOB_ERR_PARAMEXIST = -24976
    DBMSOB_ERR_NOXPSESSION = -24975
    DBMSOB_ERR_XPSESSION = -24974
    DBMSOB_ERR_XPCHECK = -24973
    DBMSOB_ERR_XPINVCONF = -24972
    DBMSOB_ERR_XPNOCHECK = -24971
    DBMSOB_ERR_XPNOMODIFY = -24970
    
    DBMSOB_ERR_XPDIRTY = -24969
    DBMSOB_ERR_XPREADONLY = -24968
    DBMSOB_ERR_SYSTEM = -24967
    DBMSOB_ERR_LOGON = -24966
    DBMSOB_ERR_SYSLOGON = -24965
    DBMSOB_ERR_EXECUTE = -24964
    DBMSOB_ERR_DEVCHECK = -24963
    DBMSOB_ERR_DEVTYPE = -24962
    DBMSOB_ERR_STATE = -24961
    DBMSOB_ERR_DBRUN = -24960
    
    DBMSOB_ERR_XPOVERFLOW = -24959
    DBMSOB_ERR_BAOVERWRITE = -24958
    DBMSOB_ERR_NOUSER = -24957
    DBMSOB_ERR_BASAVETYPECON = -24956
    DBMSOB_ERR_BANOSAVETYPE = -24955
    DBMSOB_ERR_BANOAUTOMED = -24954
    DBMSOB_ERR_DBEXIST = -24953
    DBMSOB_ERR_USRSAVE = -24952
    DBMSOB_ERR_USRREAD = -24951
    DBMSOB_ERR_USRFAIL = -24950
    
    DBMSOB_ERR_USREXISTS = -24949
    DBMSOB_ERR_NODBNAME = -24948
    DBMSOB_ERR_DBNAME = -24947
    DBMSOB_ERR_TOMANYPARAM = -24946
    DBMSOB_ERR_TOFEWPARAM = -24945
    DBMSOB_ERR_USRDELSELF = -24944
    DBMSOB_ERR_USRDELCOLD = -24943
    DBMSOB_ERR_USRDELSDBA = -24942
    DBMSOB_ERR_NEEDLOGON = -24941
    DBMSOB_ERR_NEEDSYSLOGON = -24940
    
    DBMSOB_ERR_LASTREG = -24939
    DBMSOB_ERR_NOENTRY = -24938
    DBMSOB_ERR_MISSRIGHT = -24937
    DBMSOB_ERR_DBNORUN = -24936
    DBMSOB_ERR_NOUSERS = -24935
    DBMSOB_ERR_VERSION = -24934
    DBMSOB_ERR_NOSERVICESESSION = -24933
    DBMSOB_ERR_XPMIN = -24932
    DBMSOB_ERR_XPMAX = -24931
    DBMSOB_ERR_XPVALUESET = -24930
    
    DBMSOB_ERR_UNKNOWN = -24000
End Enum

'''

' commands with user informations
Const DBMSRV_CMD_DB_CREATE = "DB_CREATE"
Const DBMSRV_CMD_UTIL_CONNECT = "UTIL_CONNECT"
Const DBMSRV_CMD_UTIL_ACTIVATE = "UTIL_ACTIVATE"
Const DBMSRV_CMD_SQL_CONNECT = "SQL_CONNECT"
Const DBMSRV_CMD_LOAD_SYSTAB = "LOAD_SYSTAB"
Const DBMSRV_CMD_USER_LOGON = "USER_LOGON"
Const DBMSRV_CMD_USER_SYSTEM = "USER_SYSTEM"

'''

Private Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)

'''
#Const UNICODE = True

#If Not UNICODE Then

' Database Manager Api Declarations

Private Declare Function SRVConnect Lib "dbmapi.dll" Alias "cn14connectDBM" ( _
    ByVal sNode As String, _
    ByVal sDatabase As String, _
    ByVal sInstRoot As String, _
    lSession As Long, _
    ByVal sErrorText As String) As Long
    
Private Declare Function SRVConnectUser Lib "dbmapi.dll" Alias "cn14connectDBMUsr" ( _
    ByVal sNode As String, _
    ByVal sDatabase As String, _
    ByVal sInstRoot As String, _
    ByVal sUser As String, _
    lSession As Long, _
    ByVal sErrorText As String) As Long
    
Private Declare Sub SRVRelease Lib "dbmapi.dll" Alias "cn14release" ( _
    lSession As Long)
    
Private Declare Function SRVRequest Lib "dbmapi.dll" Alias "cn14cmdRequest" ( _
    ByVal lSession As Long, _
    ByVal sData As String, _
    ByVal lLen As Long, _
    ByVal sErrorText As String) As Long
    
Private Declare Function SRVReceive Lib "dbmapi.dll" Alias "cn14replyReceive" ( _
    ByVal lSession As Long, _
    ByVal sData As String, _
    lLen As Long, _
    ByVal sErrorText As String) As Long
    
Private Declare Function SRVExecute Lib "dbmapi.dll" Alias "cn14cmdExecute" ( _
    ByVal lSession As Long, _
    ByVal sDataIn As String, _
    ByVal lLenIn As Long, _
    ByVal sDataOut As String, _
    lLenOut As Long, _
    ByVal sErrorText As String) As Long
    
Private Declare Function SRVAvailable Lib "dbmapi.dll" Alias "cn14replyAvailable" ( _
    ByVal lSession As Long, _
    ByVal sErrorText As String) As Long
    
Private Declare Sub SRVCancel Lib "dbmapi.dll" Alias "cn14cmdCancel" ( _
    ByVal lSession As Long)
    
Private Declare Sub SRVPacketState Lib "dbmapi.dll" Alias "cn14packetstats" ( _
    ByVal lSession As Long, _
    lSize As Long, _
    lLen As Long, _
    lPos As Long)

#End If

'''

Const RS_OK = "OK"
Const RS_ERR = "ERR"

Const ERROR_SIZE = 1024

'''

Private sServerName As String
Private sDatabaseName As String
Private sUserName As String
Private sPassword As String
Private sInstRoot As String

'''

Private lReturnCode As Long

Private lSession As Long
Private sError As String

Private sErrorText As String
Private sErrorValue As String
Private sErrorData As String
Private sErrorShortText As String

Private lSQLErrorNumber As Long
Private sSQLErrorText As String

Private bErrorRaise As Boolean

'''

Private lPacketSize As Long
Private lPacketLen As Long
Private lPacketPos As Long

'''

Private sLastCommand As String
Private sLastData As String

'''

Private bCancel As Boolean
Private bCanceled As Boolean
'''

Private bBusy As Boolean
Private lBusy As Long

'''

Private lSleep As Long

'''

Public Event BusyStateChanged(ByVal Busy As Boolean)
Public Event Error(ByVal ReturnCode As Long, ByVal ErrorText As String)

'''

#If DBG Then
Private oDbgTrace As Object
#End If

' Public

Public Property Get ServerName() As String
    ServerName = sServerName
End Property
Public Property Get DatabaseName() As String
    DatabaseName = sDatabaseName
End Property
Public Property Get InstRoot() As String
    InstRoot = sInstRoot
End Property
Public Property Get UserName() As String
    UserName = sUserName
End Property
Public Property Get Password() As String
    Password = sPassword
End Property

'''

Public Property Get ReturnCode() As Long
    ReturnCode = lReturnCode
End Property
Public Property Get ErrorText() As String
    ErrorText = sErrorText
End Property
Public Property Get ErrorValue() As String
    ErrorValue = sErrorValue
End Property
Public Property Get ErrorData() As String
    ErrorData = sErrorData
End Property
Public Property Get ErrorShortText() As String
    ErrorShortText = sErrorShortText
End Property
Public Property Get SQLErrorNumber() As Long
    SQLErrorNumber = lSQLErrorNumber
End Property
Public Property Get SQLErrorText() As String
    SQLErrorText = sSQLErrorText
End Property

'''

Public Property Get LastCommand() As String
    LastCommand = sLastCommand
End Property
Public Property Get LastData() As String
    LastData = sLastData
End Property

'''

Public Property Get IsOpen() As Boolean
    IsOpen = (lSession <> 0)
End Property

Public Property Get Busy() As Boolean
    Busy = bBusy
End Property
Public Property Let Busy(ByVal NewVal As Boolean)
    Select Case NewVal
        
        Case True:
            lBusy = lBusy + 1
            If Not bBusy Then
                bBusy = True
                RaiseEvent BusyStateChanged(bBusy)
                DoEvents
           End If
        
        Case False:
            lBusy = lBusy - 1
            If bBusy And lBusy = 0 Then
                bBusy = False
                RaiseEvent BusyStateChanged(bBusy)
                DoEvents
            End If
    
    End Select
End Property

Public Property Get AsyncSleep() As Long
    AsyncSleep = lSleep
End Property
Public Property Let AsyncSleep(ByVal NewVal As Long)
    lSleep = NewVal
End Property

Public Property Get ErrorRaise() As Boolean
    ErrorRaise = bErrorRaise
End Property
Public Property Let ErrorRaise(ByVal NewVal As Boolean)
    bErrorRaise = NewVal
End Property

Public Property Get Canceled() As Boolean
    Canceled = bCanceled
End Property

'''

Public Function OpenSession(Optional ServerName As String = "", _
                            Optional DatabaseName As String = "", _
                            Optional UserName As String = "", _
                            Optional Password As String = "", _
                            Optional InstRoot As String = "", _
                            Optional Prompt As Boolean = False) As Boolean

    #If DBG Then
    T "OpenSession(" + ServerName + "," + DatabaseName + "," + InstRoot + "," + UserName + ",*," + CStr(Prompt) + ") = "
    #End If

    Dim bOK As Boolean
    Dim sUser As String
    Dim f As frmPrompt
    
    If bBusy Then
        #If DBG Then
        TA "Busy"
        #End If
        OpenSession = False
        Exit Function
    End If
    
    Busy = True
    
    If Prompt Then
        Set f = New frmPrompt
        
        If Not f.GetParams(ServerName, DatabaseName, UserName, Password) Then
            #If DBG Then
            TA "Cancel"
            #End If
            OpenSession = False
            Exit Function
        End If
    End If
    
    If lSession <> 0 Then
        CloseSession
    End If
    
    sServerName = ServerName
    sDatabaseName = DatabaseName
    sUserName = UserName
    sPassword = Password
    sInstRoot = InstRoot
    
    If Len(sUserName) > 0 Then
        sUser = sUserName
        If Len(sPassword) > 0 Then
            sUser = sUser & "," & Password
        End If
    Else
        sUser = ""
    End If
    
    ClearError
    
    If Len(sUser) > 0 Then
        #If UNICODE Then
            If StrPtr(sServerName) = 0 Then sServerName = Empty
            If StrPtr(sDatabaseName) = 0 Then sDatabaseName = Empty
            If StrPtr(sInstRoot) = 0 Then sInstRoot = Empty
            If StrPtr(sUser) = 0 Then sUser = Empty
            lReturnCode = DBMAPI.ConnectUser(sServerName, sDatabaseName, sInstRoot, sUser, lSession, sError)
        #Else
            lReturnCode = SRVConnectUser(sServerName, sDatabaseName, sInstRoot, sUser, lSession, sError)
        #End If
    Else
        #If UNICODE Then
            If StrPtr(sServerName) = 0 Then sServerName = Empty
            If StrPtr(sDatabaseName) = 0 Then sDatabaseName = Empty
            If StrPtr(sInstRoot) = 0 Then sInstRoot = Empty
            lReturnCode = DBMAPI.Connect(sServerName, sDatabaseName, sInstRoot, lSession, sError)
        #Else
            lReturnCode = SRVConnect(sServerName, sDatabaseName, sInstRoot, lSession, sError)
        #End If
    End If
    
    FormatError
    
    If lReturnCode = DBMSOB_RC_OK Then
        #If UNICODE Then
            DBMAPI.PacketState lSession, lPacketSize, lPacketLen, lPacketPos
        #Else
            SRVPacketState lSession, lPacketSize, lPacketLen, lPacketPos
        #End If
        bOK = True
    Else
        GetRCText
        RaiseError
    End If
    
    Busy = False
    
    If Not bOK Then Reset
    
    OpenSession = bOK
    
    #If DBG Then
    If Not bOK Then
        TA "ERROR " + CStr(lReturnCode)
    Else
        TA "OK"
    End If
    #End If
End Function

Public Function Command(CommandStr As String, _
                        Data As String, _
                        Optional ByVal Asynchron As Boolean = True) As Boolean

    If Asynchron Then
        Command = CommandAsync(CommandStr, Data)
    Else
        Command = CommandNorm(CommandStr, Data)
    End If
End Function

Public Function CommandAsync(CommandStr As String, _
                             Data As String) As Boolean

    Dim sViewCmd As String
    Dim bOK As Boolean
    Dim lLen As Long
    Dim bWait As Boolean
    
    sViewCmd = GetViewCommand(CommandStr)
    
    #If DBG Then
    T "CommandAsync(" & sViewCmd & ") = "
    #End If

    bOK = False

    If bBusy Then
        #If DBG Then
        TA "Busy"
        #End If
        CommandAsync = False
        Exit Function
    End If
    
    Busy = True

    bCancel = False
    bCanceled = False
    
    sLastCommand = sViewCmd
    sLastData = ""

    ClearError
    #If UNICODE Then
        If StrPtr(CommandStr) = 0 Then CommandStr = Empty
        lReturnCode = DBMAPI.Request(lSession, CommandStr, Len(CommandStr), sError)
    #Else
        lReturnCode = SRVRequest(lSession, CommandStr, Len(CommandStr), sError)
    #End If
    FormatError
    
    If lReturnCode = DBMSOB_RC_OK Then
        
        bWait = True
        
        Do While bWait
        
            Sleep lSleep

            DoEvents
            
            ClearError
            #If UNICODE Then
                lReturnCode = DBMAPI.Available(lSession, sError)
            #Else
                lReturnCode = SRVAvailable(lSession, sError)
            #End If
            FormatError

            Select Case lReturnCode
                        
                Case DBMSOB_RC_OK:
                
                    Data = Space$(lPacketSize)
                    lLen = lPacketSize
                
                    ClearError
                    #If UNICODE Then
                        lReturnCode = DBMAPI.Receive(lSession, Data, lLen, sError)
                    #Else
                        lReturnCode = SRVReceive(lSession, Data, lLen, sError)
                    #End If
                    FormatError
                    
                    If lReturnCode = DBMSOB_RC_OK Then
                        Data = Left$(Data, lLen)
                        If CheckError(Data) Then
                            bOK = True
                        End If
                    End If

                    bWait = False

                Case DBMSOB_RC_COMMERR:
                    
                    GetRCText
                    bWait = Not bCancel 'True

                Case Else:
                
                    GetRCText
                    bWait = False

            End Select
            
            If bCancel Then
                #If UNICODE Then
                    DBMAPI.Cancel lSession
                #Else
                    SRVCancel lSession
                #End If
                bWait = False
            End If
        Loop
    Else
        GetRCText
    End If
    
    If lReturnCode = DBMSOB_RC_COMMERR And bCancel Then
        bCanceled = True
    End If
    
    If lReturnCode <> DBMSOB_RC_OK Then
        RaiseError
    End If

    Busy = False
    
    CommandAsync = bOK
    
    #If DBG Then
    If bCancel Then
        T "CommandAsync(" & sViewCmd & ") = CANCELED"
    Else
        If Not bOK Then
            TA "ERROR " + CStr(lReturnCode) + " " + sErrorText
        Else
            TA "OK"
        End If
    End If
    #End If
End Function

Public Function CommandNorm(CommandStr As String, _
                            Data As String) As Boolean

    Dim sViewCmd As String
    Dim bOK As Boolean
    Dim lLen As Long
    
    sViewCmd = GetViewCommand(CommandStr)
    
    #If DBG Then
    T "CommandNorm(" & sViewCmd & ") = "
    #End If
    
    bOK = False

    sLastCommand = sViewCmd
    sLastData = ""
    
    Data = Space$(lPacketSize)
    lLen = lPacketSize

    ClearError
    #If UNICODE Then
        If StrPtr(CommandStr) = 0 Then CommandStr = Empty
        lReturnCode = DBMAPI.Execute(lSession, CommandStr, Len(CommandStr), Data, lLen, sError)
    #Else
        lReturnCode = SRVExecute(lSession, CommandStr, Len(CommandStr), Data, lLen, sError)
    #End If
    FormatError
    
    If lReturnCode = DBMSOB_RC_OK Then
        Data = Left$(Data, lLen)
        If CheckError(Data) Then
            bOK = True
        Else
            RaiseError
        End If
    Else
        GetRCText
        RaiseError
    End If

    CommandNorm = bOK
    
    #If DBG Then
    If Not bOK Then
        TA "ERROR " + CStr(lReturnCode) + " " + sErrorText
    Else
        TA "OK"
    End If
    #End If
End Function

Public Sub CloseSession()
    #If DBG Then
    T "CloseSession()"
    #End If

    #If UNICODE Then
        DBMAPI.Release lSession
    #Else
        SRVRelease lSession
    #End If
            
    Reset
End Sub

Public Sub Cancel()
    #If DBG Then
    T "Cancel(" + sLastCommand + ")"
    #End If

    bCancel = True
    bCanceled = False
End Sub

Public Sub RaiseError()
    If bErrorRaise Then
        RaiseEvent Error(lReturnCode, sErrorText)
    End If
End Sub

'''

Private Sub Reset()
    lSession = 0
    
    sServerName = ""
    sDatabaseName = ""
    sUserName = ""
    sPassword = ""
    sInstRoot = ""
    
    bBusy = False
    lBusy = 0
    
    lSleep = 1
    
    bErrorRaise = True
End Sub

Private Sub ClearError()
    lReturnCode = DBMSOB_RC_OK
    sError = Space$(ERROR_SIZE)
    sErrorText = ""
    sErrorValue = ""
    sErrorData = ""
    sErrorShortText = ""
    lSQLErrorNumber = 0
    sSQLErrorText = ""
End Sub

Private Sub FormatError()
    Dim lPos As Long
    lPos = InStr(1, sError, Chr(0))
    If lPos > 0 Then sError = Trim$(Left$(sError, lPos - 1))
    sErrorText = Trim$(sError)
End Sub

Private Sub GetRCText()
    Select Case lReturnCode
        Case DBMSOB_RC_OK:          sErrorText = "everything works fine"
        Case DBMSOB_RC_USR_UNKNOWN: sErrorText = "user not exist"
        Case DBMSOB_RC_USR_FALSE:   sErrorText = "wrong username password combination"
        Case DBMSOB_RC_MEMORY:      sErrorText = "memory error"
        Case DBMSOB_RC_COMMERR:     sErrorText = "communication error"
        Case DBMSOB_RC_TOSMALL:     sErrorText = "communication buffer to small"
        Case DBMSOB_RC_INVSESSION:  sErrorText = "invalid session"
        Case DBMSOB_RC_NOMOREDATA:  sErrorText = "no more data in packet"
        Case DBMSOB_RC_RELEASED:    sErrorText = "session released"
        Case DBMSOB_RC_NOT_OK:      sErrorText = "common error"
        Case Else:                  sErrorText = "unknown returncode"
    End Select
    sErrorValue = ""
    sErrorData = ""
    sErrorShortText = ""
    lSQLErrorNumber = 0
    sSQLErrorText = ""
End Sub

Private Function CheckError(sData As String) As Boolean
    Dim bOK As Boolean
    Dim sRC As String
    Dim lDataPos As Long
    Dim sLine As String
    Dim lPos1 As Long
    Dim lPos2 As Long

    ClearError

    lDataPos = 1
    sRC = Trim$(GetLine(sData, lDataPos))

    If Left$(sRC, Len(RS_OK)) = RS_OK Then

        lReturnCode = DBMSOB_RC_OK

        sData = Mid$(sData, lDataPos)
        
    ElseIf Left$(sRC, Len(RS_ERR)) = RS_ERR Then
    
        sLine = Trim$(GetLine(sData, lDataPos))
        lPos1 = InStr(1, sLine, ",")
        
        If lPos1 > 1 Then
            lReturnCode = Val(Left$(sLine, lPos1 - 1))
            lPos2 = InStr(lPos1, sLine, ":")
            If lPos2 > 1 Then
                sErrorShortText = Trim$(Mid$(sLine, lPos2 + 1))
                sErrorValue = Trim$(Mid$(sLine, lPos1 + 1, lPos2 - lPos1 - 1))
            Else
                sErrorShortText = Trim$(Mid$(sLine, lPos1 + 1))
            End If
        Else
            lReturnCode = DBMSOB_RC_NOT_OK
            sErrorShortText = sLine
        End If
        
        sErrorShortText = sErrorShortText + " [" + sLastCommand + "]"
        
        sErrorText = sErrorShortText
        
        sErrorData = Mid$(sData, lDataPos)
        
        sLine = Trim$(GetLine(sData, lDataPos))
        If Len(sLine) > 0 Then
            sErrorText = sErrorText + "; " + sLine
        End If
                
        ' SQL error
        If lReturnCode = DBMSOB_ERR_SQL Then
            lPos1 = InStr(1, sLine, ",")
            If lPos1 > 1 Then
                lSQLErrorNumber = Val(Left$(sLine, lPos1 - 1))
                sSQLErrorText = Trim$(Mid$(sLine, lPos1 + 1))
            Else
                sSQLErrorText = sLine
            End If
            
            If UCase$(sSQLErrorText) = "MESSAGE NOT AVAILABLE" Or _
               Trim$(sSQLErrorText) = "" _
            Then
                Select Case lSQLErrorNumber
                    Case -111:  sSQLErrorText = "Incompatible incremental backup"
                    Case -903:  sSQLErrorText = "Host file I/O error"
                    Case -3004: sSQLErrorText = "Invalid host file sequence"
                    Case -7075: sSQLErrorText = "Current SAVE SKIPPED, next is ready to take on this tape"
                    Case -7076: sSQLErrorText = "No more data to read from tape"
                    Case -8003: sSQLErrorText = "Log and data must be compatible"
                    Case -8020: sSQLErrorText = "Next volume required"
                End Select
            End If
        End If
    End If
    
    sLastData = sData

    If lReturnCode = DBMSOB_RC_OK Then
        bOK = True
    Else
        bOK = False
    End If

    CheckError = bOK
End Function

'''

Private Function GetViewCommand(ByVal sCommand As String)
    Dim lPos As Long
    Dim sSrvCmd As String
    Dim sCmd As String
    Dim sView As String
    
    sCmd = Trim$(sCommand)
    
    lPos = InStr(1, sCmd, " ")
    If lPos > 0 Then
        sSrvCmd = Left$(sCmd, lPos - 1)
    Else
        sSrvCmd = sCmd
    End If
    
    Select Case UCase$(sSrvCmd)
        Case DBMSRV_CMD_DB_CREATE:          sView = sSrvCmd + " ..."
        Case DBMSRV_CMD_UTIL_CONNECT:       sView = sSrvCmd + " ..."
        Case DBMSRV_CMD_UTIL_ACTIVATE:      sView = sSrvCmd + " ..."
        Case DBMSRV_CMD_SQL_CONNECT:        sView = sSrvCmd + " ..."
        Case DBMSRV_CMD_LOAD_SYSTAB:        sView = sSrvCmd + " ..."
        Case DBMSRV_CMD_USER_LOGON:         sView = sSrvCmd + " ..."
        Case DBMSRV_CMD_USER_SYSTEM:        sView = sSrvCmd + " ..."
        Case Else:                          sView = sCommand
    End Select
        
    GetViewCommand = sView
End Function

'''

Public Function GetBuf(Data As String, _
                       Pos As Long, _
                       Length As Long) As String
    Dim lP1 As Long

    GetBuf = ""

    If Pos <= Len(Data) Then
        If Length = -1 Then
            GetBuf = Mid$(Data, Pos)
            Pos = Length + 1
        Else
            GetBuf = Mid$(Data, Pos, Length)
            Pos = Pos + Length
        End If
    End If
End Function

Public Function GetLine(Data As String, _
                        Pos As Long) As String
    Dim lP1 As Long
    Dim sLine As String

    sLine = ""

    If Pos <= Len(Data) Then
        lP1 = InStr(Pos, Data, vbLf)
        If lP1 > 0 Then
            If lP1 > 1 Then
                If Mid(Data, lP1 - 1, 1) = vbCr Then
                    sLine = Mid$(Data, Pos, lP1 - Pos - 1)
                Else
                    sLine = Mid$(Data, Pos, lP1 - Pos)
                End If
            Else
                sLine = ""
            End If
            Pos = lP1 + 1
        Else
            sLine = Mid$(Data, Pos)
            Pos = Len(Data) + 1
        End If
    End If

    lP1 = InStr(1, sLine, Chr(0))
    If lP1 > 0 Then sLine = Left$(sLine, lP1 - 1)

    GetLine = sLine
End Function

Public Function GetField(Line As String, _
                         Seperator As String, _
                         Pos As Long) As String
    Dim lP1 As Long

    GetField = ""

    If Pos <= Len(Line) Then
        lP1 = InStr(Pos, Line, Seperator)
        If lP1 > 0 Then
            GetField = Mid$(Line, Pos, lP1 - Pos)
            Pos = lP1 + 1
        Else
            GetField = Mid$(Line, Pos)
            Pos = Len(Line) + 1
        End If
    End If
End Function

Public Function GetProp(Data As String, _
                        Pos As Long, _
                        Value As String) As String
    Dim sLine As String
    Dim lP1 As Long
    
    GetProp = ""
    Value = ""
    
    sLine = Trim$(GetLine(Data, Pos))
    If Len(sLine) > 0 Then
        lP1 = 1
        GetProp = Trim$(GetField(sLine, "=", lP1))
        If lP1 <= Len(sLine) Then
            Value = Trim$(GetField(sLine, "=", lP1))
        End If
    End If
End Function

Public Sub GetBlanks(Line As String, Pos As Long)
    Dim lLen As Long
    Dim lP1 As Long

    lLen = Len(Line)
    lP1 = Pos
    
    If lP1 <= lLen Then
        Do
            If Mid$(Line, lP1, 1) = " " Then
                lP1 = lP1 + 1
            Else
                Exit Do
            End If
        Loop While lP1 < lLen
    End If
    
    Pos = lP1
End Sub

'''

Private Sub Class_Initialize()
    Reset
    ClearError
End Sub

Private Sub Class_Terminate()
    If lSession <> 0 Then CloseSession
End Sub

'''

#If DBG Then

Public Property Get DebugTrace() As Object
    Set DebugTrace = oDbgTrace
End Property
Public Property Set DebugTrace(NewVal As Object)
    Set oDbgTrace = NewVal
End Property

Private Sub T(ByVal sText As String)
    If Not oDbgTrace Is Nothing Then
        oDbgTrace.Text "DBMSOB(0x" + Hex(App.ThreadID) + "): " + sText
    End If
End Sub

Private Sub TA(ByVal sText As String)
    If Not oDbgTrace Is Nothing Then
        oDbgTrace.TextAdd sText
    End If
End Sub

#End If
