VERSION 5.00
Begin VB.UserControl TitleBar 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   BackColor       =   &H80000005&
   CanGetFocus     =   0   'False
   ClientHeight    =   390
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4980
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   26
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   332
   Begin VB.Image imgDisabled 
      Height          =   240
      Left            =   4620
      OLEDropMode     =   1  'Manual
      Picture         =   "TitleBar.ctx":0000
      Top             =   60
      Visible         =   0   'False
      Width           =   240
   End
   Begin VB.Label lblAt 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      Caption         =   "00:00:00"
      Height          =   195
      Left            =   2415
      OLEDropMode     =   1  'Manual
      TabIndex        =   1
      Top             =   60
      Visible         =   0   'False
      Width           =   645
   End
   Begin VB.Image imgButton 
      Height          =   240
      Left            =   4620
      OLEDropMode     =   1  'Manual
      Picture         =   "TitleBar.ctx":0542
      Top             =   60
      Width           =   240
   End
   Begin VB.Label lblCaption 
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      Caption         =   "TitleBar"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   285
      Left            =   900
      OLEDropMode     =   1  'Manual
      TabIndex        =   0
      Top             =   30
      Width           =   885
   End
   Begin VB.Image imgTitle 
      Height          =   255
      Left            =   180
      OLEDropMode     =   1  'Manual
      Top             =   45
      Width           =   255
   End
   Begin VB.Line linTitle 
      X1              =   124
      X2              =   300
      Y1              =   12
      Y2              =   12
   End
End
Attribute VB_Name = "TitleBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 2000-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Private Declare Function GetSysColor Lib "User32.dll" (ByVal nIndex As Long) As Long

Const COLOR_WINDOW = 5
Const COLOR_ACTIVECAPTION = 2

'''

Private Type ColorBytesType
    bRed As Byte
    bGreen As Byte
    bBlue As Byte
    bDummy As Byte
End Type

Private Type ColorType
    lColor As Long
End Type

Private tColorBytes As ColorBytesType
Private tColor As ColorType

'''

Private iButtonLeft As Integer
Private iButtonTop As Integer

'''

Public Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)

Public Event CloseClick()

Private dAt As Date

Private iMinHeight As Integer

Public Property Get Caption() As String
    Caption = lblCaption
End Property
Public Property Let Caption(ByVal NewVal As String)
    lblCaption = NewVal
    SetLine
End Property

Public Property Get At() As Date
    At = dAt
End Property
Public Property Let At(ByVal NewVal As Date)
    dAt = NewVal
    If dAt = 0 Then
        lblAt.Visible = False
    Else
        lblAt.Caption = " " & dAt & " "
        lblAt.Visible = True
    End If
    SetLine
End Property

Public Property Get Picture() As StdPicture
    Set Picture = imgTitle.Picture
End Property
Public Property Set Picture(ByVal NewVal As StdPicture)
    Set imgTitle.Picture = NewVal
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property
Public Property Let Enabled(ByVal NewVal As Boolean)
    UserControl.Enabled = NewVal
    imgButton.Visible = NewVal
    imgDisabled.Visible = Not NewVal
End Property

Private Sub UserControl_Initialize()
    Dim lColor1 As Long
    Dim lColor2 As Long
    
    iMinHeight = lblCaption.Height + 4
    
    imgTitle.Left = 12
    imgTitle.Top = 3
    
    lblCaption.Top = 2
    
    linTitle.Y1 = 12
    linTitle.Y2 = 12
    
    lblAt.Top = 6
    
    lColor1 = GetSysColor(COLOR_ACTIVECAPTION)
    lColor2 = GetSysColor(COLOR_WINDOW)
    
    linTitle.BorderColor = lColor1
    lblAt.ForeColor = lColor1
    
    FillBar 0, lblCaption.Left - 4, lColor1, lColor2, lblCaption.Left - 4
End Sub

Private Sub UserControl_Resize()
    If UserControl.Height <> ScaleY(iMinHeight, vbPixels, vbTwips) Then
        UserControl.Height = ScaleY(iMinHeight, vbPixels, vbTwips)
    End If
    
    imgButton.Move ScaleWidth - imgButton.Width - 4, 4
    imgDisabled.Move ScaleWidth - imgDisabled.Width - 4, 4
    
    iButtonLeft = imgButton.Left
    iButtonTop = imgButton.Top
        
    SetLine
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'''

Private Sub imgTitle_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
Private Sub imgTitle_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'''

Private Sub lblCaption_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
Private Sub lblCaption_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'''

Private Sub lblAt_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
Private Sub lblAt_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'''

Private Sub imgDisabled_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
Private Sub imgDisabled_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'''

Private Sub imgButton_Click()
    RaiseEvent CloseClick
End Sub

Private Sub imgButton_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    imgButton.Move iButtonLeft + 1, iButtonTop + 1
End Sub

Private Sub imgButton_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    imgButton.Move iButtonLeft, iButtonTop
End Sub

Private Sub imgButton_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
End Sub
Private Sub imgButton_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
    RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
End Sub

'''

Private Sub FillBar(ByVal lFirstPos As Long, _
                    ByVal lLastPos As Long, _
                    ByVal lFirstColor As Long, _
                    ByVal lLastColor As Long, _
                    ByVal lWidth As Long)
    Dim sRedStep As Single
    Dim sGreenStep As Single
    Dim sBlueStep As Single
    
    Dim sRed As Single
    Dim sGreen As Single
    Dim sBlue As Single
    
    Dim lPos As Long
    Dim lColor As Long
    
    sRedStep = GetRedStep(lFirstColor, lLastColor, lWidth)
    sGreenStep = GetGreenStep(lFirstColor, lLastColor, lWidth)
    sBlueStep = GetBlueStep(lFirstColor, lLastColor, lWidth)

    sRed = CLng(GetRed(lFirstColor))
    sGreen = CLng(GetGreen(lFirstColor))
    sBlue = CLng(GetBlue(lFirstColor))

    For lPos = lFirstPos To lLastPos
        lColor = RGB(CLng(sRed), CLng(sGreen), CLng(sBlue))
        Line (lPos, 0)-(lPos, ScaleHeight), lColor
        sRed = sRed + sRedStep
        sGreen = sGreen + sGreenStep
        sBlue = sBlue + sBlueStep
    Next
End Sub

Private Function GetRedStep(ByVal lColor1 As Long, ByVal lColor2 As Long, ByVal lWidth As Long) As Single
    GetRedStep = (CSng(GetRed(lColor2) - GetRed(lColor1))) / CSng(lWidth)
End Function

Private Function GetGreenStep(ByVal lColor1 As Long, ByVal lColor2 As Long, ByVal lWidth As Long) As Single
    GetGreenStep = (CSng(GetGreen(lColor2) - GetGreen(lColor1))) / CSng(lWidth)
End Function

Private Function GetBlueStep(ByVal lColor1 As Long, ByVal lColor2 As Long, ByVal lWidth As Long) As Single
    GetBlueStep = (CSng(GetBlue(lColor2) - GetBlue(lColor1))) / CSng(lWidth)
End Function

Private Function GetRed(ByVal lColor As Long) As Long
    tColor.lColor = lColor
    LSet tColorBytes = tColor
    GetRed = CLng(tColorBytes.bRed)
End Function

Private Function GetGreen(ByVal lColor As Long) As Long
    tColor.lColor = lColor
    LSet tColorBytes = tColor
    GetGreen = CLng(tColorBytes.bGreen)
End Function

Private Function GetBlue(ByVal lColor As Long) As Long
    tColor.lColor = lColor
    LSet tColorBytes = tColor
    GetBlue = CLng(tColorBytes.bBlue)
End Function

'''

Private Sub SetLine()
    If (lblCaption.Left + lblCaption.Width + 6) < (imgButton.Left - 6) Then
        linTitle.X1 = lblCaption.Left + lblCaption.Width + 6
        linTitle.X2 = imgButton.Left - 6
        linTitle.Visible = True
        
        If (linTitle.X2 - linTitle.X1) > (lblAt.Width + 12) Then
            If dAt = 0 Then
                lblAt.Visible = False
            Else
                lblAt.Move linTitle.X2 - lblAt.Width - 6
                lblAt.Visible = True
            End If
        Else
            lblAt.Visible = False
        End If
        
    Else
        linTitle.Visible = False
    End If
End Sub


