VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "DevSpace"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "RVB_UniqueId" ,"33F01F23017E"
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Enum DBMWizDevSpaceClassConstans
    dbmWizDSCSys
    dbmWizDSCLog
    dbmWizDSCData
End Enum

Public Enum DBMWizDevSpaceTypeConstants
    dbmWizDSTFile
    dbmWizDSTRaw
    dbmWizDSTLink
End Enum

Const DEVCLASS_SYS = "SYS"
Const DEVCLASS_LOG = "LOG"
Const DEVCLASS_DATA = "DATA"

Const MIRRORED_PREFIX = "M"

Const DEVTYPE_FILE = "FILE"
Const DEVTYPE_RAW = "RAW"
Const DEVTYPE_LINK = "LINK"

Const DEVTYPESHORT_FILE = "F"
Const DEVTYPESHORT_RAW = "R"
Const DEVTYPESHORT_LINK = "L"

Private lClass As DBMDevSpaceClassConstans
Private lType As DBMDevSpaceTypeConstants
Private sLocation As String
Private lSizePages As Long
Private lNumber As Long
Private bMirrored As Boolean
Private lMirroredType As DBMDevSpaceTypeConstants
Private sMirroredLocation As String

'''

Public Property Get Number() As Long
    Number = lNumber
End Property
Public Property Let Number(ByVal NewVal As Long)
    lNumber = NewVal
End Property

Public Property Get DeviceClass() As DBMDevSpaceClassConstans
    DeviceClass = lClass
End Property
Public Property Let DeviceClass(ByVal NewVal As DBMDevSpaceClassConstans)
    lClass = NewVal
End Property

Public Property Get DeviceClassName() As String
    Select Case lClass
        Case dbmDSCSys:     DeviceClassName = DEVCLASS_SYS
        Case dbmDSCLog:     DeviceClassName = DEVCLASS_LOG
        Case dbmDSCData:    DeviceClassName = DEVCLASS_DATA
    End Select
End Property
Public Property Let DeviceClassName(NewVal As String)
    Select Case UCase$(Trim$(NewVal))
        Case DEVCLASS_SYS:     lClass = dbmDSCSys
        Case DEVCLASS_LOG:     lClass = dbmDSCLog
        Case DEVCLASS_DATA:    lClass = dbmDSCData
    End Select
End Property

Public Property Get DeviceType() As DBMDevSpaceTypeConstants
    DeviceType = lType
End Property
Public Property Let DeviceType(ByVal NewVal As DBMDevSpaceTypeConstants)
    lType = NewVal
End Property

Public Property Get DeviceTypeName() As String
    Select Case lType
        Case dbmDSTFile:    DeviceTypeName = DEVTYPE_FILE
        Case dbmDSTRaw:     DeviceTypeName = DEVTYPE_RAW
        Case dbmDSTLink:    DeviceTypeName = DEVTYPE_LINK
    End Select
End Property
Public Property Let DeviceTypeName(NewVal As String)
    Select Case UCase$(Trim$(NewVal))
        Case DEVTYPE_FILE:  lType = dbmDSTFile
        Case DEVTYPE_RAW:   lType = dbmDSTRaw
        Case DEVTYPE_LINK:  lType = dbmDSTLink
    End Select
End Property

Public Property Get SizePages() As Long
    SizePages = lSizePages
End Property
Public Property Let SizePages(ByVal NewVal As Long)
    lSizePages = NewVal
End Property

Public Property Get Location() As String
    Location = sLocation
End Property
Public Property Let Location(NewVal As String)
    sLocation = NewVal
End Property

Public Property Get Mirrored() As Boolean
    Mirrored = bMirrored
End Property
Public Property Let Mirrored(ByVal NewVal As Boolean)
    bMirrored = NewVal
End Property

Public Property Get MirroredDeviceType() As DBMDevSpaceTypeConstants
    MirroredDeviceType = lMirroredType
End Property
Public Property Let MirroredDeviceType(ByVal NewVal As DBMDevSpaceTypeConstants)
    lMirroredType = NewVal
End Property

Public Property Get MirroredDeviceTypeName() As String
    Select Case lMirroredType
        Case dbmDSTFile:    MirroredDeviceTypeName = DEVTYPE_FILE
        Case dbmDSTRaw:     MirroredDeviceTypeName = DEVTYPE_RAW
        Case dbmDSTLink:    MirroredDeviceTypeName = DEVTYPE_LINK
    End Select
End Property
Public Property Let MirroredDeviceTypeName(NewVal As String)
    Select Case UCase$(Trim$(NewVal))
        Case DEVTYPE_FILE:  lMirroredType = dbmDSTFile
        Case DEVTYPE_RAW:   lMirroredType = dbmDSTRaw
        Case DEVTYPE_LINK:  lMirroredType = dbmDSTLink
    End Select
End Property

Public Property Get MirroredLocation() As String
    MirroredLocation = sMirroredLocation
End Property
Public Property Let MirroredLocation(NewVal As String)
    sMirroredLocation = NewVal
End Property

'''

Friend Property Get DeviceClassParam() As String
    Dim sPrefix As String
    
    sPrefix = ""
    
    If bMirrored Then
        sPrefix = MIRRORED_PREFIX
    End If
        
    Select Case lClass
        Case dbmDSCSys:     DeviceClassName = sPrefix + DEVCLASS_SYS
        Case dbmDSCLog:     DeviceClassName = sPrefix + DEVCLASS_LOG
        Case dbmDSCData:    DeviceClassName = sPrefix + DEVCLASS_DATA
    End Select
End Property

Friend Property Get DeviceTypeParam() As String
    Select Case lType
        Case dbmDSTFile:    DeviceTypeParam = DEVTYPESHORT_FILE
        Case dbmDSTRaw:     DeviceTypeParam = DEVTYPESHORT_RAW
        Case dbmDSTLink:    DeviceTypeParam = DEVTYPESHORT_LINK
    End Select
End Property



