Attribute VB_Name = "GLB"
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Public Const DEF_VERNUM = "7.4"

Public Const TXT_PRODUCT = "SAP DB"
Public Const TXT_APPLICATION = "Database Manager Wizard"
Public Const TXT_VERTEXT = "Version"
Public Const TXT_COPYRIGHT = "Copyright  1999-2001 by SAP AG"

Public TXT_VERNUM As String
Public TXT_VERSION As String
Public TXT_TITLE As String

'''

Public Const INFO_DBNAME = "Enter a name for the instance you want to install and the name of the server node where to install the instance."
Public Const INFO_INSTALLS = "Select the version of installation that shall be used for this instance."
Public Const INFO_USERS = "Enter the user name and password for the database manager operator and the database system administrator."
Public Const INFO_PARAMMODE = "Choose the mode of parameter initialization."
Public Const INFO_PARAMS = "The database instance was created successfully. If required, adjust the parameters now."
Public Const INFO_DEVSPACES = "Specify the volumes."
Public Const INFO_INSTMODE = "Choose the mode of installation"
Public Const INFO_INSTALL1 = "Press 'Install' to start the installation."
Public Const INFO_INSTALL2 = "Please wait while the database instance is installed"
Public Const INFO_INSTALL3 = "Installation of database instance successfully finished."
Public Const INFO_INSTALL4 = "An error occurs during installation."
Public Const INFO_INSTREADY1 = "To restore database instance use the Database Manager."

'''

Public Const BUTTON_OPEN = "OPEN"
Public Const BUTTON_SAVE = "SAVE"

'''

Public GUI As DBMWiz.Application
Public FRM As frmWizard
Public RES As New DBMRes.Resource
Public oHG As New Hourglass

'''

Private Declare Sub CheckDBMAPI Lib "dbmapi.dll" Alias "cn14cmdCancel" (ByVal lSession As Long)

'''

Public Sub Main()
    If Not Check() Then Exit Sub

    GetVersion

    If App.StartMode = vbSModeStandalone Then
        Set GUI = New DBMWiz.Application
    End If
End Sub

Private Function Check() As Boolean
    Dim bRC As Boolean
    
    On Error Resume Next
    
    bRC = True
    
    CheckDBMAPI 0
    
    If Err.Number <> 0 Then
        MsgBox "Error " + CStr(Err.Number) + ": " + Err.Description, vbCritical, App.Title
        bRC = False
    End If
    
    Check = bRC
End Function

Private Sub GetVersion()
    Dim oFile As New File
    Dim sMajor As String
    Dim sMinor As String
    Dim sRevision As String
    Dim sPatch As String
    
    oFile.Filename = App.Path & "\DBMGui.exe"
    oFile.Refresh
    If Not oFile.VersionString = "?" Then
        SplitVersion oFile.VersionString, sMajor, sMinor, sRevision, sPatch
    Else
        SplitVersion DEF_VERNUM, sMajor, sMinor, sRevision, sPatch
    End If
    
    If sMajor = "7000" Then
        TXT_VERNUM = DEF_VERNUM
    Else
        TXT_VERNUM = sMajor & "." & sMinor
    End If
    TXT_VERSION = TXT_VERTEXT + " " + TXT_VERNUM
    TXT_TITLE = TXT_APPLICATION + " " + TXT_VERNUM
End Sub

Private Sub SplitVersion(ByVal sVersion As String, _
                         sMajor As String, _
                         sMinor As String, _
                         sRevision As String, _
                         sPatch As String)
    Dim lPos1 As Long
    Dim lPos2 As Long
    
    sMajor = "0"
    sMinor = "0"
    sRevision = "0"
    sPatch = "0"
    
    If Len(sVersion) > 0 Then
        lPos1 = 1
        lPos2 = InStr(lPos1, sVersion, ".")
        If lPos2 > 0 Then
            sMajor = Left$(sVersion, lPos2 - 1)
            lPos1 = lPos2 + 1
            lPos2 = InStr(lPos1, sVersion, ".")
            If lPos2 > 0 Then
                sMinor = Mid$(sVersion, lPos1, lPos2 - lPos1)
                lPos1 = lPos2 + 1
                lPos2 = InStr(lPos1, sVersion, ".")
                If lPos2 > 0 Then
                    sRevision = Mid$(sVersion, lPos1, lPos2 - lPos1)
                    sPatch = Mid$(sVersion, lPos2 + 1)
                Else
                    sRevision = Mid$(sVersion, lPos1)
                End If
            Else
                sMinor = Mid$(sVersion, lPos1)
            End If
        Else
            sMajor = sVersion
        End If
    End If
End Sub


