VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "InstallData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' --- GPL ---
'
' Copyright (C) 1999-2001 SAP AG
'
' This program is free software; you can redistribute it and/or
' modify it under the terms of the GNU General Public License
' as published by the Free Software Foundation; either version 2
' of the License, or (at your option) any later version.
'
' This program is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
' GNU General Public License for more details.
'
' You should have received a copy of the GNU General Public License
' along with this program; if not, write to the Free Software
' Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
'
' --- GPL ---
Option Explicit

Const SECTION_GENERAL = "[General]"
Const SECTION_PARAMETERS = "[Parameters]"
Const SECTION_DEVSPACES = "[DevSpaces]"

Const KEY_DBNAME = "DatabaseName"
Const KEY_SRVNAME = "ServerName"
Const KEY_SRVUSR = "ServerUser"
Const KEY_SRVPWD = "ServerPassword"
Const KEY_INSTROOT = "InstRoot"
Const KEY_VERSION = "Version"
Const KEY_DBMUSR = "DBMUser"
Const KEY_DBMPWD = "DBMPassword"
Const KEY_DBAUSR = "DBAUser"
Const KEY_DBAPWD = "DBAPassword"
Const KEY_PARAMINIT = "ParamInitMode"
Const KEY_DBSOURCE = "SourceDatabase"
Const KEY_MEDIUM = "MediumName"
Const KEY_INSTMODE = "InstallMode"

Const EQUAL = "="

'''

Private sDatabaseName As String
Private sServerName As String
Private sServerUser As String
Private sServerPassword As String
Private sInstRoot As String
Private sVersion As String
Private sDBMUser As String
Private sDBMPassword As String
Private sDBAUser As String
Private sDBAPassword As String
Private lParamInitMode As DBMWizParamInitModeConstants
Private sSourceDatabase As String
Private sMediumName As String
Private lInstallMode As DBMWizInstallModeConstants
Private lInstanceType As dbmlib.DBMDatabaseInstanceTypeConstants

'''

Private oParameters As DBMWiz.Parameters
Private oDevSpaces As DBMWiz.DevSpaces

'''

Public Property Get DatabaseName() As String
    DatabaseName = sDatabaseName
End Property
Public Property Let DatabaseName(NewVal As String)
    sDatabaseName = NewVal
End Property

Public Property Get ServerName() As String
    ServerName = sServerName
End Property
Public Property Let ServerName(NewVal As String)
    sServerName = NewVal
End Property

Public Property Get ServerUser() As String
    ServerUser = sServerUser
End Property
Public Property Let ServerUser(NewVal As String)
    sServerUser = NewVal
End Property

Public Property Get ServerPassword() As String
    ServerPassword = sServerPassword
End Property
Public Property Let ServerPassword(NewVal As String)
    sServerPassword = NewVal
End Property

Public Property Get InstRoot() As String
    InstRoot = sInstRoot
End Property
Public Property Let InstRoot(NewVal As String)
    sInstRoot = NewVal
End Property

Public Property Get Version() As String
    Version = sVersion
End Property
Public Property Let Version(NewVal As String)
    sVersion = NewVal
End Property

Public Property Get DBMUser() As String
    DBMUser = sDBMUser
End Property
Public Property Let DBMUser(NewVal As String)
    sDBMUser = NewVal
End Property

Public Property Get DBMPassword() As String
    DBMPassword = sDBMPassword
End Property
Public Property Let DBMPassword(NewVal As String)
    sDBMPassword = NewVal
End Property

Public Property Get DBAUser() As String
    DBAUser = sDBAUser
End Property
Public Property Let DBAUser(NewVal As String)
    sDBAUser = NewVal
End Property

Public Property Get DBAPassword() As String
    DBAPassword = sDBAPassword
End Property
Public Property Let DBAPassword(NewVal As String)
    sDBAPassword = NewVal
End Property

Public Property Get ParamInitMode() As DBMWizParamInitModeConstants
    ParamInitMode = lParamInitMode
End Property
Public Property Let ParamInitMode(NewVal As DBMWizParamInitModeConstants)
    lParamInitMode = NewVal
End Property

Public Property Get SourceDatabase() As String
    SourceDatabase = sSourceDatabase
End Property
Public Property Let SourceDatabase(NewVal As String)
    sSourceDatabase = NewVal
End Property

Public Property Get MediumName() As String
    MediumName = sMediumName
End Property
Public Property Let MediumName(NewVal As String)
    sMediumName = NewVal
End Property

Public Property Get InstallMode() As DBMWizInstallModeConstants
    InstallMode = lInstallMode
End Property
Public Property Let InstallMode(NewVal As DBMWizInstallModeConstants)
    lInstallMode = NewVal
End Property

Public Property Get InstanceType() As dbmlib.DBMDatabaseInstanceTypeConstants
    InstanceType = lInstanceType
End Property
Public Property Let InstanceType(NewVal As dbmlib.DBMDatabaseInstanceTypeConstants)
    lInstanceType = NewVal
End Property

'''

Public Property Get Parameters() As DBMWiz.Parameters
    If oParameters Is Nothing Then
        Set oParameters = New DBMWiz.Parameters
    End If
    Set Parameters = oParameters
End Property

Public Property Get DevSpaces() As DBMWiz.DevSpaces
    If oDevSpaces Is Nothing Then
        Set oDevSpaces = New DBMWiz.DevSpaces
    End If
    Set DevSpaces = oDevSpaces
End Property

'''

Public Sub Clear()
    sDatabaseName = ""
    sServerName = ""
    sServerUser = ""
    sServerPassword = ""
    sInstRoot = ""
    sVersion = ""
    sDBMUser = ""
    sDBMPassword = ""
    sDBAUser = ""
    sDBAPassword = ""
    lParamInitMode = dbmWizParamInitModeInit
    sSourceDatabase = ""
    sMediumName = ""
    lInstallMode = dbmWizInstallModeInstall
    lInstanceType = dbmInstanceTypeNone
End Sub

'''

Public Sub LoadFromFile(Filename As String)
    Dim hFile As Integer
    Dim sLine As String
    
    hFile = FreeFile()
    
    Open Filename For Input As #hFile
    
    Do While Not EOF(hFile)
        Line Input #hFile, sLine
    Loop
    
    Close #hFile
End Sub

Public Sub SaveToFile(Filename As String)
    Dim hFile As Integer
    Dim sLine As String
    
    hFile = FreeFile()
    
    Open Filename For Output As #hFile

    Print #hFile, SECTION_GENERAL
    Print #hFile, KEY_DBNAME; EQUAL; sDatabaseName
    Print #hFile, KEY_SRVNAME; EQUAL; sServerName
    Print #hFile, KEY_SRVUSR; EQUAL; sServerUser
    Print #hFile, KEY_SRVPWD; EQUAL; sServerPassword
    Print #hFile, KEY_INSTROOT; EQUAL; sInstRoot
    Print #hFile, KEY_VERSION; EQUAL; sVersion
    Print #hFile, KEY_DBMUSR; EQUAL; sDBMUser
    Print #hFile, KEY_DBMPWD; EQUAL; sDBMPassword
    Print #hFile, KEY_DBAUSR; EQUAL; sDBAUser
    Print #hFile, KEY_DBAPWD; EQUAL; sDBAPassword
    Print #hFile, KEY_PARAMINIT; EQUAL; lParamInitMode
    Print #hFile, KEY_DBSOURCE; EQUAL; sSourceDatabase
    Print #hFile, KEY_MEDIUM; EQUAL; sMediumName
    Print #hFile, KEY_INSTMODE; EQUAL; lInstallMode
    Print #hFile,
    Print #hFile, SECTION_PARAMETERS
    Print #hFile,
    Print #hFile, SECTION_DEVSPACES
    Print #hFile,
    
    Close #hFile
End Sub

'''

Private Sub Class_Initialize()
    Set oParameters = Nothing
    Set oDevSpaces = Nothing
End Sub
